<!---
#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#    Ellad B. Tadmor
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

#
# Release: This file is part of the kim-api.git repository.
#
-->

[![Build](https://github.com/openkim/kim-api/actions/workflows/build-multiplatform.yml/badge.svg)](https://github.com/openkim/kim-api/actions/workflows/build-multiplatform.yml)
[![Documentation Status](https://readthedocs.org/projects/kim-api/badge/?version=devel)](https://kim-api.readthedocs.io/en/devel/?badge=devel)
[![Coverity Scan](https://scan.coverity.com/projects/16411/badge.svg?flat=1)](https://scan.coverity.com/projects/openkim-kim-api)
[![codecov](https://codecov.io/gh/openkim/kim-api/branch/devel/graph/badge.svg)](https://codecov.io/gh/openkim/kim-api/branch/devel)

<p align="center"><h2>The KIM API package</h2></p>

<a href="https://repology.org/project/kim-api/versions"><img src="https://repology.org/badge/vertical-allrepos/kim-api.svg" alt="Packaging status" align="right" style="padding:5px;"/></a>

The KIM API package is a system-level library that aims to give computer
programmers the ability to write atomistic or molecular simulation programs
that can seamlessly interface with implementations of interatomic models,
regardless of the programming language (C, C++, Fortran, Python, etc.) in which
the codes are written.  It is part of the larger KIM project
(https://openkim.org).


Documentation
-------------

[Full documentation](https://kim-api.readthedocs.io/en/devel) is available online via [readthedocs.org](https://readthedocs.org)


Download
--------

All official release archives of the KIM API package can be downloaded from:

[https://openkim.org/kim-api/previous-versions](https://openkim.org/kim-api/previous-versions)

Release notes are available in the [NEWS](NEWS) file.


Installation
------------

See the [INSTALL](INSTALL) file for instructions on how to build and install
the package and its documentation.


Contributing
------------

Just send us a [pull request](https://help.github.com/articles/using-pull-requests/).
When you send your request, make `devel` the destination branch on the
[kim-api repository](https://github.com/openkim/kim-api).

Please see the [README_GIT](README_GIT) file for some additional details.


Issues, bugs, requests, ideas
-----------------------------

Use the [issues](https://github.com/openkim/kim-api/issues) tracker to report
bugs.


License
-------

The KIM API is distributed under the terms of the LGPL-2.1-or-later
license.

All new contributions must be made under this license.

See [LICENSE.LGPL](LICENSE.LGPL) and
[https://spdx.org/licenses/LGPL-2.1-or-later.html](https://spdx.org/licenses/LGPL-2.1-or-later.html)
for details.


*******************************************************************************

SUPPORT

Support is always available by posting questions with all relevant information
to

<https://matsci.org/openkim>

Members of the OpenKIM development team actively monitor this forum and
will do their best to respond to questions in a timely fashion.

*******************************************************************************

edn-cpp
=======

edn lib for c++. 

##intro
Useful for parsing [edn](http://github.com/edn-format/edn). read returns an `edn::EdnNode`. There are three cases to consider: 

* If it is an atom (nil, symbol, keyword, bool, int, float, string, char) it will have a `value` property which is a string you can then cast/coerce how you please. 

* If it is a collection (list, map, vector, set) it will have a `values` property which is itself a list of `edn::EdnNode` items which you can then walk via what ever mechanism and do with them what you will. 

* If it is a tagged item you will have the raw tagname in the `value` property and then the `values` property will be a list containing the `edn::EdnNode` representing the tagname and another `edn::EdnNode` containing the value for the tag. 

In general `edn-cpp` makes no assumptions about how you want to reify the data - it just guarantees you have well formed edn node(s) which you can handle how ever you like. 


##using

	#//define DEBUG
	#include "edn.hpp"
	#include <iostream>
	
	using edn::EdnNode;
	using edn::read;
	using edn::pprint;
	
	int main() {
		try {
			EdnNode someMap = read("{:some :map :with [a vector of symbols]}");
			std::cout << pprint(someMap) << std::endl;
		} catch (const char* e) {
			std::cout << "Error parsing: " << e << std::endl;
		}
	}

will output: 

	{:some :map :with [a vector of symbols]}

And with debug uncommented: 

	<EdnMap {<EdnKeyword :some> <EdnKeyword :map> 
	         <EdnKeyword :with> <EdnVector [<EdnSymbol a> 
	                                        <EdnSymbol vector> 
	                                        <EdnSymbol of> 
	                                        <EdnSymbol symbols>]>}>

##debug
If you define DEBUG you will see debug output when using pprint. This looks like:

	<EdnMap {
	  <EdnKeyword :x> <EdnKeyword :y> 
	  <EdnKeyword :z> <EdnVector [<EdnInt 1> 
	                              <EdnInt 2> 
	                              <EdnInt 3> 
	                              <EdnTagged #<EdnSymbol tagged/item> 
	                                         <EdnString "cats-rabbits-bears">>]>}>

Which is nice when proving things are parsing as you expect. 

##api

	list<EdnToken> lex(string ednString)
	
	EdnNode read(string ednString)

	string pprint(EdnNode node)
	
	bool validSymbol(string value)
	
	bool validKeyword(string value)

	bool validNil(string value)
		
	bool validBool(string value)
	
	bool validInt(string value)
	
	bool validFloat(string value)
	
	bool validChar(string value)
	
	EdnNode handleAtom(EdnToken token)
	
	EdnNode handleCollection(EdnToken token, list<EdnNode> values)
	
	EdnNode handleTagged(EdnToken token, EdnNode value)
	
##structs

	EdnToken
		TokenType type
		int line
		string value
	
	EdnNode
		EdnToken type
		int line
		string value         #used for atoms
		list<EdnNode> values #used for collections
		
##enums

	TokenType
		TokenString
		TokenAtom
		TokenParen
		
	NodeType
		EdnNil
		EdnSymbol
		EdnKeyword
		EdnBool
		EdnInt
		EdnFloat
		EdnString
		EdnChar
		EdnList
		EdnVector
		EdnMap
		EdnSet
		EdnDiscard
		EdnTagged
		
		
##todo
make pprint actually format as demonstrated above. Right now it is just a single string with out the indentation. 

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


This directory (examples) contains directories with example Model Drivers,
Portable Models, Simulator Models, and Simulators.  Please see the README files
within each directory for information about the examples.

Items in these directories may be built as part of the main KIM API build.  Or,
they may be build separately, after the KIM API has been built and installed.
In the latter case, for Portable Models and Model Drivers, use the
kim-api-collections-management utility to build and install the items.  For the
simulators, the following example sequence of commands is typical.

$ cd simulators/ex_test_Ar_fcc_cluster
$ mkdir build
$ cd build
$ cmake ../ -DCMAKE_BUILD_TYPE=Release
$ make

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2019, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ellad B. Tadmor
#    Ryan S. Elliott
#


This directory (utility_forces_numer_deriv) contains a Verification Check that
compares the forces computed by a KIM-compliant Model with those obtained using
numerical differentiation of the Model energies.

Calling format:

   printf "model_name" | ./utility_forces_numer_deriv

Notes:

1. It checks a single configuration: a perturbed fcc cluster made of a random
   arrangement of the supported species with spacing scaled by a factor based
   on the Model's cutoff value.

2. The code computes the DIM*N components of the force vector in two ways:
   directly using the Model's force calculation (`force_model') and by
   numerical differentiation using Ridders' method (`force_numer').  The
   difference between these values in absolute value is also printed (`Force
   diff') as well as the error predicted by Ridders' method (`pred error').
   Ideally, one would expect the force difference to be less than the predicted
   error.  If that is the case the term `ok' is printed at the end of the
   line.  (Most potentials fail this check for most degrees of freedom, so this
   is not a good criterion.)

   In addition, the following normalized measure is computed:

   \alpha = 1/(DIM*N) sqrt( \sum_i w_i (f^{model}_i - f^{numer}_i)^2 / \sum_i w_i ),

   where w_i is the weight associated with term i:

   w_i = 1/\hat{\epsilon}_i,

   and \hat{\epsilon}_i is the normalized error in the numerical calculation:

   \hat{\epsilon}_i = max(\epsilon^{numer}_i, \epsilon^{prec}) /
                      max(\force^{numer}_i, \epsilon^{prec})

   The max functions impose a lower limit on computed values equal to the
   numerical precision of the computer (\epsilon^{prec}).

   \alpha has units of force and can be understood as the average error per
   degree of freedom.  The smaller the value of \alpha the more accurate the
   force calculation of the Model.

   In the expression for \alpha each term is weighted by the relative accuracy
   of the numerical estimate for the derivative.  Thus if f^{numer}_i is a poor
   estimate for the derivative (i.e. \epsilon^{numer}_i is large relative to
   f^{numer}_i) then term i contributes less to \alpha since it is less
   trustworthy.

   In addition to \alpha, the maximum term contributing to \alpha is
   identified.  For this degree of freedom, the error and normalized error are
   printed:

   forcediff_i = |f^{model}_i - f^{numer}_i}|

   forcediff_i/|f^{model}_i|

   This is *not* the largest error (i.e. the largest value of forcediff_i) due
   to the weighting term w_i.  Simply looking at the maximum value of
   forcediff_i could be misleading since the error in the numerical term,
   \epsilon^{numer}_i, may be large for the component.  Instead the maximum of
   w_i*forcediff_i is a compromise that in some sense seeks the largest error
   for components where the numerical derivative are also as accurate possible.

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#    Andrew Akerson
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


This directory (LennardJones612_UniversalShifted__MO_959249795837_003) contains
a Lennard-Jones model defined for the entire set of KIM API particle types.

* Sigma parameters are set to (2^{-1/6})*r_0, where r_0 is the atomic covalent
  radius.  Covalent radii for elements 1--96 were taken from Wolfram
  Mathematica's `ElementData["CovalentRadius"]' command.  Covalent radii for
  elements 97--118 were taken from Fig. 3 of the article Pyykko, M. Atsumi,
  J. Chem. Eur. J. 15 (2009) 12770.

* Epsilon parameters are set to the bond dissociation energy.  Bond
  dissociation energies for elements 1--55, 57--60, and 61--84 were taken from
  the CRC Handbook of Chemistry and Physics, 91st Edition, Ed. W.H. Haynes,
  2010. (as posted here:
  http://staff.ustc.edu.cn/~luo971/2010-91-CRC-BDEs-Tables.pdf)

  The value (cohesive energy, in this case) for element 56 was obtained from
  p. 50 in Charles Kittel. Introduction to Solid State Physics, 8th
  edition. Hoboken, NJ: John Wiley & Sons, Inc, 2005.

  The bond dissociation energy value for element 61 was obtained from
  "Interpolation scheme for the cohesive energies for the lanthanides and
  actinides" Borje Johansson and Anders Rosengren, Phys. Rev. B 11, 1367 (1975).

  The bond dissociation energies for elements 85--118 were not found in the
  literature.  Thus, the values used here are approximated by subtracting 10%
  from the value for the element in the same Group (column) and previous Period
  (row) of the periodic table.

* Cutoff parameters are set to 4.0*sigma.  This corresponds to a cutoff energy
  of approximately epsilon/1024.

* Lorentz-Berthelot mixing rules are used for interactions between unlike
  particles. Each interaction potential is shifted to zero energy at its cutoff
  distance.

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#    Andrew Akerson
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


This directory (LennardJones612__MD_414112407348_003) contains a Lennard-Jones
Driver which reads a parameter file containing the parameters for up to 139
species.  It supports shifted and non-shifted energy behavior.  The driver is
written in C++.  This Model Driver expects one parameter file as decribed
below.

The model driver implements the functional form:

       phi_{ij}(r) = 4 * epsilon_{ij} *
                     [ (sigma_{ij}/r)^12 - (sigma_{ij}/r)^6 ] + shift_{ij},

where i, j = 0, 1, 2, ..., N-1, and N is the number of supported species.


The format of the parameter file is as follows:

* Blank lines and lines beginning with the `#' character are ignored.

* Line 0 : N, shift
   - N         : integer number of distinct particle species
   - shift     : integer value: 0-for no shift; 1-for shifts.
                 All shift values are computed at run time
* Lines 1,2,...: species_i, species_j, cutoff, epsilon, sigma
   - species_i : A valid KIM API particle species string
   - species_j : A valid KIM API particle species string
   - cutoff    : double cutoff distance value (in Angstroms) for phi_{ij}(r)
   - epsilon   : double energy value (in eV) for  epsilon_{ij}
   - sigma     : double sigma distance value (in Angstroms) for sigma_{ij}


The parameter file must contain all "like-like" parameter sets (i.e., lines
where species_i and species_j are identical) for each species which occurs in
the file.  The model driver uses the Lorentz-Berthelot rules to generate any
"cross-interaction" parameter sets which are not provided.  The model driver
sets the `influcenceDistance' argument to max_{ij}(cutoff_{ij}).  The model
driver uses this same influenceDistance as its NeighborListCutoff value.

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


This directory (ex_model_driver_P_Morse) contains a shifted Morse pair potential
Model driver written in C.

   phi(r) = epsilon * ( - exp[ -2*C*(r - Rzero) ] + 2*exp[ -C*(r - Rzero) ] )
            + shift

where shift is computed so that phi(rcut) = 0.0

To create a KIM Model from this Model Driver, one parameter file is required.
This file must have the following format:
   Line 1: `SpeciesName' string with element symbol
   Line 2: `cutoff' value in angstroms
   Line 3: Morse `epsilon' value in eV
   Line 4: Morse `C' value in 1/Angstroms
   Line 5: Morse `Rzero' value in Angstroms
Any additional lines will be silently ignored.

#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the Common Development
# and Distribution License Version 1.0 (the "License").
#
# You can obtain a copy of the license at
# http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
# specific language governing permissions and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each file and
# include the License file in a prominent location with the name LICENSE.CDDL.
# If applicable, add the following below this CDDL HEADER, with the fields
# enclosed by brackets "[]" replaced with your own identifying information:
#
# Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
#
# CDDL HEADER END
#

#
# Copyright (c) 2013--2019, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#


This directory (ex_model_Ar_P_Morse_07C) contains a shifted Morse pair potential
Model written in C.

   phi(r) = epsilon * ( - exp[ -2*C*(r - Rzero) ] + 2*exp[ -C*(r - Rzero) ] )
            + shift

where shift is computed so that phi(rcut) = 0.0

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#

This directory (ex_model_driver_P_LJ) contains a shifted Lennard-Jones
pair potential Model driver written in Fortran 90.

   phi(r) = 4 * epsilon * ( (sigma/r)^12 - (sigma/r)^6 ) + shift

where shift is computed so that phi(rcut) = 0.0

To create a KIM Model from this Model Driver, one parameter file is required.
This file must have the following format:
   Line 1: `SpeciesName' string with element symbol
   Line 1: `cutoff' value in angstroms
   Line 2: Lennard-Jones `epsilon' value in eV
   Line 3: Lennard-Jones `sigma' value in Angstroms

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ellad B. Tadmor
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


Spring-modified Lennard-Jones (SLJ) pair potential model for Ar.

V = 0.5 \sum_i \sum_j eps_i eps_j 4 [ (sig/r_ij)^12 - (sig/r_ij)^6 ] (1)

where
      eps_i = 0.5 \sum_k spring (r_ik)^2                             (2)

The potential parameters are `sig` and the spring constant `sig`.

This potential uses two cutoffs and requires neighbors of padding
atoms for the summ in (2).

The loops in (2) are over all atoms for which r_ik < cutoff1

The loops in (1) are over all atoms for which r_ij < cutoff2

For the Ar parameterization, cutoff1 is set so that only nearest
neighbors contribute in the equilibrium 0K fcc structure, and
cutoff2 is set to include the third neighbor distance. The potential
is discontinuous at both cutoffs. It is designed for testing purposes
only.

The equilibrium spacing for the fcc structure predicted by the SLJ potential is

a0 = 2^(1/3)/sqrt(3) * (94297/491)^(1/6) sig = 1.74724 sig

The first, second and third neighbor distances in fcc are then:

r_NN1 = a0/sqrt(2)   = 1.235 sig
r_NN2 = a0           = 1.747 sig
r_NN3 = a0*sqrt(3/2) = 2.140 sig

The parameters `sig` and `spring` are selected to reproduce the experimental
properties of fcc argon:

a0  = 5.26 A
E_c = 0.0104 eV

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelComputeArguments
!!
!! \sa KIM::ModelComputeArguments, KIM_ModelComputeArguments
!!
!! \since 2.0
module kim_model_compute_arguments_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_compute_arguments_handle_type, &

    ! Constants
    KIM_MODEL_COMPUTE_ARGUMENTS_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_get_neighbor_list, &
    kim_process_dedr_term, &
    kim_process_d2edr2_term, &
    kim_get_argument_pointer, &
    kim_is_callback_present, &
    kim_set_model_buffer_pointer, &
    kim_get_model_buffer_pointer, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelComputeArguments
  !!
  !! \sa KIM::ModelComputeArguments, KIM_ModelComputeArguments
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_compute_arguments_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_compute_arguments_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_compute_arguments_handle_type), protected, save &
    :: KIM_MODEL_COMPUTE_ARGUMENTS_NULL_HANDLE

  !> \brief Compares kim_model_compute_arguments_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_compute_arguments_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_compute_arguments_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_compute_arguments_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelComputeArguments::GetNeighborList
  !!
  !! \sa KIM::ModelComputeArguments::GetNeighborList,
  !! KIM_ModelComputeArguments_GetNeighborList
  !!
  !! \since 2.0
  interface kim_get_neighbor_list
    module procedure kim_model_compute_arguments_get_neighbor_list
  end interface kim_get_neighbor_list

  !> \brief \copybrief KIM::ModelComputeArguments::ProcessDEDrTerm
  !!
  !! \sa KIM::ModelComputeArguments::ProcessDEDrTerm,
  !! KIM_ModelComputeArguments_ProcessDEDrTerm
  !!
  !! \since 2.0
  interface kim_process_dedr_term
    module procedure kim_model_compute_arguments_process_dedr_term
  end interface kim_process_dedr_term

  !> \brief \copybrief KIM::ModelComputeArguments::ProcessD2EDr2Term
  !!
  !! \sa KIM::ModelComputeArguments::ProcessD2EDr2Term,
  !! KIM_ModelComputeArguments_ProcessD2EDr2Term
  !!
  !! \since 2.0
  interface kim_process_d2edr2_term
    module procedure kim_model_compute_arguments_process_d2edr2_term
  end interface kim_process_d2edr2_term

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerInteger,
  !! KIM_ModelComputeArguments_GetArgumentPointerDouble
  !!
  !! \since 2.0
  interface kim_get_argument_pointer
    module procedure kim_model_compute_arguments_get_argument_pointer_int0
    module procedure kim_model_compute_arguments_get_argument_pointer_int1
    module procedure kim_model_compute_arguments_get_argument_pointer_int2
    module procedure kim_model_compute_arguments_get_argument_pointer_double0
    module procedure kim_model_compute_arguments_get_argument_pointer_double1
    module procedure kim_model_compute_arguments_get_argument_pointer_double2
  end interface kim_get_argument_pointer

  !> \brief \copybrief KIM::ModelComputeArguments::IsCallbackPresent
  !!
  !! \sa KIM::ModelComputeArguments::IsCallbackPresent,
  !! KIM_ModelComputeArguments_IsCallbackPresent
  !!
  !! \since 2.0
  interface kim_is_callback_present
    module procedure kim_model_compute_arguments_is_callback_present
  end interface kim_is_callback_present

  !> \brief \copybrief KIM::ModelComputeArguments::SetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArguments::SetModelBufferPointer,
  !! KIM_ModelComputeArguments_SetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_set_model_buffer_pointer
    module procedure kim_model_compute_arguments_set_model_buffer_pointer
  end interface kim_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArguments::GetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetModelBufferPointer,
  !! KIM_ModelComputeArguments_GetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_get_model_buffer_pointer
    module procedure kim_model_compute_arguments_get_model_buffer_pointer
  end interface kim_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArguments::LogEntry
  !!
  !! \sa KIM::ModelComputeArguments::LogEntry,
  !! KIM_ModelComputeArguments_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_compute_arguments_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelComputeArguments::ToString
  !!
  !! \sa KIM::ModelComputeArguments::ToString,
  !! KIM_ModelComputeArguments_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_compute_arguments_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_compute_arguments_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_compute_arguments_handle_equal(lhs, rhs)
    implicit none
    type(kim_model_compute_arguments_handle_type), intent(in) :: lhs
    type(kim_model_compute_arguments_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_compute_arguments_handle_equal = .true.
    else
      kim_model_compute_arguments_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_compute_arguments_handle_equal

  !> \brief Compares kim_model_compute_arguments_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  logical recursive function kim_model_compute_arguments_handle_not_equal(lhs, &
    rhs)
    implicit none
    type(kim_model_compute_arguments_handle_type), intent(in) :: lhs
    type(kim_model_compute_arguments_handle_type), intent(in) :: rhs

    kim_model_compute_arguments_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_compute_arguments_handle_not_equal

  !> \brief \copybrief KIM::ModelComputeArguments::GetNeighborList
  !!
  !! A Fortran PM must provide a KIM::MODEL_ROUTINE_NAME::GetNeighbotList
  !! routine.  The interface for this is given here (see also
  !! KIM::GetNeighborListFunction, \ref KIM_GetNeighborListFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine get_neighbor_list(data_object, &
  !!     number_of_neighbor_lists, cutoffs, neighbor_list_index, &
  !!     particle_number, number_of_neighbors, neighbors_of_particle, ierr) &
  !!     bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     implicit none
  !!     type(c_ptr), intent(in), value :: data_object
  !!     integer(c_int), intent(in), value :: number_of_neighbor_lists
  !!     real(c_double), intent(in) :: cutoffs(*)
  !!     integer(c_int), intent(in), value :: neighbor_list_index
  !!     integer(c_int), intent(in), value :: particle_number
  !!     integer(c_int), intent(out) :: number_of_neighbors
  !!     type(c_ptr), intent(out) :: neighbors_of_particle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine get_neighbor_ilst
  !! end interface
  !! \endcode
  !!
  !! \note The use of the "assumed size" type for `cutoffs` above is necessary
  !! for strict conformance to the Fortran/C interoperability standard.  The
  !! cutoffs array is expected to be of shape \c [number_of_neighbor_lists].
  !!
  !! \sa KIM::ModelComputeArguments::GetNeighborList,
  !! KIM_ModelComputeArguments_GetNeighborList
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_get_neighbor_list( &
    model_compute_arguments_handle, neighbor_list_index, particle_number, &
    number_of_neighbors, neighbors_of_particle, ierr)
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_neighbor_list( &
        model_compute_arguments, neighbor_list_index, particle_number, &
        number_of_neighbors, neighbors_of_particle) &
        bind(c, name="KIM_ModelComputeArguments_GetNeighborList")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        integer(c_int), intent(in), value :: neighbor_list_index
        integer(c_int), intent(in), value :: particle_number
        integer(c_int), intent(out) :: number_of_neighbors
        type(c_ptr), intent(out) :: neighbors_of_particle
      end function get_neighbor_list
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    integer(c_int), intent(in) :: neighbor_list_index
    integer(c_int), intent(in) :: particle_number
    integer(c_int), intent(out) :: number_of_neighbors
    integer(c_int), intent(out), pointer :: neighbors_of_particle(:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_neighbor_list(model_compute_arguments, neighbor_list_index-1, &
      particle_number, number_of_neighbors, p)
    if (c_associated(p)) then
      call c_f_pointer(p, neighbors_of_particle, [number_of_neighbors])
    else
      nullify(neighbors_of_particle)
    end if
  end subroutine kim_model_compute_arguments_get_neighbor_list

  !> \brief \copybrief KIM::ModelComputeArguments::ProcessDEDrTerm
  !!
  !! A Fortran PM may provide a KIM::MODEL_ROUTINE_NAME::ProcessDEDrTerm
  !! routine.  The interface for this is given here (see also
  !! KIM::ProcessDEDrTermFunction, \ref KIM_ProcessDEDrTermFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine process_dedr_term(data_object, de, r, dx, i, j, &
  !!     ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     implicit none
  !!     type(c_ptr), intent(in), value :: data_object
  !!     real(c_double), intent(in), value :: de
  !!     real(c_double), intent(in), value :: r
  !!     real(c_double), intent(in) :: dx(3)
  !!     integer(c_int), intent(in), value :: i
  !!     integer(c_int), intent(in), value :: j
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine process_dedr_term
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::ModelComputeArguments::ProcessDEDrTerm,
  !! KIM_ModelComputeArguments_ProcessDEDrTerm
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_process_dedr_term( &
    model_compute_arguments_handle, de, r, dx, i, j, ierr)
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function process_dedr_term( &
        model_compute_arguments, de, r, dx, i, j) &
        bind(c, name="KIM_ModelComputeArguments_ProcessDEDrTerm")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        real(c_double), intent(in), value :: de
        real(c_double), intent(in), value :: r
        real(c_double), intent(in) :: dx
        integer(c_int), intent(in), value :: i
        integer(c_int), intent(in), value :: j
      end function process_dedr_term
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    real(c_double), intent(in) :: de
    real(c_double), intent(in) :: r
    real(c_double), intent(in) :: dx(:)
    integer(c_int), intent(in) :: i
    integer(c_int), intent(in) :: j
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = process_dedr_term(model_compute_arguments, de, r, dx(1), i, j)
  end subroutine kim_model_compute_arguments_process_dedr_term

  !> \brief \copybrief KIM::ModelComputeArguments::ProcessD2EDr2Term
  !!
  !! A Fortran PM may provide a KIM::MODEL_ROUTINE_NAME::ProcessD2EDr2Term
  !! routine.  The interface for this is given here (see also
  !! KIM::ProcessD2EDr2TermFunction, \ref KIM_ProcessD2EDr2TermFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine process_d2edr2_term(data_object, de, r, dx, i, j, &
  !!     ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     implicit none
  !!     type(c_ptr), intent(in), value :: data_object
  !!     real(c_double), intent(in), value :: de
  !!     real(c_double), intent(in) :: r(2)
  !!     real(c_double), intent(in) :: dx(3,2)
  !!     integer(c_int), intent(in) :: i(2)
  !!     integer(c_int), intent(in) :: j(2)
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine process_d2edr2_term
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::ModelComputeArguments::ProcessD2EDr2Term,
  !! KIM_ModelComputeArguments_ProcessD2EDr2Term
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_process_d2edr2_term( &
    model_compute_arguments_handle, de, r, dx, i, j, ierr)
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function process_d2edr2_term( &
        model_compute_arguments, de, r, dx, i, j) &
        bind(c, name="KIM_ModelComputeArguments_ProcessD2EDr2Term")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        real(c_double), intent(in), value :: de
        real(c_double), intent(in) :: r
        real(c_double), intent(in) :: dx
        integer(c_int), intent(in) :: i
        integer(c_int), intent(in) :: j
      end function process_d2edr2_term
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    real(c_double), intent(in) :: de
    real(c_double), intent(in) :: r(:)
    real(c_double), intent(in) :: dx(:,:)
    integer(c_int), intent(in) :: i(:)
    integer(c_int), intent(in) :: j(:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = process_d2edr2_term(model_compute_arguments, &
      de, r(1), dx(1,1), i(1), j(1))
  end subroutine kim_model_compute_arguments_process_d2edr2_term

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_get_argument_pointer_int0( &
    model_compute_arguments_handle, compute_argument_name, int0, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_integer( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerInteger")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_integer
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(out), pointer :: int0
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_integer(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, int0)
    else
      nullify(int0)
    end if
  end subroutine kim_model_compute_arguments_get_argument_pointer_int0

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_get_argument_pointer_int1( &
    model_compute_arguments_handle, compute_argument_name, extent1, int1, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_integer( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerInteger")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_integer
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in) :: extent1
    integer(c_int), intent(out), pointer :: int1(:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_integer(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, int1, [extent1])
    else
      nullify(int1)
    end if

  end subroutine kim_model_compute_arguments_get_argument_pointer_int1

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_get_argument_pointer_int2( &
    model_compute_arguments_handle, compute_argument_name, extent1, extent2, &
    int2, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_integer( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerInteger")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_integer
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in) :: extent1
    integer(c_int), intent(in) :: extent2
    integer(c_int), intent(out), pointer :: int2(:,:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_integer(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, int2, [extent1, extent2])
    else
      nullify(int2)
    end if
  end subroutine kim_model_compute_arguments_get_argument_pointer_int2

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_get_argument_pointer_double0( &
    model_compute_arguments_handle, compute_argument_name, double0, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_double( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerDouble")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_double
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    real(c_double), intent(out), pointer :: double0
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_double(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, double0)
    else
      nullify(double0)
    end if
  end subroutine kim_model_compute_arguments_get_argument_pointer_double0

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_get_argument_pointer_double1( &
    model_compute_arguments_handle, compute_argument_name, extent1, double1, &
    ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_double( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerDouble")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_double
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in) :: extent1
    real(c_double), intent(out), pointer :: double1(:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_double(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, double1, [extent1])
    else
      nullify(double1)
    end if
  end subroutine kim_model_compute_arguments_get_argument_pointer_double1

  !> \brief \copybrief KIM::ModelComputeArguments::GetArgumentPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetArgumentPointer,
  !! KIM_ModelComputeArguments_GetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_get_argument_pointer_double2( &
    model_compute_arguments_handle, compute_argument_name, extent1, extent2, &
    double2, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_pointer_double( &
        model_compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ModelComputeArguments_GetArgumentPointerDouble")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(out) :: ptr
      end function get_argument_pointer_double
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in) :: extent1
    integer(c_int), intent(in) :: extent2
    real(c_double), intent(out), pointer :: double2(:,:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = get_argument_pointer_double(model_compute_arguments, &
      compute_argument_name, p)
    if (c_associated(p)) then
      call c_f_pointer(p, double2, [extent1, extent2])
    else
      nullify(double2)
    end if
  end subroutine kim_model_compute_arguments_get_argument_pointer_double2

  !> \brief \copybrief KIM::ModelComputeArguments::IsCallbackPresent
  !!
  !! \sa KIM::ModelComputeArguments::IsCallbackPresent,
  !! KIM_ModelComputeArguments_IsCallbackPresent
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_is_callback_present( &
    model_compute_arguments_handle, compute_callback_name, present, ierr)
    use kim_compute_callback_name_module, only : kim_compute_callback_name_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function is_callback_present( &
        model_compute_arguments, compute_callback_name, present) &
        bind(c, name="KIM_ModelComputeArguments_IsCallbackPresent")
        use, intrinsic :: iso_c_binding
        use kim_compute_callback_name_module, only : &
          kim_compute_callback_name_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
        integer(c_int), intent(out) :: present
      end function is_callback_present
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_compute_callback_name_type), intent(in) :: &
      compute_callback_name
    integer(c_int), intent(out) :: present
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    ierr = is_callback_present(model_compute_arguments, compute_callback_name, &
      present)
  end subroutine kim_model_compute_arguments_is_callback_present

  !> \brief \copybrief KIM::ModelComputeArguments::SetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArguments::SetModelBufferPointer,
  !! KIM_ModelComputeArguments_SetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_set_model_buffer_pointer( &
    model_compute_arguments_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      recursive subroutine set_model_buffer_pointer(model_compute_arguments, &
        ptr) bind(c, name="KIM_ModelComputeArguments_SetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_model_buffer_pointer
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    call set_model_buffer_pointer(model_compute_arguments, ptr)
  end subroutine kim_model_compute_arguments_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArguments::GetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArguments::GetModelBufferPointer,
  !! KIM_ModelComputeArguments_GetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_get_model_buffer_pointer( &
    model_compute_arguments_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      recursive subroutine get_model_buffer_pointer(model_compute_arguments, &
        ptr) bind(c, name="KIM_ModelComputeArguments_GetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(c_ptr), intent(out) :: ptr
      end subroutine get_model_buffer_pointer
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    call get_model_buffer_pointer(model_compute_arguments, ptr)
  end subroutine kim_model_compute_arguments_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArguments::LogEntry
  !!
  !! \sa KIM::ModelComputeArguments::LogEntry,
  !! KIM_ModelComputeArguments_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_log_entry( &
    model_compute_arguments_handle, log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      recursive subroutine log_entry(model_compute_arguments, log_verbosity, &
        message, line_number, file_name) bind(c, &
        name="KIM_ModelComputeArguments_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    call log_entry(model_compute_arguments, log_verbosity, &
      trim(message)//c_null_char, 0, ""//c_null_char)
  end subroutine kim_model_compute_arguments_log_entry

  !> \brief \copybrief KIM::ModelComputeArguments::ToString
  !!
  !! \sa KIM::ModelComputeArguments::ToString,
  !! KIM_ModelComputeArguments_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_to_string( &
    model_compute_arguments_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_compute_arguments_type
    implicit none
    interface
      type(c_ptr) recursive function model_compute_string( &
        model_compute_arguments) &
        bind(c, name="KIM_ModelComputeArguments_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_type
        implicit none
        type(kim_model_compute_arguments_type), intent(in) :: &
          model_compute_arguments
      end function model_compute_string
    end interface
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_compute_arguments_type), pointer :: model_compute_arguments

    type(c_ptr) :: p

    call c_f_pointer(model_compute_arguments_handle%p, model_compute_arguments)
    p = model_compute_string(model_compute_arguments)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_compute_arguments_to_string
end module kim_model_compute_arguments_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::SupportStatus
!!
!! \sa KIM::SupportStatus, KIM_SupportStatus
!!
!! \since 2.0
module kim_support_status_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_support_status_type, &
    ! Constants
    KIM_SUPPORT_STATUS_REQUIRED_BY_API, &
    KIM_SUPPORT_STATUS_NOT_SUPPORTED, &
    KIM_SUPPORT_STATUS_REQUIRED, &
    KIM_SUPPORT_STATUS_OPTIONAL, &
    ! Routines
    kim_known, &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_support_statuses, &
    kim_get_support_status

  !> \brief \copybrief KIM::SupportStatus
  !!
  !! \sa KIM::SupportStatus, KIM_SupportStatus
  !!
  !! \since 2.0
  type, bind(c) :: kim_support_status_type
    !> \brief \copybrief KIM::SupportStatus::supportStatusID
    !!
    !! \sa KIM::SupportStatus::supportStatusID,
    !! KIM_SupportStatus::supportStatusID
    !!
    !! \since 2.0
    integer(c_int) :: support_status_id
  end type kim_support_status_type

  !> \brief \copybrief KIM::SUPPORT_STATUS::requiredByAPI
  !!
  !! \sa KIM::SUPPORT_STATUS::requiredByAPI, KIM_SUPPORT_STATUS_requiredByAPI
  !!
  !! \since 2.0
  type(kim_support_status_type), protected, save, &
    bind(c, name="KIM_SUPPORT_STATUS_requiredByAPI") &
    :: KIM_SUPPORT_STATUS_REQUIRED_BY_API

  !> \brief \copybrief KIM::SUPPORT_STATUS::notSupported
  !!
  !! \sa KIM::SUPPORT_STATUS::notSupported, KIM_SUPPORT_STATUS_notSupported
  !!
  !! \since 2.0
  type(kim_support_status_type), protected, save, &
    bind(c, name="KIM_SUPPORT_STATUS_notSupported") &
    :: KIM_SUPPORT_STATUS_NOT_SUPPORTED

  !> \brief \copybrief KIM::SUPPORT_STATUS::required
  !!
  !! \sa KIM::SUPPORT_STATUS::required, KIM_SUPPORT_STATUS_required
  !!
  !! \since 2.0
  type(kim_support_status_type), protected, save, &
    bind(c, name="KIM_SUPPORT_STATUS_required") &
    :: KIM_SUPPORT_STATUS_REQUIRED

  !> \brief \copybrief KIM::SUPPORT_STATUS::optional
  !!
  !! \sa KIM::SUPPORT_STATUS::optional, KIM_SUPPORT_STATUS_optional
  !!
  !! \since 2.0
  type(kim_support_status_type), protected, save, &
    bind(c, name="KIM_SUPPORT_STATUS_optional") &
    :: KIM_SUPPORT_STATUS_OPTIONAL

  !> \brief \copybrief KIM::SupportStatus::Known
  !!
  !! \sa KIM::SupportStatus::Known, KIM_SupportStatus_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_support_status_known
  end interface kim_known

  !> \brief \copybrief KIM::SupportStatus::operator==()
  !!
  !! \sa KIM::SupportStatus::operator==(), KIM_SupportStatus_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_support_status_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::SupportStatus::operator!=()
  !!
  !! \sa KIM::SupportStatus::operator!=(), KIM_SupportStatus_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_support_status_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::SupportStatus::SupportStatus(std::string const &)
  !!
  !! \sa KIM::SupportStatus::SupportStatus(std::string const &),
  !! KIM_SupportStatus_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_support_status_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::SupportStatus::ToString
  !!
  !! \sa KIM::SupportStatus::ToString, KIM_SupportStatus_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_support_status_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::SupportStatus::Known
  !!
  !! \sa KIM::SupportStatus::Known, KIM_SupportStatus_Known
  !!
  !! \since 2.0
  logical recursive function kim_support_status_known(support_status)
    implicit none
    interface
      integer(c_int) recursive function known(support_status) &
        bind(c, name="KIM_SupportStatus_Known")
        use, intrinsic :: iso_c_binding
        import kim_support_status_type
        implicit none
        type(kim_support_status_type), intent(in), value :: support_status
      end function known
    end interface
    type(kim_support_status_type), intent(in) :: support_status

    kim_support_status_known = (known(support_status) /= 0)
  end function kim_support_status_known

  !> \brief \copybrief KIM::SupportStatus::operator==()
  !!
  !! \sa KIM::SupportStatus::operator==(), KIM_SupportStatus_Equal
  !!
  !! \since 2.0
  logical recursive function kim_support_status_equal(lhs, rhs)
    implicit none
    type(kim_support_status_type), intent(in) :: lhs
    type(kim_support_status_type), intent(in) :: rhs

    kim_support_status_equal &
      = (lhs%support_status_id == rhs%support_status_id)
  end function kim_support_status_equal

  !> \brief \copybrief KIM::SupportStatus::operator!=()
  !!
  !! \sa KIM::SupportStatus::operator!=(), KIM_SupportStatus_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_support_status_not_equal(lhs, rhs)
    implicit none
    type(kim_support_status_type), intent(in) :: lhs
    type(kim_support_status_type), intent(in) :: rhs

    kim_support_status_not_equal = .not. (lhs == rhs)
  end function kim_support_status_not_equal

  !> \brief \copybrief KIM::SupportStatus::SupportStatus(std::string const &)
  !!
  !! \sa KIM::SupportStatus::SupportStatus(std::string const &),
  !! KIM_SupportStatus_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_support_status_from_string(string, support_status)
    implicit none
    interface
      type(kim_support_status_type) recursive function from_string(string) &
        bind(c, name="KIM_SupportStatus_FromString")
        use, intrinsic :: iso_c_binding
        import kim_support_status_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_support_status_type), intent(out) :: support_status

    support_status = from_string(trim(string)//c_null_char)
  end subroutine kim_support_status_from_string

  !> \brief \copybrief KIM::SupportStatus::ToString
  !!
  !! \sa KIM::SupportStatus::ToString, KIM_SupportStatus_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_support_status_to_string(support_status, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(support_status) &
        bind(c, name="KIM_SupportStatus_ToString")
        use, intrinsic :: iso_c_binding
        import kim_support_status_type
        implicit none
        type(kim_support_status_type), intent(in), value :: support_status
      end function get_string
    end interface
    type(kim_support_status_type), intent(in) :: support_status
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(support_status)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_support_status_to_string

  !> \brief \copybrief KIM::SUPPORT_STATUS::GetNumberOfSupportStatuses
  !!
  !! \sa KIM::SUPPORT_STATUS::GetNumberOfSupportStatuses,
  !! KIM_SUPPORT_STATUS_GetNumberOfSupportStatuses
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_support_statuses( &
    number_of_support_statuses)
    implicit none
    interface
      recursive subroutine get_number_of_support_statuses( &
        number_of_support_statuses) &
        bind(c, name="KIM_SUPPORT_STATUS_GetNumberOfSupportStatuses")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_support_statuses
      end subroutine get_number_of_support_statuses
    end interface
    integer(c_int), intent(out) :: number_of_support_statuses

    call get_number_of_support_statuses(number_of_support_statuses)
  end subroutine kim_get_number_of_support_statuses

  !> \brief \copybrief KIM::SUPPORT_STATUS::GetSupportStatus
  !!
  !! \sa KIM::SUPPORT_STATUS::GetSupportStatus,
  !! KIM_SUPPORT_STATUS_GetSupportStatus
  !!
  !! \since 2.0
  recursive subroutine kim_get_support_status(index, support_status, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_support_status(index, &
                                                           support_status) &
        bind(c, name="KIM_SUPPORT_STATUS_GetSupportStatus")
        use, intrinsic :: iso_c_binding
        import kim_support_status_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_support_status_type), intent(out) :: support_status
      end function get_support_status
    end interface
    integer(c_int), intent(in) :: index
    type(kim_support_status_type), intent(out) :: support_status
    integer(c_int), intent(out) :: ierr

    ierr = get_support_status(index - 1, support_status)
  end subroutine kim_get_support_status
end module kim_support_status_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::Collections
!!
!! \sa KIM::Collections, KIM_Collections
!!
!! \since 2.1
module kim_collections_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_collections_handle_type, &

    ! Constants
    KIM_COLLECTIONS_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_collections_create, &
    kim_collections_destroy, &
    kim_get_item_type, &
    kim_get_item_library_file_name_and_collection, &
    kim_cache_list_of_item_metadata_files, &
    kim_get_item_metadata_file_length, &
    kim_get_item_metadata_file_values, &
    kim_cache_list_of_item_names_by_type, &
    kim_get_item_name_by_type, &
    kim_cache_list_of_item_names_by_collection_and_type, &
    kim_get_item_name_by_collection_and_type, &
    kim_get_item_library_file_name_by_collection_and_type, &
    kim_cache_list_of_item_metadata_files_by_collection_and_type, &
    kim_get_item_metadata_file_length_by_collection_and_type, &
    kim_get_item_metadata_file_values_by_collection_and_type, &
    kim_get_project_name_and_sem_ver, &
    kim_get_environment_variable_name, &
    kim_get_configuration_file_environment_variable, &
    kim_get_configuration_file_name, &
    kim_cache_list_of_directory_names, &
    kim_get_directory_name, &
    kim_set_log_id, &
    kim_push_log_verbosity, &
    kim_pop_log_verbosity


  !> \brief \copybrief KIM::Collections
  !!
  !! \sa KIM::Collections, KIM_Collections
  !!
  !! \since 2.1
  type, bind(c) :: kim_collections_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_collections_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.1
  type(kim_collections_handle_type), protected, save &
    :: KIM_COLLECTIONS_NULL_HANDLE

  !> \brief Compares kim_collections_handle_type's for equality.
  !!
  !! \since 2.1
  interface operator (.eq.)
    module procedure kim_collections_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_collections_handle_type's for inequality.
  !!
  !! \since 2.1
  interface operator (.ne.)
    module procedure kim_collections_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::Collections::GetItemType
  !!
  !! \sa KIM::Collections::GetItemType, KIM_Collections_GetItemType
  !!
  !! \since 2.1
  interface kim_get_item_type
    module procedure kim_collections_get_item_type
  end interface kim_get_item_type

  !> \brief \copybrief KIM::Collections::GetItemLibraryFileNameAndCollection
  !!
  !! \sa KIM::Collections::GetItemLibraryFileNameAndCollection,
  !! KIM_Collections_GetItemLibraryFileNameAndCollection
  !!
  !! \since 2.1
  interface kim_get_item_library_file_name_and_collection
    module procedure kim_collections_get_item_library_file_name_and_collection
  end interface kim_get_item_library_file_name_and_collection

  !> \brief \copybrief KIM::Collections::CacheListOfItemMetadataFiles
  !!
  !! \sa KIM::Collections::CacheListOfItemMetadataFiles,
  !! KIM_Collections_CacheListOfItemMetadataFiles
  !!
  !! \since 2.1
  interface kim_cache_list_of_item_metadata_files
    module procedure kim_collections_cache_list_of_item_metadata_files
  end interface kim_cache_list_of_item_metadata_files

  !> \brief Get item metadata file length and determine if the file is
  !! available as a string.
  !!
  !! \sa KIM::Collections::GetItemMetadataFile,
  !! KIM_Collections_GetItemMetadataFile
  !!
  !! \since 2.1
  interface kim_get_item_metadata_file_length
    module procedure kim_collections_get_item_metadata_file_length
  end interface kim_get_item_metadata_file_length

  !> \brief Get the item's metadata file values.
  !!
  !! \sa KIM::Collections::GetItemMetadataFile,
  !! KIM_Collections_GetItemMetadataFile
  !!
  !! \since 2.1
  interface kim_get_item_metadata_file_values
    module procedure kim_collections_get_item_metadata_file_values
  end interface kim_get_item_metadata_file_values

  !> \brief \copybrief KIM::Collections::CacheListOfItemNamesByType
  !!
  !! \sa KIM::Collections::CacheListOfItemNamesByType,
  !! KIM_Collections_CacheListOfItemNamesByType
  !!
  !! \since 2.1
  interface kim_cache_list_of_item_names_by_type
    module procedure kim_collections_cache_list_of_item_names_by_type
  end interface kim_cache_list_of_item_names_by_type

  !> \brief \copybrief KIM::Collections::GetItemNameByType
  !!
  !! \sa KIM::Collections::GetItemNameByType, KIM_Collections_GetItemNameByType
  !!
  !! \since 2.1
  interface kim_get_item_name_by_type
    module procedure kim_collections_get_item_name_by_type
  end interface kim_get_item_name_by_type

  !> \brief \copybrief KIM::Collections::CacheListOfItemNamesByCollectionAndType
  !!
  !! \sa KIM::Collections::CacheListOfItemNamesByCollectionAndType,
  !! KIM_Collections_CacheListOfItemNamesByCollectionAndType
  !!
  !! \since 2.1
  interface kim_cache_list_of_item_names_by_collection_and_type
    module procedure &
      kim_collections_cache_list_of_item_names_by_collection_and_type
  end interface kim_cache_list_of_item_names_by_collection_and_type

  !> \brief \copybrief KIM::Collections::GetItemNameByCollectionAndType
  !!
  !! \sa KIM::Collections::GetItemNameByCollectionAndType,
  !! KIM_Collections_GetItemNameByCollectionAndType
  !!
  !! \since 2.1
  interface kim_get_item_name_by_collection_and_type
    module procedure kim_collections_get_item_name_by_collection_and_type
  end interface kim_get_item_name_by_collection_and_type

  !> \brief \copybrief <!--
  !! -->KIM::Collections::GetItemLibraryFileNameByCollectionAndType
  !!
  !! \sa KIM::Collections::GetItemLibraryFileNameByCollectionAndType,
  !! KIM_Collections_GetItemLibraryFileNameByCollectionAndType
  !!
  !! \since 2.1
  interface kim_get_item_library_file_name_by_collection_and_type
    module procedure &
      kim_collections_get_item_library_file_name_by_coll_and_type
  end interface kim_get_item_library_file_name_by_collection_and_type

  !> \brief \copybrief <!--
  !! -->KIM::Collections::CacheListOfItemMetadataFilesByCollectionAndType
  !!
  !! \sa KIM::Collections::CacheListOfItemMetadataFilesByCollectionAndType,
  !! KIM_Collections_CacheListOfItemMetadataFilesByCollectionAndType
  !!
  !! \since 2.1
  interface kim_cache_list_of_item_metadata_files_by_collection_and_type
    module procedure &
    kim_colls_cache_list_of_item_metadata_files_by_coll_and_type
  end interface kim_cache_list_of_item_metadata_files_by_collection_and_type

  !> \brief Get item metadata file length and determine if the file is
  !! available as a string.
  !!
  !! \sa KIM::Collections::GetItemMetadataFileByCollectionAndType,
  !! KIM_Collections_GetItemMetadataFileByCollectionAndType
  !!
  !! \since 2.1
  interface kim_get_item_metadata_file_length_by_collection_and_type
    module procedure &
      kim_collections_get_item_metadata_file_length_by_coll_and_type
  end interface kim_get_item_metadata_file_length_by_collection_and_type

  !> \brief Get the item's metadata file values.
  !!
  !! \sa KIM::Collections::GetItemMetadataFileByCollectionAndType,
  !! KIM_Collections_GetItemMetadataFileByCollectionAndType
  !!
  !! \since 2.1
  interface kim_get_item_metadata_file_values_by_collection_and_type
    module procedure &
      kim_collections_get_item_metadata_file_values_by_coll_and_type
  end interface kim_get_item_metadata_file_values_by_collection_and_type

  !> \brief \copybrief KIM::Collections::GetProjectNameAndSemVer
  !!
  !! \sa KIM::Collections::GetProjectNameAndSemVer,
  !! KIM_Collections_GetProjectNameAndSemVer
  !!
  !! \since 2.1
  interface kim_get_project_name_and_sem_ver
    module procedure kim_collections_get_project_name_and_sem_ver
  end interface kim_get_project_name_and_sem_ver

  !> \brief \copybrief KIM::Collections::GetEnvironmentVariableName
  !!
  !! \sa KIM::Collections::GetEnvironmentVariableName,
  !! KIM_Collections_GetEnvironmentVariableName
  !!
  !! \since 2.1
  interface kim_get_environment_variable_name
    module procedure kim_collections_get_environment_variable_name
  end interface kim_get_environment_variable_name

  !> \brief \copybrief KIM::Collections::GetConfigurationFileEnvironmentVariable
  !!
  !! \sa KIM::Collections::GetConfigurationFileEnvironmentVariable,
  !! KIM_Collections_GetConfigurationFileEnvironmentVariable
  !!
  !! \since 2.1
  interface kim_get_configuration_file_environment_variable
    module procedure kim_collections_get_configuration_file_environment_variable
  end interface kim_get_configuration_file_environment_variable

  !> \brief \copybrief KIM::Collections::GetConfigurationFileName
  !!
  !! \sa KIM::Collections::GetConfigurationFileName,
  !! KIM_Collections_GetConfigurationFileName
  !!
  !! \since 2.1
  interface kim_get_configuration_file_name
    module procedure kim_collections_get_configuration_file_name
  end interface kim_get_configuration_file_name

  !> \brief \copybrief KIM::Collections::CacheListOfDirectoryNames
  !!
  !! \sa KIM::Collections::CacheListOfDirectoryNames,
  !! KIM_Collections_CacheListOfDirectoryNames
  !!
  !! \since 2.1
  interface kim_cache_list_of_directory_names
    module procedure kim_collections_cache_list_of_directory_names
  end interface kim_cache_list_of_directory_names

  !> \brief \copybrief KIM::Collections::GetDirectoryName
  !!
  !! \sa KIM::Collections::GetDirectoryName, KIM_Collections_GetDirectoryName
  !!
  !! \since 2.1
  interface kim_get_directory_name
    module procedure kim_collections_get_directory_name
  end interface kim_get_directory_name

  !> \brief \copybrief KIM::Collections::SetLogID
  !!
  !! \sa KIM::Collections::SetLogID, KIM_Collections_SetLogID
  !!
  !! \since 2.1
  interface kim_set_log_id
    module procedure kim_collections_set_log_id
  end interface kim_set_log_id

  !> \brief \copybrief KIM::Collections::PushLogVerbosity
  !!
  !! \sa KIM::Collections::PushLogVerbosity, KIM_Collections_PushLogVerbosity
  !!
  !! \since 2.1
  interface kim_push_log_verbosity
    module procedure kim_collections_push_log_verbosity
  end interface kim_push_log_verbosity

  !> \brief \copybrief KIM::Collections::PopLogVerbosity
  !!
  !! \sa KIM::Collections::, KIM_Collections_PopLogVerbosity
  !!
  !! \since 2.1
  interface kim_pop_log_verbosity
    module procedure kim_collections_pop_log_verbosity
  end interface kim_pop_log_verbosity

contains
  !> \brief Compares kim_collections_handle_type's for equality.
  !!
  !! \since 2.1
  logical recursive function kim_collections_handle_equal(lhs, rhs)
    implicit none
    type(kim_collections_handle_type), intent(in) :: lhs
    type(kim_collections_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_collections_handle_equal = .true.
    else
      kim_collections_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_collections_handle_equal

  !> \brief Compares kim_collections_handle_type's for inequality.
  !!
  !! \since 2.1
  logical recursive function kim_collections_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_collections_handle_type), intent(in) :: lhs
    type(kim_collections_handle_type), intent(in) :: rhs

    kim_collections_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_collections_handle_not_equal

  !> \brief \copybrief KIM::Collections::Create
  !!
  !! \sa KIM::Collections::Create, KIM_Collections_Create
  !!
  !! \since 2.1
  recursive subroutine kim_collections_create(collections_handle, ierr)
    implicit none
    interface
      integer(c_int) recursive function create(collections) &
        bind(c, name="KIM_Collections_Create")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(out) :: collections
      end function create
    end interface
    type(kim_collections_handle_type), intent(out) :: collections_handle
    integer(c_int), intent(out) :: ierr

    type(c_ptr) :: pcollections

    ierr = create(pcollections)
    collections_handle%p = pcollections
  end subroutine kim_collections_create

  !> \brief \copybrief KIM::Collections::Destroy
  !!
  !! \sa KIM::Collections::Destroy, KIM_Collections_Destroy
  !!
  !! \since 2.1
  recursive subroutine kim_collections_destroy(collections_handle)
    implicit none
    interface
      recursive subroutine destroy(collections) &
        bind(c, name="KIM_Collections_Destroy")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(inout) :: collections
      end subroutine destroy
    end interface
    type(kim_collections_handle_type), intent(inout) :: collections_handle

    type(c_ptr) :: pcollections
    pcollections = collections_handle%p
    call destroy(pcollections)
    collections_handle%p = c_null_ptr
  end subroutine kim_collections_destroy

  !> \brief \copybrief KIM::Collections::GetItemType
  !!
  !! \sa KIM::Collections::GetItemType, KIM_Collections_GetItemType
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_item_type(collections_handle, &
    item_name, item_type, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function get_item_type(collections, &
        item_name, item_type) bind(c, name="KIM_Collections_GetItemType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        character(c_char), intent(in) :: item_name(*)
        type(kim_collection_item_type_type), intent(out) :: item_type
      end function get_item_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    character(len=*, kind=c_char), intent(in) :: item_name
    type(kim_collection_item_type_type), intent(out) :: item_type
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_type(collections, trim(item_name)//c_null_char, item_type)
  end subroutine kim_collections_get_item_type

  !> \brief \copybrief KIM::Collections::GetItemLibraryFileNameAndCollection
  !!
  !! \sa KIM::Collections::GetItemLibraryFileNameAndCollection,
  !! KIM_Collections_GetItemLibraryFileNameAndCollection
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_get_item_library_file_name_and_collection( &
    collections_handle, item_type, item_name, file_name, collection, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_collection_module, only : kim_collection_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function &
        get_item_library_file_name_and_collection(collections, item_type, &
        item_name, file_name, collection) &
        bind(c, name="KIM_Collections_GetItemLibraryFileNameAndCollection")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_module, only : kim_collection_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_item_type_type), intent(in), value :: item_type
        character(c_char), intent(in) :: item_name(*)
        type(c_ptr), intent(out) :: file_name
        type(kim_collection_type), intent(out) :: collection
      end function get_item_library_file_name_and_collection
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_item_type_type), intent(in) :: item_type
    character(len=*, kind=c_char), intent(in) :: item_name
    character(len=*, kind=c_char), intent(out) :: file_name
    type(kim_collection_type), intent(out) :: collection
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) :: pfile_name

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_library_file_name_and_collection(collections, item_type, &
      trim(item_name)//c_null_char, pfile_name, collection)
    call kim_convert_c_char_ptr_to_string(pfile_name, file_name)
  end subroutine kim_collections_get_item_library_file_name_and_collection

  !> \brief \copybrief KIM::Collections::CacheListOfItemMetadataFiles
  !!
  !! \sa KIM::Collections::CacheListOfItemMetadataFiles,
  !! KIM_Collections_CacheListOfItemMetadataFiles
  !!
  !! \since 2.1
  recursive subroutine kim_collections_cache_list_of_item_metadata_files( &
    collections_handle, item_type, item_name, extent, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function cache_list_of_item_metadata_files( &
        collections, item_type, item_name, extent) &
        bind(c, name="KIM_Collections_CacheListOfItemMetadataFiles")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_item_type_type), intent(in), value :: item_type
        character(c_char), intent(in) :: item_name(*)
        integer(c_int), intent(out) :: extent
      end function cache_list_of_item_metadata_files
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_item_type_type), intent(in) :: item_type
    character(len=*, kind=c_char), intent(in) :: item_name
    integer(c_int), intent(out) :: extent
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = cache_list_of_item_metadata_files(collections, item_type, &
      trim(item_name)//c_null_char, extent)
  end subroutine kim_collections_cache_list_of_item_metadata_files

  !> \brief Get item metadata file length and determine if the file is
  !! available as a string.
  !!
  !! \sa KIM::Collections::GetItemMetadataFile,
  !! KIM_Collections_GetItemMetadataFile
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_item_metadata_file_length( &
    collections_handle, index, file_length, available_as_string, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    implicit none
    interface
      integer(c_int) recursive function get_item_metadata_file( &
        collections, index, file_name, file_length, file_raw_data, &
        available_as_string, file_string) &
        bind(c, name="KIM_Collections_GetItemMetadataFile_fortran")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: file_name
        integer(c_long), intent(out) :: file_length
        type(c_ptr), intent(out) :: file_raw_data
        integer(c_int), intent(out) :: available_as_string
        type(c_ptr), intent(out) :: file_string
      end function get_item_metadata_file
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    integer(c_long), intent(out) :: file_length
    integer(c_int), intent(out) :: available_as_string
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pfile_name, pfile_raw_data, pfile_string

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_metadata_file(collections, index-1, pfile_name, &
      file_length, pfile_raw_data, available_as_string, pfile_string)
  end subroutine kim_collections_get_item_metadata_file_length

  !> \brief Get the item's metadata file values.
  !!
  !! \sa KIM::Collections::GetItemMetadataFile,
  !! KIM_Collections_GetItemMetadataFile
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_item_metadata_file_values( &
    collections_handle, index, file_name, file_raw_data, file_string, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_item_metadata_file( &
        collections, index, file_name, file_length, file_raw_data, &
        available_as_string, file_string) &
        bind(c, name="KIM_Collections_GetItemMetadataFile_fortran")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: file_name
        integer(c_long), intent(out) :: file_length
        type(c_ptr), intent(out) :: file_raw_data
        integer(c_int), intent(out) :: available_as_string
        type(c_ptr), intent(out) :: file_string
      end function get_item_metadata_file
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: file_name
    integer(c_signed_char), intent(out) :: file_raw_data(:)
    character(len=*, kind=c_char), intent(out) :: file_string
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    integer(c_long) file_length
    integer(c_int) available_as_string
    type(c_ptr) pfile_name, pfile_raw_data, pfile_string
    integer(c_signed_char), pointer :: file_raw_data_fpointer(:)

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_metadata_file(collections, index-1, pfile_name, &
      file_length, pfile_raw_data, available_as_string, pfile_string)
    if (ierr .eq. 0) then
      if (size(file_raw_data) < file_length) then
        ierr = 1
        return
      end if
      if (available_as_string .eq. 1) then
        if (len(file_string) < file_length) then
          ierr = 1
          return
        end if
      end if

      call kim_convert_c_char_ptr_to_string(pfile_name, file_name)
      if (c_associated(pfile_raw_data)) then
        call c_f_pointer(pfile_raw_data, file_raw_data_fpointer, [file_length])
      else
        nullify(file_raw_data_fpointer)
      end if
      file_raw_data = file_raw_data_fpointer(1:file_length)

      if (available_as_string .eq. 1) then
        call kim_convert_c_char_ptr_to_string(pfile_string, file_string)
      end if
    end if
  end subroutine kim_collections_get_item_metadata_file_values

  !> \brief \copybrief KIM::Collections::CacheListOfItemNamesByType
  !!
  !! \sa KIM::Collections::CacheListOfItemNamesByType,
  !! KIM_Collections_CacheListOfItemNamesByType
  !!
  !! \since 2.1
  recursive subroutine kim_collections_cache_list_of_item_names_by_type( &
    collections_handle, item_type, extent, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function cache_list_of_item_names_by_type( &
        collections, item_type, extent) &
        bind(c, name="KIM_Collections_CacheListOfItemNamesByType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_item_type_type), intent(in), value :: item_type
        integer(c_int), intent(out) :: extent
      end function cache_list_of_item_names_by_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_item_type_type), intent(in) :: item_type
    integer(c_int), intent(out) :: extent
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = cache_list_of_item_names_by_type(collections, item_type, extent)
  end subroutine kim_collections_cache_list_of_item_names_by_type

  !> \brief \copybrief KIM::Collections::GetItemNameByType
  !!
  !! \sa KIM::Collections::GetItemNameByType, KIM_Collections_GetItemNameByType
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_item_name_by_type( &
    collections_handle, index, item_name, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_item_name_by_type(collections, &
        index, item_name) bind(c, name="KIM_Collections_GetItemNameByType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: item_name
      end function get_item_name_by_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: item_name
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pitem_name

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_name_by_type(collections, index-1, pitem_name)
    call kim_convert_c_char_ptr_to_string(pitem_name, item_name)
  end subroutine kim_collections_get_item_name_by_type

  !> \brief \copybrief KIM::Collections::CacheListOfItemNamesByCollectionAndType
  !!
  !! \sa KIM::Collections::CacheListOfItemNamesByCollectionAndType,
  !! KIM_Collections_CacheListOfItemNamesByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_cache_list_of_item_names_by_collection_and_type( &
    collections_handle, collection, item_type, extent, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_module, only : kim_collection_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function &
        cache_list_of_item_names_by_collection_and_type(collections, &
        collection, item_type, extent) &
        bind(c, name="KIM_Collections_CacheListOfItemNamesByCollectionAndType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_module, only : kim_collection_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_type), intent(in), value :: collection
        type(kim_collection_item_type_type), intent(in), value :: item_type
        integer(c_int), intent(out) :: extent
      end function cache_list_of_item_names_by_collection_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_type), intent(in) :: collection
    type(kim_collection_item_type_type), intent(in) :: item_type
    integer(c_int), intent(out) :: extent
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = cache_list_of_item_names_by_collection_and_type(collections, &
      collection, item_type, extent)
  end subroutine kim_collections_cache_list_of_item_names_by_collection_and_type

  !> \brief \copybrief KIM::Collections::GetItemNameByCollectionAndType
  !!
  !! \sa KIM::Collections::GetItemNameByCollectionAndType,
  !! KIM_Collections_GetItemNameByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_item_name_by_collection_and_type( &
    collections_handle, index, item_name, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_item_name_by_collection_and_type( &
        collections, index, item_name) &
        bind(c, name="KIM_Collections_GetItemNameByCollectionAndType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: item_name
      end function get_item_name_by_collection_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: item_name
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pitem_name

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_name_by_collection_and_type(collections, index-1, &
      pitem_name)
    call kim_convert_c_char_ptr_to_string(pitem_name, item_name)
  end subroutine kim_collections_get_item_name_by_collection_and_type

  !> \brief \copybrief <!--
  !! -->KIM::Collections::GetItemLibraryFileNameByCollectionAndType
  !!
  !! \sa KIM::Collections::GetItemLibraryFileNameByCollectionAndType,
  !! KIM_Collections_GetItemLibraryFileNameByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_get_item_library_file_name_by_coll_and_type( &
    collections_handle, collection, item_type, item_name, file_name, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_collection_module, only : kim_collection_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function &
        get_item_library_file_name_by_coll_and_type(collections, collection, &
        item_type, item_name, file_name) bind(c, &
        name="KIM_Collections_GetItemLibraryFileNameByCollectionAndType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_module, only : kim_collection_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_type), intent(in), value :: collection
        type(kim_collection_item_type_type), intent(in), value :: item_type
        character(c_char), intent(in) :: item_name(*)
        type(c_ptr), intent(out) :: file_name
      end function get_item_library_file_name_by_coll_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_type), intent(in) :: collection
    type(kim_collection_item_type_type), intent(in) :: item_type
    character(len=*, kind=c_char), intent(in) :: item_name
    character(len=*, kind=c_char), intent(out) :: file_name
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pfile_name

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_library_file_name_by_coll_and_type(collections, &
      collection, item_type, trim(item_name)//c_null_char, pfile_name)
    call kim_convert_c_char_ptr_to_string(pfile_name, file_name)
  end subroutine kim_collections_get_item_library_file_name_by_coll_and_type

  !> \brief \copybrief <!--
  !! -->KIM::Collections::CacheListOfItemMetadataFilesByCollectionAndType
  !!
  !! \sa KIM::Collections::CacheListOfItemMetadataFilesByCollectionAndType,
  !! KIM_Collections_CacheListOfItemMetadataFilesByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine &
    kim_colls_cache_list_of_item_metadata_files_by_coll_and_type( &
    collections_handle, collection, item_type, item_name, extent, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_module, only : kim_collection_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function &
        cache_list_of_item_metadata_files_by_coll_and_type(collections, &
        collection, item_type, item_name, extent) bind(c, &
        name="KIM_Collections_CacheListOfItemMetadataFilesByCollectionAndType")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_module, only : kim_collection_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_type), intent(in), value :: collection
        type(kim_collection_item_type_type), intent(in), value :: item_type
        character(c_char), intent(in) :: item_name(*)
        integer(c_int), intent(out) :: extent
      end function cache_list_of_item_metadata_files_by_coll_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_type), intent(in) :: collection
    type(kim_collection_item_type_type), intent(in) :: item_type
    character(len=*, kind=c_char), intent(in) :: item_name
    integer(c_int), intent(out) :: extent
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = cache_list_of_item_metadata_files_by_coll_and_type(collections, &
      collection, item_type, trim(item_name)//c_null_char, extent)
  end subroutine kim_colls_cache_list_of_item_metadata_files_by_coll_and_type

  !> \brief \copybrief KIM::Collections::GetItemMetadataFileByCollectionAndType
  !!
  !! \sa KIM::Collections::GetItemMetadataFileByCollectionAndType,
  !! KIM_Collections_GetItemMetadataFileByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_get_item_metadata_file_length_by_coll_and_type( &
    collections_handle, index, file_length, available_as_string, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    implicit none
    interface
      integer(c_int) recursive function &
        get_item_metadata_file_by_coll_and_type(collections, index, &
        file_name, file_length, file_raw_data, available_as_string, &
        file_string) &
        bind(c, &
        name="KIM_Collections_GetItemMetadataFileByCollectionAndType_fortran")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: file_name
        integer(c_long), intent(out) :: file_length
        type(c_ptr), intent(out) :: file_raw_data
        integer(c_int), intent(out) :: available_as_string
        type(c_ptr), intent(out) :: file_string
      end function get_item_metadata_file_by_coll_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in), value :: index
    integer(c_long), intent(out) :: file_length
    integer(c_int), intent(out) :: available_as_string
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pfile_name, pfile_raw_data, pfile_string

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_metadata_file_by_coll_and_type(collections, &
      index-1, pfile_name, file_length, pfile_raw_data, available_as_string, &
      pfile_string)
  end subroutine kim_collections_get_item_metadata_file_length_by_coll_and_type

  !> \brief Get the item's metadata file values.
  !!
  !! \sa KIM::Collections::GetItemMetadataFileByCollectionAndType,
  !! KIM_Collections_GetItemMetadataFileByCollectionAndType
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_get_item_metadata_file_values_by_coll_and_type( &
    collections_handle, index, file_name, file_raw_data, file_string, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function &
        get_item_metadata_file_by_coll_and_type(collections, index, &
        file_name, file_length, file_raw_data, available_as_string, &
        file_string) &
        bind(c, &
        name="KIM_Collections_GetItemMetadataFileByCollectionAndType_fortran")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: file_name
        integer(c_long), intent(out) :: file_length
        type(c_ptr), intent(out) :: file_raw_data
        integer(c_int), intent(out) :: available_as_string
        type(c_ptr), intent(out) :: file_string
      end function get_item_metadata_file_by_coll_and_type
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: file_name
    integer(c_signed_char), intent(out) :: file_raw_data(:)
    character(len=*, kind=c_char), intent(out) :: file_string
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    integer(c_long) file_length
    integer(c_int) available_as_string
    type(c_ptr) pfile_name, pfile_raw_data, pfile_string
    integer(c_signed_char), pointer :: file_raw_data_fpointer(:)

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_item_metadata_file_by_coll_and_type(collections, &
      index-1, pfile_name, file_length, pfile_raw_data, available_as_string, &
      pfile_string)
    if (ierr .eq. 0) then
      if (size(file_raw_data) < file_length) then
        ierr = 1
        return
      end if
      if (available_as_string .eq. 1) then
        if (len(file_string) < file_length) then
          ierr = 1
          return
        end if
      end if

      call kim_convert_c_char_ptr_to_string(pfile_name, file_name)
      if (c_associated(pfile_raw_data)) then
        call c_f_pointer(pfile_raw_data, file_raw_data_fpointer, [file_length])
      else
        nullify(file_raw_data_fpointer)
      end if
      file_raw_data = file_raw_data_fpointer(1:file_length)

      if (available_as_string .eq. 1) then
        call kim_convert_c_char_ptr_to_string(pfile_string, file_string)
      end if
    end if
  end subroutine kim_collections_get_item_metadata_file_values_by_coll_and_type

  !> \brief \copybrief KIM::Collections::GetProjectNameAndSemVer
  !!
  !! \sa KIM::Collections::GetProjectNameAndSemVer,
  !! KIM_Collections_GetProjectNameAndSemVer
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_project_name_and_sem_ver( &
    collections_handle, project_name, sem_ver)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_project_name_and_sem_ver(collections, &
        project_name, sem_ver) &
        bind(c, name="KIM_Collections_GetProjectNameAndSemVer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(c_ptr), intent(out) :: project_name
        type(c_ptr), intent(out) :: sem_ver
      end subroutine get_project_name_and_sem_ver
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    character(len=*, kind=c_char), intent(out) :: project_name
    character(len=*, kind=c_char), intent(out) :: sem_ver
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pproject_name, psem_ver

    call c_f_pointer(collections_handle%p, collections)
    call get_project_name_and_sem_ver(collections, pproject_name, psem_ver)
    call kim_convert_c_char_ptr_to_string(pproject_name, project_name)
    call kim_convert_c_char_ptr_to_string(psem_ver, sem_ver)
  end subroutine kim_collections_get_project_name_and_sem_ver

  !> \brief \copybrief KIM::Collections::GetEnvironmentVariableName
  !!
  !! \sa KIM::Collections::GetEnvironmentVariableName,
  !! KIM_Collections_GetEnvironmentVariableName
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_environment_variable_name( &
    collections_handle, item_type, name, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function get_environment_variable_name( &
        collections, item_type, name) &
        bind(c, name="KIM_Collections_GetEnvironmentVariableName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_item_type_type), intent(in), value :: item_type
        type(c_ptr), intent(out) :: name
      end function get_environment_variable_name
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_item_type_type), intent(in) :: item_type
    character(len=*, kind=c_char), intent(out) :: name
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pname

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_environment_variable_name(collections, item_type, pname)
    call kim_convert_c_char_ptr_to_string(pname, name)
  end subroutine kim_collections_get_environment_variable_name

  !> \brief \copybrief KIM::Collections::GetConfigurationFileEnvironmentVariable
  !!
  !! \sa KIM::Collections::GetConfigurationFileEnvironmentVariable,
  !! KIM_Collections_GetConfigurationFileEnvironmentVariable
  !!
  !! \since 2.1
  recursive subroutine &
    kim_collections_get_configuration_file_environment_variable( &
    collections_handle, name, value)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_configuration_file_environment_variable( &
        collections, name, value) &
        bind(c, name="KIM_Collections_GetConfigurationFileEnvironmentVariable")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(c_ptr), intent(out) :: name
        type(c_ptr), intent(out) :: value
      end subroutine get_configuration_file_environment_variable
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    character(len=*, kind=c_char), intent(out) :: name
    character(len=*, kind=c_char), intent(out) :: value
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pname, pvalue

    call c_f_pointer(collections_handle%p, collections)
    call get_configuration_file_environment_variable(collections, pname, pvalue)
    call kim_convert_c_char_ptr_to_string(pname, name)
    call kim_convert_c_char_ptr_to_string(pvalue, value)
  end subroutine kim_collections_get_configuration_file_environment_variable

  !> \brief \copybrief KIM::Collections::GetConfigurationFileName
  !!
  !! \sa KIM::Collections::GetConfigurationFileName,
  !! KIM_Collections_GetConfigurationFileName
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_configuration_file_name( &
    collections_handle, file_name)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_configuration_file_name(collections, file_name) &
        bind(c, name="KIM_Collections_GetConfigurationFileName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(c_ptr), intent(out) :: file_name
      end subroutine get_configuration_file_name
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    character(len=*, kind=c_char), intent(out) :: file_name
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pfile_name

    call c_f_pointer(collections_handle%p, collections)
    call get_configuration_file_name(collections, pfile_name)
    call kim_convert_c_char_ptr_to_string(pfile_name, file_name)
  end subroutine kim_collections_get_configuration_file_name

  !> \brief \copybrief KIM::Collections::CacheListOfDirectoryNames
  !!
  !! \sa KIM::Collections::CacheListOfDirectoryNames,
  !! KIM_Collections_CacheListOfDirectoryNames
  !!
  !! \since 2.1
  recursive subroutine kim_collections_cache_list_of_directory_names( &
    collections_handle, collection, item_type, extent, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_collection_module, only : kim_collection_type
    use kim_collection_item_type_module, only : kim_collection_item_type_type
    implicit none
    interface
      integer(c_int) recursive function cache_list_of_directory_names( &
        collections, collection, item_type, extent) &
        bind(c, name="KIM_Collections_CacheListOfDirectoryNames")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        use kim_collection_module, only : kim_collection_type
        use kim_collection_item_type_module, only : &
          kim_collection_item_type_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_collection_type), intent(in), value :: collection
        type(kim_collection_item_type_type), intent(in), value :: item_type
        integer(c_int), intent(out) :: extent
      end function cache_list_of_directory_names
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collection_type), intent(in) :: collection
    type(kim_collection_item_type_type), intent(in) :: item_type
    integer(c_int), intent(out) :: extent
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    ierr = cache_list_of_directory_names(collections, collection, item_type, &
      extent)
  end subroutine kim_collections_cache_list_of_directory_names

  !> \brief \copybrief KIM::Collections::GetDirectoryName
  !!
  !! \sa KIM::Collections::GetDirectoryName, KIM_Collections_GetDirectoryName
  !!
  !! \since 2.1
  recursive subroutine kim_collections_get_directory_name(collections_handle, &
    index, directory_name, ierr)
    use kim_interoperable_types_module, only : kim_collections_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_directory_name(collections, index, &
        directory_name) &
        bind(c, name="KIM_Collections_GetDirectoryName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: directory_name
      end function get_directory_name
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: directory_name
    integer(c_int), intent(out) :: ierr
    type(kim_collections_type), pointer :: collections

    type(c_ptr) pdirectory_name

    call c_f_pointer(collections_handle%p, collections)
    ierr = get_directory_name(collections, index-1, pdirectory_name)
    call kim_convert_c_char_ptr_to_string(pdirectory_name, directory_name)
  end subroutine kim_collections_get_directory_name

  !> \brief \copybrief KIM::Collections::SetLogID
  !!
  !! \sa KIM::Collections::SetLogID, KIM_Collections_SetLogID
  !!
  !! \since 2.1
  recursive subroutine kim_collections_set_log_id(collections_handle, log_id)
    use kim_interoperable_types_module, only : kim_collections_type
    implicit none
    interface
      recursive subroutine set_log_id(collections, log_id) &
        bind(c, name="KIM_Collections_SetLogID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        character(c_char), intent(in) :: log_id(*)
      end subroutine set_log_id
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    character(len=*, kind=c_char), intent(in) :: log_id
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    call set_log_id(collections, trim(log_id)//c_null_char)
  end subroutine kim_collections_set_log_id

  !> \brief \copybrief KIM::Collections::PushLogVerbosity
  !!
  !! \sa KIM::Collections::PushLogVerbosity, KIM_Collections_PushLogVerbosity
  !!
  !! \since 2.1
  recursive subroutine kim_collections_push_log_verbosity(collections_handle, &
    log_verbosity)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_collections_type
    implicit none
    interface
      recursive subroutine push_log_verbosity(collections, log_verbosity) &
        bind(c, name="KIM_Collections_PushLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_log_verbosity
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    call push_log_verbosity(collections, log_verbosity)
  end subroutine kim_collections_push_log_verbosity

  !> \brief \copybrief KIM::Collections::PopLogVerbosity
  !!
  !! \sa KIM::Collections::, KIM_Collections_PopLogVerbosity
  !!
  !! \since 2.1
  recursive subroutine kim_collections_pop_log_verbosity(collections_handle)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_collections_type
    implicit none
    interface
      recursive subroutine pop_log_verbosity(collections) &
        bind(c, name="KIM_Collections_PopLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_collections_type
        implicit none
        type(kim_collections_type), intent(in) :: collections
      end subroutine pop_log_verbosity
    end interface
    type(kim_collections_handle_type), intent(in) :: collections_handle
    type(kim_collections_type), pointer :: collections

    call c_f_pointer(collections_handle%p, collections)
    call pop_log_verbosity(collections)
  end subroutine kim_collections_pop_log_verbosity
end module kim_collections_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2020, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::EnergyUnit
!!
!! \sa KIM::EnergyUnit, KIM_EnergyUnit
!!
!! \since 2.0
module kim_energy_unit_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_energy_unit_type, &
    ! Constants
    KIM_ENERGY_UNIT_UNUSED, &
    KIM_ENERGY_UNIT_AMU_A2_PER_PS2, &
    KIM_ENERGY_UNIT_ERG, &
    KIM_ENERGY_UNIT_EV, &
    KIM_ENERGY_UNIT_HARTREE, &
    KIM_ENERGY_UNIT_J, &
    KIM_ENERGY_UNIT_KCAL_MOL, &
    ! Routines
    kim_known, &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_energy_units, &
    kim_get_energy_unit

  !> \brief \copybrief KIM::EnergyUnit
  !!
  !! \sa KIM::EnergyUnit, KIM_EnergyUnit
  !!
  !! \since 2.0
  type, bind(c) :: kim_energy_unit_type
    !> \brief \copybrief KIM::EnergyUnit::energyUnitID
    !!
    !! \sa KIM::EnergyUnit::energyUnitID, KIM_EnergyUnit::energyUnitID
    !!
    !! \since 2.0
    integer(c_int) energy_unit_id
  end type kim_energy_unit_type

  !> \brief \copybrief KIM::ENERGY_UNIT::unused
  !!
  !! \sa KIM::ENERGY_UNIT::unused, KIM_ENERGY_UNIT_unused
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_unused") &
    :: KIM_ENERGY_UNIT_UNUSED

  !> \brief \copybrief KIM::ENERGY_UNIT::amu_A2_per_ps2
  !!
  !! \sa KIM::ENERGY_UNIT::amu_A2_per_ps2, KIM_ENERGY_UNIT_amu_A2_per_ps2
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_amu_A2_per_ps2") &
    :: KIM_ENERGY_UNIT_AMU_A2_PER_PS2

  !> \brief \copybrief KIM::ENERGY_UNIT::erg
  !!
  !! \sa KIM::ENERGY_UNIT::erg, KIM_ENERGY_UNIT_erg
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_erg") &
    :: KIM_ENERGY_UNIT_ERG

  !> \brief \copybrief KIM::ENERGY_UNIT::eV
  !!
  !! \sa KIM::ENERGY_UNIT::eV, KIM_ENERGY_UNIT_eV
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_eV") &
    :: KIM_ENERGY_UNIT_EV

  !> \brief \copybrief KIM::ENERGY_UNIT::Hartree
  !!
  !! \sa KIM::ENERGY_UNIT::Hartree, KIM_ENERGY_UNIT_Hartree
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_Hartree") &
    :: KIM_ENERGY_UNIT_HARTREE

  !> \brief \copybrief KIM::ENERGY_UNIT::J
  !!
  !! \sa KIM::ENERGY_UNIT::J, KIM_ENERGY_UNIT_J
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_J") &
    :: KIM_ENERGY_UNIT_J

  !> \brief \copybrief KIM::ENERGY_UNIT::kcal_mol
  !!
  !! \sa KIM::ENERGY_UNIT::kcal_mol, KIM_ENERGY_UNIT_kcal_mol
  !!
  !! \since 2.0
  type(kim_energy_unit_type), protected, save, &
    bind(c, name="KIM_ENERGY_UNIT_kcal_mol") &
    :: KIM_ENERGY_UNIT_KCAL_MOL

  !> \brief \copybrief KIM::EnergyUnit::Known
  !!
  !! \sa KIM::EnergyUnit::Known, KIM_EnergyUnit_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_energy_unit_known
  end interface kim_known

  !> \brief \copybrief KIM::EnergyUnit::operator==()
  !!
  !! \sa KIM::EnergyUnit::operator==(), KIM_EnergyUnit_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_energy_unit_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::EnergyUnit::operator!=()
  !!
  !! \sa KIM::EnergyUnit::operator!=(), KIM_EnergyUnit_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_energy_unit_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::EnergyUnit::EnergyUnit(std::string const &)
  !!
  !! \sa KIM::EnergyUnit::EnergyUnit(std::string const &),
  !! KIM_EnergyUnit_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_energy_unit_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::EnergyUnit::ToString
  !!
  !! \sa KIM::EnergyUnit::ToString, KIM_EnergyUnit_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_energy_unit_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::EnergyUnit::Known
  !!
  !! \sa KIM::EnergyUnit::Known, KIM_EnergyUnit_Known
  !!
  !! \since 2.0
  logical recursive function kim_energy_unit_known(energy_unit)
    implicit none
    interface
      integer(c_int) recursive function known(energy_unit) &
        bind(c, name="KIM_EnergyUnit_Known")
        use, intrinsic :: iso_c_binding
        import kim_energy_unit_type
        implicit none
        type(kim_energy_unit_type), intent(in), value :: energy_unit
      end function known
    end interface
    type(kim_energy_unit_type), intent(in) :: energy_unit

    kim_energy_unit_known = (known(energy_unit) /= 0)
  end function kim_energy_unit_known

  !> \brief \copybrief KIM::EnergyUnit::operator==()
  !!
  !! \sa KIM::EnergyUnit::operator==(), KIM_EnergyUnit_Equal
  !!
  !! \since 2.0
  logical recursive function kim_energy_unit_equal(lhs, rhs)
    implicit none
    type(kim_energy_unit_type), intent(in) :: lhs
    type(kim_energy_unit_type), intent(in) :: rhs

    kim_energy_unit_equal &
      = (lhs%energy_unit_id == rhs%energy_unit_id)
  end function kim_energy_unit_equal

  !> \brief \copybrief KIM::EnergyUnit::operator!=()
  !!
  !! \sa KIM::EnergyUnit::operator!=(), KIM_EnergyUnit_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_energy_unit_not_equal(lhs, rhs)
    implicit none
    type(kim_energy_unit_type), intent(in) :: lhs
    type(kim_energy_unit_type), intent(in) :: rhs

    kim_energy_unit_not_equal = .not. (lhs == rhs)
  end function kim_energy_unit_not_equal

  !> \brief \copybrief KIM::EnergyUnit::EnergyUnit(std::string const &)
  !!
  !! \sa KIM::EnergyUnit::EnergyUnit(std::string const &),
  !! KIM_EnergyUnit_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_energy_unit_from_string(string, energy_unit)
    implicit none
    interface
      type(kim_energy_unit_type) recursive function from_string(string) &
        bind(c, name="KIM_EnergyUnit_FromString")
        use, intrinsic :: iso_c_binding
        import kim_energy_unit_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_energy_unit_type), intent(out) :: energy_unit

    energy_unit = from_string(trim(string)//c_null_char)
  end subroutine kim_energy_unit_from_string

  !> \brief \copybrief KIM::EnergyUnit::ToString
  !!
  !! \sa KIM::EnergyUnit::ToString, KIM_EnergyUnit_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_energy_unit_to_string(energy_unit, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(energy_unit) &
        bind(c, name="KIM_EnergyUnit_ToString")
        use, intrinsic :: iso_c_binding
        import kim_energy_unit_type
        implicit none
        type(kim_energy_unit_type), intent(in), value :: energy_unit
      end function get_string
    end interface
    type(kim_energy_unit_type), intent(in) :: energy_unit
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(energy_unit)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_energy_unit_to_string

  !> \brief \copybrief KIM::ENERGY_UNIT::GetNumberOfEnergyUnits
  !!
  !! \sa KIM::ENERGY_UNIT::GetNumberOfEnergyUnits,
  !! KIM_ENERGY_UNIT_GetNumberOfEnergyUnits
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_energy_units(number_of_energy_units)
    implicit none
    interface
      recursive subroutine get_number_of_energy_units(number_of_energy_units) &
        bind(c, name="KIM_ENERGY_UNIT_GetNumberOfEnergyUnits")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_energy_units
      end subroutine get_number_of_energy_units
    end interface
    integer(c_int), intent(out) :: number_of_energy_units

    call get_number_of_energy_units(number_of_energy_units)
  end subroutine kim_get_number_of_energy_units

  !> \brief \copybrief KIM::ENERGY_UNIT::GetEnergyUnit
  !!
  !! \sa KIM::ENERGY_UNIT::GetEnergyUnit, KIM_ENERGY_UNIT_GetEnergyUnit
  !!
  !! \since 2.0
  recursive subroutine kim_get_energy_unit(index, energy_unit, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_energy_unit(index, energy_unit) &
        bind(c, name="KIM_ENERGY_UNIT_GetEnergyUnit")
        use, intrinsic :: iso_c_binding
        import kim_energy_unit_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_energy_unit_type), intent(out) :: energy_unit
      end function get_energy_unit
    end interface
    integer(c_int), intent(in) :: index
    type(kim_energy_unit_type), intent(out) :: energy_unit
    integer(c_int), intent(out) :: ierr

    ierr = get_energy_unit(index - 1, energy_unit)
  end subroutine kim_get_energy_unit
end module kim_energy_unit_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

module error
  use, intrinsic :: iso_c_binding
  implicit none

  public

contains
  recursive subroutine my_error(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Error : ", trim(message)
    stop 1
  end subroutine my_error

  recursive subroutine my_warning(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Warning : ", trim(message)
  end subroutine my_warning
end module error

!-------------------------------------------------------------------------------
!
! Main program
!
!-------------------------------------------------------------------------------
program collections_example_fortran
  use, intrinsic :: iso_c_binding
  use error
  use kim_simulator_headers_module
  implicit none
  interface
    integer(c_int) function c_system(cmd) bind(c, name="system")
      use, intrinsic :: iso_c_binding
      character(c_char), intent(in) :: cmd(*)
    end function c_system
  end interface

  integer(c_int) :: ierr
  integer(c_int) :: extent
  integer(c_int) :: no_fields
  integer(c_int) :: i
  integer(c_int) :: j
  type(kim_simulator_model_handle_type) :: sm

  character(len=2048, kind=c_char) s_name
  character(len=2048, kind=c_char) s_ver
  character(len=2048, kind=c_char) species
  character(len=2048, kind=c_char) field_name
  character(len=2048, kind=c_char) line
  character(len=2048, kind=c_char) dir_name
  character(len=2048, kind=c_char) spec_name
  character(len=2048, kind=c_char) param_basename

  call kim_simulator_model_create( &
    "Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu", sm, ierr)

  if (ierr /= 0) then
    call my_error("Can't create SM.")
  end if

  call kim_get_simulator_name_and_version(sm, s_name, s_ver)
  print *, "Simulator name    : ", trim(s_name)
  print *, "Simulator version : ", trim(s_ver)
  print *, ""

  call kim_get_number_of_supported_species(sm, extent)
  print *, "SM supports", extent, " species:"
  do i = 1, extent
    call kim_get_supported_species(sm, i, species, ierr)
    if (ierr /= 0) then
      call my_error("Unable to get species.")
    else
      print '(A,I2," ",A)', achar(9), i, trim(species)
    end if
  end do
  print *, ""

  call kim_add_template_map(sm, "atom-type-sym-list", "Pb Pb Au Pb", ierr)
  if (ierr /= 0) then
    call my_error("Unable to add template map.")
  end if
  call kim_close_template_map(sm)
  call kim_get_number_of_simulator_fields(sm, no_fields)
  print '("SM has ",I2," fields :")', no_fields
  do i = 1, no_fields
    call kim_get_simulator_field_metadata(sm, i, extent, field_name, ierr)
    print '("  Field",I2," is ",A," and has ",I2," lines:")', &
      i, trim(field_name), extent

    do j = 1, extent
      call kim_get_simulator_field_line(sm, i, j, line, ierr)
      if (ierr /= 0) then
        call my_error("Unable to get field line.")
      else
        print '(A,A)', achar(9), trim(line)
      end if
    end do
  end do
  print *, ""

  call kim_get_parameter_file_directory_name(sm, dir_name)
  print '("SM param dir name is ",A)', trim(dir_name)

  call kim_get_specification_file_name(sm, spec_name)
  print '("SM spec file name is ",A)', trim(spec_name)
  ierr = c_system("cat "//trim(dir_name)//"/"//trim(spec_name)//c_null_char)

  call kim_get_number_of_parameter_files(sm, extent)
  print '("SM has ",I1," parameter files:")', extent
  do i = 1, extent
    call kim_get_parameter_file_basename(sm, i, param_basename, ierr)
    if (ierr /= 0) then
      call my_error("Unable to get parameter file basename.")
    else
      print '("Parameter file ",I2," has basename ",A)', i, trim(param_basename)
      ierr = c_system( &
             "cat "//trim(dir_name)//"/"//trim(param_basename)//c_null_char)
      print *, ""
    end if
  end do

  call kim_simulator_model_destroy(sm)

end program collections_example_fortran

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelComputeArgumentsCreate
!!
!! \sa KIM::ModelComputeArgumentsCreate,
!! KIM_ModelComputeArgumentsCreate
!!
!! \since 2.0
module kim_model_compute_arguments_create_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_compute_arguments_create_handle_type, &

    ! Constants
    KIM_MODEL_COMPUTE_ARGUMENTS_CREATE_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_set_argument_support_status, &
    kim_set_callback_support_status, &
    kim_set_model_buffer_pointer, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelComputeArgumentsCreate
  !!
  !! \sa KIM::ModelComputeArgumentsCreate,
  !! KIM_ModelComputeArgumentsCreate
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_compute_arguments_create_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_compute_arguments_create_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_compute_arguments_create_handle_type), protected, save &
    :: KIM_MODEL_COMPUTE_ARGUMENTS_CREATE_NULL_HANDLE

  !> \brief Compares kim_model_compute_arguments_create_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_compute_arguments_create_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_compute_arguments_create_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_compute_arguments_create_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::<!--
  !! -->SetArgumentSupportStatus
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetArgumentSupportStatus,
  !! KIM_ModelComputeArgumentsCreate_SetArgumentSupportStatus
  !!
  !! \since 2.0
  interface kim_set_argument_support_status
    module procedure &
      kim_model_compute_arguments_create_set_argument_support_status
  end interface kim_set_argument_support_status

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::<!--
  !! -->SetCallbackSupportStatus
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetCallbackSupportStatus,
  !! KIM_ModelComputeArgumentsCreate_SetCallbackSupportStatus
  !!
  !! \since 2.0
  interface kim_set_callback_support_status
    module procedure &
      kim_model_compute_arguments_create_set_callback_support_status
  end interface kim_set_callback_support_status

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::SetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetModelBufferPointer,
  !! KIM_ModelComputeArgumentsCreate_SetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_set_model_buffer_pointer
    module procedure kim_model_compute_arguments_create_set_model_buffer_pointer
  end interface kim_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::LogEntry
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::LogEntry,
  !! KIM_ModelComputeArgumentsCreate_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_compute_arguments_create_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::ToString
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::ToString,
  !! KIM_ModelComputeArgumentsCreate_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_compute_arguments_create_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_compute_arguments_create_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_compute_arguments_create_handle_equal( &
    lhs, rhs)
    implicit none
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: lhs
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_compute_arguments_create_handle_equal = .true.
    else
      kim_model_compute_arguments_create_handle_equal = c_associated(lhs%p, &
        rhs%p)
    end if
  end function kim_model_compute_arguments_create_handle_equal

  !> \brief Compares kim_model_compute_arguments_create_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  logical recursive function &
    kim_model_compute_arguments_create_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: lhs
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: rhs

    kim_model_compute_arguments_create_handle_not_equal = &
      .not. (lhs .eq. rhs)
  end function kim_model_compute_arguments_create_handle_not_equal

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::<!--
  !! -->SetArgumentSupportStatus
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetArgumentSupportStatus,
  !! KIM_ModelComputeArgumentsCreate_SetArgumentSupportStatus
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_create_set_argument_support_status( &
    model_commpute_arguments_create_handle, compute_argument_name, &
    support_status, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_support_status_module, only : kim_support_status_type
    use kim_interoperable_types_module, only : &
      kim_model_compute_arguments_create_type
    implicit none
    interface
      integer(c_int) recursive function set_argument_support_status( &
        model_commpute_arguments_create, compute_argument_name, &
        support_status) &
        bind(c, name="KIM_ModelComputeArgumentsCreate_SetArgumentSupportStatus")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_support_status_module, only : kim_support_status_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_create_type
        implicit none
        type(kim_model_compute_arguments_create_type), intent(in) :: &
          model_commpute_arguments_create
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(kim_support_status_type), intent(in), value :: support_status
      end function set_argument_support_status
    end interface
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_commpute_arguments_create_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    type(kim_support_status_type), intent(in) :: support_status
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_create_type), pointer :: &
      model_commpute_arguments_create

    call c_f_pointer(model_commpute_arguments_create_handle%p, &
      model_commpute_arguments_create)
    ierr = set_argument_support_status(model_commpute_arguments_create, &
      compute_argument_name, support_status)
  end subroutine kim_model_compute_arguments_create_set_argument_support_status

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::<!--
  !! -->SetCallbackSupportStatus
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetCallbackSupportStatus,
  !! KIM_ModelComputeArgumentsCreate_SetCallbackSupportStatus
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_create_set_callback_support_status( &
    model_commpute_arguments_create_handle, compute_callback_name, &
    support_status, ierr)
    use kim_compute_callback_name_module, only : kim_compute_callback_name_type
    use kim_support_status_module, only : kim_support_status_type
    use kim_interoperable_types_module, only : &
      kim_model_compute_arguments_create_type
    implicit none
    interface
      integer(c_int) recursive function set_callback_support_status( &
        model_commpute_arguments_create, compute_callback_name, &
        support_status) &
        bind(c, name="KIM_ModelComputeArgumentsCreate_SetCallbackSupportStatus")
        use, intrinsic :: iso_c_binding
        use kim_compute_callback_name_module, only : &
          kim_compute_callback_name_type
        use kim_support_status_module, only : kim_support_status_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_create_type
        implicit none
        type(kim_model_compute_arguments_create_type), intent(in) :: &
          model_commpute_arguments_create
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
        type(kim_support_status_type), intent(in), value :: support_status
      end function set_callback_support_status
    end interface
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_commpute_arguments_create_handle
    type(kim_compute_callback_name_type), intent(in) :: &
      compute_callback_name
    type(kim_support_status_type), intent(in) :: support_status
    integer(c_int), intent(out) :: ierr
    type(kim_model_compute_arguments_create_type), pointer :: &
      model_commpute_arguments_create

    call c_f_pointer(model_commpute_arguments_create_handle%p, &
      model_commpute_arguments_create)
    ierr = set_callback_support_status(model_commpute_arguments_create, &
      compute_callback_name, support_status)
  end subroutine kim_model_compute_arguments_create_set_callback_support_status

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::SetModelBufferPointer
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::SetModelBufferPointer,
  !! KIM_ModelComputeArgumentsCreate_SetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_compute_arguments_create_set_model_buffer_pointer( &
    model_commpute_arguments_create_handle, ptr)
    use kim_interoperable_types_module, only : &
      kim_model_compute_arguments_create_type
    implicit none
    interface
      recursive subroutine set_model_buffer_pointer( &
        model_commpute_arguments_create, ptr) bind(c, &
        name="KIM_ModelComputeArgumentsCreate_SetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_create_type
        implicit none
        type(kim_model_compute_arguments_create_type), intent(in) :: &
          model_commpute_arguments_create
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_model_buffer_pointer
    end interface
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_commpute_arguments_create_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_model_compute_arguments_create_type), pointer :: &
      model_commpute_arguments_create

    call c_f_pointer(model_commpute_arguments_create_handle%p, &
      model_commpute_arguments_create)
    call set_model_buffer_pointer(model_commpute_arguments_create, ptr)
  end subroutine kim_model_compute_arguments_create_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::LogEntry
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::LogEntry,
  !! KIM_ModelComputeArgumentsCreate_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_create_log_entry( &
    model_commpute_arguments_create_handle, log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : &
      kim_model_compute_arguments_create_type
    implicit none
    interface
      recursive subroutine log_entry(model_commpute_arguments_create, &
        log_verbosity, message, line_number, file_name) &
        bind(c, name="KIM_ModelComputeArgumentsCreate_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_create_type
        implicit none
        type(kim_model_compute_arguments_create_type), intent(in) :: &
          model_commpute_arguments_create
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_commpute_arguments_create_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_compute_arguments_create_type), pointer :: &
      model_commpute_arguments_create

    call c_f_pointer(model_commpute_arguments_create_handle%p, &
      model_commpute_arguments_create)
    call log_entry(model_commpute_arguments_create, log_verbosity, &
      trim(message)//c_null_char, 0, ""//c_null_char)
  end subroutine kim_model_compute_arguments_create_log_entry

  !> \brief \copybrief KIM::ModelComputeArgumentsCreate::ToString
  !!
  !! \sa KIM::ModelComputeArgumentsCreate::ToString,
  !! KIM_ModelComputeArgumentsCreate_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_create_to_string( &
    model_commpute_arguments_create_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : &
      kim_model_compute_arguments_create_type
    implicit none
    interface
      type(c_ptr) recursive function model_commpute_arguments_create_string( &
        model_commpute_arguments_create) &
        bind(c, name="KIM_ModelComputeArgumentsCreate_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_compute_arguments_create_type
        implicit none
        type(kim_model_compute_arguments_create_type), intent(in) :: &
          model_commpute_arguments_create
      end function model_commpute_arguments_create_string
    end interface
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_commpute_arguments_create_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_compute_arguments_create_type), pointer :: &
      model_commpute_arguments_create

    type(c_ptr) :: p

    call c_f_pointer(model_commpute_arguments_create_handle%p, &
      model_commpute_arguments_create)
    p = model_commpute_arguments_create_string(model_commpute_arguments_create)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_compute_arguments_create_to_string
end module kim_model_compute_arguments_create_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ellad B. Tadmor
!    Ryan S. Elliott
!    Stephen M. Whalen
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

module error
  use, intrinsic :: iso_c_binding
  implicit none
  public

contains
  recursive subroutine my_error(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Error : ", trim(message)
    stop
  end subroutine my_error

  recursive subroutine my_warning(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Warning : ", trim(message)
  end subroutine my_warning
end module error

!-------------------------------------------------------------------------------
!
! module mod_neighborlist :
!
!    Module contains type and routines related to neighbor list calculation
!
!-------------------------------------------------------------------------------

module mod_neighborlist

  use, intrinsic :: iso_c_binding

  public get_neigh

  type, bind(c) :: neighObject_type
    real(c_double) :: cutoff
    integer(c_int) :: number_of_particles
    type(c_ptr) :: neighbor_list_pointer
  end type neighObject_type
contains

!-------------------------------------------------------------------------------
!
! get_neigh neighbor list access function
!
! This function implements Locator and Iterator mode
!
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
!
! get_neigh neighbor list access function
!
! This function implements Locator and Iterator mode
!
!-------------------------------------------------------------------------------
  recursive subroutine get_neigh(data_object, number_of_neighbor_lists, &
                                 cutoffs, neighbor_list_index, request, &
                                 numnei, pnei1part, ierr) bind(c)
    use error
    implicit none

    !-- Transferred variables
    type(c_ptr), value, intent(in) :: data_object
    integer(c_int), value, intent(in) :: number_of_neighbor_lists
    real(c_double), intent(in) :: cutoffs(*)
    integer(c_int), value, intent(in) :: neighbor_list_index
    integer(c_int), value, intent(in)  :: request
    integer(c_int), intent(out) :: numnei
    type(c_ptr), intent(out) :: pnei1part
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    integer(c_int) numberOfParticles
    type(neighObject_type), pointer :: neighObject
    integer(c_int), pointer :: neighborList(:, :)

    if (number_of_neighbor_lists > 1) then
      call my_warning("Model requires too many neighbor lists")
      ierr = 1
      return
    end if

    call c_f_pointer(data_object, neighObject)
    numberOfParticles = neighObject%number_of_particles
    call c_f_pointer(neighObject%neighbor_list_pointer, neighborList, &
                     [numberOfParticles + 1, numberOfParticles])

    if (cutoffs(neighbor_list_index) > neighObject%cutoff) then
      call my_warning("neighbor list cutoff too small for model cutoff")
      ierr = 1
      return
    end if

    if ((request > numberOfParticles) .or. (request < 1)) then
      print *, request
      call my_warning("Invalid part ID in get_neigh")
      ierr = 1
      return
    end if

    ! set the returned number of neighbors for the returned part
    numnei = neighborList(1, request)

    ! set the location for the returned neighbor list
    pnei1part = c_loc(neighborList(2, request))

    ierr = 0
    return
  end subroutine get_neigh

end module mod_neighborlist

module mod_utilities
  use kim_simulator_headers_module
  implicit none
  public

contains

!-------------------------------------------------------------------------------
!
!  Check if we are compatible with the model
!
!-------------------------------------------------------------------------------
  recursive subroutine check_model_compatibility( &
    compute_arguments_handle, forces_optional, particle_energy_supported, &
    particle_energy_optional, model_is_compatible, ierr)
    use, intrinsic :: iso_c_binding
    use error
    implicit none

    !-- Transferred variables
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    logical, intent(out) :: forces_optional
    logical, intent(out) :: particle_energy_supported
    logical, intent(out) :: particle_energy_optional
    logical, intent(out) :: model_is_compatible
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    integer(c_int) i
    integer(c_int) number_of_argument_names
    integer(c_int) number_of_callback_names
    type(kim_compute_argument_name_type) argument_name
    type(kim_support_status_type) support_status
    type(kim_compute_callback_name_type) callback_name

    ! assume fail
    model_is_compatible = .false.
    particle_energy_supported = .false.
    particle_energy_optional = .false.
    forces_optional = .false.
    ierr = 0

    ! check arguments
    call kim_get_number_of_compute_argument_names( &
      number_of_argument_names)
    do i = 1, number_of_argument_names
      call kim_get_compute_argument_name(i, argument_name, &
                                         ierr)
      if (ierr /= 0) then
        call my_warning("can't get argument name")
        return
      end if
      call kim_get_argument_support_status( &
        compute_arguments_handle, argument_name, support_status, ierr)
      if (ierr /= 0) then
        call my_warning("can't get argument support_status")
        return
      end if

      ! can only handle energy, particle_energy and forces as required args
      if (support_status == KIM_SUPPORT_STATUS_REQUIRED) then
        if (.not. ( &
            (argument_name == KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY) .or. &
            (argument_name == &
             KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY) .or. &
            (argument_name == KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES))) then
          call my_warning("unsupported required argument")
          ierr = 0
          return
        end if
      end if

      ! need both energy and forces not "notSupported"
      if ((argument_name == KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY) .and. &
          (support_status == KIM_SUPPORT_STATUS_NOT_SUPPORTED)) then
        call my_warning("model does not support energy")
        ierr = 0
        return
      end if
      if (argument_name == KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES) then
        if (support_status == KIM_SUPPORT_STATUS_NOT_SUPPORTED) then
          call my_warning("model does not support forces")
          ierr = 0
          return
        else if (support_status == KIM_SUPPORT_STATUS_REQUIRED) then
          forces_optional = .false.
        else if (support_status == KIM_SUPPORT_STATUS_OPTIONAL) then
          forces_optional = .true.
        else
          call my_warning("unknown support_status for forces")
          ierr = 0
          return
        end if
      end if

      ! check support for particle_energy
      if (argument_name == &
          KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY) then
        if (support_status == KIM_SUPPORT_STATUS_NOT_SUPPORTED) then
          call my_warning("model does not support partial_particle_energy.  &
            &The associated checks will be disabled.")
          particle_energy_supported = .false.
          particle_energy_optional = .false.
        else if (support_status == KIM_SUPPORT_STATUS_REQUIRED) then
          particle_energy_supported = .true.
          particle_energy_optional = .false.
        else if (support_status == KIM_SUPPORT_STATUS_OPTIONAL) then
          particle_energy_supported = .true.
          particle_energy_optional = .true.
        else
          call my_warning("unknown support_status for particle energy")
          ierr = 0
          return
        end if
      end if
    end do

    ! check call backs
    call kim_get_number_of_compute_callback_names( &
      number_of_callback_names)
    do i = 1, number_of_callback_names
      call kim_get_compute_callback_name(i, callback_name, &
                                         ierr)
      if (ierr /= 0) then
        call my_warning("can't get call back name")
        return
      end if
      call kim_get_callback_support_status( &
        compute_arguments_handle, callback_name, support_status, ierr)
      if (ierr /= 0) then
        call my_warning("can't get call back support_status")
        return
      end if

      ! cannot handle any "required" call backs
      if (support_status == KIM_SUPPORT_STATUS_REQUIRED) then
        call my_warning("unsupported required call back")
        ierr = 0
        return
      end if
    end do

    ! got to here, then everything must be OK
    model_is_compatible = .true.
    ierr = 0
    return
  end subroutine Check_Model_Compatibility

  !-----------------------------------------------------------------------------
  !
  !  Get number and identities of particle species supported by
  !  KIM Model `modelname'
  !
  !-----------------------------------------------------------------------------
  recursive subroutine Get_Model_Supported_Species( &
    model_handle, max_species, model_species, num_species, ier)
    use, intrinsic :: iso_c_binding
    implicit none

    !-- Transferred variables
    type(kim_model_handle_type), intent(in)   :: model_handle
    integer(c_int), intent(in)   :: max_species
    type(kim_species_name_type), intent(out) :: model_species(max_species)
    integer(c_int), intent(out)  :: num_species
    integer(c_int), intent(out)  :: ier

    !-- Local variables
    integer(c_int) i
    integer(c_int) total_num_species
    type(kim_species_name_type) :: species_name
    integer(c_int) species_is_supported
    integer(c_int) code

    ! Initialize error flag
    ier = 1

    num_species = 0 ! initialize

    call kim_get_number_of_species_names(total_num_species)

    if (total_num_species > max_species) return

    num_species = 0
    do i = 1, total_num_species
      call kim_get_species_name(i, species_name, ier)
      call kim_get_species_support_and_code(model_handle, species_name, &
                                            species_is_supported, code, ier)
      if ((ier == 0) .and. (species_is_supported /= 0)) then
        num_species = num_species + 1
        model_species(num_species) = species_name
      end if
    end do

    ier = 0
    return

  end subroutine Get_Model_Supported_Species

  recursive subroutine update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                                           do_update_list, coordsave, &
                                           neighObject, ierr)
    use, intrinsic :: iso_c_binding
    use mod_neighborlist
    implicit none
    integer(c_int), parameter :: cd = c_double ! used for literal constants

    !-- Transferred variables
    integer(c_int), intent(in)    :: DIM
    integer(c_int), intent(in)    :: N
    real(c_double), intent(in)    :: coords(DIM, N)
    real(c_double), intent(in)    :: cutoff
    real(c_double), intent(in)    :: cutpad
    logical, intent(inout) :: do_update_list
    real(c_double), intent(inout) :: coordsave(DIM, N)
    type(neighObject_type), intent(inout) :: neighObject
    integer(c_int), intent(out)   :: ierr

    !-- Local variables
    real(c_double) disp, disp1, disp2, cutrange, dispvec(DIM)
    integer(c_int) i

    ! Initialize error code
    !
    ierr = 0

    ! Update neighbor lists if necessary
    !
    if (.not. do_update_list) then   ! if update not requested

      ! check whether a neighbor list update is necessary even if it hasn't been
      ! requested using the "two max sum" criterion
      disp1 = 0.0_cd
      disp2 = 0.0_cd
      do i = 1, N
        dispvec(1:DIM) = coords(1:DIM, i) - coordsave(1:DIM, i)
        disp = sqrt(dot_product(dispvec, dispvec))
        if (disp >= disp1) then        !  1st position taken
          disp2 = disp1               !  push current 1st into 2nd place
          disp1 = disp                !  and put this one into current 1st
        else if (disp >= disp2) then   !  2nd position taken
          disp2 = disp
        end if
      end do
      do_update_list = (disp1 + disp2 > cutpad)

    end if

    if (do_update_list) then

      ! save current coordinates
      coordsave(1:DIM, 1:N) = coords(1:DIM, 1:N)

      ! compute neighbor lists
      cutrange = cutoff + cutpad
      call NEIGH_PURE_cluster_neighborlist(.false., N, coords, cutrange, &
                                           neighObject)

      ! neighbor list uptodate, no need to compute again for now
      do_update_list = .false.
    end if

    return

  end subroutine update_neighborlist

  !-----------------------------------------------------------------------------
  !
  ! NEIGH_PURE_cluster_neighborlist
  !
  !-----------------------------------------------------------------------------
  recursive subroutine NEIGH_PURE_cluster_neighborlist( &
    half, numberOfParticles, coords, cutoff, neighObject)
    use, intrinsic :: iso_c_binding
    use mod_neighborlist
    implicit none

    !-- Transferred variables
    logical, intent(in)            :: half
    integer(c_int), intent(in)            :: numberOfParticles
    real(c_double), dimension(3, numberOfParticles), &
      intent(in)            :: coords
    real(c_double), intent(in)            :: cutoff
    type(neighObject_type), intent(inout) :: neighObject

    !-- Local variables
    integer(c_int), pointer :: neighborList(:, :)
    integer(c_int) i, j, a
    real(c_double) dx(3)
    real(c_double) r2
    real(c_double) cutoff2

    call c_f_pointer(neighObject%neighbor_list_pointer, neighborList, &
                     [numberOfParticles + 1, numberOfParticles])

    neighObject%cutoff = cutoff

    cutoff2 = cutoff**2

    do i = 1, numberOfParticles
      a = 1
      do j = 1, numberOfParticles
        dx(:) = coords(:, j) - coords(:, i)
        r2 = dot_product(dx, dx)
        if (r2 <= cutoff2) then
          ! part j is a neighbor of part i
          if ((j > i) .OR. ((.not. half) .AND. (i /= j))) then
            a = a + 1
            neighborList(a, i) = j
          end if
        end if
      end do
      ! part i has a-1 neighbors
      neighborList(1, i) = a - 1
    end do

    return

  end subroutine NEIGH_PURE_cluster_neighborlist

  !-----------------------------------------------------------------------------
  !
  ! create_FCC_configuration subroutine
  !
  !  creates a cubic configuration of FCC particles with lattice spacing
  !  `FCCspacing' and `nCellsPerSide' cells along each direction.
  !
  !  With periodic==.true. this will result in a total number of particles equal
  !  to 4*(nCellsPerSide)**3 + 6*(nCellsPerSide)**2 + 3*(nCellsPerSide) + 1
  !
  !  With periodic==.false. this will result in a total number of particles equal
  !  to 4*(nCellsPerSide)**3
  !
  !  Returns the Id of the particle situated in the middle of the configuration
  !  (this particle will have the most neighbors.)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine create_FCC_configuration(FCCspacing, nCellsPerSide, &
                                                periodic, coords, MiddlePartId)
    use, intrinsic :: iso_c_binding
    implicit none
    integer(c_int), parameter :: cd = c_double ! used for literal constants

    !-- Transferred variables
    real(c_double), intent(in)  :: FCCspacing
    integer(c_int), intent(in)  :: nCellsPerSide
    logical, intent(in)  :: periodic
    real(c_double), intent(out) :: coords(3, *)
    integer(c_int), intent(out) :: MiddlePartId
    !
    ! cluster setup variables
    !
    real(c_double) FCCshifts(3, 4)
    real(c_double) latVec(3)
    integer(c_int) a, i, j, k, m

    ! Create a cubic FCC cluster
    !
    FCCshifts(1, 1) = 0.0_cd
    FCCshifts(2, 1) = 0.0_cd
    FCCshifts(3, 1) = 0.0_cd
    FCCshifts(1, 2) = 0.5_cd * FCCspacing
    FCCshifts(2, 2) = 0.5_cd * FCCspacing
    FCCshifts(3, 2) = 0.0_cd
    FCCshifts(1, 3) = 0.5_cd * FCCspacing
    FCCshifts(2, 3) = 0.0_cd
    FCCshifts(3, 3) = 0.5_cd * FCCspacing
    FCCshifts(1, 4) = 0.0_cd
    FCCshifts(2, 4) = 0.5_cd * FCCspacing
    FCCshifts(3, 4) = 0.5_cd * FCCspacing

    MiddlePartID = 1 ! Always put middle particle as #1
    a = 1            ! leave space for middle particle as particle #1
    do i = 1, nCellsPerSide
      latVec(1) = (i - 1) * FCCspacing
      do j = 1, nCellsPerSide
        latVec(2) = (j - 1) * FCCspacing
        do k = 1, nCellsPerSide
          latVec(3) = (k - 1) * FCCspacing
          do m = 1, 4
            a = a + 1
            coords(:, a) = latVec + FCCshifts(:, m)
            if ((i == nCellsPerside / 2 + 1) &
                .and. (j == nCellsPerSide / 2 + 1) &
                .and. (k == nCellsPerSide / 2 + 1) &
                .and. (m == 1)) &
              then
              ! put middle particle as #1
              coords(:, 1) = latVec + FCCshifts(:, m)
              a = a - 1
            end if
          end do
        end do
        if (.not. periodic) then
          ! Add in the remaining three faces
          ! pos-x face
          latVec(1) = nCellsPerSide * FCCspacing
          latVec(2) = (i - 1) * FCCspacing
          latVec(3) = (j - 1) * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 4)
          ! pos-y face
          latVec(1) = (i - 1) * FCCspacing
          latVec(2) = nCellsPerSide * FCCspacing
          latVec(3) = (j - 1) * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 3)
          ! pos-z face
          latVec(1) = (i - 1) * FCCspacing
          latVec(2) = (j - 1) * FCCspacing
          latVec(3) = nCellsPerSide * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 2)
        end if
      end do
      if (.not. periodic) then
        ! Add in the remaining three edges
        latVec(1) = (i - 1) * FCCspacing
        latVec(2) = nCellsPerSide * FCCspacing
        latVec(3) = nCellsPerSide * FCCspacing
        a = a + 1; coords(:, a) = latVec
        latVec(1) = nCellsPerSide * FCCspacing
        latVec(2) = (i - 1) * FCCspacing
        latVec(3) = nCellsPerSide * FCCspacing
        a = a + 1; coords(:, a) = latVec
        latVec(1) = nCellsPerSide * FCCspacing
        latVec(2) = nCellsPerSide * FCCspacing
        latVec(3) = (i - 1) * FCCspacing
        a = a + 1; coords(:, a) = latVec
      end if
    end do
    if (.not. periodic) then
      ! Add in the remaining corner
      a = a + 1; coords(:, a) = nCellsPerSide * FCCspacing
    end if

    return

  end subroutine create_FCC_configuration

  recursive subroutine compute_numer_deriv( &
    partnum, dir, model_handle, compute_arguments_handle, DIM, N, coords, &
    cutoff, cutpad, energy, do_update_list, coordsave, neighObject, deriv, &
    deriv_err, ierr)
    use, intrinsic :: iso_c_binding
    use error
    use mod_neighborlist
    implicit none
    integer(c_int), parameter :: cd = c_double ! used for literal constants

    !--Transferred variables
    integer(c_int), intent(in)    :: partnum
    integer(c_int), intent(in)    :: dir
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    integer(c_int), intent(in)    :: DIM
    integer(c_int), intent(in)    :: N
    real(c_double), intent(inout) :: coords(DIM, N)
    real(c_double), intent(in)    :: cutoff
    real(c_double), intent(in)    :: cutpad
    real(c_double), intent(inout) :: energy
    logical, intent(inout) :: do_update_list
    real(c_double), intent(inout) :: coordsave(DIM, N)
    type(neighObject_type), intent(inout) :: neighObject
    real(c_double), intent(out)   :: deriv
    real(c_double), intent(out)   :: deriv_err
    integer(c_int), intent(out)   :: ierr

    !-- Local variables
    real(c_double), parameter :: eps_init = 1.e-6_cd
    integer(c_int), parameter :: number_eps_levels = 15
    real(c_double) eps, deriv_last, deriv_err_last
    integer(c_int) i

    ! Initialize error flag
    ierr = 0

    deriv_last = 0.0_cd ! initialize

    ! Outer loop of Ridders' method for computing numerical derivative
    !
    eps = eps_init
    deriv_err_last = huge(1.0_cd)
    do i = 1, number_eps_levels
      deriv = dfridr(eps, deriv_err)
      if (ierr /= 0) then
        call my_error("compute_numer_deriv")
      end if
      if (deriv_err > deriv_err_last) then
        deriv = deriv_last
        deriv_err = deriv_err_last
        exit
      end if
      eps = eps * 10.0_cd
      deriv_last = deriv
      deriv_err_last = deriv_err
    end do

    return

  contains

    !----------------------------------------------------------------------------
    !
    ! Compute numerical derivative using Ridders' method
    !
    ! Based on code from Numerical Recipes, Press et al., Second Ed., Cambridge,
    ! 1992
    !
    ! Ref: Ridders, C. J. F., "Two algorithms for the calculation of F'(x)=D",
    !      Advances in Engineering Software, Vol. 4, no. 2, pp. 75-76, 1982.
    !
    !
    ! Returns the gradient grad() of a KIM-compliant interatomic model at the
    ! current configuration by Ridders' method of polynomial extrapolation.
    ! An estimate for the error in each component of the gradient is returned in
    ! grad_err().
    !
    !----------------------------------------------------------------------------
    real(c_double) recursive function dfridr(h, err)
      implicit none

      !-- Transferred variables
      real(c_double), intent(inout) :: h
      real(c_double), intent(out)   :: err

      !-- Local variables
      integer(c_int), parameter :: NTAB = 10     ! Maximum size of tableau
      real(c_double), parameter :: CON = 1.4_cd  ! Stepsize incr. by CON at each iter
      real(c_double), parameter :: CON2 = CON * CON
      real(c_double), parameter :: BIG = huge(1.0_cd)
      real(c_double), parameter :: SAFE = 2.0_cd ! Returns when error is SAFE worse
      ! than the best so far
      integer(c_int) i, j
      real(c_double) errt, fac, hh, a(NTAB, NTAB), fp, fm, coordorig

      dfridr = 0.0_cd ! initialize
      err = BIG ! initialize

      if (abs(h) <= tiny(0.0_cd)) then  ! avoid division by zero
        ierr = 1
        return
      end if

      hh = h
      coordorig = coords(dir, partnum)
      coords(dir, partnum) = coordorig + hh
      call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                               do_update_list, coordsave, &
                               neighObject, ierr)
      call kim_compute(model_handle, compute_arguments_handle, ierr)
      if (ierr /= 0) then
        call my_error("kim_api_model_compute")
      end if
      fp = energy
      coords(dir, partnum) = coordorig - hh
      call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                               do_update_list, coordsave, &
                               neighObject, ierr)
      call kim_compute(model_handle, compute_arguments_handle, ierr)
      if (ierr /= 0) then
        call my_error("kim_api_model_compute")
      end if
      fm = energy
      coords(dir, partnum) = coordorig
      call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                               do_update_list, coordsave, &
                               neighObject, ierr)
      a(1, 1) = (fp - fm) / (2.0_cd * hh)
      ! successive columns in the Neville tableau will go to smaller step sizes
      ! and higher orders of extrapolation
      do i = 2, NTAB
        ! try new, smaller step size
        hh = hh / CON
        coords(dir, partnum) = coordorig + hh
        call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                                 do_update_list, coordsave, &
                                 neighObject, ierr)
        call kim_compute(model_handle, compute_arguments_handle, ierr)
        if (ierr /= 0) then
          call my_error("kim_api_model_compute")
        end if
        fp = energy
        coords(dir, partnum) = coordorig - hh
        call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                                 do_update_list, coordsave, &
                                 neighObject, ierr)
        call kim_compute(model_handle, compute_arguments_handle, ierr)
        if (ierr /= 0) then
          call my_error("kim_api_model_compute")
        end if
        fm = energy
        coords(dir, partnum) = coordorig
        call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                                 do_update_list, coordsave, &
                                 neighObject, ierr)
        a(1, i) = (fp - fm) / (2.0_cd * hh)
        fac = CON2
        ! compute extrapolations of various orders, requiring no new function
        ! evaluations
        do j = 2, i
          a(j, i) = (a(j - 1, i) * fac - a(j - 1, i - 1)) / (fac - 1.0_cd)
          fac = CON2 * fac
          ! The error strategy is to compute each new extrapolation to one order
          ! lower, both at the present step size and the previous one.
          errt = max(abs(a(j, i) - a(j - 1, i)), abs(a(j, i) - a(j - 1, i - 1)))
          if (errt <= err) then ! if error is decreased, save the improved answer
            err = errt
            dfridr = a(j, i)
          end if
        end do
        if (abs(a(i, i) - a(i - 1, i - 1)) >= SAFE * err) return ! if higher order is worse
        ! by significant factor
        ! `SAFE', then quit early.
      end do
      return
    end function dfridr

  end subroutine compute_numer_deriv

end module mod_utilities

!*******************************************************************************
!**
!**  PROGRAM vc_forces_numer_deriv
!**
!**  KIM compliant program to perform numerical derivative check on a model
!**
!*******************************************************************************

!-------------------------------------------------------------------------------
!
! Main program
!
!-------------------------------------------------------------------------------
program vc_forces_numer_deriv
  use, intrinsic :: iso_c_binding
  use error
  use mod_neighborlist
  use mod_utilities
  implicit none
  integer(c_int), parameter :: cd = c_double ! used for literal constants

  integer(c_int), parameter :: nCellsPerSide = 2
  integer(c_int), parameter :: DIM = 3
  real(c_double), parameter :: cutpad = 0.75_cd
  integer(c_int), parameter :: max_species = 200 ! most species supported
  real(c_double), parameter :: eps_prec = epsilon(1.0_cd)
  real(c_double) FCCspacing

  integer(c_int), parameter :: N = 4 * (nCellsPerSide)**3 &
                               + 6 * (nCellsPerSide)**2 &
                               + 3 * (nCellsPerSide) + 1
  real(c_double), allocatable          :: forces_num(:, :)
  real(c_double), allocatable          :: forces_num_err(:, :)
  type(kim_species_name_type) :: model_species(max_species)
  integer(c_int), target               :: num_species
  character(len=5, kind=c_char)        :: passfail
  real(c_double)                       :: forcediff
  real(c_double)                       :: forcediff_sumsq
  real(c_double)                       :: weight
  real(c_double)                       :: weight_sum
  real(c_double)                       :: alpha
  real(c_double)                       :: term
  real(c_double)                       :: term_max
  real(c_double), allocatable          :: cluster_coords(:, :)
  real(c_double), allocatable          :: cluster_disps(:, :)
  type(kim_species_name_type), allocatable :: cluster_species(:)
  integer(c_int) I, J, Imax, Jmax, species_code
  integer(c_int) seed_size
  integer(c_int), allocatable :: seed(:)

  !
  ! neighbor list
  !
  type(neighObject_type), target :: neighObject
  integer(c_int), allocatable, target :: neighborList(:, :)
  real(c_double), allocatable :: coordsave(:, :)
  logical do_update_list

  !
  ! KIM variables
  !
  character(len=256, kind=c_char) :: testname = "vc_forces_numer_deriv"
  character(len=256, kind=c_char) :: modelname

  type(kim_model_handle_type) :: model_handle
  type(kim_compute_arguments_handle_type) :: compute_arguments_handle
  integer(c_int) ierr, ierr2
  integer(c_int) species_is_supported
  integer(c_int), target :: numberOfParticles
  integer(c_int), target :: particleSpeciesCodes(N)
  integer(c_int), target :: particleContributing(N)
  real(c_double) :: influence_distance
  integer(c_int) :: number_of_neighbor_lists
  real(c_double), allocatable :: cutoffs(:)
  integer(c_int), allocatable :: &
    model_will_not_request_neighbors_of_noncontributing_particles(:)
  real(c_double) :: cutoff
  real(c_double), target :: energy
  real(c_double), target :: particle_energy(N)
  real(c_double), target :: particle_energy_sum
  real(c_double), target :: coords(3, N)
  real(c_double), target :: forces_kim(3, N)
  real(c_double) :: forces(3, N)
  integer(c_int) middleDum
  logical doing_non_contributing
  logical particle_energy_supported
  logical particle_energy_optional
  logical noncontrib_particle_energy_nonzero
  logical forces_optional
  logical model_is_compatible
  integer(c_int) number_of_model_routine_names
  type(kim_model_routine_name_type) model_routine_name
  integer(c_int) present
  integer(c_int) required
  integer(c_int) requested_units_accepted
  real(c_double) rnd, deriv, deriv_err
  real(c_double), pointer :: null_pointer

  nullify (null_pointer)

  doing_non_contributing = .false. ! .true. on 2nd pass through main program

  numberOfParticles = N

  term_max = 0.0_cd ! initialize

  ! Initialize error flag
  ierr = 0

  ! Initialize seed for random number generator
  !
  ! NOTE: Here, we set the seed to a fixed value for reproducibility
  call random_seed(size=seed_size) ! Get seed size for this CPU
  allocate (seed(seed_size))
  seed(:) = 13
  call random_seed(put=seed)
  deallocate (seed)

  ! Get KIM Model name to use
  print '("Please enter a valid KIM model name: ")'
  read (*, *) modelname

  ! Print output header
  !
  print *
  print *, 'VERIFICATION CHECK: NUMERICAL DERIVATIVE VERIFICATION OF FORCES'
  print *
  print '(120(''-''))'
  print '("This is Test          : ",A)', trim(testname)
  print '("Results for KIM Model : ",A)', trim(modelname)

  ! Create empty KIM object
  !
  call kim_model_create(KIM_NUMBERING_ONE_BASED, &
                        KIM_LENGTH_UNIT_A, &
                        KIM_ENERGY_UNIT_EV, &
                        KIM_CHARGE_UNIT_E, &
                        KIM_TEMPERATURE_UNIT_K, &
                        KIM_TIME_UNIT_PS, &
                        trim(modelname), &
                        requested_units_accepted, &
                        model_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_api_create")
  end if

  ! check that we are compatible
  if (requested_units_accepted == 0) then
    call my_error("Must adapt to model units")
  end if

  ! check that we know about all required routines
  call kim_get_number_of_model_routine_names(number_of_model_routine_names)
  do i = 1, number_of_model_routine_names
    call kim_get_model_routine_name(i, model_routine_name, ierr)
    if (ierr /= 0) then
      call my_error("kim_get_model_routine_name")
    end if
    call kim_is_routine_present(model_handle, model_routine_name, present, &
                                required, ierr)
    if (ierr /= 0) then
      call my_error("kim_is_routine_present")
    end if

    if ((present == 1) .and. (required == 1)) then
      if (.not. ((model_routine_name == KIM_MODEL_ROUTINE_NAME_CREATE) &
                 .or. (model_routine_name == &
                       KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_COMPUTE) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_REFRESH) &
                 .or. (model_routine_name == &
                       KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_DESTROY))) &
        then
        call my_error("Unknown required ModelRoutineName found.")
      end if
    end if
  end do

  ! create compute_arguments object
  call kim_compute_arguments_create(model_handle, &
                                    compute_arguments_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_model_compute_arguments_create")
  end if

  call check_model_compatibility(compute_arguments_handle, forces_optional, &
                                 particle_energy_supported, &
                                 particle_energy_optional, &
                                 model_is_compatible, ierr)
  if (ierr /= 0) then
    call my_error("error checking compatibility")
  end if
  if (.not. model_is_compatible) then
    call my_error("incompatibility reported by check_model_compatibility")
  end if

  ! Get list of particle species supported by the model
  !
  call Get_Model_Supported_Species(model_handle, max_species, model_species, &
                                   num_species, ierr)
  if (ierr /= 0) then
    call my_error("Get_Model_Supported_Species")
  end if
  ! Setup random cluster
  !
  allocate (cluster_coords(3, N), cluster_disps(3, N), cluster_species(N))
  do i = 1, N
    call random_number(rnd)  ! return random number between 0 and 1
    species_code = 1 + int(rnd * num_species)
    cluster_species(i) = model_species(species_code)
  end do
  FCCspacing = 1.0_cd  ! initially generate an FCC cluster with lattice
  ! spacing equal to one. This is scaled below based
  ! on the cutoff radius of the model.
  call create_FCC_configuration(FCCspacing, nCellsPerSide, .false., &
                                cluster_coords, middleDum)
  ! Generate random displacements for all particles
  !
  do I = 1, N
    do J = 1, DIM
      call random_number(rnd)  ! return random number between 0 and 1
      cluster_disps(J, I) = 0.1_cd * (rnd - 0.5_cd)
    end do
  end do

  ! register memory with the KIM system
  ierr = 0
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES, &
    numberOfParticles, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES, &
    particleSpeciesCodes, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING, &
    particleContributing, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_COORDINATES, coords, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, energy, ierr2)
  ierr = ierr + ierr2
  if (particle_energy_supported) then
    call kim_set_argument_pointer( &
      compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, particle_energy, ierr2)
    ierr = ierr + ierr2
  end if
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, forces_kim, ierr2)
  ierr = ierr + ierr2
  if (ierr /= 0) then
    call my_error("set_argument_pointer")
  end if

  ! Allocate storage for neighbor lists and
  ! store pointers to neighbor list object and access function
  !
  allocate (coordsave(DIM, N))
  allocate (neighborList(N + 1, N))
  neighObject%neighbor_list_pointer = c_loc(neighborList)
  neighObject%number_of_particles = N
  allocate (forces_num(DIM, N), forces_num_err(DIM, N))

  ! Set pointer in KIM object to neighbor list routine and object
  !
  call kim_set_callback_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_CALLBACK_NAME_GET_NEIGHBOR_LIST, KIM_LANGUAGE_NAME_FORTRAN, &
    c_funloc(get_neigh), c_loc(neighobject), ierr)
  if (ierr /= 0) then
    call my_error("set_callback_pointer")
  end if

  call kim_get_influence_distance(model_handle, influence_distance)
  call kim_get_number_of_neighbor_lists(model_handle, &
                                        number_of_neighbor_lists)
  allocate (cutoffs(number_of_neighbor_lists), &
            model_will_not_request_neighbors_of_noncontributing_particles( &
            number_of_neighbor_lists))
  call kim_get_neighbor_list_values( &
    model_handle, cutoffs, &
    model_will_not_request_neighbors_of_noncontributing_particles, ierr)
  if (ierr /= 0) then
    call my_error("get_neighbor_list_values")
  end if
  cutoff = maxval(cutoffs)

  ! Scale reference FCC configuration based on cutoff radius.
  FCCspacing = 0.75_cd * cutoff ! set the FCC spacing to a fraction
  ! of the cutoff radius
  do i = 1, N
    cluster_coords(:, i) = FCCspacing * cluster_coords(:, i)
  end do
  print '("Using FCC lattice parameter: ",f12.5)', FCCspacing
  print *

1000 continue ! Start of configuration setup

  if (doing_non_contributing) then
    ! Turn particle energy computation back on, if possible
    if (particle_energy_optional) then
      call kim_set_argument_pointer( &
        compute_arguments_handle, &
        KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, &
        particle_energy, ierr)
      if (ierr /= 0) then
        call my_error("set_argument_pointer")
      end if
    end if

    ! Turn force computation back on, if possible
    !
    if (forces_optional) then
      call kim_set_argument_pointer( &
        compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
        forces_kim, ierr)
      if (ierr /= 0) then
        call my_error("set_argument_pointer")
      end if
    end if
  end if

  do i = 1, N
    call kim_get_species_support_and_code( &
      model_handle, cluster_species(i), species_is_supported, &
      particleSpeciesCodes(i), ierr)
  end do
  if (ierr /= 0) then
    call my_error("kim_api_get_species_code")
  end if
  if (.not. doing_non_contributing) then
    do i = 1, N
      particleContributing(i) = 1  ! all particle contribute
    end do
  else
    do i = 1, N
      ! Random collection of contributing atoms
      call random_number(rnd)  ! return random number between 0 and 1
      if (rnd > 0.5) then
        particleContributing(i) = 1
      else
        particleContributing(i) = 0
      end if
    end do
  end if
  do i = 1, N
    coords(:, i) = cluster_coords(:, i) + cluster_disps(:, i)
  end do

  ! Compute neighbor lists
  !
  do_update_list = .true.
  call update_neighborlist(DIM, N, coords, cutoff, cutpad, &
                           do_update_list, coordsave, &
                           neighObject, ierr)
  if (ierr /= 0) then
    call my_error("update_neighborlist")
  end if

  ! Call model compute to get forces (gradient)
  !
  call kim_compute(model_handle, compute_arguments_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_api_model_compute")
  end if

  ! Copy forces in case model will overwrite forces_kim below
  !
  forces = forces_kim

  ! Add up particle_energy to compare with energy
  noncontrib_particle_energy_nonzero = .false.
  if (particle_energy_supported) then
    particle_energy_sum = 0.0_cd
    do i = 1, N
      if (particleContributing(i) == 0) then
        if (abs(particle_energy(i)) > epsilon(0.0_cd)) then
          noncontrib_particle_energy_nonzero = .true.
        end if
      else
        particle_energy_sum = particle_energy_sum + particle_energy(i)
      end if
    end do
  end if

  ! Print results to screen
  !
  print '(41(''=''))'
  if (.not. doing_non_contributing) then
    print '("Configuration with all contributing particles")'
  else
    print '("Configuration with some non-contributing particles")'
  end if
  if (particle_energy_supported) then
    print '(A25,2X,A25,2X,A15)', "Energy", "Sum Contrib. Energies", "Diff"
    print '(ES25.15,2X,ES25.15,2X,ES15.5)', energy, particle_energy_sum, &
      energy - particle_energy_sum
    if (noncontrib_particle_energy_nonzero) then
      call my_error( &
        "Some non-contributing particles have non-zero &
        &partial_particle_energy")
    end if
  else
    print '("Energy = ",ES25.15)', energy
  end if
  print '(41(''=''))'
  print *

  ! Turn off particle energy computation, if possible
  if (particle_energy_optional) then
    call kim_set_argument_pointer( &
      compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, &
      null_pointer, ierr)
    if (ierr /= 0) then
      call my_error("set_argument_pointer")
    end if
  end if

  ! Turn off force computation, if possible
  !
  if (forces_optional) then
    call kim_set_argument_pointer( &
      compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
      null_pointer, ierr)
    if (ierr /= 0) then
      call my_error("set_argument_pointer")
    end if
  end if

  ! Compute gradient using numerical differentiation
  !
  do I = 1, N
    do J = 1, DIM
      call compute_numer_deriv(I, J, model_handle, compute_arguments_handle, &
                               DIM, N, coords, cutoff, &
                               cutpad, energy, do_update_list, &
                               coordsave, neighObject, deriv, deriv_err, ierr)
      if (ierr /= 0) then
        call my_error("compute_numer_deriv")
      end if
      forces_num(J, I) = -deriv
      forces_num_err(J, I) = deriv_err
    end do
  end do

  ! Continue printing results to screen
  !
  print '(A6,2X,A7,2X,A4,2X,A3,2X,2A25,3A15,2X,A4)', "Part", "Contrib", &
    "Spec", "Dir", "Force_model", "Force_numer", "Force diff", "pred error", &
    "weight", "stat"
  forcediff_sumsq = 0.0_cd
  weight_sum = 0.0_cd
  do I = 1, N
    do J = 1, DIM
      forcediff = abs(forces(J, I) - forces_num(J, I))
      if (forcediff < forces_num_err(J, I)) then
        passfail = "ideal"
      else
        passfail = "     "
      end if
      weight = max(abs(forces_num(J, I)), eps_prec) / &
               max(abs(forces_num_err(J, I)), eps_prec)
      term = weight * forcediff**2
      if (term > term_max) then
        term_max = term
        Imax = I
        Jmax = J
      end if
      forcediff_sumsq = forcediff_sumsq + term
      weight_sum = weight_sum + weight
      if (J == 1) then
        print '(I6,2X,I7,2X,I4,2X,I3,2X,2ES25.15,3ES15.5,2X,A5)', &
          I, particleContributing(I), &
          particleSpeciesCodes(I), J, forces(J, I), &
          forces_num(J, I), forcediff, &
          forces_num_err(J, I), weight, passfail
      else
        print '(23X,I3,2X,2ES25.15,3ES15.5,2X,A5)', &
          J, forces(J, I), forces_num(J, I), &
          forcediff, forces_num_err(J, I), weight, passfail
      end if
    end do
    print *
  end do
  alpha = sqrt(forcediff_sumsq / weight_sum) / dble(DIM * N)
  print *
  print '("alpha = |Force_model - Force_numer|_w/(DIM*N) = ",ES15.5," &
        &(units of force)")', alpha
  print *
  print '(''Maximum term obtained for Part = '',I6,'', Dir = '',I1,'// &
    ''', forcediff = '',ES15.5, '', forcediff/force_model = '',ES15.5)', &
    Imax, Jmax, abs(forces(Jmax, Imax) - forces_num(Jmax, Imax)), &
    abs(forces(Jmax, Imax) - forces_num(Jmax, Imax)) / abs(forces(Jmax, Imax))

  if (.not. doing_non_contributing) then
    doing_non_contributing = .true.
    print *
    print *
    goto 1000
  end if

  ! Free temporary storage
  !
  deallocate (forces_num)
  deallocate (forces_num_err)
  deallocate (neighborList)
  deallocate (coordsave)
  deallocate (cutoffs)
  deallocate (model_will_not_request_neighbors_of_noncontributing_particles)

  call kim_compute_arguments_destroy(model_handle, &
                                     compute_arguments_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_model_compute_arguments_destroy")
  end if
  call kim_model_destroy(model_handle)

  ! Print output footer
  !
  print *
  print '(120(''-''))'

  ! Free cluster storage
  !
  deallocate (cluster_coords, cluster_disps, cluster_species)

  stop

end program vc_forces_numer_deriv

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelExtension
!!
!! \sa KIM::ModelExtension, KIM_ModelExtension
!!
!! \since 2.0
module kim_model_extension_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_extension_handle_type, &

    ! Constants
    KIM_MODEL_EXTENSION_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_get_extension_id, &
    kim_to_model, &
    kim_to_model_compute, &
    kim_to_model_create, &
    kim_to_model_destroy, &
    kim_to_model_driver_create, &
    kim_to_model_refresh, &
    kim_to_model_write_parameterized_model, &
    kim_to_model_compute_arguments, &
    kim_to_model_compute_arguments_create, &
    kim_to_model_compute_arguments_destroy, &
    kim_c_char_array_to_string, &
    kim_c_char_ptr_to_string, &
    kim_string_to_c_char_array, &
    kim_get_model_buffer_pointer, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelExtension
  !!
  !! \sa KIM::ModelExtension, KIM_ModelExtension
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_extension_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_extension_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_extension_handle_type), protected, save &
    :: KIM_MODEL_EXTENSION_NULL_HANDLE

  !> \brief Compares kim_model_extension_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_extension_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_extension_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_extension_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelExtension::GetExtensionID
  !!
  !! \sa KIM::ModelExtension::GetExtensionID, KIM_ModelExtension_GetExtensionID
  !!
  !! \since 2.0
  interface kim_get_extension_id
    module procedure kim_model_extension_get_extension_id
  end interface kim_get_extension_id

  !> \brief \copybrief KIM::ModelExtension::Model
  !!
  !! \sa KIM::ModelExtension::Model, KIM_ModelExtension_ToModel
  !!
  !! \since 2.0
  interface kim_to_model
    module procedure kim_model_extension_to_model
  end interface kim_to_model

  !> \brief \copybrief KIM::ModelExtension::ModelCompute
  !!
  !! \sa KIM::ModelExtension::ModelCompute, KIM_ModelExtension_ToModelCompute
  !!
  !! \since 2.0
  interface kim_to_model_compute
    module procedure kim_model_extension_to_model_compute
  end interface kim_to_model_compute

  !> \brief \copybrief KIM::ModelExtension::ModelCompute
  !!
  !! \sa KIM::ModelExtension::ModelCompute, KIM_ModelExtension_ToModelCompute
  !!
  !! \since 2.0
  interface kim_to_model_create
    module procedure kim_model_extension_to_model_create
  end interface kim_to_model_create

  !> \brief \copybrief KIM::ModelExtension::ModelDestroy
  !!
  !! \sa KIM::ModelExtension::ModelDestroy, KIM_ModelExtension_ToModelDestroy
  !!
  !! \since 2.0
  interface kim_to_model_destroy
    module procedure kim_model_extension_to_model_destroy
  end interface kim_to_model_destroy

  !> \brief \copybrief KIM::ModelExtension::ModelDriverCreate
  !!
  !! \sa KIM::ModelExtension::ModelDriverCreate,
  !! KIM_ModelExtension_ToModelDriverCreate
  !!
  !! \since 2.0
  interface kim_to_model_driver_create
    module procedure kim_model_extension_to_model_driver_create
  end interface kim_to_model_driver_create

  !> \brief \copybrief KIM::ModelExtension::ModelRefresh
  !!
  !! \sa KIM::ModelExtension::ModelRefresh, KIM_ModelExtension_ToModelRefresh
  !!
  !! \since 2.0
  interface kim_to_model_refresh
    module procedure kim_model_extension_to_model_refresh
  end interface kim_to_model_refresh

  !> \brief \copybrief KIM::ModelExtension::ModelWriteParameterizedModel
  !!
  !! \sa KIM::ModelExtension::ModelWriteParameterizedModel,
  !! KIM_ModelExtension_ToModelWriteParameterizedModel
  !!
  !! \since 2.0
  interface kim_to_model_write_parameterized_model
    module procedure kim_model_extension_to_model_write_parameterized_model
  end interface kim_to_model_write_parameterized_model

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArguments
  !!
  !! \sa KIM::ModelExtension::ModelComputeArguments,
  !! KIM_ModelExtension_ToModelComputeArguments
  !!
  !! \since 2.0
  interface kim_to_model_compute_arguments
    module procedure kim_model_extension_to_model_compute_arguments
  end interface kim_to_model_compute_arguments

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArgumentsCreate
  !!
  !! \sa KIM::ModelExtension::ModelComputeArgumentsCreate,
  !! KIM_ModelExtension_ToModelComputeArgumentsCreate
  !!
  !! \since 2.0
  interface kim_to_model_compute_arguments_create
    module procedure kim_model_extension_to_model_compute_arguments_create
  end interface kim_to_model_compute_arguments_create

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArgumentsDestroy
  !!
  !! \sa KIM::ModelExtension::ModelComputeArgumentsDestroy,
  !! KIM_ModelExtension_ToModelComputeArgumentsDestroy
  !!
  !! \since 2.0
  interface kim_to_model_compute_arguments_destroy
    module procedure kim_model_extension_to_model_compute_arguments_destroy
  end interface kim_to_model_compute_arguments_destroy

  !> \brief Copy C character array to Fortran string
  !!
  !! \since 2.0
  interface kim_c_char_array_to_string
    module procedure kim_model_extension_convert_c_char_array_to_string
  end interface kim_c_char_array_to_string

  !> \brief Copy C character pointer to Fortran string
  !!
  !! \since 2.0
  interface kim_c_char_ptr_to_string
    module procedure kim_model_extension_convert_c_char_ptr_to_string
  end interface kim_c_char_ptr_to_string

  !> \brief Convert Fortran string to C character array
  !!
  !! \since 2.0
  interface kim_string_to_c_char_array
    module procedure kim_model_extension_convert_string_to_c_char_array
  end interface kim_string_to_c_char_array

  !> \brief \copybrief KIM::ModelExtension::GetModelBufferPointer
  !!
  !! \sa KIM::ModelExtension::GetModelBufferPointer,
  !! KIM_ModelExtension_GetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_get_model_buffer_pointer
    module procedure kim_model_extension_get_model_buffer_pointer
  end interface kim_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelExtension::LogEntry
  !!
  !! \sa KIM::ModelExtension::LogEntry, KIM_ModelExtension_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_extension_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelExtension::ToString
  !!
  !! \sa KIM::ModelExtension::ToString, KIM_ModelExtension_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_extension_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_extension_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_extension_handle_equal(lhs, rhs)
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: lhs
    type(kim_model_extension_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_extension_handle_equal = .true.
    else
      kim_model_extension_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_extension_handle_equal

  !> \brief Compares kim_model_extension_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_model_extension_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: lhs
    type(kim_model_extension_handle_type), intent(in) :: rhs

    kim_model_extension_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_extension_handle_not_equal

  !> \brief \copybrief KIM::ModelExtension::GetExtensionID
  !!
  !! \sa KIM::ModelExtension::GetExtensionID, KIM_ModelExtension_GetExtensionID
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_get_extension_id( &
    model_extension_handle, extension_id)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_extension_type
    implicit none
    interface
      recursive subroutine get_extension_id(model_extension, extension_id) &
        bind(c, name="KIM_ModelExtension_GetExtensionID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_extension_type
        implicit none
        type(kim_model_extension_type), intent(in) :: model_extension
        type(c_ptr), intent(out) :: extension_id
      end subroutine get_extension_id
    end interface
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    character(len=*, kind=c_char), intent(out) :: extension_id
    type(kim_model_extension_type), pointer :: model_extension

    type(c_ptr) :: p

    call c_f_pointer(model_extension_handle%p, model_extension)
    call get_extension_id(model_extension, p)
    call kim_convert_c_char_ptr_to_string(p, extension_id)
  end subroutine kim_model_extension_get_extension_id

  !> \brief \copybrief KIM::ModelExtension::Model
  !!
  !! \sa KIM::ModelExtension::Model, KIM_ModelExtension_ToModel
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model(model_extension_handle, &
    model_handle)
    use kim_model_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_handle_type), intent(out) :: model_handle

    model_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model

  !> \brief \copybrief KIM::ModelExtension::ModelCompute
  !!
  !! \sa KIM::ModelExtension::ModelCompute, KIM_ModelExtension_ToModelCompute
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_compute( &
    model_extension_handle, model_compute_handle)
    use kim_model_compute_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_compute_handle_type), intent(out) :: model_compute_handle

    model_compute_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_compute

  !> \brief \copybrief KIM::ModelExtension::ModelCompute
  !!
  !! \sa KIM::ModelExtension::ModelCompute, KIM_ModelExtension_ToModelCompute
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_create( &
    model_extension_handle, model_create_handle)
    use kim_model_create_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_create_handle_type), intent(out) :: model_create_handle

    model_create_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_create

  !> \brief \copybrief KIM::ModelExtension::ModelDestroy
  !!
  !! \sa KIM::ModelExtension::ModelDestroy, KIM_ModelExtension_ToModelDestroy
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_destroy( &
    model_extension_handle, model_destroy_handle)
    use kim_model_destroy_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_destroy_handle_type), intent(out) :: model_destroy_handle

    model_destroy_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_destroy

  !> \brief \copybrief KIM::ModelExtension::ModelDriverCreate
  !!
  !! \sa KIM::ModelExtension::ModelDriverCreate,
  !! KIM_ModelExtension_ToModelDriverCreate
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_driver_create( &
    model_extension_handle, model_driver_create_handle)
    use kim_model_driver_create_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_driver_create_handle_type), intent(out) &
      :: model_driver_create_handle

    model_driver_create_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_driver_create

  !> \brief \copybrief KIM::ModelExtension::ModelRefresh
  !!
  !! \sa KIM::ModelExtension::ModelRefresh, KIM_ModelExtension_ToModelRefresh
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_refresh( &
    model_extension_handle, model_refresh_handle)
    use kim_model_refresh_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_refresh_handle_type), intent(out) :: model_refresh_handle

    model_refresh_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_refresh

  !> \brief \copybrief KIM::ModelExtension::ModelWriteParameterizedModel
  !!
  !! \sa KIM::ModelExtension::ModelWriteParameterizedModel,
  !! KIM_ModelExtension_ToModelWriteParameterizedModel
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_write_parameterized_model( &
    model_extension_handle, model_write_parameterized_model_handle)
    use kim_model_write_parameterized_model_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_model_write_parameterized_model_handle_type), intent(out) &
      :: model_write_parameterized_model_handle

    model_write_parameterized_model_handle%p = model_extension_handle%p
  end subroutine kim_model_extension_to_model_write_parameterized_model

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArguments
  !!
  !! \sa KIM::ModelExtension::ModelComputeArguments,
  !! KIM_ModelExtension_ToModelComputeArguments
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_compute_arguments( &
    model_extension_handle, compute_arguments_c_ptr, &
    model_compute_arguments_handle)
    use kim_model_compute_arguments_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(c_ptr), intent(in) :: compute_arguments_c_ptr
    type(kim_model_compute_arguments_handle_type), intent(out) &
      :: model_compute_arguments_handle

    ! avoid unused dummy argument warnings
    if (model_extension_handle .eq. KIM_MODEL_EXTENSION_NULL_HANDLE) continue

    model_compute_arguments_handle%p = compute_arguments_c_ptr
  end subroutine kim_model_extension_to_model_compute_arguments

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArgumentsCreate
  !!
  !! \sa KIM::ModelExtension::ModelComputeArgumentsCreate,
  !! KIM_ModelExtension_ToModelComputeArgumentsCreate
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_compute_arguments_create( &
    model_extension_handle, compute_arguments_c_ptr, &
    model_compute_arguments_create_handle)
    use kim_model_compute_arguments_create_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(c_ptr), intent(in) :: compute_arguments_c_ptr
    type(kim_model_compute_arguments_create_handle_type), intent(out) &
      :: model_compute_arguments_create_handle

    ! avoid unused dummy argument warnings
    if (model_extension_handle .eq. KIM_MODEL_EXTENSION_NULL_HANDLE) continue

    model_compute_arguments_create_handle%p = compute_arguments_c_ptr
  end subroutine kim_model_extension_to_model_compute_arguments_create

  !> \brief \copybrief KIM::ModelExtension::ModelComputeArgumentsDestroy
  !!
  !! \sa KIM::ModelExtension::ModelComputeArgumentsDestroy,
  !! KIM_ModelExtension_ToModelComputeArgumentsDestroy
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_model_compute_arguments_destroy( &
    model_extension_handle, compute_arguments_c_ptr, &
    model_compute_arguments_destroy_handle)
    use kim_model_compute_arguments_destroy_module
    implicit none
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(c_ptr), intent(in) :: compute_arguments_c_ptr
    type(kim_model_compute_arguments_destroy_handle_type), intent(out) &
      :: model_compute_arguments_destroy_handle

    ! avoid unused dummy argument warnings
    if (model_extension_handle .eq. KIM_MODEL_EXTENSION_NULL_HANDLE) continue

    model_compute_arguments_destroy_handle%p = compute_arguments_c_ptr
  end subroutine kim_model_extension_to_model_compute_arguments_destroy

  !> \brief Copy C character array to Fortran string
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_convert_c_char_array_to_string( &
    c_char_array, string)
    use kim_convert_string_module, only : kim_convert_c_char_array_to_string
    implicit none
    character(len=1, kind=c_char), intent(in) :: c_char_array(:)
    character(len=*, kind=c_char), intent(out) :: string

    call kim_convert_c_char_array_to_string(c_char_array, string)
  end subroutine kim_model_extension_convert_c_char_array_to_string

  !> \brief Copy C character pointer to Fortran string
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_convert_c_char_ptr_to_string( &
    c_char_ptr, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    type(c_ptr), intent(in) :: c_char_ptr
    character(len=*, kind=c_char), intent(out) :: string

    call kim_convert_c_char_ptr_to_string(c_char_ptr, string)
  end subroutine kim_model_extension_convert_c_char_ptr_to_string

  !> \brief Convert Fortran string to C character array
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_convert_string_to_c_char_array( &
    string, c_char_array)
    use kim_convert_string_module, only : kim_convert_string_to_c_char_array
    implicit none
    character(len=*, kind=c_char), intent(in) :: string
    character(len=1, kind=c_char), intent(out) :: c_char_array(:)

    call kim_convert_string_to_c_char_array(string, c_char_array)
  end subroutine kim_model_extension_convert_string_to_c_char_array

  !> \brief \copybrief KIM::ModelExtension::GetModelBufferPointer
  !!
  !! \sa KIM::ModelExtension::GetModelBufferPointer,
  !! KIM_ModelExtension_GetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_get_model_buffer_pointer( &
    model_extension_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_extension_type
    implicit none
    interface
      recursive subroutine get_model_buffer_pointer(model_extension, ptr) &
        bind(c, name="KIM_ModelExtension_GetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_extension_type
        implicit none
        type(kim_model_extension_type), intent(in) :: model_extension
        type(c_ptr), intent(out) :: ptr
      end subroutine get_model_buffer_pointer
    end interface
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_model_extension_type), pointer :: model_extension

    call c_f_pointer(model_extension_handle%p, model_extension)
    call get_model_buffer_pointer(model_extension, ptr)
  end subroutine kim_model_extension_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelExtension::LogEntry
  !!
  !! \sa KIM::ModelExtension::LogEntry, KIM_ModelExtension_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_log_entry(model_extension_handle, &
    log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_extension_type
    implicit none
    interface
      recursive subroutine log_entry(model_extension, log_verbosity, message, &
        line_number, file_name) bind(c, name="KIM_ModelExtension_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_model_extension_type
        implicit none
        type(kim_model_extension_type), intent(in) :: model_extension
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_extension_type), pointer :: model_extension

    call c_f_pointer(model_extension_handle%p, model_extension)
    call log_entry(model_extension, log_verbosity, trim(message)//c_null_char, &
      0, ""//c_null_char)
  end subroutine kim_model_extension_log_entry

  !> \brief \copybrief KIM::ModelExtension::ToString
  !!
  !! \sa KIM::ModelExtension::ToString, KIM_ModelExtension_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension_to_string(model_extension_handle, &
    string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_extension_type
    implicit none
    interface
      type(c_ptr) recursive function model_extension_string(model_extension) &
        bind(c, name="KIM_ModelExtension_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_extension_type
        implicit none
        type(kim_model_extension_type), intent(in) :: model_extension
      end function model_extension_string
    end interface
    type(kim_model_extension_handle_type), intent(in) :: model_extension_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_extension_type), pointer :: model_extension

    type(c_ptr) :: p

    call c_f_pointer(model_extension_handle%p, model_extension)
    p = model_extension_string(model_extension)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_extension_to_string
end module kim_model_extension_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::SimulatorModel
!!
!! \sa KIM::SimulatorModel, KIM_SimulatorModel
!!
!! \since 2.1
module kim_simulator_model_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_simulator_model_handle_type, &

    ! Constants
    KIM_SIMULATOR_MODEL_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_simulator_model_create, &
    kim_simulator_model_destroy, &
    kim_get_simulator_name_and_version, &
    kim_get_number_of_supported_species, &
    kim_get_supported_species, &
    kim_open_and_initialize_template_map, &
    kim_template_map_is_open, &
    kim_add_template_map, &
    kim_close_template_map, &
    kim_get_number_of_simulator_fields, &
    kim_get_simulator_field_metadata, &
    kim_get_simulator_field_line, &
    kim_get_parameter_file_directory_name, &
    kim_get_specification_file_name, &
    kim_get_number_of_parameter_files, &
    kim_get_parameter_file_name, &
    kim_set_simulator_buffer_pointer, &
    kim_get_simulator_buffer_pointer, &
    kim_to_string, &
    kim_set_log_id, &
    kim_push_log_verbosity, &
    kim_pop_log_verbosity


  !> \brief \copybrief KIM::SimulatorModel
  !!
  !! \sa KIM::SimulatorModel, KIM_SimulatorModel
  !!
  !! \since 2.1
  type, bind(c) :: kim_simulator_model_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_simulator_model_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.1
  type(kim_simulator_model_handle_type), protected, save &
    :: KIM_SIMULATOR_MODEL_NULL_HANDLE

  !> \brief Compares kim_simulator_model_handle_type's for equality.
  !!
  !! \since 2.1
  interface operator (.eq.)
    module procedure kim_simulator_model_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_simulator_model_handle_type's for inequality.
  !!
  !! \since 2.1
  interface operator (.ne.)
    module procedure kim_simulator_model_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorNameAndVersion
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorNameAndVersion,
  !! KIM_SimulatorModel_GetSimulatorNameAndVersion
  !!
  !! \since 2.1
  interface kim_get_simulator_name_and_version
    module procedure kim_simulator_model_get_simulator_name_and_version
  end interface kim_get_simulator_name_and_version

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfSupportedSpecies
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfSupportedSpecies,
  !! KIM_SimulatorModel_GetNumberOfSupportedSpecies
  !!
  !! \since 2.1
  interface kim_get_number_of_supported_species
    module procedure kim_simulator_model_get_number_of_supported_species
  end interface kim_get_number_of_supported_species

  !> \brief \copybrief KIM::SimulatorModel::GetSupportedSpecies
  !!
  !! \sa KIM::SimulatorModel::GetSupportedSpecies,
  !! KIM_SimulatorModel_GetSupportedSpecies
  !!
  !! \since 2.1
  interface kim_get_supported_species
    module procedure kim_simulator_model_get_supported_species
  end interface kim_get_supported_species

  !> \brief \copybrief KIM::SimulatorModel::OpenAndInitializeTemplateMap
  !!
  !! \sa KIM::SimulatorModel::OpenAndInitializeTemplateMap,
  !! KIM_SimulatorModel_OpenAndInitializeTemplateMap
  !!
  !! \since 2.1
  interface kim_open_and_initialize_template_map
    module procedure kim_simulator_model_open_and_initialize_template_map
  end interface kim_open_and_initialize_template_map

  !> \brief \copybrief KIM::SimulatorModel::TemplateMapIsOpen
  !!
  !! \sa KIM::SimulatorModel::TemplateMapIsOpen,
  !! KIM_SimulatorModel_TemplateMapIsOpen
  !!
  !! \since 2.1
  interface kim_template_map_is_open
    module procedure kim_simulator_model_template_map_is_open
  end interface kim_template_map_is_open

  !> \brief \copybrief KIM::SimulatorModel::AddTemplateMap
  !!
  !! \sa KIM::SimulatorModel::AddTemplateMap, KIM_SimulatorModel_AddTemplateMap
  !!
  !! \since 2.1
  interface kim_add_template_map
    module procedure kim_simulator_model_add_template_map
  end interface kim_add_template_map

  !> \brief \copybrief KIM::SimulatorModel::CloseTemplateMap
  !!
  !! \sa KIM::SimulatorModel::CloseTemplateMap,
  !! KIM_SimulatorModel_CloseTemplateMap
  !!
  !! \since 2.1
  interface kim_close_template_map
    module procedure kim_simulator_model_close_template_map
  end interface kim_close_template_map

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfSimulatorFields
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfSimulatorFields,
  !! KIM_SimulatorModel_GetNumberOfSimulatorFields
  !!
  !! \since 2.1
  interface kim_get_number_of_simulator_fields
    module procedure kim_simulator_model_get_number_of_simulator_fields
  end interface kim_get_number_of_simulator_fields

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorFieldMetadata
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorFieldMetadata,
  !! KIM_SimulatorModel_GetSimulatorFieldMetadata
  !!
  !! \since 2.1
  interface kim_get_simulator_field_metadata
    module procedure kim_simulator_model_get_simulator_field_metadata
  end interface kim_get_simulator_field_metadata

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorFieldLine
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorFieldLine,
  !! KIM_SimulatorModel_GetSimulatorFieldLine
  !!
  !! \since 2.1
  interface kim_get_simulator_field_line
    module procedure kim_simulator_model_get_simulator_field_line
  end interface kim_get_simulator_field_line

  !> \brief \copybrief KIM::SimulatorModel::GetParameterFileDirectoryName
  !!
  !! \sa KIM::SimulatorModel::GetParameterFileDirectoryName,
  !! KIM_SimulatorModel_GetParameterFileDirectoryName
  !!
  !! \since 2.1
  interface kim_get_parameter_file_directory_name
    module procedure kim_simulator_model_get_parameter_file_directory_name
  end interface kim_get_parameter_file_directory_name

  !> \brief \copybrief KIM::SimulatorModel::GetSpecificationFileName
  !!
  !! \sa KIM::SimulatorModel::GetSpecificationFileName,
  !! KIM_SimulatorModel_GetSpecificationFileName
  !!
  !! \since 2.1
  interface kim_get_specification_file_name
    module procedure kim_simulator_model_get_specification_file_name
  end interface kim_get_specification_file_name

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfParameterFiles
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfParameterFiles,
  !! KIM_SimulatorModel_GetNumberOfParameterFiles
  !!
  !! \since 2.1
  interface kim_get_number_of_parameter_files
    module procedure kim_simulator_model_get_number_of_parameter_files
  end interface kim_get_number_of_parameter_files

  !> \brief \copybrief KIM::SimulatorModel::GetParameterFileName
  !!
  !! \sa KIM::SimulatorModel::GetParameterFileName,
  !! KIM_SimulatorModel_GetParameterFileName
  !!
  !! \since 2.1
  interface kim_get_parameter_file_name
    module procedure kim_simulator_model_get_parameter_file_name
  end interface kim_get_parameter_file_name

  !> \brief \copybrief KIM::SimulatorModel::SetSimulatorBufferPointer
  !!
  !! \sa KIM::SimulatorModel::SetSimulatorBufferPointer,
  !! KIM_SimulatorModel_SetSimulatorBufferPointer
  !!
  !! \since 2.1
  interface kim_set_simulator_buffer_pointer
    module procedure kim_simulator_model_set_simulator_buffer_pointer
  end interface kim_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorBufferPointer
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorBufferPointer,
  !! KIM_SimulatorModel_GetSimulatorBufferPointer
  !!
  !! \since 2.1
  interface kim_get_simulator_buffer_pointer
    module procedure kim_simulator_model_get_simulator_buffer_pointer
  end interface kim_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::SimulatorModel::ToString
  !!
  !! \sa KIM::SimulatorModel::ToString, KIM_SimulatorModel_ToString
  !!
  !! \since 2.1
  interface kim_to_string
    module procedure kim_simulator_model_to_string
  end interface kim_to_string

  !> \brief \copybrief KIM::SimulatorModel::SetLogID
  !!
  !! \sa KIM::SimulatorModel::SetLogID, KIM_SimulatorModel_SetLogID
  !!
  !! \since 2.1
  interface kim_set_log_id
    module procedure kim_simulator_model_set_log_id
  end interface kim_set_log_id

  !> \brief \copybrief KIM::SimulatorModel::PushLogVerbosity
  !!
  !! \sa KIM::SimulatorModel::PushLogVerbosity,
  !! KIM_SimulatorModel_PushLogVerbosity
  !!
  !! \since 2.1
  interface kim_push_log_verbosity
    module procedure kim_simulator_model_push_log_verbosity
  end interface kim_push_log_verbosity

  !> \brief \copybrief KIM::SimulatorModel::PopLogVerbosity
  !!
  !! \sa KIM::SimulatorModel::, KIM_SimulatorModel_PopLogVerbosity
  !!
  !! \since 2.1
  interface kim_pop_log_verbosity
    module procedure kim_simulator_model_pop_log_verbosity
  end interface kim_pop_log_verbosity

contains
  !> \brief Compares kim_simulator_model_handle_type's for equality.
  !!
  !! \since 2.1
  logical recursive function kim_simulator_model_handle_equal(lhs, rhs)
    implicit none
    type(kim_simulator_model_handle_type), intent(in) :: lhs
    type(kim_simulator_model_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_simulator_model_handle_equal = .true.
    else
      kim_simulator_model_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_simulator_model_handle_equal

  !> \brief Compares kim_simulator_model_handle_type's for inequality.
  !!
  !! \since 2.1
  logical recursive function kim_simulator_model_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_simulator_model_handle_type), intent(in) :: lhs
    type(kim_simulator_model_handle_type), intent(in) :: rhs

    kim_simulator_model_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_simulator_model_handle_not_equal

  !> \brief \copybrief KIM::SimulatorModel::Create
  !!
  !! \sa KIM::SimulatorModel::Create, KIM_SimulatorModel_Create
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_create(simulator_model_name, &
    simulator_model_handle, ierr)
    implicit none
    interface
      integer(c_int) recursive function create(simulator_model_name, &
        simulator_model) bind(c, name="KIM_SimulatorModel_Create")
        use, intrinsic :: iso_c_binding
        implicit none
        character(c_char), intent(in) :: simulator_model_name(*)
        type(c_ptr), intent(out) :: simulator_model
      end function create
    end interface
    character(len=*, kind=c_char), intent(in) :: simulator_model_name
    type(kim_simulator_model_handle_type), intent(out) :: simulator_model_handle
    integer(c_int), intent(out) :: ierr

    type(c_ptr) :: psimulator_model

    ierr = create(trim(simulator_model_name)//c_null_char, psimulator_model)
    simulator_model_handle%p = psimulator_model
  end subroutine kim_simulator_model_create

  !> \brief \copybrief KIM::SimulatorModel::Destroy
  !!
  !! \sa KIM::SimulatorModel::Destroy, KIM_SimulatorModel_Destroy
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_destroy(simulator_model_handle)
    implicit none
    interface
      recursive subroutine destroy(simulator_model) &
        bind(c, name="KIM_SimulatorModel_Destroy")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(inout) :: simulator_model
      end subroutine destroy
    end interface
    type(kim_simulator_model_handle_type), intent(inout) :: &
      simulator_model_handle

    type(c_ptr) :: psimulator_model
    psimulator_model = simulator_model_handle%p
    call destroy(psimulator_model)
    simulator_model_handle%p = c_null_ptr
  end subroutine kim_simulator_model_destroy

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorNameAndVersion
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorNameAndVersion,
  !! KIM_SimulatorModel_GetSimulatorNameAndVersion
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_simulator_name_and_version( &
    simulator_model_handle, simulator_name, simulator_version)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_simulator_name_and_version(simulator_model, &
        simulator_name, simulator_version) &
        bind(c, name="KIM_SimulatorModel_GetSimulatorNameAndVersion")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(c_ptr), intent(out) :: simulator_name
        type(c_ptr), intent(out) :: simulator_version
      end subroutine get_simulator_name_and_version
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(out) :: simulator_name
    character(len=*, kind=c_char), intent(out) :: simulator_version
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) psimulator_name, psimulator_version

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_simulator_name_and_version(simulator_model, psimulator_name, &
      psimulator_version)
    call kim_convert_c_char_ptr_to_string(psimulator_name, simulator_name)
    call kim_convert_c_char_ptr_to_string(psimulator_version, simulator_version)
  end subroutine kim_simulator_model_get_simulator_name_and_version

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfSupportedSpecies
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfSupportedSpecies,
  !! KIM_SimulatorModel_GetNumberOfSupportedSpecies
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_number_of_supported_species( &
    simulator_model_handle, number_of_supported_species)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine get_number_of_supported_species(simulator_model, &
        number_of_supported_species) &
        bind(c, name="KIM_SimulatorModel_GetNumberOfSupportedSpecies")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(out) :: number_of_supported_species
      end subroutine get_number_of_supported_species
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(out) :: number_of_supported_species
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_number_of_supported_species(simulator_model, &
      number_of_supported_species)
  end subroutine kim_simulator_model_get_number_of_supported_species

  !> \brief \copybrief KIM::SimulatorModel::GetSupportedSpecies
  !!
  !! \sa KIM::SimulatorModel::GetSupportedSpecies,
  !! KIM_SimulatorModel_GetSupportedSpecies
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_supported_species( &
    simulator_model_handle, index, species_name, ierr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_supported_species(simulator_model, &
        index, species_name) &
        bind(c, name="KIM_SimulatorModel_GetSupportedSpecies")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: species_name
      end function get_supported_species
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: species_name
    integer(c_int), intent(out) :: ierr
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pspecies_name

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    ierr = get_supported_species(simulator_model, index-1, pspecies_name)
    call kim_convert_c_char_ptr_to_string(pspecies_name, species_name)
  end subroutine kim_simulator_model_get_supported_species

  !> \brief \copybrief KIM::SimulatorModel::OpenAndInitializeTemplateMap
  !!
  !! \sa KIM::SimulatorModel::OpenAndInitializeTemplateMap,
  !! KIM_SimulatorModel_OpenAndInitializeTemplateMap
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_open_and_initialize_template_map( &
    simulator_model_handle)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
        recursive subroutine open_and_initialize_template_map(simulator_model) &
        bind(c, name="KIM_SimulatorModel_OpenAndInitializeTemplateMap")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
      end subroutine open_and_initialize_template_map
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call open_and_initialize_template_map(simulator_model)
  end subroutine kim_simulator_model_open_and_initialize_template_map

  !> \brief \copybrief KIM::SimulatorModel::TemplateMapIsOpen
  !!
  !! \sa KIM::SimulatorModel::TemplateMapIsOpen,
  !! KIM_SimulatorModel_TemplateMapIsOpen
  !!
  !! \since 2.1
  integer(c_int) recursive function kim_simulator_model_template_map_is_open( &
    simulator_model_handle)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      integer(c_int) recursive function template_map_is_open(simulator_model) &
        bind(c, name="KIM_SimulatorModel_TemplateMapIsOpen")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
      end function template_map_is_open
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    kim_simulator_model_template_map_is_open = template_map_is_open( &
      simulator_model)
  end function kim_simulator_model_template_map_is_open

  !> \brief \copybrief KIM::SimulatorModel::AddTemplateMap
  !!
  !! \sa KIM::SimulatorModel::AddTemplateMap, KIM_SimulatorModel_AddTemplateMap
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_add_template_map( &
    simulator_model_handle, key, value, ierr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function add_template_map(simulator_model, key, &
        value) bind(c, name="KIM_SimulatorModel_AddTemplateMap")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        character(c_char), intent(in) :: key(*)
        character(c_char), intent(in) :: value(*)
      end function add_template_map
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(in) :: key
    character(len=*, kind=c_char), intent(in) :: value
    integer(c_int), intent(out) :: ierr
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    ierr = add_template_map(simulator_model, trim(key)//c_null_char, &
      trim(value)//c_null_char)
  end subroutine kim_simulator_model_add_template_map

  !> \brief \copybrief KIM::SimulatorModel::CloseTemplateMap
  !!
  !! \sa KIM::SimulatorModel::CloseTemplateMap,
  !! KIM_SimulatorModel_CloseTemplateMap
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_close_template_map( &
    simulator_model_handle)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
        recursive subroutine close_template_map(simulator_model) &
        bind(c, name="KIM_SimulatorModel_CloseTemplateMap")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
      end subroutine close_template_map
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call close_template_map(simulator_model)
  end subroutine kim_simulator_model_close_template_map

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfSimulatorFields
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfSimulatorFields,
  !! KIM_SimulatorModel_GetNumberOfSimulatorFields
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_number_of_simulator_fields( &
    simulator_model_handle, number_of_simulator_fields)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine get_number_of_simulator_fields(simulator_model, &
        number_of_simulator_fields) &
        bind(c, name="KIM_SimulatorModel_GetNumberOfSimulatorFields")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(out) :: number_of_simulator_fields
      end subroutine get_number_of_simulator_fields
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(out) :: number_of_simulator_fields
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_number_of_simulator_fields(simulator_model, &
      number_of_simulator_fields)
  end subroutine kim_simulator_model_get_number_of_simulator_fields

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorFieldMetadata
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorFieldMetadata,
  !! KIM_SimulatorModel_GetSimulatorFieldMetadata
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_simulator_field_metadata( &
    simulator_model_handle, field_index, extent, field_name, ierr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_simulator_field_metadata( &
        simulator_model, field_index, extent, field_name) &
        bind(c, name="KIM_SimulatorModel_GetSimulatorFieldMetadata")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(in), value :: field_index
        integer(c_int), intent(out) :: extent
        type(c_ptr), intent(out) :: field_name
      end function get_simulator_field_metadata
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(in) :: field_index
    integer(c_int), intent(out) :: extent
    character(len=*, kind=c_char), intent(out) :: field_name
    integer(c_int), intent(out) :: ierr
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pfield_name

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    ierr = get_simulator_field_metadata(simulator_model, field_index-1, &
      extent, pfield_name)
    call kim_convert_c_char_ptr_to_string(pfield_name, field_name)
  end subroutine kim_simulator_model_get_simulator_field_metadata

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorFieldLine
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorFieldLine,
  !! KIM_SimulatorModel_GetSimulatorFieldLine
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_simulator_field_line( &
    simulator_model_handle, field_index, line_index, line_value, ierr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_simulator_field_line( &
        simulator_model, field_index, line_index, line_value) &
        bind(c, name="KIM_SimulatorModel_GetSimulatorFieldLine")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(in), value :: field_index
        integer(c_int), intent(in), value :: line_index
        type(c_ptr), intent(out) :: line_value
      end function get_simulator_field_line
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(in), value :: field_index
    integer(c_int), intent(in), value :: line_index
    character(len=*, kind=c_char), intent(out) :: line_value
    integer(c_int), intent(out) :: ierr
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pline_value

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    ierr = get_simulator_field_line(simulator_model, field_index-1, &
      line_index-1, pline_value)
    call kim_convert_c_char_ptr_to_string(pline_value, line_value)
  end subroutine kim_simulator_model_get_simulator_field_line

  !> \brief \copybrief KIM::SimulatorModel::GetParameterFileDirectoryName
  !!
  !! \sa KIM::SimulatorModel::GetParameterFileDirectoryName,
  !! KIM_SimulatorModel_GetParameterFileDirectoryName
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_parameter_file_directory_name( &
    simulator_model_handle, directory_name)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_parameter_file_directory_name(simulator_model, &
        directory_name) &
        bind(c, name="KIM_SimulatorModel_GetParameterFileDirectoryName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(c_ptr), intent(out) :: directory_name
      end subroutine get_parameter_file_directory_name
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(out) :: directory_name
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pdirectory_name

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_parameter_file_directory_name(simulator_model, pdirectory_name)
    call kim_convert_c_char_ptr_to_string(pdirectory_name, directory_name)
  end subroutine kim_simulator_model_get_parameter_file_directory_name

  !> \brief \copybrief KIM::SimulatorModel::GetSpecificationFileName
  !!
  !! \sa KIM::SimulatorModel::GetSpecificationFileName,
  !! KIM_SimulatorModel_GetSpecificationFileName
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_specification_file_name( &
    simulator_model_handle, specification_file_name)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      recursive subroutine get_specification_file_name(simulator_model, &
        specification_file_name) &
        bind(c, name="KIM_SimulatorModel_GetSpecificationFileName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(c_ptr), intent(out) :: specification_file_name
      end subroutine get_specification_file_name
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(out) :: specification_file_name
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pspecification_file_name

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_specification_file_name(simulator_model, pspecification_file_name)
    call kim_convert_c_char_ptr_to_string(pspecification_file_name, &
      specification_file_name)
  end subroutine kim_simulator_model_get_specification_file_name

  !> \brief \copybrief KIM::SimulatorModel::GetNumberOfParameterFiles
  !!
  !! \sa KIM::SimulatorModel::GetNumberOfParameterFiles,
  !! KIM_SimulatorModel_GetNumberOfParameterFiles
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_number_of_parameter_files( &
    simulator_model_handle, number_of_parameter_files)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine get_number_of_parameter_files(simulator_model, &
        number_of_parameter_files) &
        bind(c, name="KIM_SimulatorModel_GetNumberOfParameterFiles")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(out) :: number_of_parameter_files
      end subroutine get_number_of_parameter_files
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(out) :: number_of_parameter_files
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_number_of_parameter_files(simulator_model, &
      number_of_parameter_files)
  end subroutine kim_simulator_model_get_number_of_parameter_files

  !> \brief \copybrief KIM::SimulatorModel::GetParameterFileName
  !!
  !! \sa KIM::SimulatorModel::GetParameterFileName,
  !! KIM_SimulatorModel_GetParameterFileName
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_parameter_file_name( &
    simulator_model_handle, index, parameter_file_name, ierr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      integer(c_int) recursive function get_parameter_file_name( &
        simulator_model, index, parameter_file_name) &
        bind(c, name="KIM_SimulatorModel_GetParameterFileName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        integer(c_int), intent(in), value :: index
        type(c_ptr), intent(out) :: parameter_file_name
      end function get_parameter_file_name
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    integer(c_int), intent(in) :: index
    character(len=*, kind=c_char), intent(out) :: parameter_file_name
    integer(c_int), intent(out) :: ierr
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) pparameter_file_name

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    ierr = get_parameter_file_name(simulator_model, index-1, &
      pparameter_file_name)
    call kim_convert_c_char_ptr_to_string(pparameter_file_name, &
      parameter_file_name)
  end subroutine kim_simulator_model_get_parameter_file_name

  !> \brief \copybrief KIM::SimulatorModel::SetSimulatorBufferPointer
  !!
  !! \sa KIM::SimulatorModel::SetSimulatorBufferPointer,
  !! KIM_SimulatorModel_SetSimulatorBufferPointer
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_set_simulator_buffer_pointer( &
    simulator_model_handle, ptr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine set_simulator_buffer_pointer(simulator_model, ptr) &
        bind(c, name="KIM_SimulatorModel_SetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_simulator_buffer_pointer
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call set_simulator_buffer_pointer(simulator_model, ptr)
  end subroutine kim_simulator_model_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::SimulatorModel::GetSimulatorBufferPointer
  !!
  !! \sa KIM::SimulatorModel::GetSimulatorBufferPointer,
  !! KIM_SimulatorModel_GetSimulatorBufferPointer
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_get_simulator_buffer_pointer( &
    simulator_model_handle, ptr)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine get_simulator_buffer_pointer(simulator_model, ptr) &
        bind(c, name="KIM_SimulatorModel_GetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(c_ptr), intent(out) :: ptr
      end subroutine get_simulator_buffer_pointer
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call get_simulator_buffer_pointer(simulator_model, ptr)
  end subroutine kim_simulator_model_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::SimulatorModel::ToString
  !!
  !! \sa KIM::SimulatorModel::ToString, KIM_SimulatorModel_ToString
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_to_string(simulator_model_handle, &
    string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      type(c_ptr) recursive function model_string(simulator_model) &
        bind(c, name="KIM_SimulatorModel_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
      end function model_string
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_simulator_model_type), pointer :: simulator_model

    type(c_ptr) :: p

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    p = model_string(simulator_model)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_simulator_model_to_string

  !> \brief \copybrief KIM::SimulatorModel::SetLogID
  !!
  !! \sa KIM::SimulatorModel::SetLogID, KIM_SimulatorModel_SetLogID
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_set_log_id(simulator_model_handle, &
    log_id)
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine set_log_id(simulator_model, log_id) &
        bind(c, name="KIM_SimulatorModel_SetLogID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        character(c_char), intent(in) :: log_id(*)
      end subroutine set_log_id
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    character(len=*, kind=c_char), intent(in) :: log_id
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call set_log_id(simulator_model, trim(log_id)//c_null_char)
  end subroutine kim_simulator_model_set_log_id

  !> \brief \copybrief KIM::SimulatorModel::PushLogVerbosity
  !!
  !! \sa KIM::SimulatorModel::PushLogVerbosity,
  !! KIM_SimulatorModel_PushLogVerbosity
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_push_log_verbosity( &
    simulator_model_handle, log_verbosity)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine push_log_verbosity(simulator_model, log_verbosity) &
        bind(c, name="KIM_SimulatorModel_PushLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_log_verbosity
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call push_log_verbosity(simulator_model, log_verbosity)
  end subroutine kim_simulator_model_push_log_verbosity

  !> \brief \copybrief KIM::SimulatorModel::PopLogVerbosity
  !!
  !! \sa KIM::SimulatorModel::, KIM_SimulatorModel_PopLogVerbosity
  !!
  !! \since 2.1
  recursive subroutine kim_simulator_model_pop_log_verbosity( &
    simulator_model_handle)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_simulator_model_type
    implicit none
    interface
      recursive subroutine pop_log_verbosity(simulator_model) &
        bind(c, name="KIM_SimulatorModel_PopLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_simulator_model_type
        implicit none
        type(kim_simulator_model_type), intent(in) :: simulator_model
      end subroutine pop_log_verbosity
    end interface
    type(kim_simulator_model_handle_type), intent(in) :: simulator_model_handle
    type(kim_simulator_model_type), pointer :: simulator_model

    call c_f_pointer(simulator_model_handle%p, simulator_model)
    call pop_log_verbosity(simulator_model)
  end subroutine kim_simulator_model_pop_log_verbosity
end module kim_simulator_model_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ComputeArguments
!!
!! \sa KIM::ComputeArguments, KIM_ComputeArguments
!!
!! \since 2.0
module kim_compute_arguments_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_compute_arguments_handle_type, &

    ! Constants
    KIM_COMPUTE_ARGUMENTS_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_get_argument_support_status, &
    kim_get_callback_support_status, &
    kim_set_argument_pointer, &
    kim_set_callback_pointer, &
    kim_are_all_required_present, &
    kim_set_simulator_buffer_pointer, &
    kim_get_simulator_buffer_pointer, &
    kim_to_string, &
    kim_set_log_id, &
    kim_push_log_verbosity, &
    kim_pop_log_verbosity


  !> \brief \copybrief KIM::ComputeArguments
  !!
  !! \sa KIM::ComputeArguments, KIM_ComputeArguments
  !!
  !! \since 2.0
  type, bind(c) :: kim_compute_arguments_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_compute_arguments_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_compute_arguments_handle_type), protected, save &
    :: KIM_COMPUTE_ARGUMENTS_NULL_HANDLE

  !> \brief Compares kim_compute_arguments_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_compute_arguments_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_compute_arguments_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_compute_arguments_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ComputeArguments::GetArgumentSupportStatus
  !!
  !! \sa KIM::ComputeArguments::GetArgumentSupportStatus,
  !! KIM_ComputeArguments_GetArgumentSupportStatus
  !!
  !! \since 2.0
  interface kim_get_argument_support_status
    module procedure kim_compute_arguments_get_argument_support_status
  end interface kim_get_argument_support_status

  !> \brief \copybrief KIM::ComputeArguments::GetCallbackSupportStatus
  !!
  !! \sa KIM::ComputeArguments::GetCallbackSupportStatus,
  !! KIM_ComputeArguments_GetCallbackSupportStatus
  !!
  !! \since 2.0
  interface kim_get_callback_support_status
    module procedure kim_compute_arguments_get_callback_support_status
  end interface kim_get_callback_support_status

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerInteger,
  !! KIM_ComputeArguments_SetArgumentPointerDouble
  !!
  !! \since 2.0
  interface kim_set_argument_pointer
    module procedure kim_compute_arguments_set_argument_pointer_int0
    module procedure kim_compute_arguments_set_argument_pointer_int1
    module procedure kim_compute_arguments_set_argument_pointer_int2
    module procedure kim_compute_arguments_set_argument_pointer_double0
    module procedure kim_compute_arguments_set_argument_pointer_double1
    module procedure kim_compute_arguments_set_argument_pointer_double2
  end interface kim_set_argument_pointer

  !> \brief \copybrief KIM::ComputeArguments::SetCallbackPointer
  !!
  !! \sa KIM::ComputeArguments::SetCallbackPointer,
  !! KIM_ComputeArguments_SetCallbackPointer
  !!
  !! \since 2.0
  interface kim_set_callback_pointer
    module procedure kim_compute_arguments_set_callback_pointer
  end interface kim_set_callback_pointer

  !> \brief \copybrief KIM::ComputeArguments::<!--
  !! -->AreAllRequiredArgumentsAndCallbacksPresent
  !!
  !! \sa KIM::ComputeArguments::AreAllRequiredArgumentsAndCallbacksPresent,
  !! KIM_ComputeArguments_AreAllRequiredArgumentsAndCallbacksPresent
  !!
  !! \since 2.0
  interface kim_are_all_required_present
    module procedure kim_compute_arguments_are_all_required_present
  end interface kim_are_all_required_present

  !> \brief \copybrief KIM::ComputeArguments::SetSimulatorBufferPointer
  !!
  !! \sa KIM::ComputeArguments::SetSimulatorBufferPointer,
  !! KIM_ComputeArguments_SetSimulatorBufferPointer
  !!
  !! \since 2.0
  interface kim_set_simulator_buffer_pointer
    module procedure kim_compute_arguments_set_simulator_buffer_pointer
  end interface kim_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::ComputeArguments::GetSimulatorBufferPointer
  !!
  !! \sa KIM::ComputeArguments::GetSimulatorBufferPointer,
  !! KIM_ComputeArguments_GetSimulatorBufferPointer
  !!
  !! \since 2.0
  interface kim_get_simulator_buffer_pointer
    module procedure kim_compute_arguments_get_simulator_buffer_pointer
  end interface kim_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::ComputeArguments::ToString
  !!
  !! \sa KIM::ComputeArguments::ToString, KIM_ComputeArguments_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_compute_arguments_to_string
  end interface kim_to_string

  !> \brief \copybrief KIM::ComputeArguments::SetLogID
  !!
  !! \sa KIM::ComputeArguments::SetLogID, KIM_ComputeArguments_SetLogID
  !!
  !! \since 2.0
  interface kim_set_log_id
    module procedure kim_compute_arguments_set_log_id
  end interface kim_set_log_id

  !> \brief \copybrief KIM::ComputeArguments::PushLogVerbosity
  !!
  !! \sa KIM::ComputeArguments::PushLogVerbosity,
  !! KIM_ComputeArguments_PushLogVerbosity
  !!
  !! \since 2.0
  interface kim_push_log_verbosity
    module procedure kim_compute_arguments_push_log_verbosity
  end interface kim_push_log_verbosity

  !> \brief \copybrief KIM::ComputeArguments::PopLogVerbosity
  !!
  !! \sa KIM::ComputeArguments::PopLogVerbosity,
  !! KIM_ComputeArguments_PopLogVerbosity
  !!
  !! \since 2.0
  interface kim_pop_log_verbosity
    module procedure kim_compute_arguments_pop_log_verbosity
  end interface kim_pop_log_verbosity

contains
  !> \brief Compares kim_compute_arguments_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_compute_arguments_handle_equal(lhs, rhs)
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: lhs
    type(kim_compute_arguments_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_compute_arguments_handle_equal = .true.
    else
      kim_compute_arguments_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_compute_arguments_handle_equal

  !> \brief Compares kim_compute_arguments_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_compute_arguments_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: lhs
    type(kim_compute_arguments_handle_type), intent(in) :: rhs

    kim_compute_arguments_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_compute_arguments_handle_not_equal

  !> \brief \copybrief KIM::ComputeArguments::GetArgumentSupportStatus
  !!
  !! \sa KIM::ComputeArguments::GetArgumentSupportStatus,
  !! KIM_ComputeArguments_GetArgumentSupportStatus
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_get_argument_support_status( &
    compute_arguments_handle, compute_argument_name, &
    support_status, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_support_status_module, only : kim_support_status_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_argument_support_status( &
        compute_arguments, compute_argument_name, support_status) &
        bind(c, name="KIM_ComputeArguments_GetArgumentSupportStatus")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_support_status_module, only : kim_support_status_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(kim_support_status_type), intent(out) :: support_status
      end function get_argument_support_status
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    type(kim_support_status_type), intent(out) :: support_status
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = get_argument_support_status(compute_arguments, &
      compute_argument_name, support_status)
  end subroutine kim_compute_arguments_get_argument_support_status

  !> \brief \copybrief KIM::ComputeArguments::GetCallbackSupportStatus
  !!
  !! \sa KIM::ComputeArguments::GetCallbackSupportStatus,
  !! KIM_ComputeArguments_GetCallbackSupportStatus
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_get_callback_support_status( &
    compute_arguments_handle, compute_callback_name, support_status, ierr)
    use kim_compute_callback_name_module, only : kim_compute_callback_name_type
    use kim_support_status_module, only : kim_support_status_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function get_callback_support_status( &
        compute_arguments, compute_callback_name, support_status) &
        bind(c, name="KIM_ComputeArguments_GetCallbackSupportStatus")
        use, intrinsic :: iso_c_binding
        use kim_compute_callback_name_module, only : &
          kim_compute_callback_name_type
        use kim_support_status_module, only : kim_support_status_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
        type(kim_support_status_type), intent(out) :: support_status
      end function get_callback_support_status
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_callback_name_type), intent(in) :: &
      compute_callback_name
    type(kim_support_status_type), intent(out) :: support_status
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = get_callback_support_status(compute_arguments, &
      compute_callback_name, support_status)
  end subroutine kim_compute_arguments_get_callback_support_status

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_int0( &
    compute_arguments_handle, compute_argument_name, int0, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function set_argument_pointer_integer( &
        compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ComputeArguments_SetArgumentPointerInteger")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(in), value :: ptr
      end function set_argument_pointer_integer
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in), target :: int0
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = set_argument_pointer_integer(compute_arguments, &
      compute_argument_name, c_loc(int0))
  end subroutine kim_compute_arguments_set_argument_pointer_int0

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_int1( &
    compute_arguments_handle, compute_argument_name, int1, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in), target :: int1(:)
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set(compute_arguments, compute_argument_name, size(int1,1,c_int), &
      int1, ierr)
    return

  contains
    recursive subroutine set(compute_arguments, compute_argument_name, &
      extent1, int1, ierr)
      use kim_compute_argument_name_module, only : &
        kim_compute_argument_name_type
      use kim_interoperable_types_module, only : kim_compute_arguments_type
      implicit none
      interface
        integer(c_int) recursive function set_argument_pointer_integer( &
          compute_arguments, compute_argument_name, ptr) &
          bind(c, name="KIM_ComputeArguments_SetArgumentPointerInteger")
          use, intrinsic :: iso_c_binding
          use kim_compute_argument_name_module, only : &
            kim_compute_argument_name_type
          use kim_interoperable_types_module, only : kim_compute_arguments_type
          implicit none
          type(kim_compute_arguments_type), intent(in) :: compute_arguments
          type(kim_compute_argument_name_type), intent(in), value :: &
            compute_argument_name
          type(c_ptr), intent(in), value :: ptr
        end function set_argument_pointer_integer
      end interface
      type(kim_compute_arguments_type), intent(in) :: compute_arguments
      type(kim_compute_argument_name_type), intent(in) :: &
        compute_argument_name
      integer(c_int), intent(in) :: extent1
      integer(c_int), intent(in), target :: int1(extent1)
      integer(c_int), intent(out) :: ierr

      ierr = set_argument_pointer_integer(compute_arguments, &
        compute_argument_name, c_loc(int1))
    end subroutine set
  end subroutine kim_compute_arguments_set_argument_pointer_int1

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_int2( &
    compute_arguments_handle, compute_argument_name, int2, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    integer(c_int), intent(in), target :: int2(:,:)
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set(compute_arguments, compute_argument_name, size(int2, 1, c_int), &
      size(int2, 2, c_int), int2, ierr)
    return

  contains
    recursive subroutine set(compute_arguments, compute_argument_name, &
      extent1, extent2, int2, ierr)
      use kim_compute_argument_name_module, only : &
        kim_compute_argument_name_type
      use kim_interoperable_types_module, only : kim_compute_arguments_type
      implicit none
      interface
        integer(c_int) recursive function set_argument_pointer_integer( &
          compute_arguments, compute_argument_name, ptr) &
          bind(c, name="KIM_ComputeArguments_SetArgumentPointerInteger")
          use, intrinsic :: iso_c_binding
          use kim_compute_argument_name_module, only : &
            kim_compute_argument_name_type
          use kim_interoperable_types_module, only : kim_compute_arguments_type
          implicit none
          type(kim_compute_arguments_type), intent(in) :: compute_arguments
          type(kim_compute_argument_name_type), intent(in), value :: &
            compute_argument_name
          type(c_ptr), intent(in), value :: ptr
        end function set_argument_pointer_integer
      end interface
      type(kim_compute_arguments_type), intent(in) :: compute_arguments
      type(kim_compute_argument_name_type), intent(in) :: &
        compute_argument_name
      integer(c_int), intent(in) :: extent1
      integer(c_int), intent(in) :: extent2
      integer(c_int), intent(in), target :: int2(extent1,extent2)
      integer(c_int), intent(out) :: ierr

      ierr = set_argument_pointer_integer(compute_arguments, &
        compute_argument_name, c_loc(int2))
    end subroutine set
  end subroutine kim_compute_arguments_set_argument_pointer_int2

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_double0( &
    compute_arguments_handle, compute_argument_name, double0, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function set_argument_pointer_double( &
        compute_arguments, compute_argument_name, ptr) &
        bind(c, name="KIM_ComputeArguments_SetArgumentPointerDouble")
        use, intrinsic :: iso_c_binding
        use kim_compute_argument_name_module, only : &
          kim_compute_argument_name_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(c_ptr), intent(in), value :: ptr
      end function set_argument_pointer_double
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    real(c_double), intent(in), target :: double0
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = set_argument_pointer_double(compute_arguments, &
      compute_argument_name, c_loc(double0))
  end subroutine kim_compute_arguments_set_argument_pointer_double0

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_double1( &
    compute_arguments_handle, compute_argument_name, double1, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    real(c_double), intent(in), target :: double1(:)
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set(compute_arguments, compute_argument_name, &
      size(double1, 1, c_int), double1, ierr)
    return

  contains
    recursive subroutine set(compute_arguments, compute_argument_name, &
      extent1, double1, ierr)
      use kim_compute_argument_name_module, only : &
        kim_compute_argument_name_type
      use kim_interoperable_types_module, only : kim_compute_arguments_type
      implicit none
      interface
        integer(c_int) recursive function set_argument_pointer_double( &
          compute_arguments, compute_argument_name, ptr) &
          bind(c, name="KIM_ComputeArguments_SetArgumentPointerDouble")
          use, intrinsic :: iso_c_binding
          use kim_compute_argument_name_module, only : &
            kim_compute_argument_name_type
          use kim_interoperable_types_module, only : kim_compute_arguments_type
          implicit none
          type(kim_compute_arguments_type), intent(in) :: compute_arguments
          type(kim_compute_argument_name_type), intent(in), value :: &
            compute_argument_name
          type(c_ptr), intent(in), value :: ptr
        end function set_argument_pointer_double
      end interface
      type(kim_compute_arguments_type), intent(in) :: compute_arguments
      type(kim_compute_argument_name_type), intent(in) :: &
        compute_argument_name
      integer(c_int), intent(in) :: extent1
      real(c_double), intent(in), target :: double1(extent1)
      integer(c_int), intent(out) :: ierr

      ierr = set_argument_pointer_double(compute_arguments, &
        compute_argument_name, c_loc(double1))
    end subroutine set
  end subroutine kim_compute_arguments_set_argument_pointer_double1

  !> \brief \copybrief KIM::ComputeArguments::SetArgumentPointer
  !!
  !! \sa KIM::ComputeArguments::SetArgumentPointer,
  !! KIM_ComputeArguments_SetArgumentPointerDouble
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_argument_pointer_double2( &
    compute_arguments_handle, compute_argument_name, double2, ierr)
    use kim_compute_argument_name_module, only : kim_compute_argument_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    real(c_double), intent(in), target :: double2(:,:)
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set(compute_arguments, compute_argument_name, &
      size(double2, 1, c_int), size(double2, 2, c_int), double2, ierr)
    return

  contains
    recursive subroutine set(compute_arguments, compute_argument_name, &
      extent1, extent2, double2, ierr)
      use kim_compute_argument_name_module, only : &
        kim_compute_argument_name_type
      implicit none
      interface
        integer(c_int) recursive function set_argument_pointer_double( &
          compute_arguments, compute_argument_name, ptr) &
          bind(c, name="KIM_ComputeArguments_SetArgumentPointerDouble")
          use, intrinsic :: iso_c_binding
          use kim_compute_argument_name_module, only : &
            kim_compute_argument_name_type
          use kim_interoperable_types_module, only : kim_compute_arguments_type
          implicit none
          type(kim_compute_arguments_type), intent(in) :: compute_arguments
          type(kim_compute_argument_name_type), intent(in), value :: &
            compute_argument_name
          type(c_ptr), intent(in), value :: ptr
        end function set_argument_pointer_double
      end interface
      type(kim_compute_arguments_type), intent(in) :: compute_arguments
      type(kim_compute_argument_name_type), intent(in) :: &
        compute_argument_name
      integer(c_int), intent(in) :: extent1
      integer(c_int), intent(in) :: extent2
      real(c_double), intent(in), target :: double2(extent1,extent2)
      integer(c_int), intent(out) :: ierr

      ierr = set_argument_pointer_double(compute_arguments, &
        compute_argument_name, c_loc(double2))
    end subroutine set
  end subroutine kim_compute_arguments_set_argument_pointer_double2

  !> \brief \copybrief KIM::ComputeArguments::SetCallbackPointer
  !!
  !! \sa KIM::ComputeArguments::SetCallbackPointer,
  !! KIM_ComputeArguments_SetCallbackPointer
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_callback_pointer( &
    compute_arguments_handle, compute_callback_name, language_name, fptr, &
    data_object, ierr)
    use kim_compute_callback_name_module, only : kim_compute_callback_name_type
    use kim_language_name_module, only : kim_language_name_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function set_callback_pointer( &
        compute_arguments, compute_callback_name, language_name, fptr, &
        data_object) bind(c, name="KIM_ComputeArguments_SetCallbackPointer")
        use, intrinsic :: iso_c_binding
        use kim_language_name_module, only : kim_language_name_type
        use kim_compute_callback_name_module, only : &
          kim_compute_callback_name_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_language_name_type), intent(in), value :: language_name
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
        type(c_funptr), intent(in), value :: fptr
        type(c_ptr), intent(in), value :: data_object
      end function set_callback_pointer
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_callback_name_type), intent(in) :: &
      compute_callback_name
    type(kim_language_name_type), intent(in) :: language_name
    type(c_funptr), intent(in), value :: fptr  ! must be left as "value"!?!
    type(c_ptr), intent(in) :: data_object
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = set_callback_pointer(compute_arguments, compute_callback_name, &
      language_name, fptr, data_object)
  end subroutine kim_compute_arguments_set_callback_pointer

  !> \brief \copybrief KIM::ComputeArguments::<!--
  !! -->AreAllRequiredArgumentsAndCallbacksPresent
  !!
  !! \sa KIM::ComputeArguments::AreAllRequiredArgumentsAndCallbacksPresent,
  !! KIM_ComputeArguments_AreAllRequiredArgumentsAndCallbacksPresent
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_are_all_required_present( &
    compute_arguments_handle, result_value, ierr)
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      integer(c_int) recursive function &
        are_all_required_arguments_and_callbacks_present( &
        compute_arguments, result_value) bind(c, &
        name="KIM_ComputeArguments_AreAllRequiredArgumentsAndCallbacksPresent")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        integer(c_int), intent(out) :: result_value
      end function are_all_required_arguments_and_callbacks_present
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    integer(c_int), intent(out) :: result_value
    integer(c_int), intent(out) :: ierr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = are_all_required_arguments_and_callbacks_present( &
      compute_arguments, result_value)
  end subroutine kim_compute_arguments_are_all_required_present

  !> \brief \copybrief KIM::ComputeArguments::SetSimulatorBufferPointer
  !!
  !! \sa KIM::ComputeArguments::SetSimulatorBufferPointer,
  !! KIM_ComputeArguments_SetSimulatorBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_simulator_buffer_pointer( &
    compute_arguments_handle, ptr)
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      recursive subroutine set_simulator_buffer_pointer(compute_arguments, &
        ptr) bind(c, name="KIM_ComputeArguments_SetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_simulator_buffer_pointer
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set_simulator_buffer_pointer(compute_arguments, ptr)
  end subroutine kim_compute_arguments_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::ComputeArguments::GetSimulatorBufferPointer
  !!
  !! \sa KIM::ComputeArguments::GetSimulatorBufferPointer,
  !! KIM_ComputeArguments_GetSimulatorBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_get_simulator_buffer_pointer( &
    compute_arguments_handle, ptr)
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      recursive subroutine get_simulator_buffer_pointer(compute_arguments, &
        ptr) bind(c, name="KIM_ComputeArguments_GetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(c_ptr), intent(out) :: ptr
      end subroutine get_simulator_buffer_pointer
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call get_simulator_buffer_pointer(compute_arguments, ptr)
  end subroutine kim_compute_arguments_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::ComputeArguments::ToString
  !!
  !! \sa KIM::ComputeArguments::ToString, KIM_ComputeArguments_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_to_string( &
    compute_arguments_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      type(c_ptr) recursive function compute_arguments_string( &
        compute_arguments) bind(c, name="KIM_ComputeArguments_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
      end function compute_arguments_string
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_compute_arguments_type), pointer :: compute_arguments

    type(c_ptr) :: p

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    p = compute_arguments_string(compute_arguments)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_compute_arguments_to_string

  !> \brief \copybrief KIM::ComputeArguments::SetLogID
  !!
  !! \sa KIM::ComputeArguments::SetLogID, KIM_ComputeArguments_SetLogID
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_set_log_id( &
    compute_arguments_handle, log_id)
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      recursive subroutine set_log_id(compute_arguments, log_id) &
        bind(c, name="KIM_ComputeArguments_SetLogID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        character(c_char), intent(in) :: log_id(*)
      end subroutine set_log_id
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    character(len=*, kind=c_char), intent(in) :: log_id
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call set_log_id(compute_arguments, trim(log_id)//c_null_char)
  end subroutine kim_compute_arguments_set_log_id

  !> \brief \copybrief KIM::ComputeArguments::PushLogVerbosity
  !!
  !! \sa KIM::ComputeArguments::PushLogVerbosity,
  !! KIM_ComputeArguments_PushLogVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_push_log_verbosity( &
    compute_arguments_handle, log_verbosity)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      recursive subroutine push_log_verbosity(compute_arguments, &
        log_verbosity) bind(c, name="KIM_ComputeArguments_PushLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_log_verbosity
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call push_log_verbosity(compute_arguments, log_verbosity)
  end subroutine kim_compute_arguments_push_log_verbosity

  !> \brief \copybrief KIM::ComputeArguments::PopLogVerbosity
  !!
  !! \sa KIM::ComputeArguments::PopLogVerbosity,
  !! KIM_ComputeArguments_PopLogVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_compute_arguments_pop_log_verbosity( &
    compute_arguments_handle)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type
    implicit none
    interface
      recursive subroutine pop_log_verbosity(compute_arguments) &
        bind(c, name="KIM_ComputeArguments_PopLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        implicit none
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
      end subroutine pop_log_verbosity
    end interface
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    call pop_log_verbosity(compute_arguments)
  end subroutine kim_compute_arguments_pop_log_verbosity
end module kim_compute_arguments_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::Collection
!!
!! \sa KIM::Collection, KIM_Collection
!!
!! \since 2.1
module kim_collection_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_collection_type, &

    ! Constants
    KIM_COLLECTION_SYSTEM, &
    KIM_COLLECTION_USER, &
    KIM_COLLECTION_ENVIRONMENT_VARIABLE, &
    KIM_COLLECTION_CURRENT_WORKING_DIRECTORY, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_collections, &
    kim_get_collection


  !> \brief \copybrief KIM::Collection
  !!
  !! \sa KIM::Collection, KIM_Collection
  !!
  !! \since 2.1
  type, bind(c) :: kim_collection_type
     !> \brief \copybrief KIM::Collection::collectionID
     !!
     !! \sa KIM::Collection::collectionID, KIM_Collection::collectionID
     !!
     !! \since 2.1
    integer(c_int) collection_id
  end type kim_collection_type

  !> \brief \copybrief KIM::COLLECTION::system
  !!
  !! \sa KIM::COLLECTION::system, KIM_COLLECTION_system
  !!
  !! \since 2.1
  type(kim_collection_type), protected, save, &
    bind(c, name="KIM_COLLECTION_system") &
    :: KIM_COLLECTION_SYSTEM

  !> \brief \copybrief KIM::COLLECTION::user
  !!
  !! \sa KIM::COLLECTION::user, KIM_COLLECTION_user
  !!
  !! \since 2.1
  type(kim_collection_type), protected, save, &
    bind(c, name="KIM_COLLECTION_user") &
    :: KIM_COLLECTION_USER

  !> \brief \copybrief KIM::COLLECTION::environmentVariable
  !!
  !! \sa KIM::COLLECTION::environmentVariable,
  !! KIM_COLLECTION_environmentVariable
  !!
  !! \since 2.1
  type(kim_collection_type), protected, save, &
    bind(c, name="KIM_COLLECTION_environmentVariable") &
    :: KIM_COLLECTION_ENVIRONMENT_VARIABLE

  !> \brief \copybrief KIM::COLLECTION::currentWorkingDirectory
  !!
  !! \sa KIM::COLLECTION::currentWorkingDirectory,
  !! KIM_COLLECTION_currentWorkingDirectory
  !!
  !! \since 2.1
  type(kim_collection_type), protected, save, &
    bind(c, name="KIM_COLLECTION_currentWorkingDirectory") &
    :: KIM_COLLECTION_CURRENT_WORKING_DIRECTORY

  !> \brief \copybrief KIM::Collection::Known
  !!
  !! \sa KIM::Collection::Known, KIM_Collection_Known
  !!
  !! \since 2.1
  interface kim_known
    module procedure kim_collection_known
  end interface kim_known

  !> \brief \copybrief KIM::Collection::operator==()
  !!
  !! \sa KIM::Collection::operator==(), KIM_Collection_Equal
  !!
  !! \since 2.1
  interface operator (.eq.)
    module procedure kim_collection_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::Collection::operator!=()
  !!
  !! \sa KIM::Collection::operator!=(), KIM_Collection_NotEqual
  !!
  !! \since 2.1
  interface operator (.ne.)
    module procedure kim_collection_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::Collection::Collection(std::string const &)
  !!
  !! \sa KIM::Collection::Collection(std::string const &),
  !! KIM_Collection_FromString
  !!
  !! \since 2.1
  interface kim_from_string
    module procedure kim_collection_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::Collection::ToString
  !!
  !! \sa KIM::Collection::ToString, KIM_Collection_ToString
  !!
  !! \since 2.1
  interface kim_to_string
    module procedure kim_collection_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::Collection::Known
  !!
  !! \sa KIM::Collection::Known, KIM_Collection_Known
  !!
  !! \since 2.1
  logical recursive function kim_collection_known(collection)
    implicit none
    interface
      integer(c_int) recursive function known(collection) &
        bind(c, name="KIM_Collection_Known")
        use, intrinsic :: iso_c_binding
        import kim_collection_type
        implicit none
        type(kim_collection_type), intent(in), value :: collection
      end function known
    end interface
    type(kim_collection_type), intent(in) :: collection

    kim_collection_known = (known(collection) /= 0)
  end function kim_collection_known

  !> \brief \copybrief KIM::Collection::operator==()
  !!
  !! \sa KIM::Collection::operator==(), KIM_Collection_Equal
  !!
  !! \since 2.1
  logical recursive function kim_collection_equal(lhs, rhs)
    implicit none
    type(kim_collection_type), intent(in) :: lhs
    type(kim_collection_type), intent(in) :: rhs

    kim_collection_equal &
      = (lhs%collection_id .eq. rhs%collection_id)
  end function kim_collection_equal

  !> \brief \copybrief KIM::Collection::operator!=()
  !!
  !! \sa KIM::Collection::operator!=(), KIM_Collection_NotEqual
  !!
  !! \since 2.1
  logical recursive function kim_collection_not_equal(lhs, rhs)
    implicit none
    type(kim_collection_type), intent(in) :: lhs
    type(kim_collection_type), intent(in) :: rhs

    kim_collection_not_equal = .not. (lhs .eq. rhs)
  end function kim_collection_not_equal

  !> \brief \copybrief KIM::Collection::Collection(std::string const &)
  !!
  !! \sa KIM::Collection::Collection(std::string const &),
  !! KIM_Collection_FromString
  !!
  !! \since 2.1
  recursive subroutine kim_collection_from_string(string, collection)
    implicit none
    interface
      type(kim_collection_type) recursive function from_string(string) &
        bind(c, name="KIM_Collection_FromString")
        use, intrinsic :: iso_c_binding
        import kim_collection_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_collection_type), intent(out) :: collection

    collection = from_string(trim(string)//c_null_char)
  end subroutine kim_collection_from_string

  !> \brief \copybrief KIM::Collection::ToString
  !!
  !! \sa KIM::Collection::ToString, KIM_Collection_ToString
  !!
  !! \since 2.1
  recursive subroutine kim_collection_to_string(collection, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(collection) &
        bind(c, name="KIM_Collection_ToString")
        use, intrinsic :: iso_c_binding
        import kim_collection_type
        implicit none
        type(kim_collection_type), intent(in), value :: collection
      end function get_string
    end interface
    type(kim_collection_type), intent(in) :: collection
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(collection)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_collection_to_string

  !> \brief \copybrief KIM::COLLECTION::GetNumberOfCollections
  !!
  !! \sa KIM::COLLECTION::GetNumberOfCollections,
  !! KIM_COLLECTION_GetNumberOfCollections
  !!
  !! \since 2.1
  recursive subroutine kim_get_number_of_collections(number_of_collections)
    implicit none
    interface
      recursive subroutine get_number_of_collections(number_of_collections) &
        bind(c, name="KIM_COLLECTION_GetNumberOfCollections")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_collections
      end subroutine get_number_of_collections
    end interface
    integer(c_int), intent(out) :: number_of_collections

    call get_number_of_collections(number_of_collections)
  end subroutine kim_get_number_of_collections

  !> \brief \copybrief KIM::COLLECTION::GetCollection
  !!
  !! \sa KIM::COLLECTION::GetCollection, KIM_COLLECTION_GetCollection
  !!
  !! \since 2.1
  recursive subroutine kim_get_collection(index, collection, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_collection(index, collection) &
        bind(c, name="KIM_COLLECTION_GetCollection")
        use, intrinsic :: iso_c_binding
        import kim_collection_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_collection_type), intent(out) :: collection
      end function get_collection
    end interface
    integer(c_int), intent(in) :: index
    type(kim_collection_type), intent(out) :: collection
    integer(c_int), intent(out) :: ierr

    ierr = get_collection(index-1, collection)
  end subroutine kim_get_collection
end module kim_collection_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2013--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

module error
  use, intrinsic :: iso_c_binding
  implicit none

  public

contains
  recursive subroutine my_error(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *,"* Error : ", trim(message)
    stop 1
  end subroutine my_error
end module error

module utilities
  implicit none

  public

contains
  subroutine dirs_for_collection(collection, col)
    use, intrinsic :: iso_c_binding
    use kim_collections_module
    use kim_collection_module
    use kim_collection_item_type_module
    implicit none
    type(kim_collection_type), intent(in) :: collection
    type(kim_collections_handle_type), intent(inout) :: col

    integer(c_int) ierr
    integer(c_int) i
    integer(c_int) extent
    character(len=2048, kind=c_char) coll_str
    character(len=2048, kind=c_char) item_type_str
    character(len=2048, kind=c_char) dir_str


    call kim_cache_list_of_directory_names(col, collection, &
      KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER, extent, ierr)
    call kim_to_string(collection, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_directory_name(col, i, dir_str, ierr)
      print '(A,A)', achar(9), trim(dir_str)
    end do

    call kim_cache_list_of_directory_names(col, collection, &
      KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL, extent, ierr)
    call kim_to_string(collection, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_directory_name(col, i, dir_str, ierr)
      print '(A,A)', achar(9), trim(dir_str)
    end do

    call kim_cache_list_of_directory_names(col, collection, &
      KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL, extent, ierr)
    call kim_to_string(collection, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_directory_name(col, i, dir_str, ierr)
      print '(A,A)', achar(9), trim(dir_str)
    end do
  end subroutine dirs_for_collection

  subroutine names_for_collection(kc, col)
    use, intrinsic :: iso_c_binding
    use kim_collections_module
    use kim_collection_module
    use kim_collection_item_type_module
    implicit none
    type(kim_collection_type), intent(in) :: kc
    type(kim_collections_handle_type), intent(inout) :: col

    integer(c_int) ierr
    integer(c_int) i
    integer(c_int) extent
    character(len=2048, kind=c_char) coll_str
    character(len=2048, kind=c_char) item_type_str
    character(len=2048, kind=c_char) name_str

    call kim_cache_list_of_item_names_by_collection_and_type(col, kc, &
      KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER, extent, ierr)
    call kim_to_string(kc, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_item_name_by_collection_and_type(col, i, name_str, ierr)
      print '(A,A)', achar(9), trim(name_str)
    end do

    call kim_cache_list_of_item_names_by_collection_and_type(col, kc, &
      KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL, extent, ierr)
    call kim_to_string(kc, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_item_name_by_collection_and_type(col, i, name_str, ierr)
      print '(A,A)', achar(9), trim(name_str)
    end do

    call kim_cache_list_of_item_names_by_collection_and_type(col, kc, &
      KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL, extent, ierr)
    call kim_to_string(kc, coll_str)
    call kim_to_string(KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL, item_type_str)
    print '(A,":",A," :")', trim(coll_str), trim(item_type_str)

    do i=1,extent
      call kim_get_item_name_by_collection_and_type(col, i, name_str, ierr)
      print '(A,A)', achar(9), trim(name_str)
    end do
  end subroutine names_for_collection
end module utilities

!-------------------------------------------------------------------------------
!
! Main program
!
!-------------------------------------------------------------------------------
program collections_example_fortran
  use, intrinsic :: iso_c_binding
  use error
  use utilities
  use kim_collection_module
  use kim_collection_item_type_module
  use kim_collections_module
  implicit none

  integer(c_int) :: ierr
  integer(c_int) :: extent
  integer(c_int) :: i
  type(kim_collections_handle_type) :: col
  type(kim_collection_type) col_t
  type(kim_collection_item_type_type) it
  character(len=2048, kind=c_char) project_name
  character(len=2048, kind=c_char) sem_ver
  character(len=2048, kind=c_char) name
  character(len=2048, kind=c_char) value
  character(len=2048, kind=c_char) file_name
  integer(c_long) file_length
  integer(c_int) available_as_string
  integer(c_signed_char) file_raw_data(10000)
  character(len=10000, kind=c_char) file_string
  character(len=2048, kind=c_char) item_type_str

  call kim_collections_create(col, ierr)

  if (ierr /= 0) then
    call my_error("Unable to create collections object.")
  end if

  call kim_get_project_name_and_sem_ver(col, project_name, sem_ver)
  print *, "Project : ", trim(project_name)
  print *, "semVer  : ", trim(sem_ver)
  print *, ""



  it = KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER
  call kim_get_environment_variable_name(col, it, name, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," env name : ",A)', trim(item_type_str), trim(name)
  print *, ""

  it = KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL
  call kim_get_environment_variable_name(col, it, name, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," env name : ",A)', trim(item_type_str), trim(name)
  print *, ""

  it = KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL
  call kim_get_environment_variable_name(col, it, name, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," env name : ",A)', trim(item_type_str), trim(name)
  print *, ""

  call kim_get_configuration_file_environment_variable(col, name, value)
  print '("config file env name  : ",A)', trim(name)
  print '("config file env value : ",A)', trim(value)
  print *, ""

  call kim_get_configuration_file_name(col, file_name)
  print '("config file name : ",A)', trim(file_name)
  print *, ""

  call dirs_for_collection(KIM_COLLECTION_SYSTEM, col)
  call dirs_for_collection(KIM_COLLECTION_USER, col)
  call dirs_for_collection(KIM_COLLECTION_ENVIRONMENT_VARIABLE, col)
  call dirs_for_collection(KIM_COLLECTION_CURRENT_WORKING_DIRECTORY, col)
  print *, ""

  call names_for_collection(KIM_COLLECTION_SYSTEM, col)
  call names_for_collection(KIM_COLLECTION_USER, col)
  call names_for_collection(KIM_COLLECTION_ENVIRONMENT_VARIABLE, col)
  call names_for_collection(KIM_COLLECTION_CURRENT_WORKING_DIRECTORY, col)
  print *, ""

  it = KIM_COLLECTION_ITEM_TYPE_MODEL_DRIVER
  call kim_cache_list_of_item_names_by_type(col, it, extent, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," :")', trim(item_type_str)
  do i=1,extent
    call kim_get_item_name_by_type(col, i, name, ierr)
    print '(A,A)', achar(9), trim(name)
  end do

  it = KIM_COLLECTION_ITEM_TYPE_PORTABLE_MODEL
  call kim_cache_list_of_item_names_by_type(col, it, extent, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," :")', trim(item_type_str)
  do i=1,extent
    call kim_get_item_name_by_type(col, i, name, ierr)
    print '(A,A)', achar(9), trim(name)
  end do

  it = KIM_COLLECTION_ITEM_TYPE_SIMULATOR_MODEL
  call kim_cache_list_of_item_names_by_type(col, it, extent, ierr)
  call kim_to_string(it, item_type_str)
  print '(A," :")', trim(item_type_str)
  do i=1,extent
    call kim_get_item_name_by_type(col, i, name, ierr)
    print '(A,A)', achar(9), trim(name)
  end do

  call kim_get_item_library_file_name_and_collection(col, it, &
    trim("Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu"), name, col_t, ierr)
  if (ierr /= 0) then
    print '(A)', "Error from GetItemLibraryFileNameAndCollection"
  else
    call kim_to_string(col_t, value)
    print '(A,A,A,A,A)', &
      "Simulator Model Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu has library name '", &
      trim(name), "' and is part of the '", trim(value), "' collection."
  end if

  call kim_cache_list_of_item_metadata_files(col, it, &
    trim("Sim_LAMMPS_LJcut_AkersonElliott_Alchemy_PbAu"), extent, ierr)
  if (ierr /= 0) then
    print '(A)', "Error from CacheListOfItemMetadataFiles"
  else
    do i=1,extent
      call kim_get_item_metadata_file_length(col, i, file_length, &
        available_as_string, ierr)
      call kim_get_item_metadata_file_values(col, i, file_name, &
        file_raw_data, file_string, ierr)
      print '(A,I2,A,A,A,I6)', "Metadata File ", i, ", ", trim(file_name), &
        ", is of length", file_length
      print '(A)', trim(file_string)
    end do
  end if

  call kim_collections_destroy(col)

end program collections_example_fortran

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ellad B. Tadmor
!    Ryan S. Elliott
!    Stephen M. Whalen
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

module error
  use, intrinsic :: iso_c_binding
  implicit none

  public

contains
  recursive subroutine my_error(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Error : ", trim(message)
    stop 1
  end subroutine my_error

  recursive subroutine my_warning(message)
    implicit none
    character(len=*, kind=c_char), intent(in) :: message

    print *, "* Warning : ", trim(message)
  end subroutine my_warning
end module error

!-------------------------------------------------------------------------------
!
! module mod_neighborlist :
!
!    Module contains type and routines related to neighbor list calculation
!
!-------------------------------------------------------------------------------

module mod_neighborlist

  use, intrinsic :: iso_c_binding

  public get_neigh

  type, bind(c) :: neighObject_type
    real(c_double) :: cutoff
    integer(c_int) :: number_of_particles
    type(c_ptr) :: neighbor_list_pointer
  end type neighObject_type
contains

  !-----------------------------------------------------------------------------
  !
  ! get_neigh neighbor list access function
  !
  ! This function implements Locator and Iterator mode
  !
  !-----------------------------------------------------------------------------
  recursive subroutine get_neigh(data_object, number_of_neighbor_lists, &
                                 cutoffs, neighbor_list_index, request, &
                                 numnei, pnei1part, ierr) bind(c)
    use error
    implicit none

    !-- Transferred variables
    type(c_ptr), value, intent(in) :: data_object
    integer(c_int), value, intent(in) :: number_of_neighbor_lists
    real(c_double), intent(in) :: cutoffs(*)
    integer(c_int), value, intent(in) :: neighbor_list_index
    integer(c_int), value, intent(in)  :: request
    integer(c_int), intent(out) :: numnei
    type(c_ptr), intent(out) :: pnei1part
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    integer(c_int) numberOfParticles
    type(neighObject_type), pointer :: neighObject
    integer(c_int), pointer :: neighborList(:, :)

    call c_f_pointer(data_object, neighObject)
    numberOfParticles = neighObject%number_of_particles
    call c_f_pointer(neighObject%neighbor_list_pointer, neighborList, &
                     [numberOfParticles + 1, numberOfParticles])

    if (number_of_neighbor_lists /= 1) then
      call my_warning("invalid number of cutoffs")
      ierr = 1
      return
    end if

    if (cutoffs(1) > neighObject%cutoff) then
      call my_warning("neighbor list cutoff too small for model cutoff")
      ierr = 1
      return
    end if

    if (neighbor_list_index /= 1) then
      call my_warning("wrong list index")
      ierr = 1
      return
    end if

    if ((request > numberOfParticles) .or. (request < 1)) then
      print *, request
      call my_warning("Invalid part ID in get_neigh")
      ierr = 1
      return
    end if

    ! set the returned number of neighbors for the returned part
    numnei = neighborList(1, request)

    ! set the location for the returned neighbor list
    pnei1part = c_loc(neighborList(2, request))

    ierr = 0
    return
  end subroutine get_neigh

end module mod_neighborlist

module mod_utility
  implicit none
  public

contains

  !-----------------------------------------------------------------------------
  !
  ! NEIGH_PURE_cluster_neighborlist
  !
  !-----------------------------------------------------------------------------
  recursive subroutine NEIGH_PURE_cluster_neighborlist( &
    half, numberOfParticles, coords, cutoff, neighObject)
    use, intrinsic :: iso_c_binding
    use mod_neighborlist
    implicit none

    !-- Transferred variables
    logical, intent(in)            :: half
    integer(c_int), intent(in)            :: numberOfParticles
    real(c_double), dimension(3, numberOfParticles), &
      intent(in)            :: coords
    real(c_double), intent(in)            :: cutoff
    type(neighObject_type), intent(inout) :: neighObject

    !-- Local variables
    integer(c_int) i, j, a
    real(c_double) dx(3)
    real(c_double) r2
    real(c_double) cutoff2
    integer(c_int), pointer :: neighborList(:, :)

    call c_f_pointer(neighObject%neighbor_list_pointer, neighborList, &
                     [numberOfParticles + 1, numberOfParticles])

    neighObject%cutoff = cutoff

    cutoff2 = cutoff**2

    do i = 1, numberOfParticles
      a = 1
      do j = 1, numberOfParticles
        dx(:) = coords(:, j) - coords(:, i)
        r2 = dot_product(dx, dx)
        if (r2 <= cutoff2) then
          ! part j is a neighbor of part i
          if ((j > i) .OR. ((.not. half) .AND. (i /= j))) then
            a = a + 1
            neighborList(a, i) = j
          end if
        end if
      end do
      ! part i has a-1 neighbors
      neighborList(1, i) = a - 1
    end do

    return

  end subroutine NEIGH_PURE_cluster_neighborlist

  !-----------------------------------------------------------------------------
  !
  ! create_FCC_configuration subroutine
  !
  !  creates a cubic configuration of FCC particles with lattice spacing
  !  `FCCspacing' and `nCellsPerSide' cells along each direction.
  !
  !  With periodic==.true. this will result in a total number of particles equal
  !  to 4*(nCellsPerSide)**3 + 6*(nCellsPerSide)**2 + 3*(nCellsPerSide) + 1
  !
  !  With periodic==.false. this will result in a total number of particles equal
  !  to 4*(nCellsPerSide)**3
  !
  !  Returns the Id of the particle situated in the middle of the configuration
  !  (this particle will have the most neighbors.)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine create_FCC_configuration(FCCspacing, nCellsPerSide, &
                                                periodic, coords, MiddlePartId)
    use, intrinsic :: iso_c_binding
    implicit none
    integer(c_int), parameter :: cd = c_double ! used for literal constants

    !-- Transferred variables
    real(c_double), intent(in)  :: FCCspacing
    integer(c_int), intent(in)  :: nCellsPerSide
    logical, intent(in)  :: periodic
    real(c_double), intent(out) :: coords(3, *)
    integer(c_int), intent(out) :: MiddlePartId
    !
    ! cluster setup variables
    !
    real(c_double) FCCshifts(3, 4)
    real(c_double) latVec(3)
    integer(c_int) a, i, j, k, m

    ! Create a cubic FCC cluster
    !
    FCCshifts(1, 1) = 0.0_cd
    FCCshifts(2, 1) = 0.0_cd
    FCCshifts(3, 1) = 0.0_cd
    FCCshifts(1, 2) = 0.5_cd * FCCspacing
    FCCshifts(2, 2) = 0.5_cd * FCCspacing
    FCCshifts(3, 2) = 0.0_cd
    FCCshifts(1, 3) = 0.5_cd * FCCspacing
    FCCshifts(2, 3) = 0.0_cd
    FCCshifts(3, 3) = 0.5_cd * FCCspacing
    FCCshifts(1, 4) = 0.0_cd
    FCCshifts(2, 4) = 0.5_cd * FCCspacing
    FCCshifts(3, 4) = 0.5_cd * FCCspacing

    MiddlePartID = 1 ! Always put middle particle as #1
    a = 1            ! leave space for middle particle as particle #1
    do i = 1, nCellsPerSide
      latVec(1) = (i - 1) * FCCspacing
      do j = 1, nCellsPerSide
        latVec(2) = (j - 1) * FCCspacing
        do k = 1, nCellsPerSide
          latVec(3) = (k - 1) * FCCspacing
          do m = 1, 4
            a = a + 1
            coords(:, a) = latVec + FCCshifts(:, m)
            if ((i == nCellsPerside / 2 + 1) &
                .and. (j == nCellsPerSide / 2 + 1) &
                .and. (k == nCellsPerSide / 2 + 1) &
                .and. (m == 1)) &
              then
              ! put middle particle as #1
              coords(:, 1) = latVec + FCCshifts(:, m)
              a = a - 1
            end if
          end do
        end do
        if (.not. periodic) then
          ! Add in the remaining three faces
          ! pos-x face
          latVec(1) = nCellsPerSide * FCCspacing
          latVec(2) = (i - 1) * FCCspacing
          latVec(3) = (j - 1) * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 4)
          ! pos-y face
          latVec(1) = (i - 1) * FCCspacing
          latVec(2) = nCellsPerSide * FCCspacing
          latVec(3) = (j - 1) * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 3)
          ! pos-z face
          latVec(1) = (i - 1) * FCCspacing
          latVec(2) = (j - 1) * FCCspacing
          latVec(3) = nCellsPerSide * FCCspacing
          a = a + 1; coords(:, a) = latVec
          a = a + 1; coords(:, a) = latVec + FCCshifts(:, 2)
        end if
      end do
      if (.not. periodic) then
        ! Add in the remaining three edges
        latVec(1) = (i - 1) * FCCspacing
        latVec(2) = nCellsPerSide * FCCspacing
        latVec(3) = nCellsPerSide * FCCspacing
        a = a + 1; coords(:, a) = latVec
        latVec(1) = nCellsPerSide * FCCspacing
        latVec(2) = (i - 1) * FCCspacing
        latVec(3) = nCellsPerSide * FCCspacing
        a = a + 1; coords(:, a) = latVec
        latVec(1) = nCellsPerSide * FCCspacing
        latVec(2) = nCellsPerSide * FCCspacing
        latVec(3) = (i - 1) * FCCspacing
        a = a + 1; coords(:, a) = latVec
      end if
    end do
    if (.not. periodic) then
      ! Add in the remaining corner
      a = a + 1; coords(:, a) = nCellsPerSide * FCCspacing
    end if

    return

  end subroutine create_FCC_configuration

end module mod_utility

!*******************************************************************************
!**
!**  PROGRAM vc_forces_numer_deriv
!**
!**  KIM compliant program to perform numerical derivative check on a model
!**
!*******************************************************************************

!-------------------------------------------------------------------------------
!
! Main program
!
!-------------------------------------------------------------------------------
program ex_test_ar_fcc_cluster_fortran
  use, intrinsic :: iso_c_binding
  use error
  use kim_simulator_headers_module
  use kim_supported_extensions_module
  use mod_neighborlist
  use mod_utility
  implicit none
  integer(c_int), parameter :: cd = c_double ! used for literal constants

  integer(c_int), parameter :: nCellsPerSide = 2
  integer(c_int), parameter :: DIM = 3

  real(c_double), parameter :: cutpad = 0.75_cd
  real(c_double), parameter :: FCCspacing = 5.260_cd
  real(c_double), parameter :: min_spacing = 0.8 * FCCspacing
  real(c_double), parameter :: max_spacing = 1.2 * FCCspacing
  real(c_double), parameter :: spacing_incr = 0.025 * FCCspacing
  real(c_double) :: current_spacing
  real(c_double) :: force_norm

  character(len=256, kind=c_char) :: modelname

  integer(c_int), parameter :: N = 4 * (nCellsPerSide)**3 &
                               + 6 * (nCellsPerSide)**2 &
                               + 3 * (nCellsPerSide) + 1

  type(neighObject_type), target :: neighObject
  integer(c_int), allocatable, target :: neighborList(:, :)

  type(kim_model_handle_type) :: model_handle
  type(kim_compute_arguments_handle_type) :: compute_arguments_handle
  real(c_double) :: influence_distance
  integer(c_int) :: number_of_neighbor_lists
  real(c_double) :: cutoff
  real(c_double) :: cutoffs(1)
  integer(c_int) :: &
    model_will_not_request_neighbors_of_noncontributing_particles(1)
  integer(c_int), target :: particle_species_codes(N)
  integer(c_int), target :: particle_contributing(N)
  real(c_double), target :: energy
  real(c_double), target :: coords(DIM, N)
  real(c_double), target :: forces(DIM, N)
  integer(c_int) i, j, ierr, ierr2

  integer(c_int) species_is_supported
  integer(c_int) species_code
  integer(c_int) requested_units_accepted
  integer(c_int) number_of_model_routine_names
  type(kim_model_routine_name_type) model_routine_name
  integer(c_int) present
  integer(c_int) required
  type(kim_supported_extensions_type), target :: supported_extensions
  character(len=KIM_MAX_EXTENSION_ID_LENGTH, kind=c_char) :: id_string

  integer :: middledum

  ! Initialize
  ierr = 0
  supported_extensions%number_of_supported_extensions = 0

  ! Get KIM Model name to use
  print '("Please enter a valid KIM model name: ")'
  read (*, *) modelname

  ! Create empty KIM object
  !
  call kim_model_create(KIM_NUMBERING_ONE_BASED, &
                        KIM_LENGTH_UNIT_A, &
                        KIM_ENERGY_UNIT_EV, &
                        KIM_CHARGE_UNIT_E, &
                        KIM_TEMPERATURE_UNIT_K, &
                        KIM_TIME_UNIT_PS, &
                        trim(modelname), &
                        requested_units_accepted, &
                        model_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_api_create")
  end if

  ! check that we are compatible
  if (requested_units_accepted == 0) then
    call my_error("Must adapt to model units")
  end if

  ! check that we know about all required routines
  call kim_get_number_of_model_routine_names(number_of_model_routine_names)
  do i = 1, number_of_model_routine_names
    call kim_get_model_routine_name(i, model_routine_name, ierr)
    if (ierr /= 0) then
      call my_error("kim_get_model_routine_name")
    end if
    call kim_is_routine_present(model_handle, model_routine_name, present, &
                                required, ierr)
    if (ierr /= 0) then
      call my_error("kim_is_routine_present")
    end if

    if ((present == 1) .and. (required == 1)) then
      if (.not. ((model_routine_name == KIM_MODEL_ROUTINE_NAME_CREATE) &
                 .or. (model_routine_name == &
                       KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_COMPUTE) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_REFRESH) &
                 .or. (model_routine_name == &
                       KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY) &
                 .or. (model_routine_name == KIM_MODEL_ROUTINE_NAME_DESTROY))) &
        then
        call my_error("Unknown required ModelRoutineName found.")
      end if
    end if
  end do

  ! check that model supports Ar
  !
  call kim_get_species_support_and_code( &
    model_handle, KIM_SPECIES_NAME_AR, species_is_supported, species_code, ierr)
  if ((ierr /= 0) .or. (species_is_supported /= 1)) then
    call my_error("Model does not support Ar")
  end if

  ! Check supported extensions, if any
  call kim_is_routine_present( &
    model_handle, KIM_MODEL_ROUTINE_NAME_EXTENSION, present, required, ierr)
  if (ierr /= 0) then
    call my_error("Unable to get Extension present/required.")
  end if
  if (present /= 0) then
    call kim_extension(model_handle, KIM_SUPPORTED_EXTENSIONS_ID, &
                       c_loc(supported_extensions), ierr)
    if (ierr /= 0) then
      call my_error("Error returned from kim_model_extension().")
    end if
    write (*, '(A,I2,A)') "Model Supports ", &
      supported_extensions%number_of_supported_extensions, &
      " Extensions:"
    do i = 1, supported_extensions%number_of_supported_extensions
      call kim_c_char_array_to_string( &
        supported_extensions%supported_extension_id(:, i), id_string)
      write (*, '(A,I2,A,A,A,A,I2)') " supportedExtensionID[", i, '] = "', &
        trim(id_string), '" ', &
        "which has required = ", &
        supported_extensions%supported_extension_required(i)
    end do
  end if

  ! Best-practice is to check that the model is compatible
  ! but we will skip it here

  ! create compute_arguments object
  call kim_compute_arguments_create( &
    model_handle, compute_arguments_handle, ierr)
  if (ierr /= 0) then
    call my_error("kim_model_compute_arguments_create")
  end if

  ! register memory with the KIM system
  ierr = 0
  call kim_set_argument_pointer( &
    compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES, &
    n, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES, &
    particle_species_codes, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING, particle_contributing, &
    ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_COORDINATES, coords, &
    ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, &
    energy, ierr2)
  ierr = ierr + ierr2
  call kim_set_argument_pointer( &
    compute_arguments_handle, KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
    forces, ierr2)
  ierr = ierr + ierr2
  if (ierr /= 0) then
    call my_error("set_argument_pointer")
  end if

  ! Allocate storage for neighbor lists
  !
  allocate (neighborList(N + 1, N))
  neighObject%neighbor_list_pointer = c_loc(neighborList)
  neighObject%number_of_particles = N

  ! Set pointer in KIM object to neighbor list routine and object
  !
  call kim_set_callback_pointer( &
    compute_arguments_handle, KIM_COMPUTE_CALLBACK_NAME_GET_NEIGHBOR_LIST, &
    KIM_LANGUAGE_NAME_FORTRAN, c_funloc(get_neigh), c_loc(neighobject), ierr)
  if (ierr /= 0) then
    call my_error("set_callback_pointer")
  end if

  call kim_get_influence_distance(model_handle, influence_distance)
  call kim_get_number_of_neighbor_lists(model_handle, &
                                        number_of_neighbor_lists)
  if (number_of_neighbor_lists /= 1) then
    call my_error("too many neighbor lists")
  end if
  call kim_get_neighbor_list_values( &
    model_handle, cutoffs, &
    model_will_not_request_neighbors_of_noncontributing_particles, ierr)
  if (ierr /= 0) then
    call my_error("get_neighbor_list_values")
  end if
  cutoff = cutoffs(1)

  ! Setup cluster
  !
  do i = 1, N
    particle_species_codes(i) = species_code
  end do

  ! setup contributing particles
  do i = 1, N
    particle_contributing(i) = 1  ! every particle contributes
  end do

  ! Print output header
  !
  print *
  print *, 'This is Test : ex_test_Ar_fcc_cluster_fortran'
  print *
  print '(80(''-''))'
  print '("Results for KIM Model : ",A)', trim(modelname)

  ! print header
  print '(3A20)', "Energy", "Force Norm", "Lattice Spacing"
  ! do the computations
  current_spacing = min_spacing
  do while (current_spacing < max_spacing)

    call create_FCC_configuration(current_spacing, nCellsPerSide, .false., &
                                  coords, middleDum)
    ! Compute neighbor lists
    call NEIGH_PURE_cluster_neighborlist(.false., N, coords, &
                                         (cutoff + cutpad), neighObject)

    ! Call model compute
    call kim_compute(model_handle, compute_arguments_handle, ierr)
    if (ierr /= 0) then
      call my_error("kim_api_model_compute")
    end if

    ! compue force_norm
    force_norm = 0.0
    do i = 1, N
      do j = 1, DIM
        force_norm = force_norm + forces(j, i) * forces(j, i)
      end do
    end do
    force_norm = sqrt(force_norm)

    ! Print results to screen
    !
    print '(3ES20.10)', energy, force_norm, current_spacing

    current_spacing = current_spacing + spacing_incr
  end do

  ! Deallocate neighbor list object
  deallocate (neighborList)

  call kim_compute_arguments_destroy( &
    model_handle, compute_arguments_handle, ierr)
  if (ierr /= 0) then
    call my_error("compute_arguments_destroy")
  end if
  call kim_model_destroy(model_handle)

end program ex_test_ar_fcc_cluster_fortran

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::Model
!!
!! \sa KIM::Model, KIM_Model
!!
!! \since 2.0
module kim_model_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_handle_type, &

    ! Constants
    KIM_MODEL_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_model_create, &
    kim_model_destroy, &
    kim_is_routine_present, &
    kim_get_influence_distance, &
    kim_get_number_of_neighbor_lists, &
    kim_get_neighbor_list_values, &
    kim_get_units, &
    kim_compute_arguments_create, &
    kim_compute_arguments_destroy, &
    kim_compute, &
    kim_extension, &
    kim_clear_then_refresh, &
    kim_write_parameterized_model, &
    kim_get_species_support_and_code, &
    kim_get_number_of_parameters, &
    kim_get_parameter_metadata, &
    kim_get_parameter, &
    kim_set_parameter, &
    kim_set_simulator_buffer_pointer, &
    kim_get_simulator_buffer_pointer, &
    kim_to_string, &
    kim_set_log_id, &
    kim_push_log_verbosity, &
    kim_pop_log_verbosity


  !> \brief \copybrief KIM::Model
  !!
  !! \sa KIM::Model, KIM_Model
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_handle_type), protected, save &
    :: KIM_MODEL_NULL_HANDLE

  !> \brief Compares kim_model_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::Model::IsRoutinePresent
  !!
  !! \sa KIM::Model::IsRoutinePresent, KIM_Model_IsRoutinePresent
  !!
  !! \since 2.0
  interface kim_is_routine_present
    module procedure kim_model_is_routine_present
  end interface kim_is_routine_present

  !> \brief \copybrief KIM::Model::GetInfluenceDistance
  !!
  !! \sa KIM::Model::GetInfluenceDistance, KIM_Model_GetInfluenceDistance
  !!
  !! \since 2.0
  interface kim_get_influence_distance
    module procedure kim_model_get_influence_distance
  end interface kim_get_influence_distance

  !> \brief Get Model's number of neighbor lists.
  !!
  !! \sa KIM::Model::GetNeighborListPointers, KIM_Model_GetNeighborListPointers
  !!
  !! \since 2.0
  interface kim_get_number_of_neighbor_lists
    module procedure kim_model_get_number_of_neighbor_lists
  end interface kim_get_number_of_neighbor_lists

  !> \brief Get Model's neighbor list values
  !!
  !! \sa KIM::Model::GetNeighborListPointers, KIM_Model_GetNeighborListPointers
  !!
  !! \since 2.0
  interface kim_get_neighbor_list_values
    module procedure kim_model_get_neighbor_list_values
  end interface kim_get_neighbor_list_values

  !> \brief \copybrief KIM::Model::GetUnits
  !!
  !! \sa KIM::Model::GetUnits, KIM_Model_GetUnits
  !!
  !! \since 2.0
  interface kim_get_units
    module procedure kim_model_get_units
  end interface kim_get_units

  !> \brief \copybrief KIM::Model::ComputeArgumentsCreate
  !!
  !! \sa KIM::Model::ComputeArgumentsCreate, KIM_Model_ComputeArgumentsCreate
  !!
  !! \since 2.0
  interface kim_compute_arguments_create
    module procedure kim_model_compute_arguments_create
  end interface kim_compute_arguments_create

  !> \brief \copybrief KIM::Model::ComputeArgumentsDestroy
  !!
  !! \sa KIM::Model::ComputeArgumentsDestroy, KIM_Model_ComputeArgumentsDestroy
  !!
  !! \since 2.0
  interface kim_compute_arguments_destroy
    module procedure kim_model_compute_arguments_destroy
  end interface kim_compute_arguments_destroy

  !> \brief \copybrief KIM::Model::Compute
  !!
  !! \sa KIM::Model::Compute, KIM_Model_Compute
  !!
  !! \since 2.0
  interface kim_compute
    module procedure kim_model_compute
  end interface kim_compute

  !> \brief \copybrief KIM::Model::Extension
  !!
  !! \sa KIM::Model::Extension, KIM_Model_Extension
  !!
  !! \since 2.0
  interface kim_extension
    module procedure kim_model_extension
  end interface kim_extension

  !> \brief \copybrief KIM::Model::ClearThenRefresh
  !!
  !! \sa KIM::Model::ClearThenRefresh, KIM_Model_ClearThenRefresh
  !!
  !! \since 2.0
  interface kim_clear_then_refresh
    module procedure kim_model_clear_then_refresh
  end interface kim_clear_then_refresh

  !> \brief \copybrief KIM::Model::WriteParameterizedModel
  !!
  !! \sa KIM::Model::WriteParameterizedModel, KIM_Model_WriteParameterizedModel
  !!
  !! \since 2.0
  interface kim_write_parameterized_model
    module procedure kim_model_write_parameterized_model
  end interface kim_write_parameterized_model

  !> \brief \copybrief KIM::Model::GetSpeciesSupportAndCode
  !!
  !! \sa KIM::Model::GetSpeciesSupportAndCode,
  !! KIM_Model_GetSpeciesSupportAndCode
  !!
  !! \since 2.0
  interface kim_get_species_support_and_code
    module procedure kim_model_get_species_support_and_code
  end interface kim_get_species_support_and_code

  !> \brief \copybrief KIM::Model::GetNumberOfParameters
  !!
  !! \sa KIM::Model::GetNumberOfParameters, KIM_Model_GetNumberOfParameters
  !!
  !! \since 2.0
  interface kim_get_number_of_parameters
    module procedure kim_model_get_number_of_parameters
  end interface kim_get_number_of_parameters

  !> \brief \copybrief KIM::Model::GetParameterMetadata
  !!
  !! \sa KIM::Model::GetParameterMetadata, KIM_Model_GetParameterMetadata
  !!
  !! \since 2.0
  interface kim_get_parameter_metadata
    module procedure kim_model_get_parameter_metadata
  end interface kim_get_parameter_metadata

  !> \brief \copybrief KIM::Model::GetParameter
  !!
  !! \sa KIM::Model::GetParameter, KIM_Model_GetParameterInteger,
  !! KIM_Model_GetParameterDouble
  !!
  !! \since 2.0
  interface kim_get_parameter
    module procedure kim_model_get_parameter_integer
    module procedure kim_model_get_parameter_double
  end interface kim_get_parameter

  !> \brief \copybrief KIM::Model::SetParameter
  !!
  !! \sa KIM::Model::SetParameter, KIM_Model_SetParameterInteger,
  !! KIM_Model_SetParameterDouble
  !!
  !! \since 2.0
  interface kim_set_parameter
    module procedure kim_model_set_parameter_integer
    module procedure kim_model_set_parameter_double
  end interface kim_set_parameter

  !> \brief \copybrief KIM::Model::SetSimulatorBufferPointer
  !!
  !! \sa KIM::Model::SetSimulatorBufferPointer,
  !! KIM_Model_SetSimulatorBufferPointer
  !!
  !! \since 2.0
  interface kim_set_simulator_buffer_pointer
    module procedure kim_model_set_simulator_buffer_pointer
  end interface kim_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::Model::GetSimulatorBufferPointer
  !!
  !! \sa KIM::Model::GetSimulatorBufferPointer,
  !! KIM_Model_GetSimulatorBufferPointer
  !!
  !! \since 2.0
  interface kim_get_simulator_buffer_pointer
    module procedure kim_model_get_simulator_buffer_pointer
  end interface kim_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::Model::ToString
  !!
  !! \sa KIM::Model::ToString, KIM_Model_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_to_string
  end interface kim_to_string

  !> \brief \copybrief KIM::Model::SetLogID
  !!
  !! \sa KIM::Model::SetLogID, KIM_Model_SetLogID
  !!
  !! \since 2.0
  interface kim_set_log_id
    module procedure kim_model_set_log_id
  end interface kim_set_log_id

  !> \brief \copybrief KIM::Model::PushLogVerbosity
  !!
  !! \sa KIM::Model::PushLogVerbosity, KIM_Model_PushLogVerbosity
  !!
  !! \since 2.0
  interface kim_push_log_verbosity
    module procedure kim_model_push_log_verbosity
  end interface kim_push_log_verbosity

  !> \brief \copybrief KIM::Model::PopLogVerbosity
  !!
  !! \sa KIM::Model::, KIM_Model_PopLogVerbosity
  !!
  !! \since 2.0
  interface kim_pop_log_verbosity
    module procedure kim_model_pop_log_verbosity
  end interface kim_pop_log_verbosity

contains
  !> \brief Compares kim_model_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_handle_equal(lhs, rhs)
    implicit none
    type(kim_model_handle_type), intent(in) :: lhs
    type(kim_model_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_handle_equal = .true.
    else
      kim_model_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_handle_equal

  !> \brief Compares kim_model_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_model_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_handle_type), intent(in) :: lhs
    type(kim_model_handle_type), intent(in) :: rhs

    kim_model_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_handle_not_equal

  !> \brief \copybrief KIM::Model::Create
  !!
  !! A Fortran PM must provide a KIM::MODEL_ROUTINE_NAME::Create routine.  The
  !! interface for this is given here.
  !!
  !! A PM not employing a MD should use the following interface (see also
  !! KIM::ModelCreateFunction, \ref KIM_ModelCreateFunction)
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine create(model_create_handle, requested_length_unit, &
  !!     requested_energy_unit, requested_charge_unit, &
  !!     requested_temperature_unit, requested_time_unit, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_create_handle_type), intent(in) :: model_create_handle
  !!     type(kim_length_unit_type), intent(in), value :: requested_length_unit
  !!     type(kim_energy_unit_type), intent(in), value :: requested_energy_unit
  !!     type(kim_charge_unit_type), intent(in), value :: requested_charge_unit
  !!     type(kim_temperature_unit_type), intent(in), value :: &
  !!       requested_temperature_unit
  !!     type(kim_time_unit_type), intent(in), value :: requested_time_unit
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine create
  !! end interface
  !! \endcode
  !!
  !! A MD should use the following interface (see also
  !! KIM::ModelDriverCreateFunction, \ref KIM_ModelDriverCreateFunction)
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine create(model_driver_create_handle, &
  !!     requested_length_unit, requested_energy_unit, requested_charge_unit, &
  !!     requested_temperature_unit, requested_time_unit, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_driver_headers_module
  !!     implicit none
  !!     type(kim_model_driver_create_handle_type), intent(in) :: &
  !!       model_create_handle
  !!     type(kim_length_unit_type), intent(in), value :: requested_length_unit
  !!     type(kim_energy_unit_type), intent(in), value :: requested_energy_unit
  !!     type(kim_charge_unit_type), intent(in), value :: requested_charge_unit
  !!     type(kim_temperature_unit_type), intent(in), value :: &
  !!       requested_temperature_unit
  !!     type(kim_time_unit_type), intent(in), value :: requested_time_unit
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine create
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::Create, KIM_Model_Create
  !!
  !! \since 2.0
  recursive subroutine kim_model_create(numbering, requested_length_unit, &
    requested_energy_unit, requested_charge_unit, &
    requested_temperature_unit, requested_time_unit, model_name, &
    requested_units_accepted, model_handle, ierr)
    use kim_numbering_module, only : kim_numbering_type
    use kim_unit_system_module, only : kim_length_unit_type, &
      kim_energy_unit_type, kim_charge_unit_type, kim_temperature_unit_type, &
      kim_time_unit_type
    implicit none
    interface
      integer(c_int) recursive function create(numbering, &
        requested_length_unit, requested_energy_unit, requested_charge_unit, &
        requested_temperature_unit, requested_time_unit, model_name, &
        requested_units_accepted, model) bind(c, name="KIM_Model_Create")
        use, intrinsic :: iso_c_binding
        use kim_numbering_module, only : kim_numbering_type
        use kim_unit_system_module, only : kim_length_unit_type, &
          kim_energy_unit_type, kim_charge_unit_type, &
          kim_temperature_unit_type, kim_time_unit_type
        implicit none
        type(kim_numbering_type), intent(in), value :: numbering
        type(kim_length_unit_type), intent(in), value :: requested_length_unit
        type(kim_energy_unit_type), intent(in), value :: requested_energy_unit
        type(kim_charge_unit_type), intent(in), value :: requested_charge_unit
        type(kim_temperature_unit_type), intent(in), value :: &
          requested_temperature_unit
        type(kim_time_unit_type), intent(in), value :: requested_time_unit
        character(c_char), intent(in) :: model_name(*)
        integer(c_int), intent(out) :: requested_units_accepted
        type(c_ptr), intent(out) :: model
      end function create
    end interface
    type(kim_numbering_type), intent(in) :: numbering
    type(kim_length_unit_type), intent(in) :: requested_length_unit
    type(kim_energy_unit_type), intent(in) :: requested_energy_unit
    type(kim_charge_unit_type), intent(in) :: requested_charge_unit
    type(kim_temperature_unit_type), intent(in) :: &
      requested_temperature_unit
    type(kim_time_unit_type), intent(in) :: requested_time_unit
    character(len=*, kind=c_char), intent(in) :: model_name
    integer(c_int), intent(out) :: requested_units_accepted
    type(kim_model_handle_type), intent(out) :: model_handle
    integer(c_int), intent(out) :: ierr

    type(c_ptr) :: pmodel

    ierr = create(numbering, requested_length_unit, requested_energy_unit, &
      requested_charge_unit, requested_temperature_unit, requested_time_unit, &
      trim(model_name)//c_null_char, requested_units_accepted, pmodel)
    model_handle%p = pmodel
  end subroutine kim_model_create

  !> \brief \copybrief KIM::Model::Destroy
  !!
  !! A Fortran PM must provide a KIM::MODEL_ROUTINE_NAME::Destroy routine.  The
  !! interface for this is given here (see also KIM::ModelDestroyFunction, \ref
  !! KIM_ModelDestroyFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine destroy(model_destroy_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_destroy_handle_type), intent(in) :: model_destroy_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine destroy
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::Destroy, KIM_Model_Destroy
  !!
  !! \since 2.0
  recursive subroutine kim_model_destroy(model_handle)
    implicit none
    interface
      recursive subroutine destroy(model) bind(c, name="KIM_Model_Destroy")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(inout) :: model
      end subroutine destroy
    end interface
    type(kim_model_handle_type), intent(inout) :: model_handle

    type(c_ptr) :: pmodel
    pmodel = model_handle%p
    call destroy(pmodel)
    model_handle%p = c_null_ptr
  end subroutine kim_model_destroy

  !> \brief \copybrief KIM::Model::IsRoutinePresent
  !!
  !! \sa KIM::Model::IsRoutinePresent, KIM_Model_IsRoutinePresent
  !!
  !! \since 2.0
  recursive subroutine kim_model_is_routine_present(model_handle, &
    model_routine_name, present, required, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    use kim_model_routine_name_module, only : kim_model_routine_name_type
    implicit none
    interface
      integer(c_int) recursive function is_routine_present(model, &
        model_routine_name, present, required) &
        bind(c, name="KIM_Model_IsRoutinePresent")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        use kim_model_routine_name_module, only : kim_model_routine_name_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(kim_model_routine_name_type), intent(in), value &
          :: model_routine_name
        integer(c_int), intent(out) :: present
        integer(c_int), intent(out) :: required
      end function is_routine_present
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_model_routine_name_type), intent(in) :: model_routine_name
    integer(c_int), intent(out) :: present
    integer(c_int), intent(out) :: required
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = is_routine_present(model, model_routine_name, present, required)
  end subroutine kim_model_is_routine_present

  !> \brief \copybrief KIM::Model::GetInfluenceDistance
  !!
  !! \sa KIM::Model::GetInfluenceDistance, KIM_Model_GetInfluenceDistance
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_influence_distance(model_handle, &
    influence_distance)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_influence_distance(model, influence_distance) &
        bind(c, name="KIM_Model_GetInfluenceDistance")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        real(c_double), intent(out) :: influence_distance
      end subroutine get_influence_distance
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    real(c_double), intent(out) :: influence_distance
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call get_influence_distance(model, influence_distance)
  end subroutine kim_model_get_influence_distance

  !> \brief Get Model's number of neighbor lists.
  !!
  !! \sa KIM::Model::GetNeighborListPointers, KIM_Model_GetNeighborListPointers
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_number_of_neighbor_lists(model_handle, &
    number_of_neighbor_lists)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_neighbor_list_pointers(model, &
        number_of_neighbor_lists, cutoffs_ptr, &
        model_will_not_request_neighbors_of_noncontributing__ptr) &
        bind(c, name="KIM_Model_GetNeighborListPointers")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(out) :: number_of_neighbor_lists
        type(c_ptr), intent(out) :: cutoffs_ptr
        type(c_ptr), intent(out) :: &
          model_will_not_request_neighbors_of_noncontributing__ptr
      end subroutine get_neighbor_list_pointers
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(out) :: number_of_neighbor_lists
    type(kim_model_type), pointer :: model

    type(c_ptr) cutoffs_ptr, hint_ptr

    call c_f_pointer(model_handle%p, model)
    call get_neighbor_list_pointers(model, number_of_neighbor_lists, &
      cutoffs_ptr, hint_ptr)
  end subroutine kim_model_get_number_of_neighbor_lists

  !> \brief Get Model's neighbor list values
  !!
  !! \sa KIM::Model::GetNeighborListPointers, KIM_Model_GetNeighborListPointers
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_neighbor_list_values(model_handle, &
    cutoffs, model_will_not_request_neighbors_of_noncontributing_particles, &
    ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_neighbor_list_pointers(model, &
        number_of_neighbor_lists, cutoffs_ptr, &
        model_will_not_request_neighbors_of_noncontributing__ptr) &
        bind(c, name="KIM_Model_GetNeighborListPointers")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(out) :: number_of_neighbor_lists
        type(c_ptr), intent(out) :: cutoffs_ptr
        type(c_ptr), intent(out) :: &
          model_will_not_request_neighbors_of_noncontributing__ptr
      end subroutine get_neighbor_list_pointers
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    real(c_double), intent(out) :: cutoffs(:)
    integer(c_int), intent(out) :: &
      model_will_not_request_neighbors_of_noncontributing_particles(:)
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    integer(c_int) number_of_neighbor_lists
    real(c_double), pointer :: cutoffs_fpointer(:)
    integer(c_int), pointer :: &
      model_will_not_request_neighbors_of_noncontributing__fpointer(:)
    type(c_ptr) cutoffs_ptr
    type(c_ptr) model_will_not_request_neighbors_of_noncontributing__ptr

    call c_f_pointer(model_handle%p, model)
    call get_neighbor_list_pointers(model, number_of_neighbor_lists, &
      cutoffs_ptr, &
      model_will_not_request_neighbors_of_noncontributing__ptr)
    if (c_associated(cutoffs_ptr)) then
      call c_f_pointer(cutoffs_ptr, cutoffs_fpointer, &
        [number_of_neighbor_lists])
    else
      nullify(cutoffs_fpointer)
    end if
    if (size(cutoffs) < number_of_neighbor_lists) then
      ierr = 1
    else
      ierr = 0
      cutoffs = cutoffs_fpointer(1:number_of_neighbor_lists)
    end if

    if (c_associated( &
      model_will_not_request_neighbors_of_noncontributing__ptr)) then
      call c_f_pointer( &
        model_will_not_request_neighbors_of_noncontributing__ptr, &
        model_will_not_request_neighbors_of_noncontributing__fpointer, &
        [number_of_neighbor_lists])
    else
      nullify( &
        model_will_not_request_neighbors_of_noncontributing__fpointer)
    end if
    if (size( &
      model_will_not_request_neighbors_of_noncontributing_particles) &
      < number_of_neighbor_lists) then
      ierr = 1
    else
      ierr = 0
      model_will_not_request_neighbors_of_noncontributing_particles = &
        model_will_not_request_neighbors_of_noncontributing__fpointer( &
        1:number_of_neighbor_lists)
    end if
  end subroutine kim_model_get_neighbor_list_values

  !> \brief \copybrief KIM::Model::GetUnits
  !!
  !! \sa KIM::Model::GetUnits, KIM_Model_GetUnits
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_units(model_handle, length_unit, &
    energy_unit, charge_unit, temperature_unit, time_unit)
    use kim_unit_system_module, only : kim_length_unit_type, &
      kim_energy_unit_type, kim_charge_unit_type, kim_temperature_unit_type, &
      kim_time_unit_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_units(model, length_unit, energy_unit, &
        charge_unit, temperature_unit, time_unit) &
        bind(c, name="KIM_Model_GetUnits")
        use, intrinsic :: iso_c_binding
        use kim_unit_system_module, only : kim_length_unit_type, &
          kim_energy_unit_type, kim_charge_unit_type, &
          kim_temperature_unit_type, kim_time_unit_type
        use kim_interoperable_types_module, only : kim_model_type
        type(kim_model_type), intent(in) :: model
        type(kim_length_unit_type), intent(out) :: length_unit
        type(kim_energy_unit_type), intent(out) :: energy_unit
        type(kim_charge_unit_type), intent(out) :: charge_unit
        type(kim_temperature_unit_type), intent(out) :: temperature_unit
        type(kim_time_unit_type), intent(out) :: time_unit
      end subroutine get_units
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_length_unit_type), intent(out) :: length_unit
    type(kim_energy_unit_type), intent(out) :: energy_unit
    type(kim_charge_unit_type), intent(out) :: charge_unit
    type(kim_temperature_unit_type), intent(out) :: temperature_unit
    type(kim_time_unit_type), intent(out) :: time_unit
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call get_units(model, length_unit, energy_unit, charge_unit, &
      temperature_unit, time_unit)
  end subroutine kim_model_get_units

  !> \brief \copybrief KIM::Model::ComputeArgumentsCreate
  !!
  !! A Fortran PM must provide a
  !! KIM::MODEL_ROUTINE_NAME::ComputeArgumentsCreate routine.  The interface
  !! for this is given here (see also KIM::ModelComputeArgumentsCreateFunction,
  !! \ref KIM_ModelComputeArgumentsCreateFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine compute_arguments_create(model_compute_handle, &
  !!     model_compute_arguments_create_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
  !!     type(kim_model_compute_arguments_create_handle_type), intent(in) &
  !!       :: model_compute_arguments_create_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine compute_arguments_create
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::ComputeArgumentsCreate, KIM_Model_ComputeArgumentsCreate
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_create(model_handle, &
    compute_arguments_handle, ierr)
    use kim_compute_arguments_module, only : &
      kim_compute_arguments_handle_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function compute_arguments_create(model, &
        compute_arguments) bind(c, name="KIM_Model_ComputeArgumentsCreate")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(c_ptr), intent(out) :: compute_arguments
      end function compute_arguments_create
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_compute_arguments_handle_type), intent(out) :: &
      compute_arguments_handle
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model
    type(c_ptr) :: pcompute_arguments

    call c_f_pointer(model_handle%p, model)

    ierr = compute_arguments_create(model, pcompute_arguments)
    if (ierr == 0) then
      compute_arguments_handle%p = pcompute_arguments
    end if
  end subroutine kim_model_compute_arguments_create

  !> \brief \copybrief KIM::Model::ComputeArgumentsDestroy
  !!
  !! A Fortran PM must provide a
  !! KIM::MODEL_ROUTINE_NAME::ComputeArgumentsDestroy routine.  The interface
  !! for this is given here (see also
  !! KIM::ModelComputeArgumentsDestroyFunction, \ref
  !! KIM_ModelComputeArgumentsDestroyFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine compute_arguments_destroy(model_compute_handle, &
  !!     model_compute_arguments_destroy_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
  !!     type(kim_model_compute_arguments_destroy_handle_type), intent(in) &
  !!       :: model_compute_arguments_destroy_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine compute_arguments_destroy
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::ComputeArgumentsDestroy, KIM_Model_ComputeArgumentsDestroy
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute_arguments_destroy(model_handle, &
    compute_arguments_handle, ierr)
    use kim_compute_arguments_module, only : &
      kim_compute_arguments_handle_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function compute_arguments_destroy(model, &
        compute_arguments) bind(c, name="KIM_Model_ComputeArgumentsDestroy")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(c_ptr), intent(inout) :: compute_arguments
      end function compute_arguments_destroy
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_compute_arguments_handle_type), intent(inout) :: &
      compute_arguments_handle
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model
    type(c_ptr) pcompute_arguments

    call c_f_pointer(model_handle%p, model)
    pcompute_arguments = compute_arguments_handle%p
    ierr = compute_arguments_destroy(model, pcompute_arguments)
    if (ierr /= 0) then
      compute_arguments_handle%p = c_null_ptr
    end if
  end subroutine kim_model_compute_arguments_destroy

  !> \brief \copybrief KIM::Model::Compute
  !!
  !! A Fortran PM must provide a KIM::MODEL_ROUTINE_NAME::Compute routine.  The
  !! interface for this is given here (see also KIM::ModelComputeFunction, \ref
  !! KIM_ModelComputeFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine compute(model_compute_handle, &
  !!     model_compute_arguments_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
  !!     type(kim_model_compute_arguments_handle_type), intent(in) :: &
  !!       model_compute_arguments_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine compute
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::Compute, KIM_Model_Compute
  !!
  !! \since 2.0
  recursive subroutine kim_model_compute(model_handle, &
    compute_arguments_handle, ierr)
    use kim_compute_arguments_module, only : kim_compute_arguments_handle_type
    use kim_interoperable_types_module, only : kim_compute_arguments_type, &
      kim_model_type
    implicit none
    interface
      integer(c_int) recursive function compute(model, compute_arguments) &
        bind(c, name="KIM_Model_Compute")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_compute_arguments_type
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(kim_compute_arguments_type), intent(in) :: compute_arguments
      end function compute
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_compute_arguments_handle_type), intent(in) :: &
      compute_arguments_handle
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model
    type(kim_compute_arguments_type), pointer :: compute_arguments

    call c_f_pointer(model_handle%p, model)
    call c_f_pointer(compute_arguments_handle%p, compute_arguments)
    ierr = compute(model, compute_arguments)
  end subroutine kim_model_compute

  !> \brief \copybrief KIM::Model::Extension
  !!
  !! A Fortran PM may provide a KIM::MODEL_ROUTINE_NAME::Extension routine.
  !! The interface for this is given here (see also
  !! KIM::ModelExtensionFunction, \ref KIM_ModelExtensionFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine extension(model_extension_handle, &
  !!     extension_structure, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_extension_handle_type), intent(in) :: &
  !!       model_extension_handle
  !!     type(c_ptr), intent(in), value :: extension_structure
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine extension
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::Extension, KIM_Model_Extension
  !!
  !! \since 2.0
  recursive subroutine kim_model_extension(model_handle, extension_id, &
    extension_structure, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function extension(model, extension_id, &
        extension_structure) bind(c, name="KIM_Model_Extension")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        character(c_char), intent(in) :: extension_id(*)
        type(c_ptr), intent(in), value :: extension_structure
      end function extension
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    character(len=*, kind=c_char), intent(in) :: extension_id
    type(c_ptr), intent(in) :: extension_structure
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = extension(model, trim(extension_id)//c_null_char, &
      extension_structure)
  end subroutine kim_model_extension

  !> \brief \copybrief KIM::Model::ClearThenRefresh
  !!
  !! A Fortran PM may need to provide a KIM::MODEL_ROUTINE_NAME::Refresh
  !! routine.  The interface for this is given here (see also
  !! KIM::ModelRefreshFunction, \ref KIM_ModelRefreshFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine refresh(model_refresh_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine refresh
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::ClearThenRefresh, KIM_Model_ClearThenRefresh
  !!
  !! \since 2.0
  recursive subroutine kim_model_clear_then_refresh(model_handle, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function clear_then_refresh(model) &
        bind(c, name="KIM_Model_ClearThenRefresh")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
      end function clear_then_refresh
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = clear_then_refresh(model)
  end subroutine kim_model_clear_then_refresh

  !> \brief \copybrief KIM::Model::WriteParameterizedModel
  !!
  !! A Fortran PM using a MD may provide a
  !! KIM::MODEL_ROUTINE_NAME::WriteParameterizedMdoel routine.  The interface
  !! for this is given here (see also
  !! KIM::ModelWriteParameterizedModelFunction, \ref
  !! KIM_ModelWriteParameterizedModelFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine write_parameterized_model( &
  !!     model_write_parameterized_model_handle, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     use kim_model_headers_module
  !!     implicit none
  !!     type(kim_model_write_parameterized_model_handle_type), intent(in) &
  !!       :: model_write_parameterized_model_handle
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine write_parameterized_model
  !! end interface
  !! \endcode
  !!
  !! \sa KIM::Model::WriteParameterizedModel, KIM_Model_WriteParameterizedModel
  !!
  !! \since 2.0
  recursive subroutine kim_model_write_parameterized_model(model_handle, &
    path, model_name, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function write_parameterized_model(model, &
        path, model_name) bind(c, name="KIM_Model_WriteParameterizedModel")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        character(c_char), intent(in) :: path(*)
        character(c_char), intent(in) :: model_name(*)
      end function write_parameterized_model
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    character(len=*, kind=c_char), intent(in) :: path
    character(len=*, kind=c_char), intent(in) :: model_name
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = write_parameterized_model(model, trim(path)//c_null_char, &
      trim(model_name)//c_null_char)
  end subroutine kim_model_write_parameterized_model

  !> \brief \copybrief KIM::Model::GetSpeciesSupportAndCode
  !!
  !! \sa KIM::Model::GetSpeciesSupportAndCode,
  !! KIM_Model_GetSpeciesSupportAndCode
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_species_support_and_code(model_handle, &
    species_name, species_is_supported, code, ierr)
    use kim_species_name_module, only : kim_species_name_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function get_species_support_and_code(model, &
        species_name, species_is_supported, code) &
        bind(c, name="KIM_Model_GetSpeciesSupportAndCode")
        use, intrinsic :: iso_c_binding
        use kim_species_name_module, only : kim_species_name_type
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(kim_species_name_type), intent(in), value :: species_name
        integer(c_int), intent(out) :: species_is_supported
        integer(c_int), intent(out) :: code
      end function get_species_support_and_code
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_species_name_type), intent(in) :: species_name
    integer(c_int), intent(out) :: species_is_supported
    integer(c_int), intent(out) :: code
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = get_species_support_and_code(model, species_name, &
      species_is_supported, code)
  end subroutine kim_model_get_species_support_and_code

  !> \brief \copybrief KIM::Model::GetNumberOfParameters
  !!
  !! \sa KIM::Model::GetNumberOfParameters, KIM_Model_GetNumberOfParameters
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_number_of_parameters(model_handle, &
    number_of_parameters)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_number_of_parameters(model, &
        number_of_parameters) bind(c, name="KIM_Model_GetNumberOfParameters")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(out) :: number_of_parameters
      end subroutine get_number_of_parameters
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(out) :: number_of_parameters
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call get_number_of_parameters(model, number_of_parameters)
  end subroutine kim_model_get_number_of_parameters

  !> \brief \copybrief KIM::Model::GetParameterMetadata
  !!
  !! \sa KIM::Model::GetParameterMetadata, KIM_Model_GetParameterMetadata
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_parameter_metadata(model_handle, &
    parameter_index, data_type, extent, name, description, ierr)
    use kim_data_type_module, only : kim_data_type_type
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function get_parameter_metadata(model, &
        parameter_index, data_type, extent, name, description) &
        bind(c, name="KIM_Model_GetParameterMetadata")
        use, intrinsic :: iso_c_binding
        use kim_data_type_module, only : kim_data_type_type
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(in), value :: parameter_index
        type(kim_data_type_type), intent(out) :: data_type
        integer(c_int), intent(out) :: extent
        type(c_ptr), intent(out) :: name
        type(c_ptr), intent(out) :: description
      end function get_parameter_metadata
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(in) :: parameter_index
    type(kim_data_type_type), intent(out) :: data_type
    integer(c_int), intent(out) :: extent
    character(len=*, kind=c_char), intent(out) :: name
    character(len=*, kind=c_char), intent(out) :: description
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    type(c_ptr) :: pname, pdesc

    call c_f_pointer(model_handle%p, model)
    ierr = get_parameter_metadata(model, parameter_index-1, data_type, extent, &
      pname, pdesc)
    call kim_convert_c_char_ptr_to_string(pname, name)
    call kim_convert_c_char_ptr_to_string(pdesc, description)
  end subroutine kim_model_get_parameter_metadata

  !> \brief \copybrief KIM::Model::GetParameter
  !!
  !! \sa KIM::Model::GetParameter, KIM_Model_GetParameterInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_parameter_integer(model_handle, &
    parameter_index, array_index, parameter_value, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function get_parameter_integer(model, &
        parameter_index, array_index, parameter_value) &
        bind(c, name="KIM_Model_GetParameterInteger")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(in), value :: parameter_index
        integer(c_int), intent(in), value :: array_index
        integer(c_int), intent(out) :: parameter_value
      end function get_parameter_integer
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(in) :: parameter_index
    integer(c_int), intent(in) :: array_index
    integer(c_int), intent(out) :: parameter_value
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = get_parameter_integer(model, parameter_index-1, array_index-1, &
      parameter_value)
  end subroutine kim_model_get_parameter_integer

  !> \brief \copybrief KIM::Model::GetParameter
  !!
  !! \sa KIM::Model::GetParameter, KIM_Model_GetParameterDouble
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_parameter_double(model_handle, &
    parameter_index, array_index, parameter_value, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function get_parameter_double(model, &
        parameter_index, array_index, parameter_value) &
        bind(c, name="KIM_Model_GetParameterDouble")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(in), value :: parameter_index
        integer(c_int), intent(in), value :: array_index
        real(c_double), intent(out) :: parameter_value
      end function get_parameter_double
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(in) :: parameter_index
    integer(c_int), intent(in) :: array_index
    real(c_double), intent(out) :: parameter_value
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = get_parameter_double(model, parameter_index-1, array_index-1, &
      parameter_value)
  end subroutine kim_model_get_parameter_double

  !> \brief \copybrief KIM::Model::SetParameter
  !!
  !! \sa KIM::Model::SetParameter, KIM_Model_SetParameterInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_set_parameter_integer(model_handle, &
    parameter_index, array_index, parameter_value, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function set_parameter_integer(model, &
        parameter_index, array_index, parameter_value) &
        bind(c, name="KIM_Model_SetParameterInteger")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(in), value :: parameter_index
        integer(c_int), intent(in), value :: array_index
        integer(c_int), intent(in), value :: parameter_value
      end function set_parameter_integer
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(in) :: parameter_index
    integer(c_int), intent(in) :: array_index
    integer(c_int), intent(in) :: parameter_value
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = set_parameter_integer(model, parameter_index-1, array_index-1, &
      parameter_value)
  end subroutine kim_model_set_parameter_integer

  !> \brief \copybrief KIM::Model::SetParameter
  !!
  !! \sa KIM::Model::SetParameter, KIM_Model_SetParameterDouble
  !!
  !! \since 2.0
  recursive subroutine kim_model_set_parameter_double(model_handle, &
    parameter_index, array_index, parameter_value, ierr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      integer(c_int) recursive function set_parameter_double(model, &
        parameter_index, array_index, parameter_value) &
        bind(c, name="KIM_Model_SetParameterDouble")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        integer(c_int), intent(in), value :: parameter_index
        integer(c_int), intent(in), value :: array_index
        real(c_double), intent(in), value :: parameter_value
      end function set_parameter_double
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    integer(c_int), intent(in) :: parameter_index
    integer(c_int), intent(in) :: array_index
    real(c_double), intent(in) :: parameter_value
    integer(c_int), intent(out) :: ierr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    ierr = set_parameter_double(model, parameter_index-1, array_index-1, &
      parameter_value)
  end subroutine kim_model_set_parameter_double

  !> \brief \copybrief KIM::Model::SetSimulatorBufferPointer
  !!
  !! \sa KIM::Model::SetSimulatorBufferPointer,
  !! KIM_Model_SetSimulatorBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_set_simulator_buffer_pointer(model_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine set_simulator_buffer_pointer(model, ptr) &
        bind(c, name="KIM_Model_SetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_simulator_buffer_pointer
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call set_simulator_buffer_pointer(model, ptr)
  end subroutine kim_model_set_simulator_buffer_pointer

  !> \brief \copybrief KIM::Model::GetSimulatorBufferPointer
  !!
  !! \sa KIM::Model::GetSimulatorBufferPointer,
  !! KIM_Model_GetSimulatorBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_get_simulator_buffer_pointer(model_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine get_simulator_buffer_pointer(model, ptr) &
        bind(c, name="KIM_Model_GetSimulatorBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(c_ptr), intent(out) :: ptr
      end subroutine get_simulator_buffer_pointer
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call get_simulator_buffer_pointer(model, ptr)
  end subroutine kim_model_get_simulator_buffer_pointer

  !> \brief \copybrief KIM::Model::ToString
  !!
  !! \sa KIM::Model::ToString, KIM_Model_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_to_string(model_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      type(c_ptr) recursive function model_string(model) &
        bind(c, name="KIM_Model_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
      end function model_string
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_type), pointer :: model

    type(c_ptr) :: p

    call c_f_pointer(model_handle%p, model)
    p = model_string(model)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_to_string

  !> \brief \copybrief KIM::Model::SetLogID
  !!
  !! \sa KIM::Model::SetLogID, KIM_Model_SetLogID
  !!
  !! \since 2.0
  recursive subroutine kim_model_set_log_id(model_handle, log_id)
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine set_log_id(model, log_id) &
        bind(c, name="KIM_Model_SetLogID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        character(c_char), intent(in) :: log_id(*)
      end subroutine set_log_id
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    character(len=*, kind=c_char), intent(in) :: log_id
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call set_log_id(model, trim(log_id)//c_null_char)
  end subroutine kim_model_set_log_id

  !> \brief \copybrief KIM::Model::PushLogVerbosity
  !!
  !! \sa KIM::Model::PushLogVerbosity, KIM_Model_PushLogVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_model_push_log_verbosity(model_handle, log_verbosity)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine push_log_verbosity(model, log_verbosity) &
        bind(c, name="KIM_Model_PushLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_log_verbosity
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call push_log_verbosity(model, log_verbosity)
  end subroutine kim_model_push_log_verbosity

  !> \brief \copybrief KIM::Model::PopLogVerbosity
  !!
  !! \sa KIM::Model::, KIM_Model_PopLogVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_model_pop_log_verbosity(model_handle)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_type
    implicit none
    interface
      recursive subroutine pop_log_verbosity(model) &
        bind(c, name="KIM_Model_PopLogVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_model_type
        implicit none
        type(kim_model_type), intent(in) :: model
      end subroutine pop_log_verbosity
    end interface
    type(kim_model_handle_type), intent(in) :: model_handle
    type(kim_model_type), pointer :: model

    call c_f_pointer(model_handle%p, model)
    call pop_log_verbosity(model)
  end subroutine kim_model_pop_log_verbosity
end module kim_model_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!    Ellad B. Tadmor
!    Valeriu Smirichinski
!    Stephen M. Whalen
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!****************************************************************************
!**
!**  MODULE ex_model_driver_P_LJ
!**
!**  Lennard-Jones pair potential KIM Model Driver
!**  shifted to have zero energy at the cutoff radius
!**
!**  Language: Fortran 2003
!**
!****************************************************************************

module ex_model_driver_p_lj

  use, intrinsic :: iso_c_binding
  use kim_model_driver_headers_module
  implicit none

  save
  private
  public &
    BUFFER_TYPE, &
    Compute_Energy_Forces, &
    compute_arguments_create, &
    compute_arguments_destroy, &
    refresh, &
    write_model, &
    destroy, &
    calc_phi, &
    calc_phi_dphi, &
    calc_phi_dphi_d2phi, &
    speccode

  ! Below are the definitions and values of all Model parameters
  integer(c_int), parameter          :: cd = c_double  ! for literal constants
  integer(c_int), parameter          :: DIM = 3        ! dimensionality of space
  integer(c_int), parameter          :: speccode = 1   ! internal species code

  !-----------------------------------------------------------------------------
  !
  !  Definition of Buffer type
  !
  !-----------------------------------------------------------------------------
  type, bind(c) :: BUFFER_TYPE
    character(c_char) :: species_name(100)
    real(c_double) :: influence_distance(1)
    real(c_double) :: Pcutoff(1)
    real(c_double) :: cutsq(1)
    integer(c_int) :: &
      model_will_not_request_neighbors_of_noncontributing_particles(1)
    real(c_double) :: epsilon(1)
    real(c_double) :: sigma(1)
    real(c_double) :: shift(1)
  end type BUFFER_TYPE

contains

  !-----------------------------------------------------------------------------
  !
  !  Calculate pair potential phi(r)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_phi(model_epsilon, &
                                model_sigma, &
                                model_shift, &
                                model_cutoff, r, phi)
    implicit none

    !-- Transferred variables
    real(c_double), intent(in)  :: model_epsilon
    real(c_double), intent(in)  :: model_sigma
    real(c_double), intent(in)  :: model_shift
    real(c_double), intent(in)  :: model_cutoff
    real(c_double), intent(in)  :: r
    real(c_double), intent(out) :: phi

    !-- Local variables
    real(c_double) rsq, sor, sor6, sor12

    rsq = r * r             !  r^2
    sor = model_sigma / r   !  (sig/r)
    sor6 = sor * sor * sor     !
    sor6 = sor6 * sor6       !  (sig/r)^6
    sor12 = sor6 * sor6       !  (sig/r)^12
    if (r > model_cutoff) then
      ! Argument exceeds cutoff radius
      phi = 0.0_cd
    else
      phi = 4.0_cd * model_epsilon * (sor12 - sor6) + model_shift
    end if

  end subroutine calc_phi

  !-----------------------------------------------------------------------------
  !
  !  Calculate pair potential phi(r) and its derivative dphi(r)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_phi_dphi(model_epsilon, &
                                     model_sigma, &
                                     model_shift, &
                                     model_cutoff, r, phi, dphi)
    implicit none

    !-- Transferred variables
    real(c_double), intent(in)  :: model_epsilon
    real(c_double), intent(in)  :: model_sigma
    real(c_double), intent(in)  :: model_shift
    real(c_double), intent(in)  :: model_cutoff
    real(c_double), intent(in)  :: r
    real(c_double), intent(out) :: phi, dphi

    !-- Local variables
    real(c_double) rsq, sor, sor6, sor12

    rsq = r * r             !  r^2
    sor = model_sigma / r   !  (sig/r)
    sor6 = sor * sor * sor     !
    sor6 = sor6 * sor6       !  (sig/r)^6
    sor12 = sor6 * sor6       !  (sig/r)^12
    if (r > model_cutoff) then
      ! Argument exceeds cutoff radius
      phi = 0.0_cd
      dphi = 0.0_cd
    else
      phi = 4.0_cd * model_epsilon * (sor12 - sor6) + model_shift
      dphi = 24.0_cd * model_epsilon * (-2.0_cd * sor12 + sor6) / r
    end if

  end subroutine calc_phi_dphi

  !-----------------------------------------------------------------------------
  !
  !  Calculate pair potential phi(r) and its derivatives dphi(r) and d2phi(r)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_phi_dphi_d2phi(model_epsilon, &
                                           model_sigma, &
                                           model_shift, &
                                           model_cutoff, r, phi, dphi, d2phi)
    implicit none

    !-- Transferred variables
    real(c_double), intent(in)  :: model_epsilon
    real(c_double), intent(in)  :: model_sigma
    real(c_double), intent(in)  :: model_shift
    real(c_double), intent(in)  :: model_cutoff
    real(c_double), intent(in)  :: r
    real(c_double), intent(out) :: phi, dphi, d2phi

    !-- Local variables
    real(c_double) rsq, sor, sor6, sor12

    rsq = r * r             !  r^2
    sor = model_sigma / r   !  (sig/r)
    sor6 = sor * sor * sor     !
    sor6 = sor6 * sor6       !  (sig/r)^6
    sor12 = sor6 * sor6       !  (sig/r)^12
    if (r > model_cutoff) then
      ! Argument exceeds cutoff radius
      phi = 0.0_cd
      dphi = 0.0_cd
      d2phi = 0.0_cd
    else
      phi = 4.0_cd * model_epsilon * (sor12 - sor6) + model_shift
      dphi = 24.0_cd * model_epsilon * (-2.0_cd * sor12 + sor6) / r
      d2phi = 24.0_cd * model_epsilon * (26.0_cd * sor12 - 7.0_cd * sor6) / rsq
    end if

  end subroutine calc_phi_dphi_d2phi

  !-----------------------------------------------------------------------------
  !
  ! Compute energy and forces on particles from the positions.
  !
  !-----------------------------------------------------------------------------
  recursive subroutine Compute_Energy_Forces( &
    model_compute_handle, model_compute_arguments_handle, ierr) bind(c)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    real(c_double) :: r, Rsqij, phi, dphi, d2phi, dEidr, d2Eidr
    integer(c_int) :: i, j, jj, numnei
    integer(c_int) :: ierr2
    integer(c_int) :: comp_force, comp_energy, comp_enepot, comp_process_dEdr, &
                      comp_process_d2Edr2
    type(BUFFER_TYPE), pointer :: buf; type(c_ptr) :: pbuf

    real(c_double), target :: Rij(DIM)
    real(c_double), target :: Rij_pairs(DIM, 2)
    real(c_double), target :: r_pairs(2)
    integer(c_int), target :: i_pairs(2), j_pairs(2)

    !-- KIM variables
    real(c_double) :: model_cutoff
    integer(c_int), pointer :: N
    real(c_double), pointer :: energy
    real(c_double), pointer :: coor(:, :)
    real(c_double), pointer :: force(:, :)
    real(c_double), pointer :: enepot(:)
    integer(c_int), pointer :: nei1part(:)
    integer(c_int), pointer :: particleSpeciesCodes(:)
    integer(c_int), pointer :: particleContributing(:)

    ! get model buffer from KIM object
    call kim_get_model_buffer_pointer(model_compute_handle, pbuf)
    call c_f_pointer(pbuf, buf)

    model_cutoff = buf%influence_distance(1)

    ! Check to see if we have been asked to compute the forces, energyperpart,
    ! energy and d1Edr
    !
    ierr = 0
    call kim_is_callback_present( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_CALLBACK_NAME_PROCESS_DEDR_TERM, comp_process_dedr, ierr2)
    ierr = ierr + ierr2
    call kim_is_callback_present( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_CALLBACK_NAME_PROCESS_D2EDR2_TERM, comp_process_d2edr2, ierr2)
    ierr = ierr + ierr2
    if (ierr /= 0) then
      call kim_log_entry(model_compute_arguments_handle, &
                         KIM_LOG_VERBOSITY_ERROR, "get_compute")
      ierr = 1
      return
    end if

    ! Unpack data from KIM object
    !
    ierr = 0
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES, n, ierr2)
    ierr = ierr + ierr2

    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES, &
      n, particlespeciesCodes, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING, &
      n, particlecontributing, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_COORDINATES, dim, n, coor, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, energy, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, dim, n, force, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, n, enepot, ierr2)
    ierr = ierr + ierr2
    if (ierr /= 0) then
      call kim_log_entry(model_compute_arguments_handle, &
                         KIM_LOG_VERBOSITY_ERROR, "get_argument_pointer")
      ierr = 1
      return
    end if

    if (associated(energy)) then
      comp_energy = 1
    else
      comp_energy = 0
    end if
    if (associated(force)) then
      comp_force = 1
    else
      comp_force = 0
    end if
    if (associated(enepot)) then
      comp_enepot = 1
    else
      comp_enepot = 0
    end if

    ! Check to be sure that the species are correct
    !

    ierr = 1 ! assume an error
    do i = 1, N
      if (particleSpeciesCodes(i) /= speccode) then
        call kim_log_entry( &
          model_compute_arguments_handle, KIM_LOG_VERBOSITY_ERROR, &
          "Unexpected species code detected")
        ierr = 1
        return
      end if
    end do
    ierr = 0 ! everything is ok

    ! Initialize potential energies, forces
    !
    if (comp_enepot == 1) enepot = 0.0_cd
    if (comp_energy == 1) energy = 0.0_cd
    if (comp_force == 1) force = 0.0_cd

    !
    !  Compute energy and forces
    !

    !  Loop over particles and compute energy and forces
    !
    do i = 1, N

      if (particleContributing(i) == 1) then
        ! Set up neighbor list for next particle
        !
        call kim_get_neighbor_list( &
          model_compute_arguments_handle, 1, i, numnei, nei1part, ierr)
        if (ierr /= 0) then
          ! some sort of problem, exit
          call kim_log_entry( &
            model_compute_arguments_handle, KIM_LOG_VERBOSITY_ERROR, &
            "kim_api_get_neigh")
          ierr = 1
          return
        end if

        ! Loop over the neighbors of particle i
        !
        do jj = 1, numnei

          j = nei1part(jj)                        ! get neighbor ID

          ! compute relative position vector
          !
          Rij(:) = coor(:, j) - coor(:, i)       ! distance vector between i j

          ! compute energy and forces
          !
          Rsqij = dot_product(Rij, Rij)                ! compute square distance
          if (Rsqij < buf%cutsq(1)) then         ! particles are interacting?

            r = sqrt(Rsqij)                          ! compute distance
            if (comp_process_d2Edr2 == 1) then
              call calc_phi_dphi_d2phi(buf%epsilon(1), &
                                       buf%sigma(1), &
                                       buf%shift(1), &
                                       buf%Pcutoff(1), &
                                       r, phi, dphi, d2phi) ! compute pair potential
              !   and it derivatives
              dEidr = 0.5_cd * dphi               !      regular contribution
              d2Eidr = 0.5_cd * d2phi
            elseif (comp_force == 1 .or. comp_process_dEdr == 1) then
              call calc_phi_dphi(buf%epsilon(1), &
                                 buf%sigma(1), &
                                 buf%shift(1), &
                                 buf%Pcutoff(1), &
                                 r, phi, dphi)        ! compute pair potential
              !   and it derivative

              dEidr = 0.5_cd * dphi                !      regular contribution
            else
              call calc_phi(buf%epsilon(1), &
                            buf%sigma(1), &
                            buf%shift(1), &
                            buf%Pcutoff(1), &
                            r, phi)                  ! compute just pair potential
            end if

            ! contribution to energy
            !
            if (comp_enepot == 1) then
              enepot(i) = enepot(i) + 0.5_cd * phi    ! accumulate energy
            end if
            if (comp_energy == 1) then
              energy = energy + 0.5_cd * phi       !      add half v to total energy
            end if

            ! contribution to process_dEdr
            !
            if (comp_process_dEdr == 1) then
              call kim_process_dedr_term( &
                model_compute_arguments_handle, deidr, r, rij, i, j, ierr)
            end if

            ! contribution to process_d2Edr2
            if (comp_process_d2Edr2 == 1) then
              r_pairs(1) = r
              r_pairs(2) = r
              Rij_pairs(:, 1) = Rij
              Rij_pairs(:, 2) = Rij
              i_pairs(1) = i
              i_pairs(2) = i
              j_pairs(1) = j
              j_pairs(2) = j

              call kim_process_d2edr2_term( &
                model_compute_arguments_handle, d2eidr, &
                r_pairs, Rij_pairs, i_pairs, j_pairs, ierr)
            end if

            ! contribution to forces
            !
            if (comp_force == 1) then
              force(:, i) = force(:, i) + dEidr * Rij / r ! accumulate force on particle i
              force(:, j) = force(:, j) - dEidr * Rij / r ! accumulate force on particle j
            end if

          end if

        end do  ! loop on jj

      end if  ! if particleContributing

    end do  ! do i

    ! Everything is great
    !
    ierr = 0
    return

  end subroutine Compute_Energy_Forces

  !-----------------------------------------------------------------------------
  !
  ! Model driver refresh routine
  !
  !-----------------------------------------------------------------------------
  recursive subroutine refresh(model_refresh_handle, ierr) bind(c)
    implicit none

    !-- transferred variables
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    real(c_double) energy_at_cutoff
    type(BUFFER_TYPE), pointer :: buf; type(c_ptr) :: pbuf

    ! get model buffer from KIM object
    call kim_get_model_buffer_pointer(model_refresh_handle, pbuf)
    call c_f_pointer(pbuf, buf)

    call kim_set_influence_distance_pointer(model_refresh_handle, &
                                            buf%influence_distance(1))
    call kim_set_neighbor_list_pointers( &
      model_refresh_handle, 1, buf%influence_distance, &
      buf%model_will_not_request_neighbors_of_noncontributing_particles)

    ! Set new values in KIM object and buffer
    !
    buf%influence_distance(1) = buf%Pcutoff(1)
    buf%cutsq(1) = (buf%Pcutoff(1))**2
    ! calculate pair potential at r=cutoff with shift=0.0
    call calc_phi(buf%epsilon(1), &
                  buf%sigma(1), &
                  0.0_cd, &
                  buf%Pcutoff(1), &
                  buf%Pcutoff(1), energy_at_cutoff)
    buf%shift(1) = -energy_at_cutoff

    ierr = 0
    return

  end subroutine refresh

  !-----------------------------------------------------------------------------
  !
  ! Model driver write_model routine
  !
  !-----------------------------------------------------------------------------
  recursive subroutine write_model( &
    model_write_parameterized_model_handle, ierr) bind(c)
    implicit none

    !-- transferred variables
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    integer i
    type(BUFFER_TYPE), pointer :: buf; type(c_ptr) :: pbuf
    character(len=512, kind=c_char) :: path
    character(len=512, kind=c_char) :: model_name
    character(len=512, kind=c_char) :: string_buffer
    character(len=100, kind=c_char) :: species_name

    ! get model buffer from KIM object
    call kim_get_model_buffer_pointer( &
      model_write_parameterized_model_handle, pbuf)
    call c_f_pointer(pbuf, buf)

    call kim_get_path(model_write_parameterized_model_handle, path)
    call kim_get_model_name(model_write_parameterized_model_handle, model_name)

    write (string_buffer, '(A)') trim(model_name)//".params"
    call kim_set_parameter_file_name(model_write_parameterized_model_handle, &
                                     string_buffer)
    write (string_buffer, '(A)') trim(path)//"/"//trim(string_buffer)

    open (42, FILE=trim(string_buffer), &
          STATUS="REPLACE", ACTION="WRITE", iostat=ierr)
    if (ierr /= 0) then
      call kim_log_entry( &
        model_write_parameterized_model_handle, KIM_LOG_VERBOSITY_ERROR, &
        "Unable to open parameter file for writing.")
      return
    end if

    do i = 1, 100
      species_name(i:i) = buf%species_name(i)
    end do
    write (42, '(A)') trim(species_name)
    write (42, '(ES20.10)') buf%Pcutoff(1)
    write (42, '(ES20.10)') buf%epsilon(1)
    write (42, '(ES20.10)') buf%sigma(1)

    ierr = 0
    return

  end subroutine write_model

  !-----------------------------------------------------------------------------
  !
  ! Model driver destroy routine
  !
  !-----------------------------------------------------------------------------
  recursive subroutine destroy(model_destroy_handle, ierr) bind(c)
    implicit none

    !-- Transferred variables
    type(kim_model_destroy_handle_type), intent(in) :: model_destroy_handle
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    type(BUFFER_TYPE), pointer :: buf; type(c_ptr) :: pbuf

    ! get model buffer from KIM object
    call kim_get_model_buffer_pointer(model_destroy_handle, pbuf)
    call c_f_pointer(pbuf, buf)

    deallocate (buf)

    ierr = 0
    return

  end subroutine destroy

  !-----------------------------------------------------------------------------
  !
  ! Model driver compute arguments create routine
  !
  !-----------------------------------------------------------------------------
  recursive subroutine compute_arguments_create( &
    model_compute_handle, model_compute_arguments_create_handle, ierr) bind(c)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_create_handle_type), intent(in) :: &
      model_compute_arguments_create_handle
    integer(c_int), intent(out) :: ierr

    integer(c_int) ierr2

    ! avoid unsed dummy argument warnings
    if (model_compute_handle == KIM_MODEL_COMPUTE_NULL_HANDLE) continue

    ierr = 0
    ierr2 = 0

    ! register arguments
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr)
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    if (ierr /= 0) then
      call kim_log_entry( &
        model_compute_arguments_create_handle, KIM_LOG_VERBOSITY_ERROR, &
        "Unable to register arguments support_statuss")
      ierr = 1
      goto 42
    end if

    ! register callbacks
    call kim_set_callback_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_CALLBACK_NAME_PROCESS_DEDR_TERM, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr)
    call kim_set_callback_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_CALLBACK_NAME_PROCESS_D2EDR2_TERM, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    if (ierr /= 0) then
      call kim_log_entry( &
        model_compute_arguments_create_handle, KIM_LOG_VERBOSITY_ERROR, &
        "Unable to register callbacks support_statuss")
      ierr = 1
      goto 42
    end if

    ierr = 0
42  continue
    return

  end subroutine compute_arguments_create

  !-----------------------------------------------------------------------------
  !
  ! Model driver compute arguments destroy routine
  !
  !-----------------------------------------------------------------------------
  recursive subroutine compute_arguments_destroy( &
    model_compute_handle, model_compute_arguments_destroy_handle, ierr) bind(c)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_destroy_handle_type), intent(in) :: &
      model_compute_arguments_destroy_handle
    integer(c_int), intent(out) :: ierr

    ! avoid unsed dummy argument warnings
    if (model_compute_handle == KIM_MODEL_COMPUTE_NULL_HANDLE) continue
    if (model_compute_arguments_destroy_handle == &
        KIM_MODEL_COMPUTE_ARGUMENTS_DESTROY_NULL_HANDLE) continue

    ierr = 0
    return
  end subroutine compute_arguments_destroy

end module ex_model_driver_p_lj

!-----------------------------------------------------------------------------
!
! Model driver create routine (REQUIRED)
!
!-----------------------------------------------------------------------------
recursive subroutine model_driver_create_routine( &
  model_driver_create_handle, requested_length_unit, requested_energy_unit, &
  requested_charge_unit, requested_temperature_unit, requested_time_unit, &
  ierr) bind(c)
  use, intrinsic :: iso_c_binding
  use ex_model_driver_p_lj
  use kim_model_driver_headers_module
  implicit none
  integer(c_int), parameter :: cd = c_double ! used for literal constants

  !-- Transferred variables
  type(kim_model_driver_create_handle_type), intent(in) &
    :: model_driver_create_handle
  type(kim_length_unit_type), intent(in), value :: requested_length_unit
  type(kim_energy_unit_type), intent(in), value :: requested_energy_unit
  type(kim_charge_unit_type), intent(in), value :: requested_charge_unit
  type(kim_temperature_unit_type), intent(in), value :: &
    requested_temperature_unit
  type(kim_time_unit_type), intent(in), value :: requested_time_unit
  integer(c_int), intent(out) :: ierr

  !-- Local variables
  integer i
  integer(c_int) :: number_of_parameter_files
  character(len=1024, kind=c_char) :: parameter_file_directory_name
  character(len=1024, kind=c_char) :: parameter_file_basename
  character(len=1024, kind=c_char) :: parameter_file_name
  integer(c_int) :: ierr2
  type(BUFFER_TYPE), pointer :: buf
  type(kim_species_name_type) species_name
  ! define variables for all model parameters to be read in
  real(c_double) factor
  character(len=100, kind=c_char) in_species
  real(c_double) in_cutoff
  real(c_double) in_epsilon
  real(c_double) in_sigma
  real(c_double) energy_at_cutoff

  ! register units
  call kim_set_units( &
    model_driver_create_handle, &
    REQUESTED_LENGTH_UNIT, &
    REQUESTED_ENERGY_UNIT, &
    KIM_CHARGE_UNIT_UNUSED, &
    KIM_TEMPERATURE_UNIT_UNUSED, &
    KIM_TIME_UNIT_UNUSED, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "Unable to set units")
    ierr = 1
    goto 42
  end if

  ! register numbering
  call kim_set_model_numbering( &
    model_driver_create_handle, KIM_NUMBERING_ONE_BASED, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "Unable to set numbering")
    ierr = 1
    goto 42
  end if

  ! store callback pointers in KIM object
  call kim_set_routine_pointer( &
    model_driver_create_handle, KIM_MODEL_ROUTINE_NAME_COMPUTE, &
    KIM_LANGUAGE_NAME_FORTRAN, 1, c_funloc(Compute_Energy_Forces), ierr)
  call kim_set_routine_pointer( &
    model_driver_create_handle, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE, &
    KIM_LANGUAGE_NAME_FORTRAN, 1, c_funloc(compute_arguments_create), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_driver_create_handle, KIM_MODEL_ROUTINE_NAME_REFRESH, &
    KIM_LANGUAGE_NAME_FORTRAN, 1, c_funloc(refresh), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_driver_create_handle, &
    KIM_MODEL_ROUTINE_NAME_WRITE_PARAMETERIZED_MODEL, &
    KIM_LANGUAGE_NAME_FORTRAN, 0, c_funloc(write_model), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_driver_create_handle, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY, &
    KIM_LANGUAGE_NAME_FORTRAN, 1, c_funloc(compute_arguments_destroy), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_driver_create_handle, KIM_MODEL_ROUTINE_NAME_DESTROY, &
    KIM_LANGUAGE_NAME_FORTRAN, 1, c_funloc(destroy), ierr2)
  ierr = ierr + ierr2
  if (ierr /= 0) then
    call kim_log_entry( &
      model_driver_create_handle, KIM_LOG_VERBOSITY_ERROR, &
      "Unable to store callback pointers")
    ierr = 1
    goto 42
  end if

  ! process parameter files
  call kim_get_number_of_parameter_files( &
    model_driver_create_handle, number_of_parameter_files)
  if (number_of_parameter_files /= 1) then
    call kim_log_entry( &
      model_driver_create_handle, KIM_LOG_VERBOSITY_ERROR, &
      "Wrong number of parameter files")
    ierr = 1
    goto 42
  end if

  ! Read in model parameters from parameter file
  !
  call kim_get_parameter_file_directory_name( &
    model_driver_create_handle, parameter_file_directory_name)
  call kim_get_parameter_file_basename( &
    model_driver_create_handle, 1, parameter_file_basename, ierr)
  if (ierr /= 0) then
    call kim_log_entry( &
      model_driver_create_handle, KIM_LOG_VERBOSITY_ERROR, &
      "Unable to get parameter file basename")
    ierr = 1
    goto 42
  end if
  parameter_file_name = trim(parameter_file_directory_name)//"/"// &
                        trim(parameter_file_basename)
  open (10, file=parameter_file_name, status="old")
  read (10, *, iostat=ierr, err=100) in_species
  read (10, *, iostat=ierr, err=100) in_cutoff
  read (10, *, iostat=ierr, err=100) in_epsilon
  read (10, *, iostat=ierr, err=100) in_sigma
  close (10)

  goto 200
100 continue
  ! reading parameters failed
  call kim_log_entry(model_driver_create_handle, &
                     KIM_LOG_VERBOSITY_ERROR, "Unable to read LJ parameters")
  ierr = 1
  goto 42

200 continue

  ! register species
  call kim_from_string(in_species, species_name)
  call kim_set_species_code( &
    model_driver_create_handle, species_name, speccode, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "Unable to set species code")
    ierr = 1
    goto 42
  end if

  ! convert to appropriate units
  call kim_convert_unit( &
    KIM_LENGTH_UNIT_A, &
    KIM_ENERGY_UNIT_EV, &
    KIM_CHARGE_UNIT_E, &
    KIM_TEMPERATURE_UNIT_K, &
    KIM_TIME_UNIT_PS, &
    requested_length_unit, &
    requested_energy_unit, &
    requested_charge_unit, &
    requested_temperature_unit, &
    requested_time_unit, &
    1.0_cd, 0.0_cd, 0.0_cd, 0.0_cd, 0.0_cd, factor, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "kim_api_convert_to_act_unit")
    ierr = 1
    goto 42
  end if
  in_cutoff = in_cutoff * factor

  call kim_convert_unit( &
    KIM_LENGTH_UNIT_A, &
    KIM_ENERGY_UNIT_EV, &
    KIM_CHARGE_UNIT_E, &
    KIM_TEMPERATURE_UNIT_K, &
    KIM_TIME_UNIT_PS, &
    requested_length_unit, &
    requested_energy_unit, &
    requested_charge_unit, &
    requested_temperature_unit, &
    requested_time_unit, &
    0.0_cd, 1.0_cd, 0.0_cd, 0.0_cd, 0.0_cd, factor, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "kim_api_convert_to_act_unit")
    ierr = 1
    goto 42
  end if
  in_epsilon = in_epsilon * factor

  call kim_convert_unit( &
    KIM_LENGTH_UNIT_A, &
    KIM_ENERGY_UNIT_EV, &
    KIM_CHARGE_UNIT_E, &
    KIM_TEMPERATURE_UNIT_K, &
    KIM_TIME_UNIT_PS, &
    requested_length_unit, &
    requested_energy_unit, &
    requested_charge_unit, &
    requested_temperature_unit, &
    requested_time_unit, &
    1.0_cd, 0.0_cd, 0.0_cd, 0.0_cd, 0.0_cd, factor, ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "kim_api_convert_to_act_unit")
    ierr = 1
    goto 42
  end if
  in_sigma = in_sigma * factor

  allocate (buf)

  ! setup buffer
  ! set value of parameters
  do i = 1, 100
    buf%species_name(i) = in_species(i:i)
  end do
  buf%influence_distance(1) = in_cutoff
  buf%Pcutoff(1) = in_cutoff
  buf%cutsq(1) = in_cutoff**2
  buf%model_will_not_request_neighbors_of_noncontributing_particles = 1
  buf%epsilon(1) = in_epsilon
  buf%sigma(1) = in_sigma
  call calc_phi(in_epsilon, &
                in_sigma, &
                0.0_cd, &
                in_cutoff, &
                in_cutoff, energy_at_cutoff)
  buf%shift(1) = -energy_at_cutoff

  ! store model cutoff in KIM object
  call kim_set_influence_distance_pointer( &
    model_driver_create_handle, buf%influence_distance(1))
  call kim_set_neighbor_list_pointers( &
    model_driver_create_handle, 1, buf%influence_distance, &
    buf%model_will_not_request_neighbors_of_noncontributing_particles)

  ! end setup buffer

  ! store in model buffer
  call kim_set_model_buffer_pointer( &
    model_driver_create_handle, c_loc(buf))

  ! set pointers to parameters in KIM object
  call kim_set_parameter_pointer( &
    model_driver_create_handle, buf%pcutoff, "cutoff", &
    "Distance beyond which particles do not interact with one another.", ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "set_parameter")
    ierr = 1
    goto 42
  end if

  call kim_set_parameter_pointer( &
    model_driver_create_handle, buf%epsilon, "epsilon", &
    "Maximum depth of the potential well.", ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "set_parameter")
    ierr = 1
    goto 42
  end if

  call kim_set_parameter_pointer( &
    model_driver_create_handle, buf%sigma, "sigma", &
    "Distance at which energy is zero and force is repulsive.", ierr)
  if (ierr /= 0) then
    call kim_log_entry(model_driver_create_handle, &
                       KIM_LOG_VERBOSITY_ERROR, "set_parameter")
    ierr = 1
    goto 42
  end if

  ierr = 0
42 continue
  return

end subroutine model_driver_create_routine

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelWriteParameterizedModel
!!
!! \sa KIM::ModelWriteParameterizedModel, KIM_ModelWriteParameterizedModel
!!
!! \since 2.0
module kim_model_write_parameterized_model_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_write_parameterized_model_handle_type, &

    ! Constants
    KIM_MODEL_WRITE_PARAMETERIZED_MODEL_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_get_path, &
    kim_get_model_name, &
    kim_set_parameter_file_name, &
    kim_get_model_buffer_pointer, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelWriteParameterizedModel
  !!
  !! \sa KIM::ModelWriteParameterizedModel, KIM_ModelWriteParameterizedModel
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_write_parameterized_model_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_write_parameterized_model_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_write_parameterized_model_handle_type), protected, save &
    :: KIM_MODEL_WRITE_PARAMETERIZED_MODEL_NULL_HANDLE

  !> \brief Compares kim_model_write_parameterized_model_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_write_parameterized_model_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_write_parameterized_model_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_write_parameterized_model_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetPath
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetPath,
  !! KIM_ModelWriteParameterizedModel_GetPath
  !!
  !! \since 2.0
  interface kim_get_path
    module procedure kim_model_write_parameterized_model_get_path
  end interface kim_get_path

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetModelName
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetModelName,
  !! KIM_ModelWriteParameterizedModel_GetModelName
  !!
  !! \since 2.0
  interface kim_get_model_name
    module procedure kim_model_write_parameterized_model_get_model_name
  end interface kim_get_model_name

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::SetParameterFileName
  !!
  !! \sa KIM::ModelWriteParameterizedModel::SetParameterFileName,
  !! KIM_ModelWriteParameterizedModel_SetParameterFileName
  !!
  !! \since 2.0
  interface kim_set_parameter_file_name
    module procedure kim_model_write_parameterized_model_set_parameter_file_name
  end interface kim_set_parameter_file_name

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetModelBufferPointer
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetModelBufferPointer,
  !! KIM_ModelWriteParameterizedModel_GetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_get_model_buffer_pointer
    module procedure &
      kim_model_write_parameterized_model_get_model_buffer_pointer
  end interface kim_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::LogEntry
  !!
  !! \sa KIM::ModelWriteParameterizedModel::LogEntry,
  !! KIM_ModelWriteParameterizedModel_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_write_parameterized_model_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::ToString
  !!
  !! \sa KIM::ModelWriteParameterizedModel::ToString,
  !! KIM_ModelWriteParameterizedModel_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_write_parameterized_model_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_write_parameterized_model_handle_type's for
  !! equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_write_parameterized_model_handle_equal( &
    lhs, rhs)
    implicit none
    type(kim_model_write_parameterized_model_handle_type), intent(in) :: lhs
    type(kim_model_write_parameterized_model_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_write_parameterized_model_handle_equal = .true.
    else
      kim_model_write_parameterized_model_handle_equal = &
        c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_write_parameterized_model_handle_equal

  !> \brief Compares kim_model_write_parameterized_model_handle_type's for
  !! inequality.
  !!
  !! \since 2.0
  logical recursive function &
    kim_model_write_parameterized_model_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_write_parameterized_model_handle_type), intent(in) :: lhs
    type(kim_model_write_parameterized_model_handle_type), intent(in) :: rhs

    kim_model_write_parameterized_model_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_write_parameterized_model_handle_not_equal

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetPath
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetPath,
  !! KIM_ModelWriteParameterizedModel_GetPath
  !!
  !! \since 2.0
  recursive subroutine kim_model_write_parameterized_model_get_path( &
    model_write_parameterized_model_handle, path)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      recursive subroutine get_path(model_write_parameterized_model, path) &
        bind(c, name="KIM_ModelWriteParameterizedModel_GetPath")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
        type(c_ptr), intent(out) :: path
      end subroutine get_path
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    character(len=*, kind=c_char), intent(out) :: path
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    type(c_ptr) :: ppath

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    call get_path(model_write_parameterized_model, ppath)
    call kim_convert_c_char_ptr_to_string(ppath, path)
  end subroutine kim_model_write_parameterized_model_get_path

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetModelName
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetModelName,
  !! KIM_ModelWriteParameterizedModel_GetModelName
  !!
  !! \since 2.0
  recursive subroutine kim_model_write_parameterized_model_get_model_name( &
    model_write_parameterized_model_handle, model_name)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      recursive subroutine get_model_name(model_write_parameterized_model, &
        model_name) &
        bind(c, name="KIM_ModelWriteParameterizedModel_GetModelName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
        type(c_ptr), intent(out) :: model_name
      end subroutine get_model_name
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    character(len=*, kind=c_char), intent(out) :: model_name
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    type(c_ptr) :: pmodel_name

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    call get_model_name(model_write_parameterized_model, pmodel_name)
    call kim_convert_c_char_ptr_to_string(pmodel_name, model_name)
  end subroutine kim_model_write_parameterized_model_get_model_name

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::SetParameterFileName
  !!
  !! \sa KIM::ModelWriteParameterizedModel::SetParameterFileName,
  !! KIM_ModelWriteParameterizedModel_SetParameterFileName
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_write_parameterized_model_set_parameter_file_name( &
    model_write_parameterized_model_handle, file_name)
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      recursive subroutine set_parameter_file_name( &
        model_write_parameterized_model, file_name) &
        bind(c, name="KIM_ModelWriteParameterizedModel_SetParameterFileName")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
        character(c_char), intent(in) :: file_name(*)
      end subroutine set_parameter_file_name
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    character(len=*, kind=c_char), intent(in) :: file_name
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    call set_parameter_file_name(model_write_parameterized_model, &
      trim(file_name)//c_null_char)
  end subroutine kim_model_write_parameterized_model_set_parameter_file_name

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::GetModelBufferPointer
  !!
  !! \sa KIM::ModelWriteParameterizedModel::GetModelBufferPointer,
  !! KIM_ModelWriteParameterizedModel_GetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine &
    kim_model_write_parameterized_model_get_model_buffer_pointer( &
    model_write_parameterized_model_handle, ptr)
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      recursive subroutine get_model_buffer_pointer( &
        model_write_parameterized_model, ptr) &
        bind(c, name="KIM_ModelCompute_GetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
        type(c_ptr), intent(out) :: ptr
      end subroutine get_model_buffer_pointer
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    call get_model_buffer_pointer(model_write_parameterized_model, ptr)
  end subroutine kim_model_write_parameterized_model_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::LogEntry
  !!
  !! \sa KIM::ModelWriteParameterizedModel::LogEntry,
  !! KIM_ModelWriteParameterizedModel_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_write_parameterized_model_log_entry( &
    model_write_parameterized_model_handle, log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      recursive subroutine log_entry(model_write_parameterized_model, &
        log_verbosity, message, line_number, file_name) &
        bind(c, name="KIM_ModelCompute_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    call log_entry(model_write_parameterized_model, log_verbosity, &
      trim(message)//c_null_char, 0, ""//c_null_char)
  end subroutine kim_model_write_parameterized_model_log_entry

  !> \brief \copybrief KIM::ModelWriteParameterizedModel::ToString
  !!
  !! \sa KIM::ModelWriteParameterizedModel::ToString,
  !! KIM_ModelWriteParameterizedModel_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_write_parameterized_model_to_string( &
    model_write_parameterized_model_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : &
      kim_model_write_parameterized_model_type
    implicit none
    interface
      type(c_ptr) recursive function model_write_parameterized_model_string( &
        model_write_parameterized_model) &
        bind(c, name="KIM_ModelCompute_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : &
          kim_model_write_parameterized_model_type
        implicit none
        type(kim_model_write_parameterized_model_type), intent(in) &
          :: model_write_parameterized_model
      end function model_write_parameterized_model_string
    end interface
    type(kim_model_write_parameterized_model_handle_type), intent(in) &
      :: model_write_parameterized_model_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_write_parameterized_model_type), pointer &
      :: model_write_parameterized_model

    type(c_ptr) :: p

    call c_f_pointer(model_write_parameterized_model_handle%p, &
      model_write_parameterized_model)
    p = model_write_parameterized_model_string(model_write_parameterized_model)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_write_parameterized_model_to_string
end module kim_model_write_parameterized_model_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelRefresh
!!
!! \sa KIM::ModelRefresh, KIM_ModelRefresh
!!
!! \since 2.0
module kim_model_refresh_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_refresh_handle_type, &

    ! Constants
    KIM_MODEL_REFRESH_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_set_influence_distance_pointer, &
    kim_set_neighbor_list_pointers, &
    kim_get_model_buffer_pointer, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelRefresh
  !!
  !! \sa KIM::ModelRefresh, KIM_ModelRefresh
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_refresh_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_refresh_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_refresh_handle_type), protected, save &
    :: KIM_MODEL_REFRESH_NULL_HANDLE

  !> \brief Compares kim_model_refresh_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_refresh_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_refresh_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_refresh_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelRefresh::SetInfluenceDistancePointer
  !!
  !! \sa KIM::ModelRefresh::SetInfluenceDistancePointer,
  !! KIM_ModelRefresh_SetInfluenceDistancePointer
  !!
  !! \since 2.0
  interface kim_set_influence_distance_pointer
    module procedure kim_model_refresh_set_influence_distance_pointer
  end interface kim_set_influence_distance_pointer

  !> \brief \copybrief KIM::ModelRefresh::SetNeighborListPointers
  !!
  !! \sa KIM::ModelRefresh::SetNeighborListPointers,
  !! KIM_ModelRefresh_SetNeighborListPointers
  !!
  !! \since 2.0
  interface kim_set_neighbor_list_pointers
    module procedure kim_model_refresh_set_neighbor_list_pointers
  end interface kim_set_neighbor_list_pointers

  !> \brief \copybrief KIM::ModelRefresh::GetModelBufferPointer
  !!
  !! \sa KIM::ModelRefresh::GetModelBufferPointer,
  !! KIM_ModelRefresh_GetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_get_model_buffer_pointer
    module procedure kim_model_refresh_get_model_buffer_pointer
  end interface kim_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelRefresh::LogEntry
  !!
  !! \sa KIM::ModelRefresh::LogEntry, KIM_ModelRefresh_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_refresh_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelRefresh::ToString
  !!
  !! \sa KIM::ModelRefresh::ToString, KIM_ModelRefresh_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_refresh_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_refresh_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_refresh_handle_equal(lhs, rhs)
    implicit none
    type(kim_model_refresh_handle_type), intent(in) :: lhs
    type(kim_model_refresh_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p) .and. c_associated(rhs%p))) then
      kim_model_refresh_handle_equal = .true.
    else
      kim_model_refresh_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_refresh_handle_equal

  !> \brief Compares kim_model_refresh_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_model_refresh_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_refresh_handle_type), intent(in) :: lhs
    type(kim_model_refresh_handle_type), intent(in) :: rhs

    kim_model_refresh_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_refresh_handle_not_equal

  !> \brief \copybrief KIM::ModelRefresh::SetInfluenceDistancePointer
  !!
  !! \sa KIM::ModelRefresh::SetInfluenceDistancePointer,
  !! KIM_ModelRefresh_SetInfluenceDistancePointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_refresh_set_influence_distance_pointer( &
    model_refresh_handle, influence_distance)
    use kim_interoperable_types_module, only : kim_model_refresh_type
    implicit none
    interface
      recursive subroutine set_influence_distance_pointer(model_refresh, &
        influence_distance) &
        bind(c, name="KIM_ModelRefresh_SetInfluenceDistancePointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_refresh_type
        implicit none
        type(kim_model_refresh_type), intent(in) :: &
          model_refresh
        type(c_ptr), intent(in), value :: influence_distance
      end subroutine set_influence_distance_pointer
    end interface
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    real(c_double), intent(in), target :: influence_distance
    type(kim_model_refresh_type), pointer :: model_refresh

    call c_f_pointer(model_refresh_handle%p, model_refresh)
    call set_influence_distance_pointer(model_refresh, &
      c_loc(influence_distance))
  end subroutine kim_model_refresh_set_influence_distance_pointer

  !> \brief \copybrief KIM::ModelRefresh::SetNeighborListPointers
  !!
  !! \sa KIM::ModelRefresh::SetNeighborListPointers,
  !! KIM_ModelRefresh_SetNeighborListPointers
  !!
  !! \since 2.0
  recursive subroutine kim_model_refresh_set_neighbor_list_pointers( &
    model_refresh_handle, number_of_neighbor_lists, cutoffs, &
    modelWillNotRequestNeighborsOfNoncontributingParticles)
    use kim_interoperable_types_module, only : kim_model_refresh_type
    implicit none
    interface
      recursive subroutine set_neighbor_list_pointers(model_refresh, &
        number_of_neighbor_lists, cutoffs_ptr, &
        modelWillNotRequestNeighborsOfNoncontributingParticles) &
        bind(c, name="KIM_ModelRefresh_SetNeighborListPointers")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_refresh_type
        implicit none
        type(kim_model_refresh_type), intent(in) :: &
          model_refresh
        integer(c_int), intent(in), value :: number_of_neighbor_lists
        type(c_ptr), intent(in), value :: cutoffs_ptr
        type(c_ptr), intent(in), value :: &
          modelWillNotRequestNeighborsOfNoncontributingParticles
      end subroutine set_neighbor_list_pointers
    end interface
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    integer(c_int), intent(in) :: number_of_neighbor_lists
    real(c_double), intent(in), target :: cutoffs(number_of_neighbor_lists)
    integer(c_int), intent(in), target :: &
      modelWillNotRequestNeighborsOfNoncontributingParticles( &
      number_of_neighbor_lists)
    type(kim_model_refresh_type), pointer :: model_refresh

    call c_f_pointer(model_refresh_handle%p, model_refresh)
    call set_neighbor_list_pointers(model_refresh, number_of_neighbor_lists, &
      c_loc(cutoffs), &
      c_loc(modelWillNotRequestNeighborsOfNoncontributingParticles))
  end subroutine kim_model_refresh_set_neighbor_list_pointers

  !> \brief \copybrief KIM::ModelRefresh::GetModelBufferPointer
  !!
  !! \sa KIM::ModelRefresh::GetModelBufferPointer,
  !! KIM_ModelRefresh_GetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_refresh_get_model_buffer_pointer( &
    model_refresh_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_refresh_type
    implicit none
    interface
      recursive subroutine get_model_buffer_pointer(model_refresh, ptr) &
        bind(c, name="KIM_ModelRefresh_GetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_refresh_type
        implicit none
        type(kim_model_refresh_type), intent(in) :: &
          model_refresh
        type(c_ptr), intent(out) :: ptr
      end subroutine get_model_buffer_pointer
    end interface
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    type(c_ptr), intent(out) :: ptr
    type(kim_model_refresh_type), pointer :: model_refresh

    call c_f_pointer(model_refresh_handle%p, model_refresh)
    call get_model_buffer_pointer(model_refresh, ptr)
  end subroutine kim_model_refresh_get_model_buffer_pointer

  !> \brief \copybrief KIM::ModelRefresh::LogEntry
  !!
  !! \sa KIM::ModelRefresh::LogEntry, KIM_ModelRefresh_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_refresh_log_entry(model_refresh_handle, &
    log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_refresh_type
    implicit none
    interface
      recursive subroutine log_entry(model_refresh, log_verbosity, message, &
        line_number, file_name) bind(c, name="KIM_ModelRefresh_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_model_refresh_type
        implicit none
        type(kim_model_refresh_type), intent(in) :: &
          model_refresh
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_refresh_type), pointer :: model_refresh

    call c_f_pointer(model_refresh_handle%p, model_refresh)
    call log_entry(model_refresh, log_verbosity, trim(message)//c_null_char, &
      0, ""//c_null_char)
  end subroutine kim_model_refresh_log_entry

  !> \brief \copybrief KIM::ModelRefresh::ToString
  !!
  !! \sa KIM::ModelRefresh::ToString, KIM_ModelRefresh_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_refresh_to_string(model_refresh_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_refresh_type
    implicit none
    interface
      type(c_ptr) recursive function model_refresh_string(model_refresh) &
        bind(c, name="KIM_ModelRefresh_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_refresh_type
        implicit none
        type(kim_model_refresh_type), intent(in) :: &
          model_refresh
      end function model_refresh_string
    end interface
    type(kim_model_refresh_handle_type), intent(in) :: model_refresh_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_refresh_type), pointer :: model_refresh

    type(c_ptr) :: p

    call c_f_pointer(model_refresh_handle%p, model_refresh)
    p = model_refresh_string(model_refresh)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_refresh_to_string
end module kim_model_refresh_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelCreate
!!
!! \sa KIM::ModelCreate, KIM_ModelCreate
!!
!! \since 2.0
module kim_model_create_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_create_handle_type, &

    ! Constants
    KIM_MODEL_CREATE_NULL_HANDLE, &

    ! Routines
    operator (.eq.), &
    operator (.ne.), &
    kim_set_model_numbering, &
    kim_set_influence_distance_pointer, &
    kim_set_neighbor_list_pointers, &
    kim_set_routine_pointer, &
    kim_set_species_code, &
    kim_set_parameter_pointer, &
    kim_set_model_buffer_pointer, &
    kim_set_units, &
    kim_convert_unit, &
    kim_log_entry, &
    kim_to_string


  !> \brief \copybrief KIM::ModelCreate
  !!
  !! \sa KIM::ModelCreate, KIM_ModelCreate
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_create_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_model_create_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_model_create_handle_type), protected, save &
    :: KIM_MODEL_CREATE_NULL_HANDLE

  !> \brief Compares kim_model_create_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_create_handle_equal
  end interface operator (.eq.)

  !> \brief Compares kim_model_create_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_create_handle_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelCreate::SetModelNumbering
  !!
  !! \sa KIM::ModelCreate::SetModelNumbering, KIM_ModelCreate_SetModelNumbering
  !!
  !! \since 2.0
  interface kim_set_model_numbering
    module procedure kim_model_create_set_model_numbering
  end interface kim_set_model_numbering

  !> \brief \copybrief KIM::ModelCreate::SetInfluenceDistancePointer
  !!
  !! \sa KIM::ModelCreate::SetInfluenceDistancePointer,
  !! KIM_ModelCreate_SetInfluenceDistancePointer
  !!
  !! \since 2.0
  interface kim_set_influence_distance_pointer
    module procedure kim_model_create_set_influence_distance_pointer
  end interface kim_set_influence_distance_pointer

  !> \brief \copybrief KIM::ModelCreate::SetNeighborListPointers
  !!
  !! \sa KIM::ModelCreate::SetNeighborListPointers,
  !! KIM_ModelCreate_SetNeighborListPointers
  !!
  !! \since 2.0
  interface kim_set_neighbor_list_pointers
    module procedure kim_model_create_set_neighbor_list_pointers
  end interface kim_set_neighbor_list_pointers

  !> \brief \copybrief KIM::ModelCreate::SetRoutinePointer
  !!
  !! \sa KIM::ModelCreate::SetRoutinePointer, KIM_ModelCreate_SetRoutinePointer
  !!
  !! \since 2.0
  interface kim_set_routine_pointer
    module procedure kim_model_create_set_routine_pointer
  end interface kim_set_routine_pointer

  !> \brief \copybrief KIM::ModelCreate::SetSpeciesCode
  !!
  !! \sa KIM::ModelCreate::SetSpeciesCode, KIM_ModelCreate_SetSpeciesCode
  !!
  !! \since 2.0
  interface kim_set_species_code
    module procedure kim_model_create_set_species_code
  end interface kim_set_species_code

  !> \brief \copybrief KIM::ModelCreate::SetParameterPointer
  !!
  !! \sa KIM::ModelCreate::SetParameterPointer,
  !! KIM_ModelCreate_SetParameterPointerInteger,
  !! KIM_ModelCreate_SetParameterPointerDouble
  !!
  !! \since 2.0
  interface kim_set_parameter_pointer
    module procedure kim_model_create_set_parameter_pointer_integer
    module procedure kim_model_create_set_parameter_pointer_double
  end interface kim_set_parameter_pointer

  !> \brief \copybrief KIM::ModelCreate::SetModelBufferPointer
  !!
  !! \sa KIM::ModelCreate::SetModelBufferPointer,
  !! KIM_ModelCreate_SetModelBufferPointer
  !!
  !! \since 2.0
  interface kim_set_model_buffer_pointer
    module procedure kim_model_create_set_model_buffer_pointer
  end interface kim_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelCreate::SetUnits
  !!
  !! \sa KIM::ModelCreate::SetUnits, KIM_ModelCreate_SetUnits
  !!
  !! \since 2.0
  interface kim_set_units
    module procedure kim_model_create_set_units
  end interface kim_set_units

  !> \brief \copybrief KIM::ModelCreate::ConvertUnit
  !!
  !! \sa KIM::ModelCreate::ConvertUnit, KIM_ModelCreate_ConvertUnit
  !!
  !! \since 2.0
  interface kim_convert_unit
    module procedure kim_model_create_convert_unit
  end interface kim_convert_unit

  !> \brief \copybrief KIM::ModelCreate::LogEntry
  !!
  !! \sa KIM::ModelCreate::LogEntry, KIM_ModelCreate_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_model_create_log_entry
  end interface kim_log_entry

  !> \brief \copybrief KIM::ModelCreate::ToString
  !!
  !! \sa KIM::ModelCreate::ToString, KIM_ModelCreate_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_create_to_string
  end interface kim_to_string

contains
  !> \brief Compares kim_model_create_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_model_create_handle_equal(lhs, rhs)
    implicit none
    type(kim_model_create_handle_type), intent(in) :: lhs
    type(kim_model_create_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_model_create_handle_equal = .true.
    else
      kim_model_create_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_model_create_handle_equal

  !> \brief Compares kim_model_create_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_model_create_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_model_create_handle_type), intent(in) :: lhs
    type(kim_model_create_handle_type), intent(in) :: rhs

    kim_model_create_handle_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_create_handle_not_equal

  !> \brief \copybrief KIM::ModelCreate::SetModelNumbering
  !!
  !! \sa KIM::ModelCreate::SetModelNumbering, KIM_ModelCreate_SetModelNumbering
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_model_numbering( &
    model_create_handle, numbering, ierr)
    use kim_numbering_module, only : kim_numbering_type
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      integer(c_int) recursive function set_model_numbering(model_create, &
        numbering) bind(c, name="KIM_ModelCreate_SetModelNumbering")
        use, intrinsic :: iso_c_binding
        use kim_numbering_module, only : kim_numbering_type
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(kim_numbering_type), intent(in), value :: numbering
      end function set_model_numbering
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(kim_numbering_type), intent(in) :: numbering
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    ierr = set_model_numbering(model_create, numbering)
  end subroutine kim_model_create_set_model_numbering

  !> \brief \copybrief KIM::ModelCreate::SetInfluenceDistancePointer
  !!
  !! \sa KIM::ModelCreate::SetInfluenceDistancePointer,
  !! KIM_ModelCreate_SetInfluenceDistancePointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_influence_distance_pointer( &
    model_create_handle, influence_distance)
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      recursive subroutine set_influence_distance_pointer(model_create, &
        influence_distance) &
        bind(c, name="KIM_ModelCreate_SetInfluenceDistancePointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(c_ptr), intent(in), value :: influence_distance
      end subroutine set_influence_distance_pointer
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    real(c_double), intent(in), target :: influence_distance
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call set_influence_distance_pointer(model_create, &
      c_loc(influence_distance))
  end subroutine kim_model_create_set_influence_distance_pointer

  !> \brief \copybrief KIM::ModelCreate::SetNeighborListPointers
  !!
  !! \sa KIM::ModelCreate::SetNeighborListPointers,
  !! KIM_ModelCreate_SetNeighborListPointers
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_neighbor_list_pointers( &
    model_create_handle, number_of_neighbor_lists, cutoffs, &
    model_will_not_request_neighbors_of_noncontributing_particles)
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      recursive subroutine set_neighbor_list_pointers(model_create, &
        number_of_neighbor_lists, cutoffs_ptr, &
        model_will_not_request_neighbors_of_noncontributing_particles) &
        bind(c, name="KIM_ModelCreate_SetNeighborListPointers")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        integer(c_int), intent(in), value :: number_of_neighbor_lists
        type(c_ptr), intent(in), value :: cutoffs_ptr
        type(c_ptr), intent(in), value :: &
          model_will_not_request_neighbors_of_noncontributing_particles
      end subroutine set_neighbor_list_pointers
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    integer(c_int), intent(in) :: number_of_neighbor_lists
    real(c_double), intent(in), target :: cutoffs(number_of_neighbor_lists)
    integer(c_int), intent(in), target :: &
      model_will_not_request_neighbors_of_noncontributing_particles( &
      number_of_neighbor_lists)
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call set_neighbor_list_pointers(model_create, number_of_neighbor_lists, &
      c_loc(cutoffs), &
      c_loc(model_will_not_request_neighbors_of_noncontributing_particles))
  end subroutine kim_model_create_set_neighbor_list_pointers

  !> \brief \copybrief KIM::ModelCreate::SetRoutinePointer
  !!
  !! \sa KIM::ModelCreate::SetRoutinePointer, KIM_ModelCreate_SetRoutinePointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_routine_pointer( &
    model_create_handle, model_routine_name, language_name, required, fptr, &
    ierr)
    use kim_model_routine_name_module, only : kim_model_routine_name_type
    use kim_language_name_module, only : kim_language_name_type
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      integer(c_int) recursive function set_routine_pointer(model_create, &
        model_routine_name, language_name, required, fptr) &
        bind(c, name="KIM_ModelCreate_SetRoutinePointer")
        use, intrinsic :: iso_c_binding
        use kim_model_routine_name_module, only : kim_model_routine_name_type
        use kim_language_name_module, only : kim_language_name_type
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(kim_model_routine_name_type), intent(in), value &
          :: model_routine_name
        type(kim_language_name_type), intent(in), value :: language_name
        integer(c_int), intent(in), value :: required
        type(c_funptr), intent(in), value :: fptr
      end function set_routine_pointer
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(kim_model_routine_name_type), intent(in) :: model_routine_name
    type(kim_language_name_type), intent(in) :: language_name
    integer(c_int), intent(in) :: required
    type(c_funptr), intent(in), value :: fptr  ! must be left as "value"!?!
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    ierr = set_routine_pointer(model_create, model_routine_name, &
      language_name, required, fptr)
  end subroutine kim_model_create_set_routine_pointer

  !> \brief \copybrief KIM::ModelCreate::SetSpeciesCode
  !!
  !! \sa KIM::ModelCreate::SetSpeciesCode, KIM_ModelCreate_SetSpeciesCode
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_species_code(model_create_handle, &
    species_name, code, ierr)
    use kim_species_name_module, only : kim_species_name_type
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      integer(c_int) recursive function set_species_code(model_create, &
        species_name, code) &
        bind(c, name="KIM_ModelCreate_SetSpeciesCode")
        use, intrinsic :: iso_c_binding
        use kim_species_name_module, only : kim_species_name_type
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(kim_species_name_type), intent(in), value :: species_name
        integer(c_int), intent(in), value :: code
      end function set_species_code
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(kim_species_name_type), intent(in) :: species_name
    integer(c_int), intent(in) :: code
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    ierr = set_species_code(model_create, species_name, code)
  end subroutine kim_model_create_set_species_code

  !> \brief \copybrief KIM::ModelCreate::SetParameterPointer
  !!
  !! \sa KIM::ModelCreate::SetParameterPointer,
  !! KIM_ModelCreate_SetParameterPointerInteger
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_parameter_pointer_integer( &
    model_create_handle, int1, name, description, ierr)
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    integer(c_int), intent(in), target :: int1(:)
    character(len=*, kind=c_char), intent(in) :: name
    character(len=*, kind=c_char), intent(in) :: description
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call set_parameter(model_create, size(int1, 1, c_int), int1, name, &
      description, ierr)
    return

  contains
    recursive subroutine set_parameter(model_create, extent, int1, name, &
      description, ierr)
      use kim_interoperable_types_module, only : kim_model_create_type
      implicit none
      interface
        integer(c_int) recursive function set_parameter_pointer_integer( &
          model_create, extent, ptr, name, description) &
          bind(c, name="KIM_ModelCreate_SetParameterPointerInteger")
          use, intrinsic :: iso_c_binding
          use kim_interoperable_types_module, only : kim_model_create_type
          implicit none
          type(kim_model_create_type), intent(in) :: model_create
          integer(c_int), intent(in), value :: extent
          type(c_ptr), intent(in), value :: ptr
          character(c_char), intent(in) :: name(*)
          character(c_char), intent(in) :: description(*)
        end function set_parameter_pointer_integer
      end interface
      type(kim_model_create_type), intent(in) :: model_create
      integer(c_int), intent(in) :: extent
      integer(c_int), intent(in), target :: int1(extent)
      character(len=*, kind=c_char), intent(in) :: name
      character(len=*, kind=c_char), intent(in) :: description
      integer(c_int), intent(out) :: ierr

      ierr = set_parameter_pointer_integer(model_create, extent, &
        c_loc(int1), trim(name)//c_null_char, &
        trim(description)//c_null_char)
    end subroutine set_parameter
  end subroutine kim_model_create_set_parameter_pointer_integer

  !> \brief \copybrief KIM::ModelCreate::SetParameterPointer
  !!
  !! \sa KIM::ModelCreate::SetParameterPointer,
  !! KIM_ModelCreate_SetParameterPointerDouble
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_parameter_pointer_double( &
    model_create_handle, double1, name, description, ierr)
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    real(c_double), intent(in), target :: double1(:)
    character(len=*, kind=c_char), intent(in) :: name
    character(len=*, kind=c_char), intent(in) :: description
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call set_parameter(model_create, size(double1, 1, c_int), double1, &
      name, description, ierr)
    return

  contains
    recursive subroutine set_parameter(model_create, extent, double1, name, &
      description, ierr)
      implicit none
      interface
        integer(c_int) recursive function set_parameter_pointer_double( &
          model_create, extent, ptr, name, description) &
          bind(c, name="KIM_ModelCreate_SetParameterPointerDouble")
          use, intrinsic :: iso_c_binding
          use kim_interoperable_types_module, only : kim_model_create_type
          implicit none
          type(kim_model_create_type), intent(in) :: model_create
          integer(c_int), intent(in), value :: extent
          type(c_ptr), intent(in), value :: ptr
          character(c_char), intent(in) :: name(*)
          character(c_char), intent(in) :: description(*)
        end function set_parameter_pointer_double
      end interface
      type(kim_model_create_type), intent(in) :: model_create
      integer(c_int), intent(in) :: extent
      real(c_double), intent(in), target :: double1(extent)
      character(len=*, kind=c_char), intent(in) :: name
      character(len=*, kind=c_char), intent(in) :: description
      integer(c_int), intent(out) :: ierr

      ierr = set_parameter_pointer_double(model_create, extent, &
        c_loc(double1), trim(name)//c_null_char, &
        trim(description)//c_null_char)
    end subroutine set_parameter
  end subroutine kim_model_create_set_parameter_pointer_double

  !> \brief \copybrief KIM::ModelCreate::SetModelBufferPointer
  !!
  !! \sa KIM::ModelCreate::SetModelBufferPointer,
  !! KIM_ModelCreate_SetModelBufferPointer
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_model_buffer_pointer( &
    model_create_handle, ptr)
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      recursive subroutine set_model_buffer_pointer(model_create, ptr) &
        bind(c, name="KIM_ModelCreate_SetModelBufferPointer")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(c_ptr), intent(in), value :: ptr
      end subroutine set_model_buffer_pointer
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(c_ptr), intent(in) :: ptr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call set_model_buffer_pointer(model_create, ptr)
  end subroutine kim_model_create_set_model_buffer_pointer

  !> \brief \copybrief KIM::ModelCreate::SetUnits
  !!
  !! \sa KIM::ModelCreate::SetUnits, KIM_ModelCreate_SetUnits
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_set_units(model_create_handle, &
    length_unit, energy_unit, charge_unit, temperature_unit, time_unit, ierr)
    use kim_unit_system_module, only : &
      kim_length_unit_type, &
      kim_energy_unit_type, &
      kim_charge_unit_type, &
      kim_temperature_unit_type, &
      kim_time_unit_type
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      integer(c_int) recursive function set_units(model_create, length_unit, &
        energy_unit, charge_unit, temperature_unit, time_unit) &
        bind(c, name="KIM_ModelCreate_SetUnits")
        use, intrinsic :: iso_c_binding
        use kim_unit_system_module, only : &
          kim_length_unit_type, &
          kim_energy_unit_type, &
          kim_charge_unit_type, &
          kim_temperature_unit_type, &
          kim_time_unit_type
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(kim_length_unit_type), intent(in), value :: length_unit
        type(kim_energy_unit_type), intent(in), value :: energy_unit
        type(kim_charge_unit_type), intent(in), value :: charge_unit
        type(kim_temperature_unit_type), intent(in), value :: temperature_unit
        type(kim_time_unit_type), intent(in), value :: time_unit
      end function set_units
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(kim_length_unit_type), intent(in) :: length_unit
    type(kim_energy_unit_type), intent(in) :: energy_unit
    type(kim_charge_unit_type), intent(in) :: charge_unit
    type(kim_temperature_unit_type), intent(in) :: temperature_unit
    type(kim_time_unit_type), intent(in) :: time_unit
    integer(c_int), intent(out) :: ierr
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    ierr = set_units(model_create, length_unit, energy_unit, &
      charge_unit, temperature_unit, time_unit)
  end subroutine kim_model_create_set_units

  !> \brief \copybrief KIM::ModelCreate::ConvertUnit
  !!
  !! \sa KIM::ModelCreate::ConvertUnit, KIM_ModelCreate_ConvertUnit
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_convert_unit( &
    from_length_unit, from_energy_unit, &
    from_charge_unit, from_temperature_unit, from_time_unit, &
    to_length_unit, to_energy_unit, to_charge_unit, to_temperature_unit, &
    to_time_unit, length_exponent, energy_exponent, charge_exponent, &
    temperature_exponent, time_exponent, conversion_factor, ierr)
    use kim_unit_system_module, only : kim_length_unit_type
    use kim_unit_system_module, only : kim_energy_unit_type
    use kim_unit_system_module, only : kim_charge_unit_type
    use kim_unit_system_module, only : kim_temperature_unit_type
    use kim_unit_system_module, only : kim_time_unit_type
    implicit none
    interface
      integer(c_int) recursive function convert_unit( &
        from_length_unit, from_energy_unit, &
        from_charge_unit, from_temperature_unit, from_time_unit, &
        to_length_unit, to_energy_unit, to_charge_unit, to_temperature_unit, &
        to_time_unit, length_exponent, energy_exponent, charge_exponent, &
        temperature_exponent, time_exponent, conversion_factor) &
        bind(c, name="KIM_ModelCreate_ConvertUnit")
        use, intrinsic :: iso_c_binding
        use kim_unit_system_module, only : kim_length_unit_type
        use kim_unit_system_module, only : kim_energy_unit_type
        use kim_unit_system_module, only : kim_charge_unit_type
        use kim_unit_system_module, only : kim_temperature_unit_type
        use kim_unit_system_module, only : kim_time_unit_type
        implicit none
        type(kim_length_unit_type), intent(in), value :: from_length_unit
        type(kim_energy_unit_type), intent(in), value :: from_energy_unit
        type(kim_charge_unit_type), intent(in), value :: from_charge_unit
        type(kim_temperature_unit_type), intent(in), value :: &
          from_temperature_unit
        type(kim_time_unit_type), intent(in), value :: from_time_unit
        type(kim_length_unit_type), intent(in), value :: to_length_unit
        type(kim_energy_unit_type), intent(in), value :: to_energy_unit
        type(kim_charge_unit_type), intent(in), value :: to_charge_unit
        type(kim_temperature_unit_type), intent(in), value :: &
          to_temperature_unit
        type(kim_time_unit_type), intent(in), value :: to_time_unit
        real(c_double), intent(in), value :: length_exponent
        real(c_double), intent(in), value :: energy_exponent
        real(c_double), intent(in), value :: charge_exponent
        real(c_double), intent(in), value :: temperature_exponent
        real(c_double), intent(in), value :: time_exponent
        real(c_double), intent(out) :: conversion_factor
      end function convert_unit
    end interface
    type(kim_length_unit_type), intent(in) :: from_length_unit
    type(kim_energy_unit_type), intent(in) :: from_energy_unit
    type(kim_charge_unit_type), intent(in) :: from_charge_unit
    type(kim_temperature_unit_type), intent(in) :: from_temperature_unit
    type(kim_time_unit_type), intent(in) :: from_time_unit
    type(kim_length_unit_type), intent(in) :: to_length_unit
    type(kim_energy_unit_type), intent(in) :: to_energy_unit
    type(kim_charge_unit_type), intent(in) :: to_charge_unit
    type(kim_temperature_unit_type), intent(in) :: to_temperature_unit
    type(kim_time_unit_type), intent(in) :: to_time_unit
    real(c_double), intent(in) :: length_exponent
    real(c_double), intent(in) :: energy_exponent
    real(c_double), intent(in) :: charge_exponent
    real(c_double), intent(in) :: temperature_exponent
    real(c_double), intent(in) :: time_exponent
    real(c_double), intent(out) :: conversion_factor
    integer(c_int), intent(out) :: ierr

    ierr = convert_unit(from_length_unit, &
      from_energy_unit, from_charge_unit, from_temperature_unit, &
      from_time_unit, to_length_unit, to_energy_unit, to_charge_unit, &
      to_temperature_unit, to_time_unit, length_exponent, energy_exponent, &
      charge_exponent, temperature_exponent, time_exponent, conversion_factor)
  end subroutine kim_model_create_convert_unit

  !> \brief \copybrief KIM::ModelCreate::LogEntry
  !!
  !! \sa KIM::ModelCreate::LogEntry, KIM_ModelCreate_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_log_entry(model_create_handle, &
    log_verbosity, message)
    use kim_log_verbosity_module, only : kim_log_verbosity_type
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      recursive subroutine log_entry(model_create, log_verbosity, message, &
        line_number, file_name) bind(c, name="KIM_ModelCreate_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only : kim_log_verbosity_type
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_model_create_type), pointer :: model_create

    call c_f_pointer(model_create_handle%p, model_create)
    call log_entry(model_create, log_verbosity, trim(message)//c_null_char, &
      0, ""//c_null_char)
  end subroutine kim_model_create_log_entry

  !> \brief \copybrief KIM::ModelCreate::ToString
  !!
  !! \sa KIM::ModelCreate::ToString, KIM_ModelCreate_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_create_to_string(model_create_handle, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only : kim_model_create_type
    implicit none
    interface
      type(c_ptr) recursive function model_create_string(model_create) &
        bind(c, name="KIM_ModelCreate_ToString")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only : kim_model_create_type
        implicit none
        type(kim_model_create_type), intent(in) :: model_create
      end function model_create_string
    end interface
    type(kim_model_create_handle_type), intent(in) :: model_create_handle
    character(len=*, kind=c_char), intent(out) :: string
    type(kim_model_create_type), pointer :: model_create

    type(c_ptr) :: p

    call c_f_pointer(model_create_handle%p, model_create)
    p = model_create_string(model_create)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_create_to_string
end module kim_model_create_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::SpeciesName
!!
!! \sa KIM::SpeciesName, KIM_SpeciesName
!!
!! \since 2.0
module kim_species_name_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_species_name_type, &

    ! Constants
    KIM_SPECIES_NAME_ELECTRON, &
    KIM_SPECIES_NAME_H, &
    KIM_SPECIES_NAME_HE, &
    KIM_SPECIES_NAME_LI, &
    KIM_SPECIES_NAME_BE, &
    KIM_SPECIES_NAME_B, &
    KIM_SPECIES_NAME_C, &
    KIM_SPECIES_NAME_N, &
    KIM_SPECIES_NAME_O, &
    KIM_SPECIES_NAME_F, &
    KIM_SPECIES_NAME_NE, &
    KIM_SPECIES_NAME_NA, &
    KIM_SPECIES_NAME_MG, &
    KIM_SPECIES_NAME_AL, &
    KIM_SPECIES_NAME_SI, &
    KIM_SPECIES_NAME_P, &
    KIM_SPECIES_NAME_S, &
    KIM_SPECIES_NAME_CL, &
    KIM_SPECIES_NAME_AR, &
    KIM_SPECIES_NAME_K, &
    KIM_SPECIES_NAME_CA, &
    KIM_SPECIES_NAME_SC, &
    KIM_SPECIES_NAME_TI, &
    KIM_SPECIES_NAME_V, &
    KIM_SPECIES_NAME_CR, &
    KIM_SPECIES_NAME_MN, &
    KIM_SPECIES_NAME_FE, &
    KIM_SPECIES_NAME_CO, &
    KIM_SPECIES_NAME_NI, &
    KIM_SPECIES_NAME_CU, &
    KIM_SPECIES_NAME_ZN, &
    KIM_SPECIES_NAME_GA, &
    KIM_SPECIES_NAME_GE, &
    KIM_SPECIES_NAME_AS, &
    KIM_SPECIES_NAME_SE, &
    KIM_SPECIES_NAME_BR, &
    KIM_SPECIES_NAME_KR, &
    KIM_SPECIES_NAME_RB, &
    KIM_SPECIES_NAME_SR, &
    KIM_SPECIES_NAME_Y, &
    KIM_SPECIES_NAME_ZR, &
    KIM_SPECIES_NAME_NB, &
    KIM_SPECIES_NAME_MO, &
    KIM_SPECIES_NAME_TC, &
    KIM_SPECIES_NAME_RU, &
    KIM_SPECIES_NAME_RH, &
    KIM_SPECIES_NAME_PD, &
    KIM_SPECIES_NAME_AG, &
    KIM_SPECIES_NAME_CD, &
    KIM_SPECIES_NAME_IN, &
    KIM_SPECIES_NAME_SN, &
    KIM_SPECIES_NAME_SB, &
    KIM_SPECIES_NAME_TE, &
    KIM_SPECIES_NAME_I, &
    KIM_SPECIES_NAME_XE, &
    KIM_SPECIES_NAME_CS, &
    KIM_SPECIES_NAME_BA, &
    KIM_SPECIES_NAME_LA, &
    KIM_SPECIES_NAME_CE, &
    KIM_SPECIES_NAME_PR, &
    KIM_SPECIES_NAME_ND, &
    KIM_SPECIES_NAME_PM, &
    KIM_SPECIES_NAME_SM, &
    KIM_SPECIES_NAME_EU, &
    KIM_SPECIES_NAME_GD, &
    KIM_SPECIES_NAME_TB, &
    KIM_SPECIES_NAME_DY, &
    KIM_SPECIES_NAME_HO, &
    KIM_SPECIES_NAME_ER, &
    KIM_SPECIES_NAME_TM, &
    KIM_SPECIES_NAME_YB, &
    KIM_SPECIES_NAME_LU, &
    KIM_SPECIES_NAME_HF, &
    KIM_SPECIES_NAME_TA, &
    KIM_SPECIES_NAME_W, &
    KIM_SPECIES_NAME_RE, &
    KIM_SPECIES_NAME_OS, &
    KIM_SPECIES_NAME_IR, &
    KIM_SPECIES_NAME_PT, &
    KIM_SPECIES_NAME_AU, &
    KIM_SPECIES_NAME_HG, &
    KIM_SPECIES_NAME_TL, &
    KIM_SPECIES_NAME_PB, &
    KIM_SPECIES_NAME_BI, &
    KIM_SPECIES_NAME_PO, &
    KIM_SPECIES_NAME_AT, &
    KIM_SPECIES_NAME_RN, &
    KIM_SPECIES_NAME_FR, &
    KIM_SPECIES_NAME_RA, &
    KIM_SPECIES_NAME_AC, &
    KIM_SPECIES_NAME_TH, &
    KIM_SPECIES_NAME_PA, &
    KIM_SPECIES_NAME_U, &
    KIM_SPECIES_NAME_NP, &
    KIM_SPECIES_NAME_PU, &
    KIM_SPECIES_NAME_AM, &
    KIM_SPECIES_NAME_CM, &
    KIM_SPECIES_NAME_BK, &
    KIM_SPECIES_NAME_CF, &
    KIM_SPECIES_NAME_ES, &
    KIM_SPECIES_NAME_FM, &
    KIM_SPECIES_NAME_MD, &
    KIM_SPECIES_NAME_NO, &
    KIM_SPECIES_NAME_LR, &
    KIM_SPECIES_NAME_RF, &
    KIM_SPECIES_NAME_DB, &
    KIM_SPECIES_NAME_SG, &
    KIM_SPECIES_NAME_BH, &
    KIM_SPECIES_NAME_HS, &
    KIM_SPECIES_NAME_MT, &
    KIM_SPECIES_NAME_DS, &
    KIM_SPECIES_NAME_RG, &
    KIM_SPECIES_NAME_CN, &
    KIM_SPECIES_NAME_NH, &
    KIM_SPECIES_NAME_FL, &
    KIM_SPECIES_NAME_MC, &
    KIM_SPECIES_NAME_LV, &
    KIM_SPECIES_NAME_TS, &
    KIM_SPECIES_NAME_OG, &
    KIM_SPECIES_NAME_USER01, &
    KIM_SPECIES_NAME_USER02, &
    KIM_SPECIES_NAME_USER03, &
    KIM_SPECIES_NAME_USER04, &
    KIM_SPECIES_NAME_USER05, &
    KIM_SPECIES_NAME_USER06, &
    KIM_SPECIES_NAME_USER07, &
    KIM_SPECIES_NAME_USER08, &
    KIM_SPECIES_NAME_USER09, &
    KIM_SPECIES_NAME_USER10, &
    KIM_SPECIES_NAME_USER11, &
    KIM_SPECIES_NAME_USER12, &
    KIM_SPECIES_NAME_USER13, &
    KIM_SPECIES_NAME_USER14, &
    KIM_SPECIES_NAME_USER15, &
    KIM_SPECIES_NAME_USER16, &
    KIM_SPECIES_NAME_USER17, &
    KIM_SPECIES_NAME_USER18, &
    KIM_SPECIES_NAME_USER19, &
    KIM_SPECIES_NAME_USER20, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_species_names, &
    kim_get_species_name


  !> \brief \copybrief KIM::SpeciesName
  !!
  !! \sa KIM::SpeciesName, KIM_SpeciesName
  !!
  !! \since 2.0
  type, bind(c) :: kim_species_name_type
    integer(c_int) species_name_id
  end type kim_species_name_type

  !> \brief \copybrief KIM::SPECIES_NAME::electron
  !!
  !! \sa KIM::SPECIES_NAME::electron, KIM_SPECIES_NAME_electron
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_electron") &
    :: KIM_SPECIES_NAME_ELECTRON

  !> \brief \copybrief KIM::SPECIES_NAME::H
  !!
  !! \sa KIM::SPECIES_NAME::H, KIM_SPECIES_NAME_H
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_H") &
    :: KIM_SPECIES_NAME_H

  !> \brief \copybrief KIM::SPECIES_NAME::He
  !!
  !! \sa KIM::SPECIES_NAME::He, KIM_SPECIES_NAME_He
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_He") &
    :: KIM_SPECIES_NAME_HE

  !> \brief \copybrief KIM::SPECIES_NAME::Li
  !!
  !! \sa KIM::SPECIES_NAME::Li, KIM_SPECIES_NAME_Li
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Li") &
    :: KIM_SPECIES_NAME_LI

  !> \brief \copybrief KIM::SPECIES_NAME::Be
  !!
  !! \sa KIM::SPECIES_NAME::Be, KIM_SPECIES_NAME_Be
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Be") &
    :: KIM_SPECIES_NAME_BE

  !> \brief \copybrief KIM::SPECIES_NAME::B
  !!
  !! \sa KIM::SPECIES_NAME::B, KIM_SPECIES_NAME_B
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_B") &
    :: KIM_SPECIES_NAME_B

  !> \brief \copybrief KIM::SPECIES_NAME::C
  !!
  !! \sa KIM::SPECIES_NAME::C, KIM_SPECIES_NAME_C
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_C") &
    :: KIM_SPECIES_NAME_C

  !> \brief \copybrief KIM::SPECIES_NAME::N
  !!
  !! \sa KIM::SPECIES_NAME::N, KIM_SPECIES_NAME_N
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_N") &
    :: KIM_SPECIES_NAME_N

  !> \brief \copybrief KIM::SPECIES_NAME::O
  !!
  !! \sa KIM::SPECIES_NAME::O, KIM_SPECIES_NAME_O
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_O") &
    :: KIM_SPECIES_NAME_O

  !> \brief \copybrief KIM::SPECIES_NAME::F
  !!
  !! \sa KIM::SPECIES_NAME::F, KIM_SPECIES_NAME_F
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_F") &
    :: KIM_SPECIES_NAME_F

  !> \brief \copybrief KIM::SPECIES_NAME::Ne
  !!
  !! \sa KIM::SPECIES_NAME::Ne, KIM_SPECIES_NAME_Ne
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ne") &
    :: KIM_SPECIES_NAME_NE

  !> \brief \copybrief KIM::SPECIES_NAME::Na
  !!
  !! \sa KIM::SPECIES_NAME::Na, KIM_SPECIES_NAME_Na
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Na") &
    :: KIM_SPECIES_NAME_NA

  !> \brief \copybrief KIM::SPECIES_NAME::Mg
  !!
  !! \sa KIM::SPECIES_NAME::Mg, KIM_SPECIES_NAME_Mg
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Mg") &
    :: KIM_SPECIES_NAME_MG

  !> \brief \copybrief KIM::SPECIES_NAME::Al
  !!
  !! \sa KIM::SPECIES_NAME::Al, KIM_SPECIES_NAME_Al
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Al") &
    :: KIM_SPECIES_NAME_AL

  !> \brief \copybrief KIM::SPECIES_NAME::Si
  !!
  !! \sa KIM::SPECIES_NAME::Si, KIM_SPECIES_NAME_Si
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Si") &
    :: KIM_SPECIES_NAME_SI

  !> \brief \copybrief KIM::SPECIES_NAME::P
  !!
  !! \sa KIM::SPECIES_NAME::P, KIM_SPECIES_NAME_P
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_P") &
    :: KIM_SPECIES_NAME_P

  !> \brief \copybrief KIM::SPECIES_NAME::S
  !!
  !! \sa KIM::SPECIES_NAME::S, KIM_SPECIES_NAME_S
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_S") &
    :: KIM_SPECIES_NAME_S

  !> \brief \copybrief KIM::SPECIES_NAME::Cl
  !!
  !! \sa KIM::SPECIES_NAME::Cl, KIM_SPECIES_NAME_Cl
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cl") &
    :: KIM_SPECIES_NAME_CL

  !> \brief \copybrief KIM::SPECIES_NAME::Ar
  !!
  !! \sa KIM::SPECIES_NAME::Ar, KIM_SPECIES_NAME_Ar
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ar") &
    :: KIM_SPECIES_NAME_AR

  !> \brief \copybrief KIM::SPECIES_NAME::K
  !!
  !! \sa KIM::SPECIES_NAME::K, KIM_SPECIES_NAME_K
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_K") &
    :: KIM_SPECIES_NAME_K

  !> \brief \copybrief KIM::SPECIES_NAME::Ca
  !!
  !! \sa KIM::SPECIES_NAME::Ca, KIM_SPECIES_NAME_Ca
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ca") &
    :: KIM_SPECIES_NAME_CA

  !> \brief \copybrief KIM::SPECIES_NAME::Sc
  !!
  !! \sa KIM::SPECIES_NAME::Sc, KIM_SPECIES_NAME_Sc
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sc") &
    :: KIM_SPECIES_NAME_SC

  !> \brief \copybrief KIM::SPECIES_NAME::Ti
  !!
  !! \sa KIM::SPECIES_NAME::Ti, KIM_SPECIES_NAME_Ti
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ti") &
    :: KIM_SPECIES_NAME_TI

  !> \brief \copybrief KIM::SPECIES_NAME::V
  !!
  !! \sa KIM::SPECIES_NAME::V, KIM_SPECIES_NAME_V
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_V") &
    :: KIM_SPECIES_NAME_V

  !> \brief \copybrief KIM::SPECIES_NAME::Cr
  !!
  !! \sa KIM::SPECIES_NAME::Cr, KIM_SPECIES_NAME_Cr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cr") &
    :: KIM_SPECIES_NAME_CR

  !> \brief \copybrief KIM::SPECIES_NAME::Mn
  !!
  !! \sa KIM::SPECIES_NAME::Mn, KIM_SPECIES_NAME_Mn
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Mn") &
    :: KIM_SPECIES_NAME_MN

  !> \brief \copybrief KIM::SPECIES_NAME::Fe
  !!
  !! \sa KIM::SPECIES_NAME::Fe, KIM_SPECIES_NAME_Fe
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Fe") &
    :: KIM_SPECIES_NAME_FE

  !> \brief \copybrief KIM::SPECIES_NAME::Co
  !!
  !! \sa KIM::SPECIES_NAME::Co, KIM_SPECIES_NAME_Co
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Co") &
    :: KIM_SPECIES_NAME_CO

  !> \brief \copybrief KIM::SPECIES_NAME::Ni
  !!
  !! \sa KIM::SPECIES_NAME::Ni, KIM_SPECIES_NAME_Ni
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ni") &
    :: KIM_SPECIES_NAME_NI

  !> \brief \copybrief KIM::SPECIES_NAME::Cu
  !!
  !! \sa KIM::SPECIES_NAME::Cu, KIM_SPECIES_NAME_Cu
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cu") &
    :: KIM_SPECIES_NAME_CU

  !> \brief \copybrief KIM::SPECIES_NAME::Zn
  !!
  !! \sa KIM::SPECIES_NAME::Zn, KIM_SPECIES_NAME_Zn
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Zn") &
    :: KIM_SPECIES_NAME_ZN

  !> \brief \copybrief KIM::SPECIES_NAME::Ga
  !!
  !! \sa KIM::SPECIES_NAME::Ga, KIM_SPECIES_NAME_Ga
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ga") &
    :: KIM_SPECIES_NAME_GA

  !> \brief \copybrief KIM::SPECIES_NAME::Ge
  !!
  !! \sa KIM::SPECIES_NAME::Ge, KIM_SPECIES_NAME_Ge
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ge") &
    :: KIM_SPECIES_NAME_GE

  !> \brief \copybrief KIM::SPECIES_NAME::As
  !!
  !! \sa KIM::SPECIES_NAME::As, KIM_SPECIES_NAME_As
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_As") &
    :: KIM_SPECIES_NAME_AS

  !> \brief \copybrief KIM::SPECIES_NAME::Se
  !!
  !! \sa KIM::SPECIES_NAME::Se, KIM_SPECIES_NAME_Se
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Se") &
    :: KIM_SPECIES_NAME_SE

  !> \brief \copybrief KIM::SPECIES_NAME::Br
  !!
  !! \sa KIM::SPECIES_NAME::Br, KIM_SPECIES_NAME_Br
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Br") &
    :: KIM_SPECIES_NAME_BR

  !> \brief \copybrief KIM::SPECIES_NAME::Kr
  !!
  !! \sa KIM::SPECIES_NAME::Kr, KIM_SPECIES_NAME_Kr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Kr") &
    :: KIM_SPECIES_NAME_KR

  !> \brief \copybrief KIM::SPECIES_NAME::Rb
  !!
  !! \sa KIM::SPECIES_NAME::Rb, KIM_SPECIES_NAME_Rb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Rb") &
    :: KIM_SPECIES_NAME_RB

  !> \brief \copybrief KIM::SPECIES_NAME::Sr
  !!
  !! \sa KIM::SPECIES_NAME::Sr, KIM_SPECIES_NAME_Sr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sr") &
    :: KIM_SPECIES_NAME_SR

  !> \brief \copybrief KIM::SPECIES_NAME::Y
  !!
  !! \sa KIM::SPECIES_NAME::Y, KIM_SPECIES_NAME_Y
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Y") &
    :: KIM_SPECIES_NAME_Y

  !> \brief \copybrief KIM::SPECIES_NAME::Zr
  !!
  !! \sa KIM::SPECIES_NAME::Zr, KIM_SPECIES_NAME_Zr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Zr") &
    :: KIM_SPECIES_NAME_ZR

  !> \brief \copybrief KIM::SPECIES_NAME::Nb
  !!
  !! \sa KIM::SPECIES_NAME::Nb, KIM_SPECIES_NAME_Nb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Nb") &
    :: KIM_SPECIES_NAME_NB

  !> \brief \copybrief KIM::SPECIES_NAME::Mo
  !!
  !! \sa KIM::SPECIES_NAME::Mo, KIM_SPECIES_NAME_Mo
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Mo") &
    :: KIM_SPECIES_NAME_MO

  !> \brief \copybrief KIM::SPECIES_NAME::Tc
  !!
  !! \sa KIM::SPECIES_NAME::Tc, KIM_SPECIES_NAME_Tc
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Tc") &
    :: KIM_SPECIES_NAME_TC

  !> \brief \copybrief KIM::SPECIES_NAME::Ru
  !!
  !! \sa KIM::SPECIES_NAME::Ru, KIM_SPECIES_NAME_Ru
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ru") &
    :: KIM_SPECIES_NAME_RU

  !> \brief \copybrief KIM::SPECIES_NAME::Rh
  !!
  !! \sa KIM::SPECIES_NAME::Rh, KIM_SPECIES_NAME_Rh
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Rh") &
    :: KIM_SPECIES_NAME_RH

  !> \brief \copybrief KIM::SPECIES_NAME::Pd
  !!
  !! \sa KIM::SPECIES_NAME::Pd, KIM_SPECIES_NAME_Pd
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pd") &
    :: KIM_SPECIES_NAME_PD

  !> \brief \copybrief KIM::SPECIES_NAME::Ag
  !!
  !! \sa KIM::SPECIES_NAME::Ag, KIM_SPECIES_NAME_Ag
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ag") &
    :: KIM_SPECIES_NAME_AG

  !> \brief \copybrief KIM::SPECIES_NAME::Cd
  !!
  !! \sa KIM::SPECIES_NAME::Cd, KIM_SPECIES_NAME_Cd
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cd") &
    :: KIM_SPECIES_NAME_CD

  !> \brief \copybrief KIM::SPECIES_NAME::In
  !!
  !! \sa KIM::SPECIES_NAME::In, KIM_SPECIES_NAME_In
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_In") &
    :: KIM_SPECIES_NAME_IN

  !> \brief \copybrief KIM::SPECIES_NAME::Sn
  !!
  !! \sa KIM::SPECIES_NAME::Sn, KIM_SPECIES_NAME_Sn
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sn") &
    :: KIM_SPECIES_NAME_SN

  !> \brief \copybrief KIM::SPECIES_NAME::Sb
  !!
  !! \sa KIM::SPECIES_NAME::Sb, KIM_SPECIES_NAME_Sb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sb") &
    :: KIM_SPECIES_NAME_SB

  !> \brief \copybrief KIM::SPECIES_NAME::Te
  !!
  !! \sa KIM::SPECIES_NAME::Te, KIM_SPECIES_NAME_Te
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Te") &
    :: KIM_SPECIES_NAME_TE

  !> \brief \copybrief KIM::SPECIES_NAME::I
  !!
  !! \sa KIM::SPECIES_NAME::I, KIM_SPECIES_NAME_I
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_I") &
    :: KIM_SPECIES_NAME_I

  !> \brief \copybrief KIM::SPECIES_NAME::Xe
  !!
  !! \sa KIM::SPECIES_NAME::Xe, KIM_SPECIES_NAME_Xe
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Xe") &
    :: KIM_SPECIES_NAME_XE

  !> \brief \copybrief KIM::SPECIES_NAME::Cs
  !!
  !! \sa KIM::SPECIES_NAME::Cs, KIM_SPECIES_NAME_Cs
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cs") &
    :: KIM_SPECIES_NAME_CS

  !> \brief \copybrief KIM::SPECIES_NAME::Ba
  !!
  !! \sa KIM::SPECIES_NAME::Ba, KIM_SPECIES_NAME_Ba
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ba") &
    :: KIM_SPECIES_NAME_BA

  !> \brief \copybrief KIM::SPECIES_NAME::La
  !!
  !! \sa KIM::SPECIES_NAME::La, KIM_SPECIES_NAME_La
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_La") &
    :: KIM_SPECIES_NAME_LA

  !> \brief \copybrief KIM::SPECIES_NAME::Ce
  !!
  !! \sa KIM::SPECIES_NAME::Ce, KIM_SPECIES_NAME_Ce
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ce") &
    :: KIM_SPECIES_NAME_CE

  !> \brief \copybrief KIM::SPECIES_NAME::Pr
  !!
  !! \sa KIM::SPECIES_NAME::Pr, KIM_SPECIES_NAME_Pr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pr") &
    :: KIM_SPECIES_NAME_PR

  !> \brief \copybrief KIM::SPECIES_NAME::Nd
  !!
  !! \sa KIM::SPECIES_NAME::Nd, KIM_SPECIES_NAME_Nd
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Nd") &
    :: KIM_SPECIES_NAME_ND

  !> \brief \copybrief KIM::SPECIES_NAME::Pm
  !!
  !! \sa KIM::SPECIES_NAME::Pm, KIM_SPECIES_NAME_Pm
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pm") &
    :: KIM_SPECIES_NAME_PM

  !> \brief \copybrief KIM::SPECIES_NAME::Sm
  !!
  !! \sa KIM::SPECIES_NAME::Sm, KIM_SPECIES_NAME_Sm
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sm") &
    :: KIM_SPECIES_NAME_SM

  !> \brief \copybrief KIM::SPECIES_NAME::Eu
  !!
  !! \sa KIM::SPECIES_NAME::Eu, KIM_SPECIES_NAME_Eu
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Eu") &
    :: KIM_SPECIES_NAME_EU

  !> \brief \copybrief KIM::SPECIES_NAME::Gd
  !!
  !! \sa KIM::SPECIES_NAME::Gd, KIM_SPECIES_NAME_Gd
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Gd") &
    :: KIM_SPECIES_NAME_GD

  !> \brief \copybrief KIM::SPECIES_NAME::Tb
  !!
  !! \sa KIM::SPECIES_NAME::Tb, KIM_SPECIES_NAME_Tb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Tb") &
    :: KIM_SPECIES_NAME_TB

  !> \brief \copybrief KIM::SPECIES_NAME::Dy
  !!
  !! \sa KIM::SPECIES_NAME::Dy, KIM_SPECIES_NAME_Dy
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Dy") &
    :: KIM_SPECIES_NAME_DY

  !> \brief \copybrief KIM::SPECIES_NAME::Ho
  !!
  !! \sa KIM::SPECIES_NAME::Ho, KIM_SPECIES_NAME_Ho
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ho") &
    :: KIM_SPECIES_NAME_HO

  !> \brief \copybrief KIM::SPECIES_NAME::Er
  !!
  !! \sa KIM::SPECIES_NAME::Er, KIM_SPECIES_NAME_Er
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Er") &
    :: KIM_SPECIES_NAME_ER

  !> \brief \copybrief KIM::SPECIES_NAME::Tm
  !!
  !! \sa KIM::SPECIES_NAME::Tm, KIM_SPECIES_NAME_Tm
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Tm") &
    :: KIM_SPECIES_NAME_TM

  !> \brief \copybrief KIM::SPECIES_NAME::Yb
  !!
  !! \sa KIM::SPECIES_NAME::Yb, KIM_SPECIES_NAME_Yb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Yb") &
    :: KIM_SPECIES_NAME_YB

  !> \brief \copybrief KIM::SPECIES_NAME::Lu
  !!
  !! \sa KIM::SPECIES_NAME::Lu, KIM_SPECIES_NAME_Lu
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Lu") &
    :: KIM_SPECIES_NAME_LU

  !> \brief \copybrief KIM::SPECIES_NAME::Hf
  !!
  !! \sa KIM::SPECIES_NAME::Hf, KIM_SPECIES_NAME_Hf
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Hf") &
    :: KIM_SPECIES_NAME_HF

  !> \brief \copybrief KIM::SPECIES_NAME::Ta
  !!
  !! \sa KIM::SPECIES_NAME::Ta, KIM_SPECIES_NAME_Ta
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ta") &
    :: KIM_SPECIES_NAME_TA

  !> \brief \copybrief KIM::SPECIES_NAME::W
  !!
  !! \sa KIM::SPECIES_NAME::W, KIM_SPECIES_NAME_W
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_W") &
    :: KIM_SPECIES_NAME_W

  !> \brief \copybrief KIM::SPECIES_NAME::Re
  !!
  !! \sa KIM::SPECIES_NAME::Re, KIM_SPECIES_NAME_Re
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Re") &
    :: KIM_SPECIES_NAME_RE

  !> \brief \copybrief KIM::SPECIES_NAME::Os
  !!
  !! \sa KIM::SPECIES_NAME::Os, KIM_SPECIES_NAME_Os
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Os") &
    :: KIM_SPECIES_NAME_OS

  !> \brief \copybrief KIM::SPECIES_NAME::Ir
  !!
  !! \sa KIM::SPECIES_NAME::Ir, KIM_SPECIES_NAME_Ir
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ir") &
    :: KIM_SPECIES_NAME_IR

  !> \brief \copybrief KIM::SPECIES_NAME::Pt
  !!
  !! \sa KIM::SPECIES_NAME::Pt, KIM_SPECIES_NAME_Pt
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pt") &
    :: KIM_SPECIES_NAME_PT

  !> \brief \copybrief KIM::SPECIES_NAME::Au
  !!
  !! \sa KIM::SPECIES_NAME::Au, KIM_SPECIES_NAME_Au
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Au") &
    :: KIM_SPECIES_NAME_AU

  !> \brief \copybrief KIM::SPECIES_NAME::Hg
  !!
  !! \sa KIM::SPECIES_NAME::Hg, KIM_SPECIES_NAME_Hg
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Hg") &
    :: KIM_SPECIES_NAME_HG

  !> \brief \copybrief KIM::SPECIES_NAME::Tl
  !!
  !! \sa KIM::SPECIES_NAME::Tl, KIM_SPECIES_NAME_Tl
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Tl") &
    :: KIM_SPECIES_NAME_TL

  !> \brief \copybrief KIM::SPECIES_NAME::Pb
  !!
  !! \sa KIM::SPECIES_NAME::Pb, KIM_SPECIES_NAME_Pb
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pb") &
    :: KIM_SPECIES_NAME_PB

  !> \brief \copybrief KIM::SPECIES_NAME::Bi
  !!
  !! \sa KIM::SPECIES_NAME::Bi, KIM_SPECIES_NAME_Bi
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Bi") &
    :: KIM_SPECIES_NAME_BI

  !> \brief \copybrief KIM::SPECIES_NAME::Po
  !!
  !! \sa KIM::SPECIES_NAME::Po, KIM_SPECIES_NAME_Po
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Po") &
    :: KIM_SPECIES_NAME_PO

  !> \brief \copybrief KIM::SPECIES_NAME::At
  !!
  !! \sa KIM::SPECIES_NAME::At, KIM_SPECIES_NAME_At
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_At") &
    :: KIM_SPECIES_NAME_AT

  !> \brief \copybrief KIM::SPECIES_NAME::Rn
  !!
  !! \sa KIM::SPECIES_NAME::Rn, KIM_SPECIES_NAME_Rn
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Rn") &
    :: KIM_SPECIES_NAME_RN

  !> \brief \copybrief KIM::SPECIES_NAME::Fr
  !!
  !! \sa KIM::SPECIES_NAME::Fr, KIM_SPECIES_NAME_Fr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Fr") &
    :: KIM_SPECIES_NAME_FR

  !> \brief \copybrief KIM::SPECIES_NAME::Ra
  !!
  !! \sa KIM::SPECIES_NAME::Ra, KIM_SPECIES_NAME_Ra
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ra") &
    :: KIM_SPECIES_NAME_RA

  !> \brief \copybrief KIM::SPECIES_NAME::Ac
  !!
  !! \sa KIM::SPECIES_NAME::Ac, KIM_SPECIES_NAME_Ac
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ac") &
    :: KIM_SPECIES_NAME_AC

  !> \brief \copybrief KIM::SPECIES_NAME::Th
  !!
  !! \sa KIM::SPECIES_NAME::Th, KIM_SPECIES_NAME_Th
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Th") &
    :: KIM_SPECIES_NAME_TH

  !> \brief \copybrief KIM::SPECIES_NAME::Pa
  !!
  !! \sa KIM::SPECIES_NAME::Pa, KIM_SPECIES_NAME_Pa
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pa") &
    :: KIM_SPECIES_NAME_PA

  !> \brief \copybrief KIM::SPECIES_NAME::U
  !!
  !! \sa KIM::SPECIES_NAME::U, KIM_SPECIES_NAME_U
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_U") &
    :: KIM_SPECIES_NAME_U

  !> \brief \copybrief KIM::SPECIES_NAME::Np
  !!
  !! \sa KIM::SPECIES_NAME::Np, KIM_SPECIES_NAME_Np
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Np") &
    :: KIM_SPECIES_NAME_NP

  !> \brief \copybrief KIM::SPECIES_NAME::Pu
  !!
  !! \sa KIM::SPECIES_NAME::Pu, KIM_SPECIES_NAME_Pu
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Pu") &
    :: KIM_SPECIES_NAME_PU

  !> \brief \copybrief KIM::SPECIES_NAME::Am
  !!
  !! \sa KIM::SPECIES_NAME::Am, KIM_SPECIES_NAME_Am
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Am") &
    :: KIM_SPECIES_NAME_AM

  !> \brief \copybrief KIM::SPECIES_NAME::Cm
  !!
  !! \sa KIM::SPECIES_NAME::Cm, KIM_SPECIES_NAME_Cm
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cm") &
    :: KIM_SPECIES_NAME_CM

  !> \brief \copybrief KIM::SPECIES_NAME::Bk
  !!
  !! \sa KIM::SPECIES_NAME::Bk, KIM_SPECIES_NAME_Bk
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Bk") &
    :: KIM_SPECIES_NAME_BK

  !> \brief \copybrief KIM::SPECIES_NAME::Cf
  !!
  !! \sa KIM::SPECIES_NAME::Cf, KIM_SPECIES_NAME_Cf
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cf") &
    :: KIM_SPECIES_NAME_CF

  !> \brief \copybrief KIM::SPECIES_NAME::Es
  !!
  !! \sa KIM::SPECIES_NAME::Es, KIM_SPECIES_NAME_Es
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Es") &
    :: KIM_SPECIES_NAME_ES

  !> \brief \copybrief KIM::SPECIES_NAME::Fm
  !!
  !! \sa KIM::SPECIES_NAME::Fm, KIM_SPECIES_NAME_Fm
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Fm") &
    :: KIM_SPECIES_NAME_FM

  !> \brief \copybrief KIM::SPECIES_NAME::Md
  !!
  !! \sa KIM::SPECIES_NAME::Md, KIM_SPECIES_NAME_Md
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Md") &
    :: KIM_SPECIES_NAME_MD

  !> \brief \copybrief KIM::SPECIES_NAME::No
  !!
  !! \sa KIM::SPECIES_NAME::No, KIM_SPECIES_NAME_No
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_No") &
    :: KIM_SPECIES_NAME_NO

  !> \brief \copybrief KIM::SPECIES_NAME::Lr
  !!
  !! \sa KIM::SPECIES_NAME::Lr, KIM_SPECIES_NAME_Lr
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Lr") &
    :: KIM_SPECIES_NAME_LR

  !> \brief \copybrief KIM::SPECIES_NAME::Rf
  !!
  !! \sa KIM::SPECIES_NAME::Rf, KIM_SPECIES_NAME_Rf
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Rf") &
    :: KIM_SPECIES_NAME_RF

  !> \brief \copybrief KIM::SPECIES_NAME::Db
  !!
  !! \sa KIM::SPECIES_NAME::Db, KIM_SPECIES_NAME_Db
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Db") &
    :: KIM_SPECIES_NAME_DB

  !> \brief \copybrief KIM::SPECIES_NAME::Sg
  !!
  !! \sa KIM::SPECIES_NAME::Sg, KIM_SPECIES_NAME_Sg
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Sg") &
    :: KIM_SPECIES_NAME_SG

  !> \brief \copybrief KIM::SPECIES_NAME::Bh
  !!
  !! \sa KIM::SPECIES_NAME::Bh, KIM_SPECIES_NAME_Bh
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Bh") &
    :: KIM_SPECIES_NAME_BH

  !> \brief \copybrief KIM::SPECIES_NAME::Hs
  !!
  !! \sa KIM::SPECIES_NAME::Hs, KIM_SPECIES_NAME_Hs
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Hs") &
    :: KIM_SPECIES_NAME_HS

  !> \brief \copybrief KIM::SPECIES_NAME::Mt
  !!
  !! \sa KIM::SPECIES_NAME::Mt, KIM_SPECIES_NAME_Mt
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Mt") &
    :: KIM_SPECIES_NAME_MT

  !> \brief \copybrief KIM::SPECIES_NAME::Ds
  !!
  !! \sa KIM::SPECIES_NAME::Ds, KIM_SPECIES_NAME_Ds
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ds") &
    :: KIM_SPECIES_NAME_DS

  !> \brief \copybrief KIM::SPECIES_NAME::Rg
  !!
  !! \sa KIM::SPECIES_NAME::Rg, KIM_SPECIES_NAME_Rg
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Rg") &
    :: KIM_SPECIES_NAME_RG

  !> \brief \copybrief KIM::SPECIES_NAME::Cn
  !!
  !! \sa KIM::SPECIES_NAME::Cn, KIM_SPECIES_NAME_Cn
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Cn") &
    :: KIM_SPECIES_NAME_CN

  !> \brief \copybrief KIM::SPECIES_NAME::Nh
  !!
  !! \sa KIM::SPECIES_NAME::Nh, KIM_SPECIES_NAME_Nh
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Nh") &
    :: KIM_SPECIES_NAME_NH

  !> \brief \copybrief KIM::SPECIES_NAME::Fl
  !!
  !! \sa KIM::SPECIES_NAME::Fl, KIM_SPECIES_NAME_Fl
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Fl") &
    :: KIM_SPECIES_NAME_FL

  !> \brief \copybrief KIM::SPECIES_NAME::Mc
  !!
  !! \sa KIM::SPECIES_NAME::Mc, KIM_SPECIES_NAME_Mc
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Mc") &
    :: KIM_SPECIES_NAME_MC

  !> \brief \copybrief KIM::SPECIES_NAME::Lv
  !!
  !! \sa KIM::SPECIES_NAME::Lv, KIM_SPECIES_NAME_Lv
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Lv") &
    :: KIM_SPECIES_NAME_LV

  !> \brief \copybrief KIM::SPECIES_NAME::Ts
  !!
  !! \sa KIM::SPECIES_NAME::Ts, KIM_SPECIES_NAME_Ts
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Ts") &
    :: KIM_SPECIES_NAME_TS

  !> \brief \copybrief KIM::SPECIES_NAME::Og
  !!
  !! \sa KIM::SPECIES_NAME::Og, KIM_SPECIES_NAME_Og
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_Og") &
    :: KIM_SPECIES_NAME_OG

  !> \brief \copybrief KIM::SPECIES_NAME::user01
  !!
  !! \sa KIM::SPECIES_NAME::user01, KIM_SPECIES_NAME_user01
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user01") &
    :: KIM_SPECIES_NAME_USER01

  !> \brief \copybrief KIM::SPECIES_NAME::user02
  !!
  !! \sa KIM::SPECIES_NAME::user02, KIM_SPECIES_NAME_user02
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user02") &
    :: KIM_SPECIES_NAME_USER02

  !> \brief \copybrief KIM::SPECIES_NAME::user03
  !!
  !! \sa KIM::SPECIES_NAME::user03, KIM_SPECIES_NAME_user03
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user03") &
    :: KIM_SPECIES_NAME_USER03

  !> \brief \copybrief KIM::SPECIES_NAME::user04
  !!
  !! \sa KIM::SPECIES_NAME::user04, KIM_SPECIES_NAME_user04
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user04") &
    :: KIM_SPECIES_NAME_USER04

  !> \brief \copybrief KIM::SPECIES_NAME::user05
  !!
  !! \sa KIM::SPECIES_NAME::user05, KIM_SPECIES_NAME_user05
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user05") &
    :: KIM_SPECIES_NAME_USER05

  !> \brief \copybrief KIM::SPECIES_NAME::user06
  !!
  !! \sa KIM::SPECIES_NAME::user06, KIM_SPECIES_NAME_user06
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user06") &
    :: KIM_SPECIES_NAME_USER06

  !> \brief \copybrief KIM::SPECIES_NAME::user07
  !!
  !! \sa KIM::SPECIES_NAME::user07, KIM_SPECIES_NAME_user07
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user07") &
    :: KIM_SPECIES_NAME_USER07

  !> \brief \copybrief KIM::SPECIES_NAME::user08
  !!
  !! \sa KIM::SPECIES_NAME::user08, KIM_SPECIES_NAME_user08
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user08") &
    :: KIM_SPECIES_NAME_USER08

  !> \brief \copybrief KIM::SPECIES_NAME::user09
  !!
  !! \sa KIM::SPECIES_NAME::user09, KIM_SPECIES_NAME_user09
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user09") &
    :: KIM_SPECIES_NAME_USER09

  !> \brief \copybrief KIM::SPECIES_NAME::user10
  !!
  !! \sa KIM::SPECIES_NAME::user10, KIM_SPECIES_NAME_user10
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user10") &
    :: KIM_SPECIES_NAME_USER10

  !> \brief \copybrief KIM::SPECIES_NAME::user11
  !!
  !! \sa KIM::SPECIES_NAME::user11, KIM_SPECIES_NAME_user11
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user11") &
    :: KIM_SPECIES_NAME_USER11

  !> \brief \copybrief KIM::SPECIES_NAME::user12
  !!
  !! \sa KIM::SPECIES_NAME::user12, KIM_SPECIES_NAME_user12
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user12") &
    :: KIM_SPECIES_NAME_USER12

  !> \brief \copybrief KIM::SPECIES_NAME::user13
  !!
  !! \sa KIM::SPECIES_NAME::user13, KIM_SPECIES_NAME_user13
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user13") &
    :: KIM_SPECIES_NAME_USER13

  !> \brief \copybrief KIM::SPECIES_NAME::user14
  !!
  !! \sa KIM::SPECIES_NAME::user14, KIM_SPECIES_NAME_user14
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user14") &
    :: KIM_SPECIES_NAME_USER14

  !> \brief \copybrief KIM::SPECIES_NAME::user15
  !!
  !! \sa KIM::SPECIES_NAME::user15, KIM_SPECIES_NAME_user15
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user15") &
    :: KIM_SPECIES_NAME_USER15

  !> \brief \copybrief KIM::SPECIES_NAME::user16
  !!
  !! \sa KIM::SPECIES_NAME::user16, KIM_SPECIES_NAME_user16
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user16") &
    :: KIM_SPECIES_NAME_USER16

  !> \brief \copybrief KIM::SPECIES_NAME::user17
  !!
  !! \sa KIM::SPECIES_NAME::user17, KIM_SPECIES_NAME_user17
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user17") &
    :: KIM_SPECIES_NAME_USER17

  !> \brief \copybrief KIM::SPECIES_NAME::user18
  !!
  !! \sa KIM::SPECIES_NAME::user18, KIM_SPECIES_NAME_user18
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user18") &
    :: KIM_SPECIES_NAME_USER18

  !> \brief \copybrief KIM::SPECIES_NAME::user19
  !!
  !! \sa KIM::SPECIES_NAME::user19, KIM_SPECIES_NAME_user19
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user19") &
    :: KIM_SPECIES_NAME_USER19

  !> \brief \copybrief KIM::SPECIES_NAME::user20
  !!
  !! \sa KIM::SPECIES_NAME::user20, KIM_SPECIES_NAME_user20
  !!
  !! \since 2.0
  type(kim_species_name_type), protected, save, &
    bind(c, name="KIM_SPECIES_NAME_user20") &
    :: KIM_SPECIES_NAME_USER20


  !> \brief \copybrief KIM::SpeciesName::Known
  !!
  !! \sa KIM::SpeciesName::Known, KIM_SpeciesName_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_species_name_known
  end interface kim_known

  !> \brief \copybrief KIM::SpeciesName::operator==()
  !!
  !! \sa KIM::SpeciesName::operator==(), KIM_SpeciesName_Equal
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_species_name_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::SpeciesName::operator!=()
  !!
  !! \sa KIM::SpeciesName::operator!=, KIM_SpeciesName_NotEqual
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_species_name_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::SpeciesName::SpeciesName(std::string const &)
  !!
  !! \sa KIM::SpeciesName::SpeciesName(std::string const &),
  !! KIM_SpeciesName_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_species_name_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::SpeciesName::ToString
  !!
  !! \sa KIM::SpeciesName::ToString, KIM_SpeciesName_ToSting
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_species_name_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::SpeciesName::Known
  !!
  !! \sa KIM::SpeciesName::Known, KIM_SpeciesName_Known
  !!
  !! \since 2.0
  logical recursive function kim_species_name_known(species_name)
    implicit none
    interface
      integer(c_int) recursive function known(species_name) &
        bind(c, name="KIM_SpeciesName_Known")
        use, intrinsic :: iso_c_binding
        import kim_species_name_type
        implicit none
        type(kim_species_name_type), intent(in), value :: species_name
      end function known
    end interface
    type(kim_species_name_type), intent(in) :: species_name

    kim_species_name_known = (known(species_name) /= 0)
  end function kim_species_name_known

  !> \brief \copybrief KIM::SpeciesName::operator==()
  !!
  !! \sa KIM::SpeciesName::operator==(), KIM_SpeciesName_Equal
  !!
  !! \since 2.0
  logical recursive function kim_species_name_equal(lhs, rhs)
    implicit none
    type(kim_species_name_type), intent(in) :: lhs
    type(kim_species_name_type), intent(in) :: rhs

    kim_species_name_equal &
      = (lhs%species_name_id .eq. rhs%species_name_id)
  end function kim_species_name_equal

  !> \brief \copybrief KIM::SpeciesName::operator!=()
  !!
  !! \sa KIM::SpeciesName::operator!=, KIM_SpeciesName_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_species_name_not_equal(lhs, rhs)
    implicit none
    type(kim_species_name_type), intent(in) :: lhs
    type(kim_species_name_type), intent(in) :: rhs

    kim_species_name_not_equal = .not. (lhs .eq. rhs)
  end function kim_species_name_not_equal

  !> \brief \copybrief KIM::SpeciesName::SpeciesName(std::string const &)
  !!
  !! \sa KIM::SpeciesName::SpeciesName(std::string const &),
  !! KIM_SpeciesName_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_species_name_from_string(string, species_name)
    implicit none
    interface
      type(kim_species_name_type) recursive function from_string(string) &
        bind(c, name="KIM_SpeciesName_FromString")
        use, intrinsic :: iso_c_binding
        import kim_species_name_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_species_name_type), intent(out) :: species_name

    species_name = from_string(trim(string)//c_null_char)
  end subroutine kim_species_name_from_string

  !> \brief \copybrief KIM::SpeciesName::ToString
  !!
  !! \sa KIM::SpeciesName::ToString, KIM_SpeciesName_ToSting
  !!
  !! \since 2.0
  recursive subroutine kim_species_name_to_string(species_name, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(species_name) &
        bind(c, name="KIM_SpeciesName_ToString")
        use, intrinsic :: iso_c_binding
        import kim_species_name_type
        implicit none
        type(kim_species_name_type), intent(in), value :: species_name
      end function get_string
    end interface
    type(kim_species_name_type), intent(in) :: species_name
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(species_name)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_species_name_to_string

  !> \brief \copybrief KIM::SPECIES_NAME::GetNumberOfSpeciesNames
  !!
  !! \sa KIM::SPECIES_NAME::GetNumberOfSpeciesNames,
  !! KIM_SPECIES_NAME_GetNumberOfSpeciesNames
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_species_names(number_of_species_names)
    implicit none
    interface
      recursive subroutine get_number_of_species_names( &
        number_of_species_names) &
        bind(c, name="KIM_SPECIES_NAME_GetNumberOfSpeciesNames")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_species_names
      end subroutine get_number_of_species_names
    end interface
    integer(c_int), intent(out) :: number_of_species_names

    call get_number_of_species_names(number_of_species_names)
  end subroutine kim_get_number_of_species_names

  !> \brief \copybrief KIM::SPECIES_NAME::GetSpeciesName
  !!
  !! \sa KIM::SPECIES_NAME::GetSpeciesName, KIM_SPECIES_NAME_GetSpeciesName
  !!
  !! \since 2.0
  recursive subroutine kim_get_species_name(index, species_name, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_species_name(index, species_name) &
        bind(c, name="KIM_SPECIES_NAME_GetSpeciesName")
        use, intrinsic :: iso_c_binding
        import kim_species_name_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_species_name_type), intent(out) :: species_name
      end function get_species_name
    end interface
    integer(c_int), intent(in) :: index
    type(kim_species_name_type), intent(out) :: species_name
    integer(c_int), intent(out) :: ierr

    ierr = get_species_name(index-1, species_name)
  end subroutine kim_get_species_name
end module kim_species_name_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ellad B. Tadmor
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!
!
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!

!****************************************************************************
!**
!**  MODULE ex_model_Ar_SLJ_MultiCutoff
!**
!** Spring-modified Lennard-Jones (SLJ) pair potential model for Ar
!**
!**  V = 0.5 \sum_i \sum_j eps_i eps_j 4 [ (sig/r_ij)^12 - (sig/r_ij)^6 ] (1)
!**
!**  where
!**        eps_i = 0.5 \sum_k spring (r_ik)^2                             (2)
!**
!**  See README for details.
!**
!**  Language: Fortran 2003
!**
!**  Author: Ellad B. Tadmor
!**
!**  Date: August 23, 2018
!**
!****************************************************************************

module ex_model_Ar_SLJ_MultiCutoff

  use, intrinsic :: iso_c_binding
  use kim_model_headers_module
  implicit none

  save
  private
  public Compute_Energy_Forces, &
    model_destroy_func, &
    model_compute_arguments_create, &
    model_compute_arguments_destroy, &
    model_cutoff1, &
    model_cutoff2, &
    speccode, &
    buffer_type

  ! Below are the definitions and values of all Model parameters
  integer(c_int), parameter :: cd = c_double  ! used for literal constants
  integer(c_int), parameter :: DIM = 3  ! dimensionality of space
  integer(c_int), parameter :: speccode = 1  ! internal species code

  !-----------------------------------------------------------------------------
  ! Below are the definitions and values of all additional model parameters
  !
  ! Recall that the Fortran 2003 format for declaring parameters is as follows:
  !
  ! integer(c_int), parameter :: parname = value  ! This defines an integer
  !                                               ! parameter called `parname'
  !                                               ! with a value equal to
  !                                               ! `value' (a number)
  !
  ! real(c_double), parameter :: parname = value  ! This defines a real(c_double)
  !                                               ! parameter called `parname'
  !                                               ! with a value equal to
  !                                               ! `value' (a number)
  !-----------------------------------------------------------------------------
  real(c_double), parameter :: lj_spring = 0.00051226_cd
  real(c_double), parameter :: lj_sigma = 5.26_cd / 1.74724_cd
  ! experimental fcc lattice constant is a0=5.26
  real(c_double), parameter :: model_cutoff1 = 1.25 * lj_sigma
  ! short-range nearest neighbor for fcc
  real(c_double), parameter :: model_cutoff2 = 2.25 * lj_sigma
  ! long-range third neighbor for fcc
  real(c_double), parameter :: model_cutsq1 = model_cutoff1**2
  real(c_double), parameter :: model_cutsq2 = model_cutoff2**2

  type, bind(c) :: buffer_type
    real(c_double) :: influence_distance
    real(c_double) :: cutoff(2)
    integer(c_int) :: &
      model_will_not_request_neighbors_of_noncontributing_particles(2)
  end type buffer_type

contains

  !-----------------------------------------------------------------------------
  !
  !  Calculate Lennard-Jones potential phi(r) and, if requested,
  !  its derivative dphi(r)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_phi(r, phi, dphi, calc_deriv)
    implicit none

    !-- Transferred variables
    real(c_double), intent(in)  :: r
    real(c_double), intent(out) :: phi
    real(c_double), intent(out) :: dphi
    logical, intent(in)  :: calc_deriv

    !-- Local variables
    real(c_double) rsq, sor, sor6, sor12

    rsq = r * r             !  r^2
    sor = lj_sigma / r      !  (sig/r)
    sor6 = sor * sor * sor     !
    sor6 = sor6 * sor6       !  (sig/r)^6
    sor12 = sor6 * sor6       !  (sig/r)^12
    if (r > model_cutoff2) then
      ! Argument exceeds cutoff radius
      phi = 0.0_cd
      if (calc_deriv) dphi = 0.0_cd
    else
      phi = 4.0_cd * (sor12 - sor6)
      if (calc_deriv) dphi = 24.0_cd * (-2.0_cd * sor12 + sor6) / r
    end if

  end subroutine calc_phi

  !-----------------------------------------------------------------------------
  !
  !  Calculate short-range linear spring-based energy amplitude for `atom`
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_spring_energyamp(model_compute_arguments_handle, &
                                             atom, coor, eps, ierr)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_arguments_handle_type), &
      intent(in)  :: model_compute_arguments_handle
    integer(c_int), intent(in)  :: atom
    real(c_double), intent(in)  :: coor(:, :)
    real(c_double), intent(out) :: eps
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    integer(c_int) k, kk
    real(c_double) Rrel(DIM)
    real(c_double) Rsqrel
    integer(c_int) numneishort
    integer(c_int), pointer :: neishort(:)

    ! Get short-range neighbors of `atom`
    call kim_get_neighbor_list( &
      model_compute_arguments_handle, 1, atom, numneishort, neishort, ierr)
    if (ierr /= 0) return

    eps = 0.0_cd
    do kk = 1, numneishort
      k = neishort(kk)
      Rrel(:) = coor(:, k) - coor(:, atom)
      Rsqrel = dot_product(Rrel, Rrel)
      if (Rsqrel < model_cutsq1) eps = eps + Rsqrel
    end do
    eps = 0.5_cd * lj_spring * eps

  end subroutine calc_spring_energyamp

  !-----------------------------------------------------------------------------
  !
  !  Calculate short-range linear spring-based contribution to force
  !
  !-----------------------------------------------------------------------------
  recursive subroutine calc_spring_force(model_compute_arguments_handle, atom, &
                                         coor, eps, phi, force, ierr)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_arguments_handle_type), &
      intent(in)     :: model_compute_arguments_handle
    integer(c_int), intent(in)     :: atom
    real(c_double), intent(in)     :: coor(:, :)
    real(c_double), intent(in)     :: eps
    real(c_double), intent(in)     :: phi
    real(c_double), intent(inout)  :: force(:, :)
    integer(c_int), intent(out)    :: ierr

    !-- Local variables
    integer(c_int) k, kk
    real(c_double) Rrel(DIM), dforce(DIM)
    real(c_double) Rsqrel
    integer(c_int) numneishort
    integer(c_int), pointer :: neishort(:)

    ! Get short-range neighbors of `atom`
    call kim_get_neighbor_list( &
      model_compute_arguments_handle, 1, atom, numneishort, neishort, ierr)
    if (ierr /= 0) return

    ! Add contribution to force on `atom` and its near neighbors that contribute
    ! to the spring term
    do kk = 1, numneishort
      k = neishort(kk)
      Rrel(:) = coor(:, k) - coor(:, atom)
      Rsqrel = dot_product(Rrel, Rrel)
      if (Rsqrel < model_cutsq1) then
        dforce(:) = 0.5_cd * eps * lj_spring * Rrel(:) * phi
        force(:, atom) = force(:, atom) + dforce(:) ! accumulate force on atom
        force(:, k) = force(:, k) - dforce(:)    ! accumulate force on k
      end if
    end do

  end subroutine calc_spring_force

  !-----------------------------------------------------------------------------
  !
  ! Compute energy and forces on particles from the positions.
  !
  !-----------------------------------------------------------------------------
  recursive subroutine Compute_Energy_Forces( &
    model_compute_handle, model_compute_arguments_handle, ierr) bind(c)
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_handle_type), intent(in) :: &
      model_compute_arguments_handle
    integer(c_int), intent(out) :: ierr

    !-- Local variables
    real(c_double) :: Rij(DIM), dforce(DIM)
    real(c_double) :: r, Rsqij, phi, dphi, dEidr, epsi, epsj
    integer(c_int) :: i, j, jj, comp_force, comp_enepot, comp_energy
    !integer(c_int) :: comp_virial
    integer(c_int) :: numnei
    integer(c_int) :: ierr2
    logical        :: calc_deriv

    !-- KIM variables
    integer(c_int), pointer :: N
    real(c_double), pointer :: energy
    real(c_double), pointer :: coor(:, :)
    real(c_double), pointer :: force(:, :)
    real(c_double), pointer :: enepot(:)
    integer(c_int), pointer :: nei1part(:)
    integer(c_int), pointer :: particleSpeciesCodes(:)
    integer(c_int), pointer :: particleContributing(:)
    !real(c_double), pointer :: virial(:)

    ! Unpack data from KIM object
    !
    ierr = 0
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES, N, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES, n, &
      particleSpeciesCodes, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING, n, &
      particleContributing, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_COORDINATES, dim, n, coor, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, energy, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, dim, n, force, ierr2)
    ierr = ierr + ierr2
    call kim_get_argument_pointer( &
      model_compute_arguments_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, n, enepot, ierr2)
    ierr = ierr + ierr2
    !call kim_model_compute_arguments_get_argument_pointer( &
    !  model_compute_arguments_handle, &
    !  KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_VIRIAL, 6, virial, ierr2)
    !ierr = ierr + ierr2
    if (ierr /= 0) then
      call kim_log_entry(model_compute_arguments_handle, &
                         KIM_LOG_VERBOSITY_ERROR, "get data")
      return
    end if

    ! Check to see if we have been asked to compute the forces, energyperpart,
    ! energy and virial
    !
    if (associated(energy)) then
      comp_energy = 1
    else
      comp_energy = 0
    end if
    if (associated(force)) then
      comp_force = 1
    else
      comp_force = 0
    end if
    if (associated(enepot)) then
      comp_enepot = 1
    else
      comp_enepot = 0
    end if
    !if (associated(virial)) then
    !  comp_virial = 1
    !else
    !  comp_virial = 0
    !end if
    calc_deriv = comp_force == 1 !.or.comp_virial.eq.1

    ! Check to be sure that the species are correct
    !
    ierr = 1 ! assume an error
    do i = 1, N
      if (particleSpeciesCodes(i) /= speccode) then
        call kim_log_entry( &
          model_compute_handle, KIM_LOG_VERBOSITY_ERROR, &
          "Unexpected species code detected")
        return
      end if
    end do
    ierr = 0 ! everything is ok

    ! Initialize potential energies, forces, virial term
    !
    if (comp_enepot == 1) enepot = 0.0_cd
    if (comp_energy == 1) energy = 0.0_cd
    if (comp_force == 1) force = 0.0_cd
    !if (comp_virial.eq.1) virial = 0.0_cd
    if (calc_deriv) dEidr = 0.0_cd

    !
    !  Compute energy and forces
    !

    !  Loop over particles and compute energy and forces
    !
    do i = 1, N
      if (particleContributing(i) == 1) then
        ! Set up neighbor list for next particle
        call kim_get_neighbor_list( &
          model_compute_arguments_handle, 2, i, numnei, nei1part, ierr)
        if (ierr /= 0) then
          ! some sort of problem, exit
          call kim_log_entry( &
            model_compute_arguments_handle, KIM_LOG_VERBOSITY_ERROR, &
            "GetNeighborList failed")
          ierr = 1
          return
        end if

        ! Get short range contribution for atom i to energy amplitude
        call calc_spring_energyamp(model_compute_arguments_handle, &
                                   i, coor, epsi, ierr)
        if (ierr /= 0) then
          ! some sort of problem, exit
          call kim_log_entry( &
            model_compute_handle, KIM_LOG_VERBOSITY_ERROR, &
            "GetNeighborList failed")
          ierr = 1
          return
        end if

        ! Loop over the neighbors of particle i
        !
        do jj = 1, numnei

          j = nei1part(jj)                           ! get neighbor ID

          ! Get short range contribution for atom j to energy amplitude
          call calc_spring_energyamp(model_compute_arguments_handle, j, coor, &
                                     epsj, ierr)
          if (ierr /= 0) then
            ! some sort of problem, exit
            call kim_log_entry( &
              model_compute_handle, KIM_LOG_VERBOSITY_ERROR, &
              "GetNeighborList failed")
            ierr = 1
            return
          end if

          ! compute relative position vector
          !
          Rij(:) = coor(:, j) - coor(:, i)          ! distance vector between i j

          ! compute energy and forces
          !
          Rsqij = dot_product(Rij, Rij)               ! compute square distance
          if (Rsqij < model_cutsq2) then        ! particles are interacting?

            r = sqrt(Rsqij)                          ! compute distance
            call calc_phi(r, phi, dphi, calc_deriv)     ! compute pair potential and deriv
            if (calc_deriv) dEidr = 0.5_cd * dphi

            ! contribution to energy
            !
            if (comp_enepot == 1) then
              enepot(i) = enepot(i) + 0.5_cd * epsi * epsj * phi   ! accumulate energy
            end if
            if (comp_energy == 1) then
              energy = energy + 0.5_cd * epsi * epsj * phi
            end if

            !!@@@@@@@@@@@@@@@@@@@@ NOT FIXED YET
            !        ! contribution to virial tensor,
            !        !   virial(i,j)=r(i)*r(j)*(dV/dr)/r
            !        !
            !        if (comp_virial.eq.1) then
            !          virial(1) = virial(1) + Rij(1)*Rij(1)*dEidr/r
            !          virial(2) = virial(2) + Rij(2)*Rij(2)*dEidr/r
            !          virial(3) = virial(3) + Rij(3)*Rij(3)*dEidr/r
            !          virial(4) = virial(4) + Rij(2)*Rij(3)*dEidr/r
            !          virial(5) = virial(5) + Rij(1)*Rij(3)*dEidr/r
            !          virial(6) = virial(6) + Rij(1)*Rij(2)*dEidr/r
            !        endif
            !!@@@@@@@@@@@@@@@@@@@@

            ! contribution to forces
            !
            if (comp_force == 1) then
              ! Contribution due to short range neighbors of i
              call calc_spring_force(model_compute_arguments_handle, i, coor, &
                                     epsj, phi, force, ierr)
              if (ierr /= 0) then
                ! some sort of problem, exit
                call kim_log_entry( &
                  model_compute_handle, KIM_LOG_VERBOSITY_ERROR, &
                  "GetNeighborList failed")
                ierr = 1
                return
              end if
              ! Contribution due to short range neighbors of j
              call calc_spring_force(model_compute_arguments_handle, j, coor, &
                                     epsi, phi, force, ierr)
              if (ierr /= 0) then
                ! some sort of problem, exit
                call kim_log_entry( &
                  model_compute_handle, KIM_LOG_VERBOSITY_ERROR, &
                  "GetNeighborList failed")
                ierr = 1
                return
              end if
              ! Contribution due to deriv of LJ term
              dforce(:) = epsi * epsj * dEidr * Rij(:) / r
              force(:, i) = force(:, i) + dforce(:) ! accumulate force on i
              force(:, j) = force(:, j) - dforce(:) ! accumulate force on j
            end if

          end if

        end do  ! loop on jj

      end if  ! if particleContributing

    end do  ! do i

    ! Everything is great
    !
    ierr = 0
    return

  end subroutine Compute_Energy_Forces

  !-----------------------------------------------------------------------------
  !
  ! Model destroy routine (REQUIRED)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine model_destroy_func(model_destroy_handle, ierr) bind(c)
    use, intrinsic :: iso_c_binding
    implicit none

    !-- Transferred variables
    type(kim_model_destroy_handle_type), intent(inout) :: model_destroy_handle
    integer(c_int), intent(out) :: ierr

    type(buffer_type), pointer :: buf; type(c_ptr) :: pbuf

    call kim_get_model_buffer_pointer(model_destroy_handle, pbuf)
    call c_f_pointer(pbuf, buf)
    call kim_log_entry(model_destroy_handle, KIM_LOG_VERBOSITY_INFORMATION, &
                       "deallocating model buffer")
    deallocate (buf)
    ierr = 0  ! everything is good
  end subroutine model_destroy_func

  !-----------------------------------------------------------------------------
  !
  ! Model compute arguments create routine (REQUIRED)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine model_compute_arguments_create( &
    model_compute_handle, model_compute_arguments_create_handle, ierr) bind(c)
    use, intrinsic :: iso_c_binding
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_create_handle_type), intent(inout) :: &
      model_compute_arguments_create_handle
    integer(c_int), intent(out) :: ierr

    integer(c_int) :: ierr2

    ! avoid unsed dummy argument warnings
    if (model_compute_handle == KIM_MODEL_COMPUTE_NULL_HANDLE) continue

    ierr = 0
    ierr2 = 0

    ! register arguments
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    call kim_set_argument_support_status( &
      model_compute_arguments_create_handle, &
      KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, &
      KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    ierr = ierr + ierr2
    !  call kim_set_argument_support_status( &
    !    model_compute_arguments_create_handle, &
    !    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_VIRIAL, &
    !    KIM_SUPPORT_STATUS_OPTIONAL, ierr2)
    !  ierr = ierr + ierr2

    ! register call backs
    ! NONE

    if (ierr /= 0) then
      ierr = 1
      call kim_log_entry( &
        model_compute_arguments_create_handle, &
        KIM_LOG_VERBOSITY_ERROR, &
        "Unable to successfully create compute_arguments object")
    end if

    return
  end subroutine model_compute_arguments_create

  !-----------------------------------------------------------------------------
  !
  ! Model compute arguments destroy routine (REQUIRED)
  !
  !-----------------------------------------------------------------------------
  recursive subroutine model_compute_arguments_destroy( &
    model_compute_handle, model_compute_arguments_destroy_handle, ierr) bind(c)
    use, intrinsic :: iso_c_binding
    implicit none

    !-- Transferred variables
    type(kim_model_compute_handle_type), intent(in) :: model_compute_handle
    type(kim_model_compute_arguments_destroy_handle_type), intent(inout) :: &
      model_compute_arguments_destroy_handle
    integer(c_int), intent(out) :: ierr

    ! avoid unsed dummy argument warnings
    if (model_compute_handle == KIM_MODEL_COMPUTE_NULL_HANDLE) continue
    if (model_compute_arguments_destroy_handle == &
        KIM_MODEL_COMPUTE_ARGUMENTS_DESTROY_NULL_HANDLE) continue

    ierr = 0
    return
  end subroutine model_compute_arguments_destroy

end module ex_model_Ar_SLJ_MultiCutoff

!-------------------------------------------------------------------------------
!
! Model create routine (REQUIRED)
!
!-------------------------------------------------------------------------------
recursive subroutine model_create_routine( &
  model_create_handle, requested_length_unit, requested_energy_unit, &
  requested_charge_unit, requested_temperature_unit, requested_time_unit, &
  ierr) bind(c)
  use, intrinsic :: iso_c_binding
  use ex_model_Ar_SLJ_MultiCutoff
  use kim_model_headers_module
  implicit none

  !-- Transferred variables
  type(kim_model_create_handle_type), intent(inout) :: model_create_handle
  type(kim_length_unit_type), intent(in), value :: requested_length_unit
  type(kim_energy_unit_type), intent(in), value :: requested_energy_unit
  type(kim_charge_unit_type), intent(in), value :: requested_charge_unit
  type(kim_temperature_unit_type), intent(in), value :: &
    requested_temperature_unit
  type(kim_time_unit_type), intent(in), value :: requested_time_unit
  integer(c_int), intent(out) :: ierr

  !-- KIM variables
  integer(c_int) :: ierr2
  type(buffer_type), pointer :: buf

  ierr = 0
  ierr2 = 0

  ! avoid unsed dummy argument warnings
  if (requested_length_unit == KIM_LENGTH_UNIT_UNUSED) continue
  if (requested_energy_unit == KIM_ENERGY_UNIT_UNUSED) continue
  if (requested_charge_unit == KIM_CHARGE_UNIT_UNUSED) continue
  if (requested_temperature_unit == KIM_TEMPERATURE_UNIT_UNUSED) continue
  if (requested_time_unit == KIM_TIME_UNIT_UNUSED) continue

  ! set units
  call kim_set_units(model_create_handle, &
                     KIM_LENGTH_UNIT_A, &
                     KIM_ENERGY_UNIT_EV, &
                     KIM_CHARGE_UNIT_UNUSED, &
                     KIM_TEMPERATURE_UNIT_UNUSED, &
                     KIM_TIME_UNIT_UNUSED, &
                     ierr2)
  ierr = ierr + ierr2

  ! register species
  call kim_set_species_code(model_create_handle, &
                            KIM_SPECIES_NAME_AR, speccode, ierr2)
  ierr = ierr + ierr2

  ! register numbering
  call kim_set_model_numbering(model_create_handle, &
                               KIM_NUMBERING_ONE_BASED, ierr2)
  ierr = ierr + ierr2

  ! register function pointers
  call kim_set_routine_pointer( &
    model_create_handle, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE, KIM_LANGUAGE_NAME_FORTRAN, &
    1, c_funloc(Compute_Energy_Forces), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_create_handle, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE, &
    KIM_LANGUAGE_NAME_FORTRAN, &
    1, c_funloc(model_compute_arguments_create), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_create_handle, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY, &
    KIM_LANGUAGE_NAME_FORTRAN, &
    1, c_funloc(model_compute_arguments_destroy), ierr2)
  ierr = ierr + ierr2
  call kim_set_routine_pointer( &
    model_create_handle, &
    KIM_MODEL_ROUTINE_NAME_DESTROY, KIM_LANGUAGE_NAME_FORTRAN, 1, &
    c_funloc(model_destroy_func), ierr2)
  ierr = ierr + ierr2

  ! allocate buffer
  allocate (buf)

  ! store model buffer in KIM object
  call kim_set_model_buffer_pointer(model_create_handle, &
                                    c_loc(buf))

  ! set buffer values
  buf%influence_distance = model_cutoff1 + model_cutoff2
  buf%cutoff(1) = model_cutoff1
  buf%cutoff(2) = model_cutoff2
  buf%model_will_not_request_neighbors_of_noncontributing_particles(1) = 0
  buf%model_will_not_request_neighbors_of_noncontributing_particles(2) = 1

  ! register influence distance
  call kim_set_influence_distance_pointer( &
    model_create_handle, buf%influence_distance)

  ! register cutoff
  call kim_set_neighbor_list_pointers( &
    model_create_handle, 2, buf%cutoff, &
    buf%model_will_not_request_neighbors_of_noncontributing_particles)

  if (ierr /= 0) then
    ierr = 1
    deallocate (buf)
    call kim_log_entry( &
      model_create_handle, KIM_LOG_VERBOSITY_ERROR, &
      "Unable to successfully initialize model")
  end if

  return

end subroutine model_create_routine

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::LogVerbosity
!!
!! \sa KIM::LogVerbosity, KIM_LogVerbosity
!!
!! \since 2.0
module kim_log_verbosity_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_log_verbosity_type, &
    ! Constants
    KIM_LOG_VERBOSITY_SILENT, &
    KIM_LOG_VERBOSITY_FATAL, &
    KIM_LOG_VERBOSITY_ERROR, &
    KIM_LOG_VERBOSITY_WARNING, &
    KIM_LOG_VERBOSITY_INFORMATION, &
    KIM_LOG_VERBOSITY_DEBUG, &
    ! Routines
    kim_known, &
    operator(.lt.), &
    operator(.gt.), &
    operator(.le.), &
    operator(.ge.), &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_log_verbosities, &
    kim_get_log_verbosity

  !> \brief \copybrief KIM::LogVerbosity
  !!
  !! \sa KIM::LogVerbosity, KIM_LogVerbosity
  !!
  !! \since 2.0
  type, bind(c) :: kim_log_verbosity_type
    !> \brief \copybrief KIM::LogVerbosity::logVerbosityID
    !!
    !! \sa KIM::LogVerbosity::logVerbosityID, KIM_LogVerbosity::logVerbosityID
    !!
    !! \since 2.0
    integer(c_int) :: log_verbosity_id
  end type kim_log_verbosity_type

  !> \brief \copybrief KIM::LOG_VERBOSITY::silent
  !!
  !! \sa KIM::LOG_VERBOSITY::silent, KIM_LOG_VERBOSITY_silent
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_silent") &
    :: KIM_LOG_VERBOSITY_SILENT

  !> \brief \copybrief KIM::LOG_VERBOSITY::fatal
  !!
  !! \sa KIM::LOG_VERBOSITY::fatal, KIM_LOG_VERBOSITY_fatal
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_fatal") &
    :: KIM_LOG_VERBOSITY_FATAL

  !> \brief \copybrief KIM::LOG_VERBOSITY::error
  !!
  !! \sa KIM::LOG_VERBOSITY::error, KIM_LOG_VERBOSITY_error
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_error") &
    :: KIM_LOG_VERBOSITY_ERROR

  !> \brief \copybrief KIM::LOG_VERBOSITY::warning
  !!
  !! \sa KIM::LOG_VERBOSITY::warning, KIM_LOG_VERBOSITY_warning
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_warning") &
    :: KIM_LOG_VERBOSITY_WARNING

  !> \brief \copybrief KIM::LOG_VERBOSITY::information
  !!
  !! \sa KIM::LOG_VERBOSITY::information, KIM_LOG_VERBOSITY_information
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_information") &
    :: KIM_LOG_VERBOSITY_INFORMATION

  !> \brief \copybrief KIM::LOG_VERBOSITY::debug
  !!
  !! \sa KIM::LOG_VERBOSITY::debug, KIM_LOG_VERBOSITY_debug
  !!
  !! \since 2.0
  type(kim_log_verbosity_type), protected, save, &
    bind(c, name="KIM_LOG_VERBOSITY_debug") &
    :: KIM_LOG_VERBOSITY_DEBUG

  !> \brief \copybrief KIM::LogVerbosity::Known
  !!
  !! \sa KIM::LogVerbosity::Known, KIM_LogVerbosity_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_log_verbosity_known
  end interface kim_known

  !> \brief \copybrief KIM::LogVerbosity::operator<()
  !!
  !! \sa KIM::LogVerbosity::operator<(), KIM_LogVerbosity_LessThan
  !!
  !! \since 2.0
  interface operator(.lt.)
    module procedure kim_log_verbosity_less_than
  end interface operator(.lt.)

  !> \brief \copybrief KIM::LogVerbosity::operator>()
  !!
  !! \sa KIM::LogVerbosity::operator>(), KIM_LogVerbosity_GreaterThan
  !!
  !! \since 2.0
  interface operator(.gt.)
    module procedure kim_log_verbosity_greater_than
  end interface operator(.gt.)

  !> \brief \copybrief KIM::LogVerbosity::operator<=()
  !!
  !! \sa KIM::LogVerbosity::operator<=(), KIM_LogVerbosity_LessThanEqual
  !!
  !! \since 2.0
  interface operator(.le.)
    module procedure kim_log_verbosity_less_than_equal
  end interface operator(.le.)

  !> \brief \copybrief KIM::LogVerbosity::operator>=()
  !!
  !! \sa KIM::LogVerbosity::operator>=(), KIM_LogVerbosity_GreaterThanEqual
  !!
  !! \since 2.0
  interface operator(.ge.)
    module procedure kim_log_verbosity_greater_than_equal
  end interface operator(.ge.)

  !> \brief \copybrief KIM::LogVerbosity::operator==()
  !!
  !! \sa KIM::LogVerbosity::operator==(), KIM_LogVerbosity_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_log_verbosity_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::LogVerbosity::operator!=()
  !!
  !! \sa KIM::LogVerbosity::operator!=(), KIM_LogVerbosity_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_log_verbosity_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::LogVerbosity::LogVerbosity(std::string const &)
  !!
  !! \sa KIM::LogVerbosity::LogVerbosity(std::string const &),
  !! KIM_LogVerbosity_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_log_verbosity_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::LogVerbosity::ToString
  !!
  !! \sa KIM::LogVerbosity::ToString, KIM_LogVerbosity_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_log_verbosity_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::LogVerbosity::Known
  !!
  !! \sa KIM::LogVerbosity::Known, KIM_LogVerbosity_Known
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_known(log_verbosity)
    implicit none
    interface
      integer(c_int) recursive function known(log_verbosity) &
        bind(c, name="KIM_LogVerbosity_Known")
        use, intrinsic :: iso_c_binding
        import kim_log_verbosity_type
        implicit none
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end function known
    end interface
    type(kim_log_verbosity_type), intent(in) :: log_verbosity

    kim_log_verbosity_known = (known(log_verbosity) /= 0)
  end function kim_log_verbosity_known

  !> \brief \copybrief KIM::LogVerbosity::operator<()
  !!
  !! \sa KIM::LogVerbosity::operator<(), KIM_LogVerbosity_LessThan
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_less_than(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_less_than &
      = (lhs%log_verbosity_id < rhs%log_verbosity_id)
  end function kim_log_verbosity_less_than

  !> \brief \copybrief KIM::LogVerbosity::operator>()
  !!
  !! \sa KIM::LogVerbosity::operator>(), KIM_LogVerbosity_GreaterThan
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_greater_than(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_greater_than &
      = (lhs%log_verbosity_id >= rhs%log_verbosity_id)
  end function kim_log_verbosity_greater_than

  !> \brief \copybrief KIM::LogVerbosity::operator<=()
  !!
  !! \sa KIM::LogVerbosity::operator<=(), KIM_LogVerbosity_LessThanEqual
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_less_than_equal(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_less_than_equal &
      = (lhs%log_verbosity_id <= rhs%log_verbosity_id)
  end function kim_log_verbosity_less_than_equal

  !> \brief \copybrief KIM::LogVerbosity::operator>=()
  !!
  !! \sa KIM::LogVerbosity::operator>=(), KIM_LogVerbosity_GreaterThanEqual
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_greater_than_equal(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_greater_than_equal &
      = (lhs%log_verbosity_id >= rhs%log_verbosity_id)
  end function kim_log_verbosity_greater_than_equal

  !> \brief \copybrief KIM::LogVerbosity::operator==()
  !!
  !! \sa KIM::LogVerbosity::operator==(), KIM_LogVerbosity_Equal
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_equal(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_equal &
      = (lhs%log_verbosity_id == rhs%log_verbosity_id)
  end function kim_log_verbosity_equal

  !> \brief \copybrief KIM::LogVerbosity::operator!=()
  !!
  !! \sa KIM::LogVerbosity::operator!=(), KIM_LogVerbosity_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_log_verbosity_not_equal(lhs, rhs)
    implicit none
    type(kim_log_verbosity_type), intent(in) :: lhs
    type(kim_log_verbosity_type), intent(in) :: rhs

    kim_log_verbosity_not_equal = .not. (lhs == rhs)
  end function kim_log_verbosity_not_equal

  !> \brief \copybrief KIM::LogVerbosity::LogVerbosity(std::string const &)
  !!
  !! \sa KIM::LogVerbosity::LogVerbosity(std::string const &),
  !! KIM_LogVerbosity_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_log_verbosity_from_string(string, log_verbosity)
    implicit none
    interface
      type(kim_log_verbosity_type) recursive function from_string(string) &
        bind(c, name="KIM_LogVerbosity_FromString")
        use, intrinsic :: iso_c_binding
        import kim_log_verbosity_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_log_verbosity_type), intent(out) :: log_verbosity

    log_verbosity = from_string(trim(string)//c_null_char)
  end subroutine kim_log_verbosity_from_string

  !> \brief \copybrief KIM::LogVerbosity::ToString
  !!
  !! \sa KIM::LogVerbosity::ToString, KIM_LogVerbosity_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_log_verbosity_to_string(log_verbosity, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(log_verbosity) &
        bind(c, name="KIM_LogVerbosity_ToString")
        use, intrinsic :: iso_c_binding
        import kim_log_verbosity_type
        implicit none
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end function get_string
    end interface
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(log_verbosity)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_log_verbosity_to_string

  !> \brief \copybrief KIM::LOG_VERBOSITY::GetNumberOfLogVerbosities
  !!
  !! \sa KIM::LOG_VERBOSITY::GetNumberOfLogVerbosities,
  !! KIM_LOG_VERBOSITY_GetNumberOfLogVerbosities
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_log_verbosities( &
    number_of_log_verbosities)
    implicit none
    interface
      recursive subroutine get_number_of_log_verbosities( &
        number_of_log_verbosities) &
        bind(c, name="KIM_LOG_VERBOSITY_GetNumberOfLogVerbosities")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_log_verbosities
      end subroutine get_number_of_log_verbosities
    end interface
    integer(c_int), intent(out) :: number_of_log_verbosities

    call get_number_of_log_verbosities(number_of_log_verbosities)
  end subroutine kim_get_number_of_log_verbosities

  !> \brief \copybrief KIM::LOG_VERBOSITY::GetLogVerbosity
  !!
  !! \sa KIM::LOG_VERBOSITY::GetLogVerbosity, KIM_LOG_VERBOSITY_GetLogVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_get_log_verbosity(index, log_verbosity, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_log_verbosity( &
        index, log_verbosity) bind(c, name="KIM_LOG_VERBOSITY_GetLogVerbosity")
        use, intrinsic :: iso_c_binding
        import kim_log_verbosity_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_log_verbosity_type), intent(out) :: log_verbosity
      end function get_log_verbosity
    end interface
    integer(c_int), intent(in) :: index
    type(kim_log_verbosity_type), intent(out) :: log_verbosity
    integer(c_int), intent(out) :: ierr

    ierr = get_log_verbosity(index - 1, log_verbosity)
  end subroutine kim_get_log_verbosity
end module kim_log_verbosity_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::SEM_VER
!!
!! \sa KIM::SEM_VER
!!
!! \since 2.0
module kim_sem_ver_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Routines
    kim_get_sem_ver, &
    kim_is_less_than, &
    kim_parse_sem_ver

contains
  !> \brief \copybrief KIM::SEM_VER::GetSemVer
  !!
  !! \sa KIM::SEM_VER::GetSemVer, KIM_SEM_VER_GetSemVer
  !!
  !! \since 2.0
  recursive subroutine kim_get_sem_ver(version)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_sem_ver() &
        bind(c, name="KIM_SEM_VER_GetSemVer")
        use, intrinsic :: iso_c_binding
        implicit none
      end function get_sem_ver
    end interface
    character(len=*, kind=c_char), intent(out) :: version

    type(c_ptr) :: p

    p = get_sem_ver()
    call kim_convert_c_char_ptr_to_string(p, version)
  end subroutine kim_get_sem_ver

  !> \brief \copybrief KIM::SEM_VER::IsLessThan
  !!
  !! \sa KIM::SEM_VER::IsLessThan, KIM_SEM_VER_IsLessThan
  !!
  !! \since 2.0
  recursive subroutine kim_is_less_than(lhs, rhs, is_less_than, ierr)
    implicit none
    interface
      integer(c_int) recursive function is_less_than_func(lhs, rhs, &
                                                          is_less_than) &
        bind(c, name="KIM_SEM_VER_IsLessThan")
        use, intrinsic :: iso_c_binding
        implicit none
        character(c_char), intent(in) :: lhs(*)
        character(c_char), intent(in) :: rhs(*)
        integer(c_int), intent(out) :: is_less_than
      end function is_less_than_func
    end interface
    character(len=*, kind=c_char), intent(in) :: lhs
    character(len=*, kind=c_char), intent(in) :: rhs
    integer(c_int), intent(out) :: is_less_than
    integer(c_int), intent(out) :: ierr

    ierr = is_less_than_func(trim(lhs)//c_null_char, trim(rhs)//c_null_char, &
                             is_less_than)
  end subroutine kim_is_less_than

  !> \brief \copybrief KIM::SEM_VER::ParseSemVer
  !!
  !! \sa KIM::SEM_VER::ParseSemVer, KIM_SEM_VER_ParseSemVer
  !!
  !! \since 2.0
  recursive subroutine kim_parse_sem_ver(version, major, minor, patch, &
                                         prerelease, build_metadata, ierr)
    use kim_convert_string_module, only: kim_convert_c_char_array_to_string
    implicit none
    interface
      integer(c_int) recursive function parse_sem_ver( &
        version, prerelease_length, build_metadata_length, major, minor, &
        patch, prerelease, build_metadata) &
        bind(c, name="KIM_SEM_VER_ParseSemVer")
        use, intrinsic :: iso_c_binding
        implicit none
        character(c_char), intent(in) :: version(*)
        integer(c_int), intent(in), value :: prerelease_length
        integer(c_int), intent(in), value :: build_metadata_length
        integer(c_int), intent(out) :: major
        integer(c_int), intent(out) :: minor
        integer(c_int), intent(out) :: patch
        type(c_ptr), intent(in), value :: prerelease
        type(c_ptr), intent(in), value :: build_metadata
      end function parse_sem_ver
    end interface
    character(len=*, kind=c_char), intent(in) :: version
    integer(c_int), intent(out) :: major
    integer(c_int), intent(out) :: minor
    integer(c_int), intent(out) :: patch
    character(len=*, kind=c_char), intent(out) :: prerelease
    character(len=*, kind=c_char), intent(out) :: build_metadata
    integer(c_int), intent(out) :: ierr

    character(len=1, kind=c_char), target :: prerelease_local(len(prerelease))
    character(len=1, kind=c_char), target :: &
      build_metadata_local(len(build_metadata))

    ierr = parse_sem_ver(trim(version)//c_null_char, len(prerelease), &
                         len(build_metadata), major, minor, patch, &
                         c_loc(prerelease_local), c_loc(build_metadata_local))
    call kim_convert_c_char_array_to_string(prerelease_local, prerelease)
    call kim_convert_c_char_array_to_string(build_metadata_local, &
                                            build_metadata)
  end subroutine kim_parse_sem_ver
end module kim_sem_ver_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ModelRoutineName
!!
!! \sa KIM::ModelRoutineName, KIM_ModelRoutineName
!!
!! \since 2.0
module kim_model_routine_name_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_model_routine_name_type, &

    ! Constants
    KIM_MODEL_ROUTINE_NAME_CREATE, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE, &
    KIM_MODEL_ROUTINE_NAME_EXTENSION, &
    KIM_MODEL_ROUTINE_NAME_REFRESH, &
    KIM_MODEL_ROUTINE_NAME_WRITE_PARAMETERIZED_MODEL, &
    KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY, &
    KIM_MODEL_ROUTINE_NAME_DESTROY, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_model_routine_names, &
    kim_get_model_routine_name


  !> \brief \copybrief KIM::ModelRoutineName
  !!
  !! \sa KIM::ModelRoutineName, KIM_ModelRoutineName
  !!
  !! \since 2.0
  type, bind(c) :: kim_model_routine_name_type
     !> \brief \copybrief KIM::ModelRoutineName::modelRoutineNameID
     !!
     !! \sa KIM::ModelRoutineName::modelRoutineNameID,
     !! KIM_ModelRoutineName::modelRoutineNameID
     !!
     !! \since 2.0
    integer(c_int) model_routine_name_id
  end type kim_model_routine_name_type

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::Create
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::Create, KIM_MODEL_ROUTINE_NAME_Create
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_Create") &
    :: KIM_MODEL_ROUTINE_NAME_CREATE

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::ComputeArgumentsCreate
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::ComputeArgumentsCreate,
  !! KIM_MODEL_ROUTINE_NAME_ComputeArgumentsCreate
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_ComputeArgumentsCreate") &
    :: KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_CREATE

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::Compute
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::Compute, KIM_MODEL_ROUTINE_NAME_Compute
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_Compute") &
    :: KIM_MODEL_ROUTINE_NAME_COMPUTE

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::Extension
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::Extension, KIM_MODEL_ROUTINE_NAME_Extension
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_Extension") &
    :: KIM_MODEL_ROUTINE_NAME_EXTENSION

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::Refresh
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::Refresh, KIM_MODEL_ROUTINE_NAME_Refresh
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_Refresh") &
    :: KIM_MODEL_ROUTINE_NAME_REFRESH

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::WriteParameterizedModel
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::WriteParameterizedModel,
  !! KIM_MODEL_ROUTINE_NAME_WriteParameterizedModel
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_WriteParameterizedModel") &
    :: KIM_MODEL_ROUTINE_NAME_WRITE_PARAMETERIZED_MODEL

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::ComputeArgumentsDestroy
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::ComputeArgumentsDestroy,
  !! KIM_MODEL_ROUTINE_NAME_ComputeArgumentsDestroy
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_ComputeArgumentsDestroy") &
    :: KIM_MODEL_ROUTINE_NAME_COMPUTE_ARGUMENTS_DESTROY

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::Destroy
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::Destroy, KIM_MODEL_ROUTINE_NAME_Destroy
  !!
  !! \since 2.0
  type(kim_model_routine_name_type), protected, save, &
    bind(c, name="KIM_MODEL_ROUTINE_NAME_Destroy") &
    :: KIM_MODEL_ROUTINE_NAME_DESTROY

  !> \brief \copybrief KIM::ModelRoutineName::Known
  !!
  !! \sa KIM::ModelRoutineName::Known, KIM_ModelRoutineName_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_model_routine_name_known
  end interface kim_known

  !> \brief \copybrief KIM::ModelRoutineName::operator==()
  !!
  !! \sa KIM::ModelRoutineName::operator==(), KIM_ModelRoutineName_Equal
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_model_routine_name_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::ModelRoutineName::operator!=()
  !!
  !! \sa KIM::ModelRoutineName::operator!=(), KIM_ModelRoutineName_NotEqual
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_model_routine_name_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ModelRoutineName::<!--
  !! -->ModelRoutineName(std::string const &)
  !!
  !! \sa KIM::ModelRoutineName::ModelRoutineName(std::string const &),
  !! KIM_ModelRoutineName_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_model_routine_name_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::ModelRoutineName::ToString
  !!
  !! \sa KIM::ModelRoutineName::ToString, KIM_ModelRoutineName_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_model_routine_name_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::ModelRoutineName::Known
  !!
  !! \sa KIM::ModelRoutineName::Known, KIM_ModelRoutineName_Known
  !!
  !! \since 2.0
  logical recursive function kim_model_routine_name_known(model_routine_name)
    implicit none
    interface
      integer(c_int) recursive function known(model_routine_name) &
        bind(c, name="KIM_ModelRoutineName_Known")
        use, intrinsic :: iso_c_binding
        import kim_model_routine_name_type
        implicit none
        type(kim_model_routine_name_type), intent(in), value :: &
          model_routine_name
      end function known
    end interface
    type(kim_model_routine_name_type), intent(in) :: model_routine_name

    kim_model_routine_name_known = (known(model_routine_name) /= 0)
  end function kim_model_routine_name_known

  !> \brief \copybrief KIM::ModelRoutineName::operator==()
  !!
  !! \sa KIM::ModelRoutineName::operator==(), KIM_ModelRoutineName_Equal
  !!
  !! \since 2.0
  logical recursive function kim_model_routine_name_equal(lhs, rhs)
    implicit none
    type(kim_model_routine_name_type), intent(in) :: lhs
    type(kim_model_routine_name_type), intent(in) :: rhs

    kim_model_routine_name_equal &
      = (lhs%model_routine_name_id .eq. rhs%model_routine_name_id)
  end function kim_model_routine_name_equal

  !> \brief \copybrief KIM::ModelRoutineName::operator!=()
  !!
  !! \sa KIM::ModelRoutineName::operator!=(), KIM_ModelRoutineName_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_model_routine_name_not_equal(lhs, rhs)
    implicit none
    type(kim_model_routine_name_type), intent(in) :: lhs
    type(kim_model_routine_name_type), intent(in) :: rhs

    kim_model_routine_name_not_equal = .not. (lhs .eq. rhs)
  end function kim_model_routine_name_not_equal

  !> \brief \copybrief KIM::ModelRoutineName::<!--
  !! -->ModelRoutineName(std::string const &)
  !!
  !! \sa KIM::ModelRoutineName::ModelRoutineName(std::string const &),
  !! KIM_ModelRoutineName_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_model_routine_name_from_string(string, &
    model_routine_name)
    implicit none
    interface
      type(kim_model_routine_name_type) recursive function from_string(string) &
        bind(c, name="KIM_ModelRoutineName_FromString")
        use, intrinsic :: iso_c_binding
        import kim_model_routine_name_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_model_routine_name_type), intent(out) :: model_routine_name

    model_routine_name = from_string(trim(string)//c_null_char)
  end subroutine kim_model_routine_name_from_string

  !> \brief \copybrief KIM::ModelRoutineName::ToString
  !!
  !! \sa KIM::ModelRoutineName::ToString, KIM_ModelRoutineName_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_model_routine_name_to_string(model_routine_name, &
    string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(model_routine_name) &
        bind(c, name="KIM_ModelRoutineName_ToString")
        use, intrinsic :: iso_c_binding
        import kim_model_routine_name_type
        implicit none
        type(kim_model_routine_name_type), intent(in), value :: &
          model_routine_name
      end function get_string
    end interface
    type(kim_model_routine_name_type), intent(in) :: &
      model_routine_name
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(model_routine_name)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_model_routine_name_to_string

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::GetNumberOfModelRoutineNames
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::GetNumberOfModelRoutineNames,
  !! KIM_MODEL_ROUTINE_NAME_GetNumberOfModelRoutineNames
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_model_routine_names( &
    number_of_model_routine_names)
    implicit none
    interface
      recursive subroutine get_number_of_model_routine_names( &
        number_of_model_routine_names) &
        bind(c, &
        name="KIM_MODEL_ROUTINE_NAME_GetNumberOfModelRoutineNames")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_model_routine_names
      end subroutine get_number_of_model_routine_names
    end interface
    integer(c_int), intent(out) :: number_of_model_routine_names

    call get_number_of_model_routine_names(number_of_model_routine_names)
  end subroutine kim_get_number_of_model_routine_names

  !> \brief \copybrief KIM::MODEL_ROUTINE_NAME::GetModelRoutineName
  !!
  !! \sa KIM::MODEL_ROUTINE_NAME::GetModelRoutineName,
  !! KIM_MODEL_ROUTINE_NAME_GetModelRoutineName
  !!
  !! \since 2.0
  recursive subroutine kim_get_model_routine_name(index, &
    model_routine_name, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_model_routine_name(index, &
        model_routine_name) &
        bind(c, name="KIM_MODEL_ROUTINE_NAME_GetModelRoutineName")
        use, intrinsic :: iso_c_binding
        import kim_model_routine_name_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_model_routine_name_type), intent(out) :: &
          model_routine_name
      end function get_model_routine_name
    end interface
    integer(c_int), intent(in) :: index
    type(kim_model_routine_name_type), intent(out) :: model_routine_name
    integer(c_int), intent(out) :: ierr

    ierr = get_model_routine_name(index-1, model_routine_name)
  end subroutine kim_get_model_routine_name
end module kim_model_routine_name_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ComputeArgumentName
!!
!! \sa KIM::ComputeArgumentName, KIM_ComputeArgumentName
!!
!! \since 2.0
module kim_compute_argument_name_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_compute_argument_name_type, &

    ! Constants
    KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING, &
    KIM_COMPUTE_ARGUMENT_NAME_COORDINATES, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_VIRIAL, &
    KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_VIRIAL, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_compute_argument_names, &
    kim_get_compute_argument_name, &
    kim_get_compute_argument_data_type


  !> \brief \copybrief KIM::ComputeArgumentName
  !!
  !! \sa KIM::ComputeArgumentName, KIM_ComputeArgumentName
  !!
  !! \since 2.0
  type, bind(c) :: kim_compute_argument_name_type
     !> \brief \copybrief KIM::ComputeArgumentName::computeArgumentNameID
     !!
     !! \sa KIM::ComputeArgumentName::computeArgumentNameID,
     !! KIM_ComputeArgumentName::computeArgumentNameID
     !!
     !! \since 2.0
    integer(c_int) compute_argument_name_id
  end type kim_compute_argument_name_type

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::numberOfParticles
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::numberOfParticles,
  !! KIM_COMPUTE_ARGUMENT_NAME_numberOfParticles
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_numberOfParticles") &
    :: KIM_COMPUTE_ARGUMENT_NAME_NUMBER_OF_PARTICLES

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::particleSpeciesCodes
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::particleSpeciesCodes,
  !! KIM_COMPUTE_ARGUMENT_NAME_particleSpeciesCodes
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_particleSpeciesCodes") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_SPECIES_CODES

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::particleContributing
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::particleContributing,
  !! KIM_COMPUTE_ARGUMENT_NAME_particleContributing
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_particleContributing") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTICLE_CONTRIBUTING

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::coordinates
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::coordinates,
  !! KIM_COMPUTE_ARGUMENT_NAME_coordinates
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_coordinates") &
    :: KIM_COMPUTE_ARGUMENT_NAME_COORDINATES

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::partialEnergy
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::partialEnergy,
  !! KIM_COMPUTE_ARGUMENT_NAME_partialEnergy
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_partialEnergy") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_ENERGY

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::partialForces
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::partialForces,
  !! KIM_COMPUTE_ARGUMENT_NAME_partialForces
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_partialForces") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_FORCES

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::partialParticleEnergy
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::partialParticleEnergy,
  !! KIM_COMPUTE_ARGUMENT_NAME_partialParticleEnergy
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_partialParticleEnergy") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_ENERGY

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::partialVirial
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::partialVirial,
  !! KIM_COMPUTE_ARGUMENT_NAME_partialVirial
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_partialVirial") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_VIRIAL

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::partialParticleVirial
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::partialParticleVirial,
  !! KIM_COMPUTE_ARGUMENT_NAME_partialParticleVirial
  !!
  !! \since 2.0
  type(kim_compute_argument_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_partialParticleVirial") &
    :: KIM_COMPUTE_ARGUMENT_NAME_PARTIAL_PARTICLE_VIRIAL

  !> \brief \copybrief KIM::ComputeArgumentName::Known
  !!
  !! \sa KIM::ComputeArgumentName::Known, KIM_ComputeArgumentName_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_compute_argument_name_known
  end interface kim_known

  !> \brief \copybrief KIM::ComputeArgumentName::operator==()
  !!
  !! \sa KIM::ComputeArgumentName::operator==(), KIM_ComputeArgumentName_Equal
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_compute_argument_name_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::ComputeArgumentName::operator!=()
  !!
  !! \sa KIM::ComputeArgumentName::operator!=(),
  !! KIM_ComputeArgumentName_NotEqual
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_compute_argument_name_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ComputeArgumentName::<!--
  !! -->ComputeArgumentName(std::string const &)
  !!
  !! \sa KIM::ComputeArgumentName::ComputeArgumentName(std::string const &),
  !! KIM_ComputeArgumentName_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_compute_argument_name_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::ComputeArgumentName::ToString
  !!
  !! \sa KIM::ComputeArgumentName::ToString, KIM_ComputeArgumentName_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_compute_argument_name_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::ComputeArgumentName::Known
  !!
  !! \sa KIM::ComputeArgumentName::Known, KIM_ComputeArgumentName_Known
  !!
  !! \since 2.0
  logical recursive function kim_compute_argument_name_known( &
    compute_argument_name)
    implicit none
    interface
      integer(c_int) recursive function known(compute_argument_name) &
        bind(c, name="KIM_ComputeArgumentName_Known")
        use, intrinsic :: iso_c_binding
        import kim_compute_argument_name_type
        implicit none
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
      end function known
    end interface
    type(kim_compute_argument_name_type), intent(in) :: compute_argument_name

    kim_compute_argument_name_known = (known(compute_argument_name) /= 0)
  end function kim_compute_argument_name_known

  !> \brief \copybrief KIM::ComputeArgumentName::operator==()
  !!
  !! \sa KIM::ComputeArgumentName::operator==(), KIM_ComputeArgumentName_Equal
  !!
  !! \since 2.0
  logical recursive function kim_compute_argument_name_equal(lhs, rhs)
    implicit none
    type(kim_compute_argument_name_type), intent(in) :: lhs
    type(kim_compute_argument_name_type), intent(in) :: rhs

    kim_compute_argument_name_equal &
      = (lhs%compute_argument_name_id .eq. rhs%compute_argument_name_id)
  end function kim_compute_argument_name_equal

  !> \brief \copybrief KIM::ComputeArgumentName::operator!=()
  !!
  !! \sa KIM::ComputeArgumentName::operator!=(),
  !! KIM_ComputeArgumentName_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_compute_argument_name_not_equal(lhs, rhs)
    implicit none
    type(kim_compute_argument_name_type), intent(in) :: lhs
    type(kim_compute_argument_name_type), intent(in) :: rhs

    kim_compute_argument_name_not_equal = .not. (lhs .eq. rhs)
  end function kim_compute_argument_name_not_equal

  !> \brief \copybrief KIM::ComputeArgumentName::<!--
  !! -->ComputeArgumentName(std::string const &)
  !!
  !! \sa KIM::ComputeArgumentName::ComputeArgumentName(std::string const &),
  !! KIM_ComputeArgumentName_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_compute_argument_name_from_string(string, &
    compute_argument_name)
    implicit none
    interface
      type(kim_compute_argument_name_type) recursive function from_string( &
        string) bind(c, name="KIM_ComputeArgumentName_FromString")
        use, intrinsic :: iso_c_binding
        import kim_compute_argument_name_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_compute_argument_name_type), intent(out) :: compute_argument_name

    compute_argument_name = from_string(trim(string)//c_null_char)
  end subroutine kim_compute_argument_name_from_string

  !> \brief \copybrief KIM::ComputeArgumentName::ToString
  !!
  !! \sa KIM::ComputeArgumentName::ToString, KIM_ComputeArgumentName_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_compute_argument_name_to_string( &
    compute_argument_name, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(compute_argument_name) &
        bind(c, name="KIM_ComputeArgumentName_ToString")
        use, intrinsic :: iso_c_binding
        import kim_compute_argument_name_type
        implicit none
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
      end function get_string
    end interface
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(compute_argument_name)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_compute_argument_name_to_string

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::<!--
  !! -->GetNumberOfComputeArgumentNames
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::GetNumberOfComputeArgumentNames,
  !! KIM_COMPUTE_ARGUMENT_NAME_GetNumberOfComputeArgumentNames
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_compute_argument_names( &
    number_of_compute_argument_names)
    implicit none
    interface
      recursive subroutine get_number_of_compute_argument_names( &
        number_of_compute_argument_names) &
        bind(c, &
        name="KIM_COMPUTE_ARGUMENT_NAME_GetNumberOfComputeArgumentNames")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_compute_argument_names
      end subroutine get_number_of_compute_argument_names
    end interface
    integer(c_int), intent(out) :: number_of_compute_argument_names

    call get_number_of_compute_argument_names(number_of_compute_argument_names)
  end subroutine kim_get_number_of_compute_argument_names


  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::<!--
  !! -->GetComputeArgumentName
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::GetComputeArgumentName,
  !! KIM_COMPUTE_ARGUMENT_NAME_GetComputeArgumentName
  !!
  !! \since 2.0
  recursive subroutine kim_get_compute_argument_name(index, &
    compute_argument_name, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_compute_argument_name(index, &
        compute_argument_name) &
        bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_GetComputeArgumentName")
        use, intrinsic :: iso_c_binding
        import kim_compute_argument_name_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_compute_argument_name_type), intent(out) :: &
          compute_argument_name
      end function get_compute_argument_name
    end interface
    integer(c_int), intent(in) :: index
    type(kim_compute_argument_name_type), intent(out) :: compute_argument_name
    integer(c_int), intent(out) :: ierr

    ierr = get_compute_argument_name(index-1, compute_argument_name)
  end subroutine kim_get_compute_argument_name

  !> \brief \copybrief KIM::COMPUTE_ARGUMENT_NAME::<!--
  !! -->GetComputeArgumentDataType
  !!
  !! \sa KIM::COMPUTE_ARGUMENT_NAME::GetComputeArgumentDataType,
  !! KIM_COMPUTE_ARGUMENT_NAME_GetComputeArgumentDataType
  !!
  !! \since 2.0
  recursive subroutine kim_get_compute_argument_data_type( &
    compute_argument_name, &
    data_type, ierr)
    use kim_data_type_module, only : kim_data_type_type
    implicit none
    interface
      integer(c_int) recursive function get_compute_argument_data_type( &
        compute_argument_name, data_type) &
        bind(c, name="KIM_COMPUTE_ARGUMENT_NAME_GetComputeArgumentDataType")
        use, intrinsic :: iso_c_binding
        use kim_data_type_module, only : kim_data_type_type
        import kim_compute_argument_name_type
        implicit none
        type(kim_compute_argument_name_type), intent(in), value :: &
          compute_argument_name
        type(kim_data_type_type), intent(out) :: data_type
      end function get_compute_argument_data_type
    end interface
    type(kim_compute_argument_name_type), intent(in) :: &
      compute_argument_name
    type(kim_data_type_type), intent(out) :: data_type
    integer(c_int), intent(out) :: ierr

    ierr = get_compute_argument_data_type(compute_argument_name, data_type)
  end subroutine kim_get_compute_argument_data_type
end module kim_compute_argument_name_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::LanguageName
!!
!! \sa KIM::LanguageName, KIM_LanguageName
!!
!! \since 2.0
module kim_language_name_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_language_name_type, &
    ! Constants
    KIM_LANGUAGE_NAME_CPP, &
    KIM_LANGUAGE_NAME_C, &
    KIM_LANGUAGE_NAME_FORTRAN, &
    ! Routines
    kim_known, &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_language_names, &
    kim_get_language_name

  !> \brief \copybrief KIM::LanguageName
  !!
  !! \sa KIM::LanguageName, KIM_LanguageName
  !!
  !! \since 2.0
  type, bind(c) :: kim_language_name_type
    !> \brief \copybrief KIM::LanguageName::languageNameID
    !!
    !! \sa KIM::LanguageName::languageNameID, KIM_LanguageName::languageNameID
    !!
    !! \since 2.0
    integer(c_int) :: language_name_id
  end type kim_language_name_type

  !> \brief \copybrief KIM::LANGUAGE_NAME::cpp
  !!
  !! \sa KIM::LANGUAGE_NAME::cpp, KIM_LANGUAGE_NAME_cpp
  !!
  !! \since 2.0
  type(kim_language_name_type), protected, save, &
    bind(c, name="KIM_LANGUAGE_NAME_cpp") &
    :: KIM_LANGUAGE_NAME_CPP

  !> \brief \copybrief KIM::LANGUAGE_NAME::c
  !!
  !! \sa KIM::LANGUAGE_NAME::c, KIM_LANGUAGE_NAME_c
  !!
  !! \since 2.0
  type(kim_language_name_type), protected, save, &
    bind(c, name="KIM_LANGUAGE_NAME_c") &
    :: KIM_LANGUAGE_NAME_C

  !> \brief \copybrief KIM::LANGUAGE_NAME::fortran
  !!
  !! \sa KIM::LANGUAGE_NAME::fortran, KIM_LANGUAGE_NAME_fortran
  !!
  !! \since 2.0
  type(kim_language_name_type), protected, save, &
    bind(c, name="KIM_LANGUAGE_NAME_fortran") &
    :: KIM_LANGUAGE_NAME_FORTRAN

  !> \brief \copybrief KIM::LanguageName::Known
  !!
  !! \sa KIM::LanguageName::Known, KIM_LanguageName_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_language_name_known
  end interface kim_known

  !> \brief \copybrief KIM::LanguageName::operator==()
  !!
  !! \sa KIM::LanguageName::operator==(), KIM_LanguageName_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_language_name_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::LanguageName::operator!=()
  !!
  !! \sa KIM::LanguageName::operator!=(), KIM_LanguageName_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_language_name_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::LanguageName::LanguageName(std::string const &)
  !!
  !! \sa KIM::LanguageName::LanguageName(std::string const &),
  !! KIM_LanguageName_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_language_name_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::LanguageName::ToString
  !!
  !! \sa KIM::LanguageName::ToString, KIM_LanguageName_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_language_name_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::LanguageName::Known
  !!
  !! \sa KIM::LanguageName::Known, KIM_LanguageName_Known
  !!
  !! \since 2.0
  logical recursive function kim_language_name_known(language_name)
    implicit none
    interface
      integer(c_int) recursive function known(language_name) &
        bind(c, name="KIM_LanguageName_Known")
        use, intrinsic :: iso_c_binding
        import kim_language_name_type
        implicit none
        type(kim_language_name_type), intent(in), value :: language_name
      end function known
    end interface
    type(kim_language_name_type), intent(in) :: language_name

    kim_language_name_known = (known(language_name) /= 0)
  end function kim_language_name_known

  !> \brief \copybrief KIM::LanguageName::operator==()
  !!
  !! \sa KIM::LanguageName::operator==(), KIM_LanguageName_Equal
  !!
  !! \since 2.0
  logical recursive function kim_language_name_equal(lhs, rhs)
    implicit none
    type(kim_language_name_type), intent(in) :: lhs
    type(kim_language_name_type), intent(in) :: rhs

    kim_language_name_equal &
      = (lhs%language_name_id == rhs%language_name_id)
  end function kim_language_name_equal

  !> \brief \copybrief KIM::LanguageName::operator!=()
  !!
  !! \sa KIM::LanguageName::operator!=(), KIM_LanguageName_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_language_name_not_equal(lhs, rhs)
    implicit none
    type(kim_language_name_type), intent(in) :: lhs
    type(kim_language_name_type), intent(in) :: rhs

    kim_language_name_not_equal = .not. (lhs == rhs)
  end function kim_language_name_not_equal

  !> \brief \copybrief KIM::LanguageName::LanguageName(std::string const &)
  !!
  !! \sa KIM::LanguageName::LanguageName(std::string const &),
  !! KIM_LanguageName_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_language_name_from_string(string, language_name)
    implicit none
    interface
      type(kim_language_name_type) recursive function from_string(string) &
        bind(c, name="KIM_LanguageName_FromString")
        use, intrinsic :: iso_c_binding
        import kim_language_name_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_language_name_type), intent(out) :: language_name

    language_name = from_string(trim(string)//c_null_char)
  end subroutine kim_language_name_from_string

  !> \brief \copybrief KIM::LanguageName::ToString
  !!
  !! \sa KIM::LanguageName::ToString, KIM_LanguageName_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_language_name_to_string(language_name, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(language_name) &
        bind(c, name="KIM_LanguageName_ToString")
        use, intrinsic :: iso_c_binding
        import kim_language_name_type
        implicit none
        type(kim_language_name_type), intent(in), value :: language_name
      end function get_string
    end interface
    type(kim_language_name_type), intent(in) :: language_name
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(language_name)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_language_name_to_string

  !> \brief \copybrief KIM::LANGUAGE_NAME::GetNumberOfLanguageNames
  !!
  !! \sa KIM::LANGUAGE_NAME::GetNumberOfLanguageNames,
  !! KIM_LANGUAGE_NAME_GetNumberOfLanguageNames
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_language_names( &
    number_of_language_names)
    implicit none
    interface
      recursive subroutine get_number_of_language_names( &
        number_of_language_names) &
        bind(c, name="KIM_LANGUAGE_NAME_GetNumberOfLanguageNames")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_language_names
      end subroutine get_number_of_language_names
    end interface
    integer(c_int), intent(out) :: number_of_language_names

    call get_number_of_language_names(number_of_language_names)
  end subroutine kim_get_number_of_language_names

  !> \brief \copybrief KIM::LANGUAGE_NAME::GetLanguageName
  !!
  !! \sa KIM::LANGUAGE_NAME::GetLanguageName, KIM_LANGUAGE_NAME_GetLanguageName
  !!
  !! \since 2.0
  recursive subroutine kim_get_language_name(index, language_name, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_language_name(index, &
                                                          language_name) &
        bind(c, name="KIM_LANGUAGE_NAME_GetLanguageName")
        use, intrinsic :: iso_c_binding
        import kim_language_name_type
        integer(c_int), intent(in), value :: index
        type(kim_language_name_type), intent(out) :: language_name
      end function get_language_name
    end interface
    integer(c_int), intent(in) :: index
    type(kim_language_name_type), intent(out) :: language_name
    integer(c_int), intent(out) :: ierr

    ierr = get_language_name(index - 1, language_name)
  end subroutine kim_get_language_name
end module kim_language_name_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

module kim_unit_system_module
  use, intrinsic :: iso_c_binding

  use kim_length_unit_module
  use kim_energy_unit_module
  use kim_charge_unit_module
  use kim_temperature_unit_module
  use kim_time_unit_module

  public
end module kim_unit_system_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::TimeUnit
!!
!! \sa KIM::TimeUnit, KIM_TimeUnit
!!
!! \since 2.0
module kim_time_unit_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_time_unit_type, &

    ! Constants
    KIM_TIME_UNIT_UNUSED, &
    KIM_TIME_UNIT_FS, &
    KIM_TIME_UNIT_PS, &
    KIM_TIME_UNIT_NS, &
    KIM_TIME_UNIT_S, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_time_units, &
    kim_get_time_unit


  !> \brief \copybrief KIM::TimeUnit
  !!
  !! \sa KIM::TimeUnit, KIM_TimeUnit
  !!
  !! \since 2.0
  type, bind(c) :: kim_time_unit_type
    !> \brief \copybrief KIM::TimeUnit::timeUnitID
    !!
    !! \sa KIM::TimeUnit::timeUnitID, KIM_TimeUnit::timeUnitID
    !!
    !! \since 2.0
    integer(c_int) time_unit_id
  end type kim_time_unit_type

  !> \brief \copybrief KIM::TIME_UNIT::unused
  !!
  !! \sa KIM::TIME_UNIT::unused, KIM_TIME_UNIT_unused
  !!
  !! \since 2.0
  type(kim_time_unit_type), protected, save, &
    bind(c, name="KIM_TIME_UNIT_unused") &
    :: KIM_TIME_UNIT_UNUSED

  !> \brief \copybrief KIM::TIME_UNIT::fs
  !!
  !! \sa KIM::TIME_UNIT::fs, KIM_TIME_UNIT_fs
  !!
  !! \since 2.0
  type(kim_time_unit_type), protected, save, &
    bind(c, name="KIM_TIME_UNIT_fs") &
    :: KIM_TIME_UNIT_FS

  !> \brief \copybrief KIM::TIME_UNIT::ps
  !!
  !! \sa KIM::TIME_UNIT::ps, KIM_TIME_UNIT_ps
  !!
  !! \since 2.0
  type(kim_time_unit_type), protected, save, &
    bind(c, name="KIM_TIME_UNIT_ps") &
    :: KIM_TIME_UNIT_PS

  !> \brief \copybrief KIM::TIME_UNIT::ns
  !!
  !! \sa KIM::TIME_UNIT::ns, KIM_TIME_UNIT_ns
  !!
  !! \since 2.0
  type(kim_time_unit_type), protected, save, &
    bind(c, name="KIM_TIME_UNIT_ns") &
    :: KIM_TIME_UNIT_NS

  !> \brief \copybrief KIM::TIME_UNIT::s
  !!
  !! \sa KIM::TIME_UNIT::s, KIM_TIME_UNIT_s
  !!
  !! \since 2.0
  type(kim_time_unit_type), protected, save, &
    bind(c, name="KIM_TIME_UNIT_s") &
    :: KIM_TIME_UNIT_S

  !> \brief \copybrief KIM::TimeUnit::Known
  !!
  !! \sa KIM::TimeUnit::Known, KIM_TimeUnit_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_time_unit_known
  end interface kim_known

  !> \brief \copybrief KIM::TimeUnit::operator==()
  !!
  !! \sa KIM::TimeUnit::operator==(), KIM_TimeUnit_Equal
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_time_unit_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::TimeUnit::operator!=()
  !!
  !! \sa KIM::TimeUnit::operator!=(), KIM_TimeUnit_NotEqual
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_time_unit_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::TimeUnit::TimeUnit(std::string const &)
  !!
  !! \sa KIM::TimeUnit::TimeUnit(std::string const &), KIM_TimeUnit_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_time_unit_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::TimeUnit::ToString
  !!
  !! \sa KIM::TimeUnit::ToString, KIM_TimeUnit_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_time_unit_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::TimeUnit::Known
  !!
  !! \sa KIM::TimeUnit::Known, KIM_TimeUnit_Known
  !!
  !! \since 2.0
  logical recursive function kim_time_unit_known(time_unit)
    implicit none
    interface
      integer(c_int) recursive function known(time_unit) &
        bind(c, name="KIM_TimeUnit_Known")
        use, intrinsic :: iso_c_binding
        import kim_time_unit_type
        implicit none
        type(kim_time_unit_type), intent(in), value :: time_unit
      end function known
    end interface
    type(kim_time_unit_type), intent(in) :: time_unit

    kim_time_unit_known = (known(time_unit) /= 0)
  end function kim_time_unit_known

  !> \brief \copybrief KIM::TimeUnit::operator==()
  !!
  !! \sa KIM::TimeUnit::operator==(), KIM_TimeUnit_Equal
  !!
  !! \since 2.0
  logical recursive function kim_time_unit_equal(lhs, rhs)
    implicit none
    type(kim_time_unit_type), intent(in) :: lhs
    type(kim_time_unit_type), intent(in) :: rhs

    kim_time_unit_equal &
      = (lhs%time_unit_id .eq. rhs%time_unit_id)
  end function kim_time_unit_equal

  !> \brief \copybrief KIM::TimeUnit::operator!=()
  !!
  !! \sa KIM::TimeUnit::operator!=(), KIM_TimeUnit_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_time_unit_not_equal(lhs, rhs)
    implicit none
    type(kim_time_unit_type), intent(in) :: lhs
    type(kim_time_unit_type), intent(in) :: rhs

    kim_time_unit_not_equal = .not. (lhs .eq. rhs)
  end function kim_time_unit_not_equal

  !> \brief \copybrief KIM::TimeUnit::TimeUnit(std::string const &)
  !!
  !! \sa KIM::TimeUnit::TimeUnit(std::string const &), KIM_TimeUnit_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_time_unit_from_string(string, time_unit)
    implicit none
    interface
      type(kim_time_unit_type) recursive function from_string(string) &
        bind(c, name="KIM_TimeUnit_FromString")
        use, intrinsic :: iso_c_binding
        import kim_time_unit_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_time_unit_type), intent(out) :: time_unit

    time_unit = from_string(trim(string)//c_null_char)
  end subroutine kim_time_unit_from_string

  !> \brief \copybrief KIM::TimeUnit::ToString
  !!
  !! \sa KIM::TimeUnit::ToString, KIM_TimeUnit_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_time_unit_to_string(time_unit, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(time_unit) &
        bind(c, name="KIM_TimeUnit_ToString")
        use, intrinsic :: iso_c_binding
        import kim_time_unit_type
        implicit none
        type(kim_time_unit_type), intent(in), value :: time_unit
      end function get_string
    end interface
    type(kim_time_unit_type), intent(in) :: time_unit
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(time_unit)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_time_unit_to_string

  !> \brief \copybrief KIM::TIME_UNIT::GetNumberOfTimeUnits
  !!
  !! \sa KIM::TIME_UNIT::GetNumberOfTimeUnits,
  !! KIM_TIME_UNIT_GetNumberOfTimeUnits
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_time_units(number_of_time_units)
    implicit none
    interface
      recursive subroutine get_number_of_time_units(number_of_time_units) &
        bind(c, name="KIM_TIME_UNIT_GetNumberOfTimeUnits")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_time_units
      end subroutine get_number_of_time_units
    end interface
    integer(c_int), intent(out) :: number_of_time_units

    call get_number_of_time_units(number_of_time_units)
  end subroutine kim_get_number_of_time_units

  !> \brief \copybrief KIM::TIME_UNIT::GetTimeUnit
  !!
  !! \sa KIM::TIME_UNIT::GetTimeUnit, KIM_TIME_UNIT_GetTimeUnit
  !!
  !! \since 2.0
  recursive subroutine kim_get_time_unit(index, time_unit, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_time_unit(index, time_unit) &
        bind(c, name="KIM_TIME_UNIT_GetTimeUnit")
        use, intrinsic :: iso_c_binding
        import kim_time_unit_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_time_unit_type), intent(out) :: time_unit
      end function get_time_unit
    end interface
    integer(c_int), intent(in) :: index
    type(kim_time_unit_type), intent(out) :: time_unit
    integer(c_int), intent(out) :: ierr

    ierr = get_time_unit(index-1, time_unit)
  end subroutine kim_get_time_unit
end module kim_time_unit_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


!> \brief \copybrief KIM::ComputeCallbackName
!!
!! \sa KIM::ComputeCallbackName, KIM_ComputeCallbackName
!!
!! \since 2.0
module kim_compute_callback_name_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_compute_callback_name_type, &

    ! Constants
    KIM_COMPUTE_CALLBACK_NAME_GET_NEIGHBOR_LIST, &
    KIM_COMPUTE_CALLBACK_NAME_PROCESS_DEDR_TERM, &
    KIM_COMPUTE_CALLBACK_NAME_PROCESS_D2EDR2_TERM, &

    ! Routines
    kim_known, &
    operator (.eq.), &
    operator (.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_compute_callback_names, &
    kim_get_compute_callback_name


  !> \brief \copybrief KIM::ComputeCallbackName
  !!
  !! \sa KIM::ComputeCallbackName, KIM_ComputeCallbackName
  !!
  !! \since 2.0
  type, bind(c) :: kim_compute_callback_name_type
     !> \brief \copybrief KIM::ComputeCallbackName::computeCallbackNameID
     !!
     !! \sa KIM::ComputeCallbackName::computeCallbackNameID,
     !! KIM_ComputeCallbackName::computeCallbackNameID
     !!
     !! \since 2.0
    integer(c_int) compute_callback_name_id
  end type kim_compute_callback_name_type

  !> \brief \copybrief KIM::COMPUTE_CALLBACK_NAME::GetNeighborList
  !!
  !! \sa KIM::COMPUTE_CALLBACK_NAME::GetNeighborList,
  !! KIM_COMPUTE_CALLBACK_NAME_GetNeighborList
  !!
  !! \since 2.0
  type(kim_compute_callback_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_CALLBACK_NAME_GetNeighborList") &
    :: KIM_COMPUTE_CALLBACK_NAME_GET_NEIGHBOR_LIST

  !> \brief \copybrief KIM::COMPUTE_CALLBACK_NAME::ProcessDEDrTerm
  !!
  !! \sa KIM::COMPUTE_CALLBACK_NAME::ProcessDEDrTerm,
  !! KIM_COMPUTE_CALLBACK_NAME_ProcessDEDrTerm
  !!
  !! \since 2.0
  type(kim_compute_callback_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_CALLBACK_NAME_ProcessDEDrTerm") &
    :: KIM_COMPUTE_CALLBACK_NAME_PROCESS_DEDR_TERM

  !> \brief \copybrief KIM::COMPUTE_CALLBACK_NAME::ProcessD2EDr2Term
  !!
  !! \sa KIM::COMPUTE_CALLBACK_NAME::ProcessD2EDr2Term,
  !! KIM_COMPUTE_CALLBACK_NAME_ProcessD2EDr2Term
  !!
  !! \since 2.0
  type(kim_compute_callback_name_type), protected, save, &
    bind(c, name="KIM_COMPUTE_CALLBACK_NAME_ProcessD2EDr2Term") &
    :: KIM_COMPUTE_CALLBACK_NAME_PROCESS_D2EDR2_TERM

  !> \brief \copybrief KIM::ComputeCallbackName::Known
  !!
  !! \sa KIM::ComputeCallbackName::Known, KIM_ComputeCallbackName_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_compute_callback_name_known
  end interface kim_known

  !> \brief \copybrief KIM::ComputeCallbackName::operator==()
  !!
  !! \sa KIM::ComputeCallbackName::operator==(), KIM_ComputeCallbackName_Equal
  !!
  !! \since 2.0
  interface operator (.eq.)
    module procedure kim_compute_callback_name_equal
  end interface operator (.eq.)

  !> \brief \copybrief KIM::ComputeCallbackName::operator!=()
  !!
  !! \sa KIM::ComputeCallbackName::operator!=(),
  !! KIM_ComputeCallbackName_NotEqual
  !!
  !! \since 2.0
  interface operator (.ne.)
    module procedure kim_compute_callback_name_not_equal
  end interface operator (.ne.)

  !> \brief \copybrief KIM::ComputeCallbackName::<!--
  !! -->ComputeCallbackName(std::string const &)
  !!
  !! \sa KIM::ComputeCallbackName::ComputeCallbackName(std::string const &),
  !! KIM_ComputeCallbackName_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_compute_callback_name_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::ComputeCallbackName::ToString
  !!
  !! \sa KIM::ComputeCallbackName::ToString, KIM_ComputeCallbackName_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_compute_callback_name_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::ComputeCallbackName::Known
  !!
  !! \sa KIM::ComputeCallbackName::Known, KIM_ComputeCallbackName_Known
  !!
  !! \since 2.0
  logical recursive function kim_compute_callback_name_known( &
    compute_callback_name)
    implicit none
    interface
      integer(c_int) recursive function known(compute_callback_name) &
        bind(c, name="KIM_ComputeCallbackName_Known")
        use, intrinsic :: iso_c_binding
        import kim_compute_callback_name_type
        implicit none
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
      end function known
    end interface
    type(kim_compute_callback_name_type), intent(in) :: compute_callback_name

    kim_compute_callback_name_known = (known(compute_callback_name) /= 0)
  end function kim_compute_callback_name_known

  !> \brief \copybrief KIM::ComputeCallbackName::operator==()
  !!
  !! \sa KIM::ComputeCallbackName::operator==(), KIM_ComputeCallbackName_Equal
  !!
  !! \since 2.0
  logical recursive function kim_compute_callback_name_equal(lhs, rhs)
    implicit none
    type(kim_compute_callback_name_type), intent(in) :: lhs
    type(kim_compute_callback_name_type), intent(in) :: rhs

    kim_compute_callback_name_equal &
      = (lhs%compute_callback_name_id .eq. rhs%compute_callback_name_id)
  end function kim_compute_callback_name_equal

  !> \brief \copybrief KIM::ComputeCallbackName::operator!=()
  !!
  !! \sa KIM::ComputeCallbackName::operator!=(),
  !! KIM_ComputeCallbackName_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_compute_callback_name_not_equal(lhs, rhs)
    implicit none
    type(kim_compute_callback_name_type), intent(in) :: lhs
    type(kim_compute_callback_name_type), intent(in) :: rhs

    kim_compute_callback_name_not_equal = .not. (lhs .eq. rhs)
  end function kim_compute_callback_name_not_equal

  !> \brief \copybrief KIM::ComputeCallbackName::<!--
  !! -->ComputeCallbackName(std::string const &)
  !!
  !! \sa KIM::ComputeCallbackName::ComputeCallbackName(std::string const &),
  !! KIM_ComputeCallbackName_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_compute_callback_name_from_string(string, &
    compute_callback_name)
    implicit none
    interface
      type(kim_compute_callback_name_type) recursive function from_string( &
        string) bind(c, name="KIM_ComputeCallbackName_FromString")
        use, intrinsic :: iso_c_binding
        import kim_compute_callback_name_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_compute_callback_name_type), intent(out) :: compute_callback_name

    compute_callback_name = from_string(trim(string)//c_null_char)
  end subroutine kim_compute_callback_name_from_string

  !> \brief \copybrief KIM::ComputeCallbackName::ToString
  !!
  !! \sa KIM::ComputeCallbackName::ToString, KIM_ComputeCallbackName_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_compute_callback_name_to_string( &
    compute_callback_name, string)
    use kim_convert_string_module, only : kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(compute_callback_name) &
        bind(c, name="KIM_ComputeCallbackName_ToString")
        use, intrinsic :: iso_c_binding
        import kim_compute_callback_name_type
        implicit none
        type(kim_compute_callback_name_type), intent(in), value :: &
          compute_callback_name
      end function get_string
    end interface
    type(kim_compute_callback_name_type), intent(in) :: &
      compute_callback_name
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(compute_callback_name)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_compute_callback_name_to_string

  !> \brief \copybrief KIM::COMPUTE_CALLBACK_NAME::<!--
  !! -->GetNumberOfComputeCallbackNames
  !!
  !! \sa KIM::COMPUTE_CALLBACK_NAME::GetNumberOfComputeCallbackNames,
  !! KIM_COMPUTE_CALLBACK_NAME_GetNumberOfComputeCallbackNames
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_compute_callback_names( &
    number_of_compute_callback_names)
    implicit none
    interface
      recursive subroutine get_number_of_compute_callback_names( &
        number_of_compute_callback_names) &
        bind(c, &
        name="KIM_COMPUTE_CALLBACK_NAME_GetNumberOfComputeCallbackNames")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_compute_callback_names
      end subroutine get_number_of_compute_callback_names
    end interface
    integer(c_int), intent(out) :: number_of_compute_callback_names

    call get_number_of_compute_callback_names(number_of_compute_callback_names)
  end subroutine kim_get_number_of_compute_callback_names

  !> \brief \copybrief KIM::COMPUTE_CALLBACK_NAME::GetComputeCallbackName
  !!
  !! \sa KIM::COMPUTE_CALLBACK_NAME::GetComputeCallbackName,
  !! KIM_COMPUTE_CALLBACK_NAME_GetComputeCallbackName
  !!
  !! \since 2.0
  recursive subroutine kim_get_compute_callback_name(index, &
    compute_callback_name, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_compute_callback_name(index, &
        compute_callback_name) &
        bind(c, name="KIM_COMPUTE_CALLBACK_NAME_GetComputeCallbackName")
        use, intrinsic :: iso_c_binding
        import kim_compute_callback_name_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_compute_callback_name_type), intent(out) :: &
          compute_callback_name
      end function get_compute_callback_name
    end interface
    integer(c_int), intent(in) :: index
    type(kim_compute_callback_name_type), intent(out) :: compute_callback_name
    integer(c_int), intent(out) :: ierr

    ierr = get_compute_callback_name(index-1, compute_callback_name)
  end subroutine kim_get_compute_callback_name
end module kim_compute_callback_name_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

module kim_convert_string_module
  implicit none
  private

  public &
    kim_convert_c_char_array_to_string, &
    kim_convert_c_char_ptr_to_string, &
    kim_convert_string_to_c_char_array

contains
  recursive subroutine kim_convert_c_char_array_to_string(c_char_array, string)
    use, intrinsic :: iso_c_binding
    implicit none
    character(len=1, kind=c_char), intent(in) :: c_char_array(:)
    character(len=*, kind=c_char), intent(out) :: string

    integer(c_int) :: i
    integer(c_int) :: null_index
    integer(c_int) :: length

    length = len(string) + 1
    do null_index = 1, length
      if (c_char_array(null_index) == c_null_char) exit
    end do
    if (null_index == length) then
      null_index = len(string)
    else
      null_index = null_index - 1
    end if
    string = ""
    do i = 1, null_index
      string(i:i) = c_char_array(i)
    end do
  end subroutine kim_convert_c_char_array_to_string

  recursive subroutine kim_convert_c_char_ptr_to_string(c_char_ptr, string)
    use, intrinsic :: iso_c_binding
    implicit none
    type(c_ptr), intent(in) :: c_char_ptr
    character(len=*, kind=c_char), intent(out) :: string

    character(len=1, kind=c_char), pointer :: fp(:)
    integer(c_int) :: length

    if (c_associated(c_char_ptr)) then
      length = len(string) + 1
      call c_f_pointer(c_char_ptr, fp, [length])
      call kim_convert_c_char_array_to_string(fp, string)
    else
      string = ""
    end if
  end subroutine kim_convert_c_char_ptr_to_string

  recursive subroutine kim_convert_string_to_c_char_array(string, c_char_array)
    use, intrinsic :: iso_c_binding
    implicit none
    character(len=*, kind=c_char), intent(in) :: string
    character(len=1, kind=c_char), intent(out) :: c_char_array(:)

    c_char_array(:) = trim(string)//c_null_char
  end subroutine kim_convert_string_to_c_char_array
end module kim_convert_string_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

module kim_interoperable_types_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_collections_type, &
    kim_compute_arguments_type, &
    kim_log_type, &
    kim_model_compute_arguments_create_type, &
    kim_model_compute_arguments_destroy_type, &
    kim_model_compute_arguments_type, &
    kim_model_compute_type, &
    kim_model_create_type, &
    kim_model_extension_type, &
    kim_model_destroy_type, &
    kim_model_driver_create_type, &
    kim_model_type, &
    kim_model_refresh_type, &
    kim_model_write_parameterized_model_type, &
    kim_simulator_model_type

  type, bind(c) :: kim_collections_type
    private
    type(c_ptr) :: p
  end type kim_collections_type

  type, bind(c) :: kim_compute_arguments_type
    private
    type(c_ptr) :: p
  end type kim_compute_arguments_type

  type, bind(c) :: kim_log_type
    private
    type(c_ptr) :: p
  end type kim_log_type

  type, bind(c) :: kim_model_compute_arguments_create_type
    private
    type(c_ptr) :: p
  end type kim_model_compute_arguments_create_type

  type, bind(c) :: kim_model_compute_arguments_destroy_type
    private
    type(c_ptr) :: p
  end type kim_model_compute_arguments_destroy_type

  type, bind(c) :: kim_model_compute_arguments_type
    private
    type(c_ptr) :: p
  end type kim_model_compute_arguments_type

  type, bind(c) :: kim_model_compute_type
    private
    type(c_ptr) :: p
  end type kim_model_compute_type

  type, bind(c) :: kim_model_create_type
    private
    type(c_ptr) :: p
  end type kim_model_create_type

  type, bind(c) :: kim_model_extension_type
    private
    type(c_ptr) :: p
  end type kim_model_extension_type

  type, bind(c) :: kim_model_destroy_type
    private
    type(c_ptr) :: p
  end type kim_model_destroy_type

  type, bind(c) :: kim_model_driver_create_type
    private
    type(c_ptr) :: p
  end type kim_model_driver_create_type

  type, bind(c) :: kim_model_type
    private
    type(c_ptr) :: p
  end type kim_model_type

  type, bind(c) :: kim_model_refresh_type
    private
    type(c_ptr) :: p
  end type kim_model_refresh_type

  type, bind(c) :: kim_model_write_parameterized_model_type
    private
    type(c_ptr) :: p
  end type kim_model_write_parameterized_model_type

  type, bind(c) :: kim_simulator_model_type
    private
    type(c_ptr) :: p
  end type kim_simulator_model_type
end module kim_interoperable_types_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::LengthUnit
!!
!! \sa KIM::LengthUnit, KIM_LengthUnit
!!
!! \since 2.0
module kim_length_unit_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derive types
    kim_length_unit_type, &
    ! Constants
    KIM_LENGTH_UNIT_UNUSED, &
    KIM_LENGTH_UNIT_A, &
    KIM_LENGTH_UNIT_BOHR, &
    KIM_LENGTH_UNIT_CM, &
    KIM_LENGTH_UNIT_M, &
    KIM_LENGTH_UNIT_NM, &
    ! Routines
    kim_known, &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_length_units, &
    kim_get_length_unit

  !> \brief \copybrief KIM::LengthUnit
  !!
  !! \sa KIM::LengthUnit, KIM_LengthUnit
  !!
  !! \since 2.0
  type, bind(c) :: kim_length_unit_type
    !> \brief \copybrief KIM::LengthUnit::lengthUnitID
    !!
    !! \sa KIM::LengthUnit::lengthUnitID, KIM_LengthUnit::lengthUnitID
    !!
    !! \since 2.0
    integer(c_int) length_unit_id
  end type kim_length_unit_type

  !> \brief \copybrief KIM::LENGTH_UNIT::unused
  !!
  !! \sa KIM::LENGTH_UNIT::unused, KIM_LENGTH_UNIT_unused
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_unused") &
    :: KIM_LENGTH_UNIT_UNUSED

  !> \brief \copybrief KIM::LENGTH_UNIT::A
  !!
  !! \sa KIM::LENGTH_UNIT::A, KIM_LENGTH_UNIT_A
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_A") &
    :: KIM_LENGTH_UNIT_A

  !> \brief \copybrief KIM::LENGTH_UNIT::Bohr
  !!
  !! \sa KIM::LENGTH_UNIT::Bohr, KIM_LENGTH_UNIT_Bohr
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_Bohr") &
    :: KIM_LENGTH_UNIT_BOHR

  !> \brief \copybrief KIM::LENGTH_UNIT::cm
  !!
  !! \sa KIM::LENGTH_UNIT::cm, KIM_LENGTH_UNIT_cm
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_cm") &
    :: KIM_LENGTH_UNIT_CM

  !> \brief \copybrief KIM::LENGTH_UNIT::m
  !!
  !! \sa KIM::LENGTH_UNIT::m, KIM_LENGTH_UNIT_m
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_m") &
    :: KIM_LENGTH_UNIT_M

  !> \brief \copybrief KIM::LENGTH_UNIT::nm
  !!
  !! \sa KIM::LENGTH_UNIT::nm, KIM_LENGTH_UNIT_nm
  !!
  !! \since 2.0
  type(kim_length_unit_type), protected, save, &
    bind(c, name="KIM_LENGTH_UNIT_nm") &
    :: KIM_LENGTH_UNIT_NM

  !> \brief \copybrief KIM::LengthUnit::Known
  !!
  !! \sa KIM::LengthUnit::Known, KIM_LengthUnit_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_length_unit_known
  end interface kim_known

  !> \brief \copybrief KIM::LengthUnit::operator==()
  !!
  !! \sa KIM::LengthUnit::operator==(), KIM_LengthUnit_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_length_unit_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::LengthUnit::operator!=()
  !!
  !! \sa KIM::LengthUnit::operator!=(), KIM_LengthUnit_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_length_unit_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::LengthUnit::LengthUnit(std::string const &)
  !!
  !! \sa KIM::LengthUnit::LengthUnit(std::string const &),
  !! KIM_LengthUnit_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_length_unit_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::LengthUnit::ToString
  !!
  !! \sa KIM::LengthUnit::ToString, KIM_LengthUnit_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_length_unit_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::LengthUnit::Known
  !!
  !! \sa KIM::LengthUnit::Known, KIM_LengthUnit_Known
  !!
  !! \since 2.0
  logical recursive function kim_length_unit_known(length_unit)
    implicit none
    interface
      integer(c_int) recursive function known(length_unit) &
        bind(c, name="KIM_LengthUnit_Known")
        use, intrinsic :: iso_c_binding
        import kim_length_unit_type
        implicit none
        type(kim_length_unit_type), intent(in), value :: length_unit
      end function known
    end interface
    type(kim_length_unit_type), intent(in) :: length_unit

    kim_length_unit_known = (known(length_unit) /= 0)
  end function kim_length_unit_known

  !> \brief \copybrief KIM::LengthUnit::operator==()
  !!
  !! \sa KIM::LengthUnit::operator==(), KIM_LengthUnit_Equal
  !!
  !! \since 2.0
  logical recursive function kim_length_unit_equal(lhs, rhs)
    implicit none
    type(kim_length_unit_type), intent(in) :: lhs
    type(kim_length_unit_type), intent(in) :: rhs

    kim_length_unit_equal &
      = (lhs%length_unit_id == rhs%length_unit_id)
  end function kim_length_unit_equal

  !> \brief \copybrief KIM::LengthUnit::operator!=()
  !!
  !! \sa KIM::LengthUnit::operator!=(), KIM_LengthUnit_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_length_unit_not_equal(lhs, rhs)
    implicit none
    type(kim_length_unit_type), intent(in) :: lhs
    type(kim_length_unit_type), intent(in) :: rhs

    kim_length_unit_not_equal = .not. (lhs == rhs)
  end function kim_length_unit_not_equal

  !> \brief \copybrief KIM::LengthUnit::LengthUnit(std::string const &)
  !!
  !! \sa KIM::LengthUnit::LengthUnit(std::string const &),
  !! KIM_LengthUnit_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_length_unit_from_string(string, length_unit)
    implicit none
    interface
      type(kim_length_unit_type) recursive function from_string(string) &
        bind(c, name="KIM_LengthUnit_FromString")
        use, intrinsic :: iso_c_binding
        import kim_length_unit_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_length_unit_type), intent(out) :: length_unit

    length_unit = from_string(trim(string)//c_null_char)
  end subroutine kim_length_unit_from_string

  !> \brief \copybrief KIM::LengthUnit::ToString
  !!
  !! \sa KIM::LengthUnit::ToString, KIM_LengthUnit_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_length_unit_to_string(length_unit, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(length_unit) &
        bind(c, name="KIM_LengthUnit_ToString")
        use, intrinsic :: iso_c_binding
        import kim_length_unit_type
        implicit none
        type(kim_length_unit_type), intent(in), value :: length_unit
      end function get_string
    end interface
    type(kim_length_unit_type), intent(in) :: length_unit
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(length_unit)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_length_unit_to_string

  !> \brief \copybrief KIM::LENGTH_UNIT::GetNumberOfLengthUnits
  !!
  !! \sa KIM::LENGTH_UNIT::GetNumberOfLengthUnits,
  !! KIM_LENGTH_UNIT_GetNumberOfLengthUnits
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_length_units(number_of_length_units)
    implicit none
    interface
      recursive subroutine get_number_of_length_units(number_of_length_units) &
        bind(c, name="KIM_LENGTH_UNIT_GetNumberOfLengthUnits")
        use, intrinsic :: iso_c_binding
        integer(c_int), intent(out) :: number_of_length_units
      end subroutine get_number_of_length_units
    end interface
    integer(c_int), intent(out) :: number_of_length_units

    call get_number_of_length_units(number_of_length_units)
  end subroutine kim_get_number_of_length_units

  !> \brief \copybrief KIM::LENGTH_UNIT::GetLengthUnit
  !!
  !! \sa KIM::LENGTH_UNIT::GetLengthUnit, KIM_LENGTH_UNIT_GetLengthUnit
  !!
  !! \since 2.0
  recursive subroutine kim_get_length_unit(index, length_unit, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_length_unit(index, length_unit) &
        bind(c, name="KIM_LENGTH_UNIT_GetLengthUnit")
        use, intrinsic :: iso_c_binding
        import kim_length_unit_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_length_unit_type), intent(out) :: length_unit
      end function get_length_unit
    end interface
    integer(c_int), intent(in) :: index
    type(kim_length_unit_type), intent(out) :: length_unit
    integer(c_int), intent(out) :: ierr

    ierr = get_length_unit(index - 1, length_unit)
  end subroutine kim_get_length_unit
end module kim_length_unit_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::DataType
!!
!! \sa KIM::DataType, KIM_DataType
!!
!! \since 2.0
module kim_data_type_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_data_type_type, &
    ! Constants
    KIM_DATA_TYPE_INTEGER, &
    KIM_DATA_TYPE_DOUBLE, &
    ! Routines
    kim_known, &
    operator(.eq.), &
    operator(.ne.), &
    kim_from_string, &
    kim_to_string, &
    kim_get_number_of_data_types, &
    kim_get_data_type

  !> \brief \copybrief KIM::DataType
  !!
  !! \sa KIM::DataType, KIM_DataType
  !!
  !! \since 2.0
  type, bind(c) :: kim_data_type_type
    !> \brief \copybrief KIM::DataType::dataTypeID
    !!
    !! \sa KIM::DataType::dataTypeID, KIM_DataType::dataTypeID
    !!
    !! \since 2.0
    integer(c_int) :: data_type_id
  end type kim_data_type_type

  !> \brief \copybrief KIM::DATA_TYPE::Integer
  !!
  !! \sa KIM::DATA_TYPE::Integer, KIM_DATA_TYPE_Integer
  !!
  !! \since 2.0
  type(kim_data_type_type), protected, save, &
    bind(c, name="KIM_DATA_TYPE_Integer") &
    :: KIM_DATA_TYPE_INTEGER

  !> \brief \copybrief KIM::DATA_TYPE::Double
  !!
  !! \sa KIM::DATA_TYPE::Double, KIM_DATA_TYPE_Double
  !!
  !! \since 2.0
  type(kim_data_type_type), protected, save, &
    bind(c, name="KIM_DATA_TYPE_Double") &
    :: KIM_DATA_TYPE_DOUBLE

  !> \brief \copybrief KIM::DataType::Known
  !!
  !! \sa KIM::DataType::Known, KIM_DataType_Known
  !!
  !! \since 2.0
  interface kim_known
    module procedure kim_data_type_known
  end interface kim_known

  !> \brief \copybrief KIM::DataType::operator==()
  !!
  !! \sa KIM::DataType::operator==(), KIM_DataType_Equal
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_data_type_equal
  end interface operator(.eq.)

  !> \brief \copybrief KIM::DataType::operator!=()
  !!
  !! \sa KIM::DataType::operator!=(), KIM_DataType_NotEqual
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_data_type_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::DataType::DataType(std::string const &)
  !!
  !! \sa KIM::DataType::DataType(std::string const &), KIM_DataType_FromString
  !!
  !! \since 2.0
  interface kim_from_string
    module procedure kim_data_type_from_string
  end interface kim_from_string

  !> \brief \copybrief KIM::DataType::ToString
  !!
  !! \sa KIM::DataType::ToString, KIM_DataType_ToString
  !!
  !! \since 2.0
  interface kim_to_string
    module procedure kim_data_type_to_string
  end interface kim_to_string

contains
  !> \brief \copybrief KIM::DataType::Known
  !!
  !! \sa KIM::DataType::Known, KIM_DataType_Known
  !!
  !! \since 2.0
  logical recursive function kim_data_type_known(data_type)
    implicit none
    interface
      integer(c_int) recursive function known(data_type) &
        bind(c, name="KIM_DataType_Known")
        use, intrinsic :: iso_c_binding
        import kim_data_type_type
        implicit none
        type(kim_data_type_type), intent(in), value :: data_type
      end function known
    end interface
    type(kim_data_type_type), intent(in) :: data_type

    kim_data_type_known = (known(data_type) /= 0)
  end function kim_data_type_known

  !> \brief \copybrief KIM::DataType::operator==()
  !!
  !! \sa KIM::DataType::operator==(), KIM_DataType_Equal
  !!
  !! \since 2.0
  logical recursive function kim_data_type_equal(lhs, rhs)
    implicit none
    type(kim_data_type_type), intent(in) :: lhs
    type(kim_data_type_type), intent(in) :: rhs

    kim_data_type_equal &
      = (lhs%data_type_id == rhs%data_type_id)
  end function kim_data_type_equal

  !> \brief \copybrief KIM::DataType::operator!=()
  !!
  !! \sa KIM::DataType::operator!=(), KIM_DataType_NotEqual
  !!
  !! \since 2.0
  logical recursive function kim_data_type_not_equal(lhs, rhs)
    implicit none
    type(kim_data_type_type), intent(in) :: lhs
    type(kim_data_type_type), intent(in) :: rhs

    kim_data_type_not_equal = .not. (lhs == rhs)
  end function kim_data_type_not_equal

  !> \brief \copybrief KIM::DataType::DataType(std::string const &)
  !!
  !! \sa KIM::DataType::DataType(std::string const &), KIM_DataType_FromString
  !!
  !! \since 2.0
  recursive subroutine kim_data_type_from_string(string, data_type)
    implicit none
    interface
      type(kim_data_type_type) recursive function from_string(string) &
        bind(c, name="KIM_DataType_FromString")
        use, intrinsic :: iso_c_binding
        import kim_data_type_type
        implicit none
        character(c_char), intent(in) :: string(*)
      end function from_string
    end interface
    character(len=*, kind=c_char), intent(in) :: string
    type(kim_data_type_type), intent(out) :: data_type

    data_type = from_string(trim(string)//c_null_char)
  end subroutine kim_data_type_from_string

  !> \brief \copybrief KIM::DataType::ToString
  !!
  !! \sa KIM::DataType::ToString, KIM_DataType_ToString
  !!
  !! \since 2.0
  recursive subroutine kim_data_type_to_string(data_type, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    interface
      type(c_ptr) recursive function get_string(data_type) &
        bind(c, name="KIM_DataType_ToString")
        use, intrinsic :: iso_c_binding
        import kim_data_type_type
        implicit none
        type(kim_data_type_type), intent(in), value :: data_type
      end function get_string
    end interface
    type(kim_data_type_type), intent(in) :: data_type
    character(len=*, kind=c_char), intent(out) :: string

    type(c_ptr) :: p

    p = get_string(data_type)
    call kim_convert_c_char_ptr_to_string(p, string)
  end subroutine kim_data_type_to_string

  !> \brief \copybrief KIM::DATA_TYPE::GetNumberOfDataTypes
  !!
  !! \sa KIM::DATA_TYPE::GetNumberOfDataTypes,
  !! KIM_DATA_TYPE_GetNumberOfDataTypes
  !!
  !! \since 2.0
  recursive subroutine kim_get_number_of_data_types(number_of_data_types)
    implicit none
    interface
      recursive subroutine get_number_of_data_types(number_of_data_types) &
        bind(c, name="KIM_DATA_TYPE_GetNumberOfDataTypes")
        use, intrinsic :: iso_c_binding
        implicit none
        integer(c_int), intent(out) :: number_of_data_types
      end subroutine get_number_of_data_types
    end interface
    integer(c_int), intent(out) :: number_of_data_types

    call get_number_of_data_types(number_of_data_types)
  end subroutine kim_get_number_of_data_types

  !> \brief \copybrief KIM::DATA_TYPE::GetDataType
  !!
  !! \sa KIM::DATA_TYPE::GetDataType, KIM_DATA_TYPE_GetDataType
  !!
  !! \since 2.0
  recursive subroutine kim_get_data_type(index, data_type, ierr)
    implicit none
    interface
      integer(c_int) recursive function get_data_type(index, data_type) &
        bind(c, name="KIM_DATA_TYPE_GetDataType")
        use, intrinsic :: iso_c_binding
        import kim_data_type_type
        implicit none
        integer(c_int), intent(in), value :: index
        type(kim_data_type_type), intent(out) :: data_type
      end function get_data_type
    end interface
    integer(c_int), intent(in) :: index
    type(kim_data_type_type), intent(out) :: data_type
    integer(c_int), intent(out) :: ierr

    ierr = get_data_type(index - 1, data_type)
  end subroutine kim_get_data_type
end module kim_data_type_module

!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!

!
! Copyright (c) 2016--2019, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!

!
! Release: This file is part of the kim-api.git repository.
!


module kim_model_headers_module
  use, intrinsic :: iso_c_binding

  use kim_model_create_module
  use kim_log_verbosity_module
  use kim_language_name_module
  use kim_numbering_module
  use kim_model_routine_name_module
  use kim_species_name_module
  use kim_support_status_module
  use kim_unit_system_module
  use kim_model_compute_arguments_create_module
  use kim_compute_argument_name_module
  use kim_data_type_module
  use kim_compute_callback_name_module
  use kim_model_compute_arguments_module
  use kim_model_compute_arguments_destroy_module
  use kim_model_compute_module
  use kim_model_extension_module
  use kim_model_refresh_module
  use kim_model_write_parameterized_model_module
  use kim_model_destroy_module

  public
end module kim_model_headers_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::Log
!!
!! \sa KIM::Log, KIM_Log
!!
!! \since 2.0
module kim_log_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_log_handle_type, &
    ! Constants
    KIM_LOG_NULL_HANDLE, &
    ! Routines
    operator(.eq.), &
    operator(.ne.), &
    kim_log_create, &
    kim_log_destroy, &
    kim_push_default_verbosity, &
    kim_pop_default_verbosity, &
    kim_push_default_print_function, &
    kim_pop_default_print_function, &
    kim_convert_c_string, &
    kim_get_id, &
    kim_set_id, &
    kim_push_verbosity, &
    kim_pop_verbosity, &
    kim_log_entry

  !> \brief \copybrief KIM::Log
  !!
  !! \sa KIM::Log, KIM_Log
  !!
  !! \since 2.0
  type, bind(c) :: kim_log_handle_type
    type(c_ptr) :: p = c_null_ptr
  end type kim_log_handle_type

  !> \brief NULL handle for use in comparisons.
  !!
  !! \since 2.0
  type(kim_log_handle_type), protected, save &
    :: KIM_LOG_NULL_HANDLE

  !> \brief Compares kim_log_handle_type's for equality.
  !!
  !! \since 2.0
  interface operator(.eq.)
    module procedure kim_log_handle_equal
  end interface operator(.eq.)

  !> \brief Compares kim_log_handle_type's for inequality.
  !!
  !! \since 2.0
  interface operator(.ne.)
    module procedure kim_log_handle_not_equal
  end interface operator(.ne.)

  !> \brief \copybrief KIM::Log::PushDefaultVerbosity
  !!
  !! \sa KIM::Log::PushDefaultVerbosity, KIM_Log_PushDefaultVerbosity
  !!
  !! \since 2.0
  interface kim_push_default_verbosity
    module procedure kim_log_push_default_verbosity
  end interface kim_push_default_verbosity

  !> \brief \copybrief KIM::Log::PopDefaultVerbosity
  !!
  !! \sa KIM::Log::PopDefaultVerbosity, KIM_Log_PopDefaultVerbosity
  !!
  !! \since 2.0
  interface kim_pop_default_verbosity
    module procedure kim_log_pop_default_verbosity
  end interface kim_pop_default_verbosity

  !> \brief \copybrief KIM::Log::PushDefaultPrintFunction
  !!
  !! \sa KIM::Log::PushDefaultPrintFunction, KIM_Log_PushDefaultPrintFunction
  !!
  !! \since 2.2
  interface kim_push_default_print_function
    module procedure kim_log_push_default_print_function
  end interface kim_push_default_print_function

  !> \brief \copybrief KIM::Log::PopDefaultPrintFunction
  !!
  !! \sa KIM::Log::PopDefaultPrintFunction, KIM_Log_PopDefaultPrintFunction
  !!
  !! \since 2.2
  interface kim_pop_default_print_function
    module procedure kim_log_pop_default_print_function
  end interface kim_pop_default_print_function

  !> \brief \copybrief kim_log_module::kim_log_convert_c_string
  !!
  !! \since 2.2
  interface kim_convert_c_string
    module procedure kim_log_convert_c_string
  end interface kim_convert_c_string

  !> \brief \copybrief KIM::Log::GetID
  !!
  !! \sa KIM::Log::GetID, KIM_Log_GetID
  !!
  !! \since 2.0
  interface kim_get_id
    module procedure kim_log_get_id
  end interface kim_get_id

  !> \brief \copybrief KIM::Log::SetID
  !!
  !! \sa KIM::Log::SetID, KIM_Log_SetID
  !!
  !! \since 2.0
  interface kim_set_id
    module procedure kim_log_set_id
  end interface kim_set_id

  !> \brief \copybrief KIM::Log::PushVerbosity
  !!
  !! \sa KIM::Log::PushVerbosity, KIM_Log_PushVerbosity
  !!
  !! \since 2.0
  interface kim_push_verbosity
    module procedure kim_log_push_verbosity
  end interface kim_push_verbosity

  !> \brief \copybrief KIM::Log::PopVerbosity
  !!
  !! \sa KIM::Log::PopVerbosity, KIM_Log_PopVerbosity
  !!
  !! \since 2.0
  interface kim_pop_verbosity
    module procedure kim_log_pop_verbosity
  end interface kim_pop_verbosity

  !> \brief \copybrief KIM::Log::LogEntry
  !!
  !! \sa KIM::Log::LogEntry, KIM_Log_LogEntry
  !!
  !! \since 2.0
  interface kim_log_entry
    module procedure kim_log_log_entry
  end interface kim_log_entry

contains
  !> \brief Compares kim_log_handle_type's for equality.
  !!
  !! \since 2.0
  logical recursive function kim_log_handle_equal(lhs, rhs)
    implicit none
    type(kim_log_handle_type), intent(in) :: lhs
    type(kim_log_handle_type), intent(in) :: rhs

    if ((.not. c_associated(lhs%p)) .and. (.not. c_associated(rhs%p))) then
      kim_log_handle_equal = .true.
    else
      kim_log_handle_equal = c_associated(lhs%p, rhs%p)
    end if
  end function kim_log_handle_equal

  !> \brief Compares kim_log_handle_type's for inequality.
  !!
  !! \since 2.0
  logical recursive function kim_log_handle_not_equal(lhs, rhs)
    implicit none
    type(kim_log_handle_type), intent(in) :: lhs
    type(kim_log_handle_type), intent(in) :: rhs

    kim_log_handle_not_equal = .not. (lhs == rhs)
  end function kim_log_handle_not_equal

  !> \brief \copybrief KIM::Log::Create
  !!
  !! \sa KIM::Log::Create, KIM_Log_Create
  !!
  !! \since 2.0
  recursive subroutine kim_log_create(log_handle, ierr)
    implicit none
    interface
      integer(c_int) recursive function create(log) &
        bind(c, name="KIM_Log_Create")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(out) :: log
      end function create
    end interface
    type(kim_log_handle_type), intent(out) :: log_handle
    integer(c_int), intent(out) :: ierr

    type(c_ptr) :: plog

    ierr = create(plog)
    log_handle%p = plog
  end subroutine kim_log_create

  !> \brief \copybrief KIM::Log::Destroy
  !!
  !! \sa KIM::Log::Destroy, KIM_Log_Destroy
  !!
  !! \since 2.0
  recursive subroutine kim_log_destroy(log_handle)
    implicit none
    interface
      recursive subroutine destroy(log) bind(c, name="KIM_Log_Destroy")
        use, intrinsic :: iso_c_binding
        implicit none
        type(c_ptr), intent(inout) :: log
      end subroutine destroy
    end interface
    type(kim_log_handle_type), intent(inout) :: log_handle

    type(c_ptr) :: plog
    plog = log_handle%p
    call destroy(plog)
    log_handle%p = c_null_ptr
  end subroutine kim_log_destroy

  !> \brief \copybrief KIM::Log::PushDefaultVerbosity
  !!
  !! \sa KIM::Log::PushDefaultVerbosity, KIM_Log_PushDefaultVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_log_push_default_verbosity(log_verbosity)
    use kim_log_verbosity_module, only: kim_log_verbosity_type
    implicit none
    interface
      recursive subroutine push_default_verbosity(log_verbosity) &
        bind(c, name="KIM_Log_PushDefaultVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only: kim_log_verbosity_type
        implicit none
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_default_verbosity
    end interface
    type(kim_log_verbosity_type), intent(in) :: log_verbosity

    call push_default_verbosity(log_verbosity)
  end subroutine kim_log_push_default_verbosity

  !> \brief \copybrief KIM::Log::PopDefaultVerbosity
  !!
  !! \sa KIM::Log::PopDefaultVerbosity, KIM_Log_PopDefaultVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_log_pop_default_verbosity()
    implicit none
    interface
      recursive subroutine pop_default_verbosity() &
        bind(c, name="KIM_Log_PopDefaultVerbosity")
        use, intrinsic :: iso_c_binding
        implicit none
      end subroutine pop_default_verbosity
    end interface

    call pop_default_verbosity()
  end subroutine kim_log_pop_default_verbosity

  !> \brief \copybrief KIM::Log::PushDefaultPrintFunction
  !!
  !! A Fortran routine may provide a KIM::Log::PrintFunction routine.  The
  !! interface for this is given here (see also KIM::LogPrintFunction, \ref
  !! KIM_LogPrintFunction).
  !!
  !! \code{.f90}
  !! interface
  !!   recursive subroutine log_print_function(entry_string, ierr) bind(c)
  !!     use, intrinsic :: iso_c_binding
  !!     type(c_ptr), intent(in), value :: entry_string
  !!     integer(c_int), intent(out) :: ierr
  !!   end subroutine log_print_function
  !! end interface
  !! \endcode
  !!
  !! The routine must take a c_ptr pointing to a null terminated c string
  !! representing the log message.  To work with this, the kim_log_module
  !! provides a conversion routine: kim_log_module::kim_convert_c_string.
  !!
  !! An example log print function, which simply writes log messages to stdout,
  !! is given here:
  !!
  !! \code{.f90}
  !! recursive subroutine log_print_function(entry_string, ierr) bind(c)
  !!   use, intrinsic :: iso_c_binding
  !!   use kim_log_module, only : kim_convert_c_string
  !!   type(c_ptr), intent(in), value :: entry_string
  !!   integer(c_int), intent(out) :: ierr
  !!
  !!   character(len=2048, kind=c_char) :: message
  !!
  !!   call kim_convert_c_string(entry_string, message)
  !!   print *, trim(message)
  !!
  !!   ierr = 0
  !!   return
  !! end subroutine log_print_function
  !! \endcode
  !!
  !! \sa KIM::Log::PushDefaultPrintFunction, KIM_Log_PushDefaultPrintFunction
  !!
  !! \since 2.2
  recursive subroutine kim_log_push_default_print_function(language_name, fptr)
    use kim_language_name_module, only: kim_language_name_type
    implicit none
    interface
      recursive subroutine push_default_print_function(language_name, fptr) &
        bind(c, name="KIM_Log_PushDefaultPrintFunction")
        use, intrinsic :: iso_c_binding
        use kim_language_name_module, only: kim_language_name_type
        implicit none
        type(kim_language_name_type), intent(in), value :: language_name
        type(c_funptr), intent(in), value :: fptr
      end subroutine push_default_print_function
    end interface
    type(kim_language_name_type), intent(in) :: language_name
    type(c_funptr), intent(in), value :: fptr  ! must be left as "value"!?!

    call push_default_print_function(language_name, fptr)
  end subroutine kim_log_push_default_print_function

  !> \brief \copybrief KIM::Log::PopDefaultPrintFunction
  !!
  !! \sa KIM::Log::PopDefaultPrintFunction, KIM_Log_PopDefaultPrintFunction
  !!
  !! \since 2.2
  recursive subroutine kim_log_pop_default_print_function()
    implicit none
    interface
      recursive subroutine pop_default_print_function() &
        bind(c, name="KIM_Log_PopDefaultPrintFunction")
        use, intrinsic :: iso_c_binding
        implicit none
      end subroutine pop_default_print_function
    end interface

    call pop_default_print_function()
  end subroutine kim_log_pop_default_print_function

  !> \brief Convert a c sting to a Fortran string
  !!
  !! Convert a c string, given in terms of a char pointer to a Fortran string
  !! variable.
  !!
  !! \param[in]  c_char_ptr A pointer to a null terminated c string
  !! \param[out] string A Fortran string variable
  !!
  !! \since 2.2
  recursive subroutine kim_log_convert_c_string(c_char_ptr, string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    implicit none
    type(c_ptr), intent(in), value :: c_char_ptr
    character(len=*, kind=c_char), intent(out) :: string

    call kim_convert_c_char_ptr_to_string(c_char_ptr, string)
  end subroutine kim_log_convert_c_string

  !> \brief \copybrief KIM::Log::GetID
  !!
  !! \sa KIM::Log::GetID, KIM_Log_GetID
  !!
  !! \since 2.0
  recursive subroutine kim_log_get_id(log_handle, id_string)
    use kim_convert_string_module, only: kim_convert_c_char_ptr_to_string
    use kim_interoperable_types_module, only: kim_log_type
    implicit none
    interface
      type(c_ptr) recursive function get_id(log) bind(c, name="KIM_Log_GetID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only: kim_log_type
        implicit none
        type(kim_log_type), intent(in) :: log
      end function get_id
    end interface
    type(kim_log_handle_type), intent(in) :: log_handle
    character(len=*, kind=c_char), intent(out) :: id_string
    type(kim_log_type), pointer :: log

    type(c_ptr) :: p

    call c_f_pointer(log_handle%p, log)
    p = get_id(log)
    call kim_convert_c_char_ptr_to_string(p, id_string)
  end subroutine kim_log_get_id

  !> \brief \copybrief KIM::Log::SetID
  !!
  !! \sa KIM::Log::SetID, KIM_Log_SetID
  !!
  !! \since 2.0
  recursive subroutine kim_log_set_id(log_handle, id_string)
    use kim_interoperable_types_module, only: kim_log_type
    implicit none
    interface
      recursive subroutine set_id(log, id_string) bind(c, name="KIM_Log_SetID")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only: kim_log_type
        implicit none
        type(kim_log_type), intent(in) :: log
        character(c_char), intent(in) :: id_string(*)
      end subroutine set_id
    end interface
    type(kim_log_handle_type), intent(in) :: log_handle
    character(len=*, kind=c_char), intent(in) :: id_string
    type(kim_log_type), pointer :: log

    call c_f_pointer(log_handle%p, log)
    call set_id(log, trim(id_string)//c_null_char)
  end subroutine kim_log_set_id

  !> \brief \copybrief KIM::Log::PushVerbosity
  !!
  !! \sa KIM::Log::PushVerbosity, KIM_Log_PushVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_log_push_verbosity(log_handle, log_verbosity)
    use kim_log_verbosity_module, only: kim_log_verbosity_type
    use kim_interoperable_types_module, only: kim_log_type
    implicit none
    interface
      recursive subroutine push_verbosity(log, log_verbosity) &
        bind(c, name="KIM_Log_PushVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only: kim_log_verbosity_type
        use kim_interoperable_types_module, only: kim_log_type
        implicit none
        type(kim_log_type), intent(in) :: log
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
      end subroutine push_verbosity
    end interface
    type(kim_log_handle_type), intent(in) :: log_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    type(kim_log_type), pointer :: log

    call c_f_pointer(log_handle%p, log)
    call push_verbosity(log, log_verbosity)
  end subroutine kim_log_push_verbosity

  !> \brief \copybrief KIM::Log::PopVerbosity
  !!
  !! \sa KIM::Log::PopVerbosity, KIM_Log_PopVerbosity
  !!
  !! \since 2.0
  recursive subroutine kim_log_pop_verbosity(log_handle)
    use kim_interoperable_types_module, only: kim_log_type
    implicit none
    interface
      recursive subroutine pop_verbosity(log) &
        bind(c, name="KIM_Log_PopVerbosity")
        use, intrinsic :: iso_c_binding
        use kim_interoperable_types_module, only: kim_log_type
        implicit none
        type(kim_log_type), intent(in) :: log
      end subroutine pop_verbosity
    end interface
    type(kim_log_handle_type), intent(in) :: log_handle
    type(kim_log_type), pointer :: log

    call c_f_pointer(log_handle%p, log)
    call pop_verbosity(log)
  end subroutine kim_log_pop_verbosity

  !> \brief \copybrief KIM::Log::LogEntry
  !!
  !! \sa KIM::Log::LogEntry, KIM_Log_LogEntry
  !!
  !! \since 2.0
  recursive subroutine kim_log_log_entry(log_handle, log_verbosity, message)
    use kim_log_verbosity_module, only: kim_log_verbosity_type
    use kim_interoperable_types_module, only: kim_log_type
    implicit none
    interface
      recursive subroutine log_entry(log, log_verbosity, message, line_number, &
                                     file_name) bind(c, name="KIM_Log_LogEntry")
        use, intrinsic :: iso_c_binding
        use kim_log_verbosity_module, only: kim_log_verbosity_type
        use kim_interoperable_types_module, only: kim_log_type
        implicit none
        type(kim_log_type), intent(in) :: log
        type(kim_log_verbosity_type), intent(in), value :: log_verbosity
        character(c_char), intent(in) :: message(*)
        integer(c_int), intent(in), value :: line_number
        character(c_char), intent(in) :: file_name(*)
      end subroutine log_entry
    end interface
    type(kim_log_handle_type), intent(in) :: log_handle
    type(kim_log_verbosity_type), intent(in) :: log_verbosity
    character(len=*, kind=c_char), intent(in) :: message
    type(kim_log_type), pointer :: log

    call c_f_pointer(log_handle%p, log)
    call log_entry(log, log_verbosity, trim(message)//c_null_char, &
                   0, ""//c_null_char)
  end subroutine kim_log_log_entry
end module kim_log_module

!
! KIM-API: An API for interatomic models
! Copyright (c) 2013--2022, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Ryan S. Elliott
!
! SPDX-License-Identifier: LGPL-2.1-or-later
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this library; if not, write to the Free Software Foundation,
! Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
!

!
! Release: This file is part of the kim-api.git repository.
!

!> \brief \copybrief KIM::SupportedExtensions
!!
!! \sa KIM::SupportedExtensions, KIM_SupportedExtensions
!!
!! \since 2.0
module kim_supported_extensions_module
  use, intrinsic :: iso_c_binding
  implicit none
  private

  public &
    ! Derived types
    kim_supported_extensions_type, &
    ! Constants
    KIM_SUPPORTED_EXTENSIONS_ID, &
    KIM_MAX_EXTENSION_ID_LENGTH, &
    KIM_MAX_NUMBER_OF_EXTENSIONS

  character(len=*, kind=c_char), parameter &
    :: KIM_SUPPORTED_EXTENSIONS_ID = "KIM_SupportedExtensions"
  integer(c_int), parameter :: KIM_MAX_EXTENSION_ID_LENGTH = 128
  integer(c_int), parameter :: KIM_MAX_NUMBER_OF_EXTENSIONS = 64

  !> \brief \copybrief KIM::SupportedExtensions
  !!
  !! \sa KIM::SupportedExtensions, KIM_SupportedExtensions
  !!
  !! \since 2.0
  type, bind(c) :: kim_supported_extensions_type
    !> \brief \copybrief KIM::SupportedExtensions::numberOfSupportedExtensions
    !!
    !! \sa KIM::SupportedExtensions::numberOfSupportedExtensions,
    !! KIM_SupportedExtensions::numberOfSupportedExtensions
    !!
    !! \since 2.0
    integer(c_int) number_of_supported_extensions

    !> \brief \copybrief KIM::SupportedExtensions::supportedExtensionID
    !!
    !! \sa KIM::SupportedExtensions::supportedExtensionID,
    !! KIM_SupportedExtensions::supportedExtensionID
    !!
    !! \since 2.0
    character(c_char) supported_extension_id(KIM_MAX_EXTENSION_ID_LENGTH, &
                                             KIM_MAX_NUMBER_OF_EXTENSIONS)

    !> \brief \copybrief KIM::SupportedExtensions::supportedExtensionRequired
    !!
    !! \sa KIM::SupportedExtensions::supportedExtensionRequired,
    !! KIM_SupportedExtensions::supportedExtensionRequired
    !!
    !! \since 2.0
    integer(c_int) supported_extension_required(KIM_MAX_NUMBER_OF_EXTENSIONS)
  end type kim_supported_extensions_type
end module kim_supported_extensions_module

#!/bin/sh
#

#
# KIM-API: An API for interatomic models
# Copyright (c) 2013--2022, Regents of the University of Minnesota.
# All rights reserved.
#
# Contributors:
#    Ryan S. Elliott
#    Stephen M. Whalen
#
# SPDX-License-Identifier: LGPL-2.1-or-later
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#


flName=LennardJones612ImplementationComputeDispatch.cpp

printf "switch (GetComputeIndex(isComputeProcess_dEdr,\n"   >  $flName
printf "                        isComputeProcess_d2Edr2,\n" >> $flName
printf "                        isComputeEnergy,\n"         >> $flName
printf "                        isComputeForces,\n"         >> $flName
printf "                        isComputeParticleEnergy,\n" >> $flName
printf "                        isComputeVirial,\n"         >> $flName
printf "                        isComputeParticleVirial,\n" >> $flName
printf "                        isShift))\n"                >> $flName
printf "{\n"                                                >> $flName

i=0
for processdE in false true; do
  for processd2E in false true; do
    for energy in false true; do
      for force in false true; do
        for particleEnergy in false true; do
          for virial in false true; do
            for particleVirial in false true; do
              for sshift in false true; do
                printf "  case $i:\n"                                     >> $flName
                printf "    ier = Compute<$processdE, $processd2E, "      >> $flName
                printf "$energy, $force, "                                >> $flName
                printf "$particleEnergy, $virial, "                       >> $flName
                printf "$particleVirial, $sshift>(\n"                     >> $flName
                printf "        modelCompute,\n"                          >> $flName
                printf "        modelComputeArguments,\n"                 >> $flName
                printf "        particleSpeciesCodes,\n"                  >> $flName
                printf "        particleContributing,\n"                  >> $flName
                printf "        coordinates,\n"                           >> $flName
                printf "        energy,\n"                                >> $flName
                printf "        forces,\n"                                >> $flName
                printf "        particleEnergy,\n"                        >> $flName
                printf "        *virial,\n"                               >> $flName
                printf "        particleVirial);\n"                       >> $flName
                printf "    break;\n"                                     >> $flName
                i=`expr $i + 1`
              done  # sshift
            done  # particleVirial
          done  # virial
        done  # particleEnergy
      done  # force
    done  # energy
  done  # processd2E
done  # processdE

printf "  default:\n"                                                        >> $flName
printf "    std::cout << \"Unknown compute function index\" << std::endl;\n" >> $flName
printf "    ier = true;\n"                                                   >> $flName
printf "    break;\n"                                                        >> $flName
printf "}\n"                                                                 >> $flName
